package pneumaticCraft.client;

import java.util.Set;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.BlockPos;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.util.RenderUtils;

public class AreaShowHandler{
    private final Set<BlockPos> showingPositions;
    private final int color;
    private int renderList;

    public AreaShowHandler(Set<BlockPos> area, int color){
        showingPositions = area;
        this.color = color;
        compileRenderList();
    }

    private void compileRenderList(){
        renderList = GL11.glGenLists(1);
        GL11.glNewList(renderList, GL11.GL_COMPILE);

        WorldRenderer wr = Tessellator.func_178181_a().func_178180_c();
        RenderUtils.glColorHex(color, 150);
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181705_e);

        for(BlockPos pos : showingPositions) {
            wr.func_178969_c(pos.func_177958_n() + 0.25F, pos.func_177956_o() + 0.25F, pos.func_177952_p() + 0.25F);

            wr.func_181662_b(0, 0, 0).func_181675_d();
            wr.func_181662_b(0, 0.5, 0).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0).func_181675_d();
            wr.func_181662_b(0.5, 0, 0).func_181675_d();

            wr.func_181662_b(0.5, 0, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0, 0, 0.5).func_181675_d();

            wr.func_181662_b(0, 0, 0).func_181675_d();
            wr.func_181662_b(0, 0, 0.5).func_181675_d();
            wr.func_181662_b(0, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0, 0.5, 0).func_181675_d();

            wr.func_181662_b(0.5, 0.5, 0).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0, 0).func_181675_d();

            wr.func_181662_b(0, 0, 0).func_181675_d();
            wr.func_181662_b(0.5, 0, 0).func_181675_d();
            wr.func_181662_b(0.5, 0, 0.5).func_181675_d();
            wr.func_181662_b(0, 0, 0.5).func_181675_d();

            wr.func_181662_b(0, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0).func_181675_d();
            wr.func_181662_b(0, 0.5, 0).func_181675_d();
        }

        Tessellator.func_178181_a().func_78381_a();

        wr.func_181668_a(GL11.GL_LINES, DefaultVertexFormats.field_181705_e);
        RenderUtils.glColorHex(0, 150);

        for(BlockPos pos : showingPositions) {
            wr.func_178969_c(pos.func_177958_n() + 0.25F, pos.func_177956_o() + 0.25F, pos.func_177952_p() + 0.25F);

            wr.func_181662_b(0, 0, 0).func_181675_d();
            wr.func_181662_b(0, 0.5, 0).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0).func_181675_d();
            wr.func_181662_b(0.5, 0, 0).func_181675_d();

            wr.func_181662_b(0.5, 0, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0, 0, 0.5).func_181675_d();

            wr.func_181662_b(0, 0, 0).func_181675_d();
            wr.func_181662_b(0, 0, 0.5).func_181675_d();
            wr.func_181662_b(0, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0, 0.5, 0).func_181675_d();

            wr.func_181662_b(0.5, 0.5, 0).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0, 0).func_181675_d();

            wr.func_181662_b(0, 0, 0).func_181675_d();
            wr.func_181662_b(0.5, 0, 0).func_181675_d();
            wr.func_181662_b(0.5, 0, 0.5).func_181675_d();
            wr.func_181662_b(0, 0, 0.5).func_181675_d();

            wr.func_181662_b(0, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0.5).func_181675_d();
            wr.func_181662_b(0.5, 0.5, 0).func_181675_d();
            wr.func_181662_b(0, 0.5, 0).func_181675_d();
        }

        wr.func_178969_c(0, 0, 0);
        Tessellator.func_178181_a().func_78381_a();
        GL11.glEndList();
    }

    public void render(){
        GL11.glCallList(renderList);
    }
}
