package pneumaticCraft.client;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderBiped;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.Vec3;
import net.minecraftforge.client.event.ModelBakeEvent;
import net.minecraftforge.client.event.RenderLivingEvent;
import net.minecraftforge.client.event.RenderWorldLastEvent;
import net.minecraftforge.client.event.TextureStitchEvent;
import net.minecraftforge.client.model.IFlexibleBakedModel;
import net.minecraftforge.client.model.IModel;
import net.minecraftforge.client.model.obj.OBJLoader;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.api.item.IProgrammable;
import pneumaticCraft.client.gui.IGuiDrone;
import pneumaticCraft.client.render.RenderProgressingLine;
import pneumaticCraft.client.util.RenderUtils;
import pneumaticCraft.common.DateEventHandler;
import pneumaticCraft.common.block.tubes.ModuleRegistrator;
import pneumaticCraft.common.block.tubes.ModuleRegulatorTube;
import pneumaticCraft.common.block.tubes.TubeModule;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.item.ItemMinigun;
import pneumaticCraft.common.item.ItemProgrammingPuzzle;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.minigun.Minigun;
import pneumaticCraft.common.progwidgets.IProgWidget;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;
import pneumaticCraft.lib.Names;

import com.google.common.collect.Maps;

public class ClientEventHandler{
    public static float playerRenderPartialTick;
    private final RenderProgressingLine minigunFire = new RenderProgressingLine().setProgress(1);
    private final Map<IModel, Class<? extends TubeModule>> awaitingBaking = new HashMap<IModel, Class<? extends TubeModule>>();

    @SubscribeEvent
    public void onItemTooltip(ItemTooltipEvent event){
        if(event.itemStack.func_77973_b() instanceof IProgrammable) {
            IProgrammable programmable = (IProgrammable)event.itemStack.func_77973_b();
            if(programmable.canProgram(event.itemStack) && programmable.showProgramTooltip()) {
                boolean hasInvalidPrograms = false;
                List<String> addedEntries = new ArrayList<String>();
                Map<String, Integer> widgetMap = getPuzzleSummary(TileEntityProgrammer.getProgWidgets(event.itemStack));
                for(Map.Entry<String, Integer> entry : widgetMap.entrySet()) {
                    IProgWidget widget = ItemProgrammingPuzzle.getWidgetForName(entry.getKey());
                    String prefix = "";
                    GuiScreen curScreen = Minecraft.func_71410_x().field_71462_r;
                    if(curScreen instanceof IGuiDrone) {
                        if(!((IGuiDrone)curScreen).getDrone().isProgramApplicable(widget)) {
                            prefix = EnumChatFormatting.RED + "";
                            hasInvalidPrograms = true;
                        }
                    }
                    addedEntries.add(prefix + "-" + entry.getValue() + "x " + I18n.func_135052_a("programmingPuzzle." + entry.getKey() + ".name"));
                }
                if(hasInvalidPrograms) {
                    event.toolTip.add(EnumChatFormatting.RED + I18n.func_135052_a("gui.tooltip.programmable.invalidPieces"));
                }
                Collections.sort(addedEntries);
                event.toolTip.addAll(addedEntries);
            }
        }
    }

    private static Map<String, Integer> getPuzzleSummary(List<IProgWidget> widgets){
        Map<String, Integer> map = new HashMap<String, Integer>();
        for(IProgWidget widget : widgets) {
            if(!map.containsKey(widget.getWidgetString())) {
                map.put(widget.getWidgetString(), 1);
            } else {
                map.put(widget.getWidgetString(), map.get(widget.getWidgetString()) + 1);
            }
        }
        return map;
    }

    @SubscribeEvent
    public void onLivingRender(RenderLivingEvent.Pre event){
        setRenderHead(event.entity, false);
    }

    @SubscribeEvent
    public void onLivingRender(RenderLivingEvent.Post event){
        setRenderHead(event.entity, true);
    }

    private void setRenderHead(EntityLivingBase entity, boolean setRender){
        if(entity.func_71124_b(4) != null && entity.func_71124_b(4).func_77973_b() == Itemss.pneumaticHelmet && (Config.useHelmetModel || DateEventHandler.isIronManEvent())) {
            Render renderer = Minecraft.func_71410_x().func_175598_ae().func_78713_a(entity);
            if(renderer instanceof RenderBiped) {
                ((RenderBiped)renderer).field_77071_a.field_78116_c.field_78806_j = setRender;
            }
        }
    }

    /* TODO 1.8 @SubscribeEvent
      public void onPlayerRender(RenderPlayerEvent.Pre event){
          playerRenderPartialTick = event.partialRenderTick;
          if(!Config.useHelmetModel && !DateEventHandler.isIronManEvent() || event.entityPlayer.getCurrentArmor(3) == null || event.entityPlayer.getCurrentArmor(3).getItem() != Itemss.pneumaticHelmet) return;
          event.renderer.modelBipedMain.bipedHead.showModel = false;
      }

      @SubscribeEvent
      public void onPlayerRender(RenderPlayerEvent.Post event){
          event.renderer.modelBipedMain.bipedHead.showModel = true;
      }*/

    @SubscribeEvent
    public void tickEnd(TickEvent.RenderTickEvent event){
        if(event.phase == TickEvent.Phase.END && FMLClientHandler.instance().getClient().field_71415_G && PneumaticCraft.proxy.getPlayer().field_70170_p != null && (ModuleRegulatorTube.inverted || !ModuleRegulatorTube.inLine)) {
            Minecraft mc = FMLClientHandler.instance().getClient();
            ScaledResolution sr = new ScaledResolution(mc);
            FontRenderer fontRenderer = FMLClientHandler.instance().getClient().field_71466_p;
            String warning = EnumChatFormatting.RED + I18n.func_135052_a("gui.regulatorTube.hudMessage." + (ModuleRegulatorTube.inverted ? "inverted" : "notInLine"));
            fontRenderer.func_175063_a(warning, sr.func_78326_a() / 2 - fontRenderer.func_78256_a(warning) / 2, sr.func_78328_b() / 2 + 30, 0xFFFFFFFF);
        }
    }

    @SubscribeEvent
    public void onWorldRender(RenderWorldLastEvent event){
        double gunRadius = 1.1D;

        EntityPlayer thisPlayer = Minecraft.func_71410_x().field_71439_g;
        double playerX = thisPlayer.field_70169_q + (thisPlayer.field_70165_t - thisPlayer.field_70169_q) * event.partialTicks;
        double playerY = thisPlayer.field_70167_r + (thisPlayer.field_70163_u - thisPlayer.field_70167_r) * event.partialTicks;
        double playerZ = thisPlayer.field_70166_s + (thisPlayer.field_70161_v - thisPlayer.field_70166_s) * event.partialTicks;
        GL11.glPushMatrix();
        GL11.glTranslated(-playerX, -playerY, -playerZ);

        for(EntityPlayer player : Minecraft.func_71410_x().field_71441_e.field_73010_i) {
            if(thisPlayer == player && Minecraft.func_71410_x().field_71474_y.field_74320_O == 0) continue;
            ItemStack curItem = player.func_71045_bC();
            if(curItem != null && curItem.func_77973_b() == Itemss.minigun) {
                Minigun minigun = ((ItemMinigun)Itemss.minigun).getMinigun(curItem, player);
                if(minigun.isMinigunActivated() && minigun.getMinigunSpeed() == Minigun.MAX_GUN_SPEED) {
                    GL11.glPushMatrix();
                    playerX = player.field_70169_q + (player.field_70165_t - player.field_70169_q) * event.partialTicks;
                    playerY = player.field_70167_r + (player.field_70163_u - player.field_70167_r) * event.partialTicks;
                    playerZ = player.field_70166_s + (player.field_70161_v - player.field_70166_s) * event.partialTicks;
                    GL11.glTranslated(playerX, playerY + 0.5, playerZ);

                    GL11.glDisable(GL11.GL_TEXTURE_2D);
                    //GL11.glDisable(GL11.GL_LIGHTING);
                    RenderUtils.glColorHex(0xFF000000 | minigun.getAmmoColor());
                    for(int i = 0; i < 5; i++) {

                        Vec3 directionVec = player.func_70040_Z().func_72432_b();
                        Vec3 vec = new Vec3(directionVec.field_72450_a, 0, directionVec.field_72449_c).func_72432_b();
                        vec.func_178785_b((float)Math.toRadians(-15 + (player.field_70759_as - player.field_70761_aq)));
                        minigunFire.startX = vec.field_72450_a * gunRadius;
                        minigunFire.startY = vec.field_72448_b * gunRadius - player.func_70033_W();
                        minigunFire.startZ = vec.field_72449_c * gunRadius;
                        minigunFire.endX = directionVec.field_72450_a * 20 + player.func_70681_au().nextDouble() - 0.5;
                        minigunFire.endY = directionVec.field_72448_b * 20 + player.func_70681_au().nextDouble() - 0.5;
                        minigunFire.endZ = directionVec.field_72449_c * 20 + player.func_70681_au().nextDouble() - 0.5;
                        minigunFire.render();
                    }
                    GL11.glColor4d(1, 1, 1, 1);
                    // GL11.glEnable(GL11.GL_LIGHTING);
                    GL11.glEnable(GL11.GL_TEXTURE_2D);
                    GL11.glPopMatrix();
                }
            }
        }
        GL11.glPopMatrix();
    }

    @SubscribeEvent
    public void onTextureStitch(TextureStitchEvent.Pre event){
        System.out.println("Stitching...");
        ModuleRegistrator.models = Maps.newHashMap();
        for(Class<? extends TubeModule> moduleClass : ModuleRegistrator.modules.values()) {
            try {
                TubeModule module = moduleClass.newInstance();

                OBJLoader objLoader = OBJLoader.instance;
                IModel modelDefinition = objLoader.loadModel(new ResourceLocation(Names.MOD_ID, "models/block/modules/" + module.getModelName() + ".obj"));
                awaitingBaking.put(modelDefinition, moduleClass);
                for(ResourceLocation texture : modelDefinition.getTextures()) {
                    event.map.func_174942_a(texture);
                }
            } catch(Exception e) {
                e.printStackTrace();
            }
        }
    }

    @SubscribeEvent
    public void onModelBaking(ModelBakeEvent event){
        System.out.println("Baking...");
        for(Map.Entry<IModel, Class<? extends TubeModule>> entry : awaitingBaking.entrySet()) {
            IFlexibleBakedModel model = entry.getKey().bake(entry.getKey().getDefaultState(), DefaultVertexFormats.field_176600_a, RenderUtils.TEXTURE_GETTER);
            ModuleRegistrator.models.put(entry.getValue(), model);
        }
    }
}
