package pneumaticCraft.client.gui;

import java.awt.Point;
import java.util.Arrays;
import java.util.List;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fml.client.FMLClientHandler;

import org.apache.commons.lang3.text.WordUtils;

import pneumaticCraft.client.gui.semiblock.GuiLogisticsLiquidFilter;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.client.gui.widget.WidgetFluidFilter;
import pneumaticCraft.client.gui.widget.WidgetLabel;
import pneumaticCraft.client.gui.widget.WidgetTextFieldNumber;
import pneumaticCraft.common.inventory.ContainerAmadronAddTrade;
import pneumaticCraft.common.item.ItemAmadronTablet;
import pneumaticCraft.common.item.ItemGPSTool;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketAmadronTradeAdd;
import pneumaticCraft.common.recipes.AmadronOfferCustom;
import pneumaticCraft.lib.Textures;

public class GuiAmadronAddTrade extends GuiPneumaticContainerBase{
    private GuiSearcher searchGui;
    private GuiInventorySearcher invSearchGui;
    private GuiInventorySearcher gpsSearchGui;
    private GuiLogisticsLiquidFilter fluidGui;
    private boolean isSettingInput;

    private WidgetFluidFilter inputFluid;
    private WidgetFluidFilter outputFluid;

    private WidgetTextFieldNumber inputNumber, outputNumber;
    private WidgetLabel inputNumberLabel, outputNumberLabel;
    private GuiButton addButton;

    private BlockPos inputPosition, outputPosition;

    public GuiAmadronAddTrade(){
        super(new ContainerAmadronAddTrade(), null, Textures.GUI_WIDGET_OPTIONS_STRING);
        field_146999_f = 183;
        field_147000_g = 202;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        ContainerAmadronAddTrade container = (ContainerAmadronAddTrade)field_147002_h;

        addLabel(I18n.func_135052_a("gui.amadron.addTrade.selling"), field_147003_i + 4, field_147009_r + 5);
        addLabel(I18n.func_135052_a("gui.amadron.addTrade.buying"), field_147003_i + 93, field_147009_r + 5);

        field_146292_n.add(new GuiButton(0, field_147003_i + 4, field_147009_r + 20, 85, 20, "Search item..."));
        field_146292_n.add(new GuiButton(1, field_147003_i + 4, field_147009_r + 42, 85, 20, "Search inv..."));
        field_146292_n.add(new GuiButton(2, field_147003_i + 4, field_147009_r + 64, 85, 20, "Search fluid..."));
        field_146292_n.add(new GuiButton(3, field_147003_i + 93, field_147009_r + 20, 85, 20, "Search item..."));
        field_146292_n.add(new GuiButton(4, field_147003_i + 93, field_147009_r + 42, 85, 20, "Search inv..."));
        field_146292_n.add(new GuiButton(5, field_147003_i + 93, field_147009_r + 64, 85, 20, "Search fluid..."));
        field_146292_n.add(addButton = new GuiButton(8, field_147003_i + 50, field_147009_r + 164, 85, 20, "Add Trade"));

        Fluid oldInputFluid = inputFluid != null ? inputFluid.getFluid() : null;
        Fluid oldOutputFluid = outputFluid != null ? outputFluid.getFluid() : null;
        inputFluid = new WidgetFluidFilter(-1, field_147003_i + 10, field_147009_r + 90);
        outputFluid = new WidgetFluidFilter(-1, field_147003_i + 99, field_147009_r + 90);
        inputFluid.setFluid(oldInputFluid);
        outputFluid.setFluid(oldOutputFluid);
        addWidget(inputFluid);
        addWidget(outputFluid);

        GuiButtonSpecial gpsButton1 = new GuiButtonSpecial(6, field_147003_i + 10, field_147009_r + 115, 20, 20, "");
        GuiButtonSpecial gpsButton2 = new GuiButtonSpecial(7, field_147003_i + 99, field_147009_r + 115, 20, 20, "");
        gpsButton1.setTooltipText(Arrays.asList(WordUtils.wrap(I18n.func_135052_a("gui.amadron.button.selectSellingBlock.tooltip"), 40).split(System.getProperty("line.separator"))));
        gpsButton2.setTooltipText(Arrays.asList(WordUtils.wrap(I18n.func_135052_a("gui.amadron.button.selectPaymentBlock.tooltip"), 40).split(System.getProperty("line.separator"))));
        gpsButton1.setRenderStacks(new ItemStack(Itemss.GPSTool));
        gpsButton2.setRenderStacks(new ItemStack(Itemss.GPSTool));
        addWidget(gpsButton1);
        addWidget(gpsButton2);

        inputNumber = new WidgetTextFieldNumber(field_146289_q, field_147003_i + 6, field_147009_r + 145, 40, field_146289_q.field_78288_b).setValue(inputNumber != null ? inputNumber.getValue() : 0);
        outputNumber = new WidgetTextFieldNumber(field_146289_q, field_147003_i + 95, field_147009_r + 145, 40, field_146289_q.field_78288_b).setValue(outputNumber != null ? outputNumber.getValue() : 0);
        inputNumber.setTooltip(I18n.func_135052_a("gui.amadron.addTrade.itemFluidAmount"));
        outputNumber.setTooltip(I18n.func_135052_a("gui.amadron.addTrade.itemFluidAmount"));
        addWidget(inputNumber);
        addWidget(outputNumber);

        if(searchGui != null) {
            if(isSettingInput) {
                inputFluid.setFluid(null);
                container.setStack(0, searchGui.getSearchStack());
            } else {
                outputFluid.setFluid(null);
                container.setStack(1, searchGui.getSearchStack());
            }
        }
        if(invSearchGui != null) {
            if(isSettingInput) {
                inputFluid.setFluid(null);
                container.setStack(0, invSearchGui.getSearchStack());
            } else {
                outputFluid.setFluid(null);
                container.setStack(1, invSearchGui.getSearchStack());
            }
        }
        if(fluidGui != null) {
            if(isSettingInput) {
                container.setStack(0, null);
                inputFluid.setFluid(fluidGui.getFilter());
            } else {
                container.setStack(1, null);
                outputFluid.setFluid(fluidGui.getFilter());
            }
        }
        if(gpsSearchGui != null) {
            if(isSettingInput) {
                inputPosition = gpsSearchGui.getSearchStack() != null ? ItemGPSTool.getGPSLocation(gpsSearchGui.getSearchStack()) : null;
            } else {
                outputPosition = gpsSearchGui.getSearchStack() != null ? ItemGPSTool.getGPSLocation(gpsSearchGui.getSearchStack()) : null;
            }
        }
        searchGui = null;
        fluidGui = null;
        invSearchGui = null;
        gpsSearchGui = null;

        inputNumberLabel = new WidgetLabel(field_147003_i + 52, field_147009_r + 145, container.getStack(0) != null ? "x" : inputFluid.getFluid() != null ? "mB" : "");
        outputNumberLabel = new WidgetLabel(field_147003_i + 149, field_147009_r + 145, container.getStack(1) != null ? "x" : outputFluid.getFluid() != null ? "mB" : "");
        addWidget(inputNumberLabel);
        addWidget(outputNumberLabel);
    }

    @Override
    public void func_146284_a(GuiButton button){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        ContainerAmadronAddTrade container = (ContainerAmadronAddTrade)field_147002_h;
        if(button.field_146127_k < 6 && button.field_146127_k >= 0) {
            isSettingInput = button.field_146127_k < 3;
            if(button.field_146127_k % 3 == 0) {
                searchGui = new GuiSearcher(player);
                searchGui.setSearchStack(container.getStack(isSettingInput ? 0 : 1));
                FMLClientHandler.instance().showGuiScreen(searchGui);
            } else if(button.field_146127_k % 3 == 1) {
                invSearchGui = new GuiInventorySearcher(player);
                invSearchGui.setSearchStack(container.getStack(isSettingInput ? 0 : 1));
                FMLClientHandler.instance().showGuiScreen(invSearchGui);
            } else if(button.field_146127_k % 3 == 2) {
                fluidGui = new GuiLogisticsLiquidFilter(this);
                fluidGui.setFilter(isSettingInput ? inputFluid.getFluid() : outputFluid.getFluid());
                FMLClientHandler.instance().showGuiScreen(fluidGui);
            }

        } else if(button.field_146127_k == 8) {
            Object input;
            if(container.getStack(0) != null) {
                input = container.getStack(0).func_77946_l();
                ((ItemStack)input).field_77994_a = inputNumber.getValue();
            } else {
                input = new FluidStack(inputFluid.getFluid(), inputNumber.getValue());
            }
            Object output;
            if(container.getStack(1) != null) {
                output = container.getStack(1).func_77946_l();
                ((ItemStack)output).field_77994_a = outputNumber.getValue();
            } else {
                output = new FluidStack(outputFluid.getFluid(), outputNumber.getValue());
            }
            AmadronOfferCustom trade = new AmadronOfferCustom(input, output, player);
            BlockPos pos = getInputPosition();
            int dimensionId = getInputDimension();
            trade.setProvidingPosition(pos, dimensionId);
            pos = getOutputPosition();
            dimensionId = getOutputDimension();
            trade.setReturningPosition(pos, dimensionId);
            NetworkHandler.sendToServer(new PacketAmadronTradeAdd(trade.invert()));
            player.func_71053_j();
        }
        super.func_146284_a(button);
    }

    @Override
    public void actionPerformed(IGuiWidget widget){
        if(widget.getID() == 6 || widget.getID() == 7) {
            gpsSearchGui = new GuiInventorySearcher(FMLClientHandler.instance().getClientPlayerEntity());
            isSettingInput = widget.getID() == 6;
            ItemStack gps = new ItemStack(Itemss.GPSTool);
            BlockPos pos;
            if(widget.getID() == 6) {
                pos = getInputPosition();
            } else {
                pos = getOutputPosition();
            }
            if(pos != null) ItemGPSTool.setGPSLocation(gps, pos);
            gpsSearchGui.setSearchStack(ItemGPSTool.getGPSLocation(gps) != null ? gps : null);
            FMLClientHandler.instance().showGuiScreen(gpsSearchGui);
        }
        super.actionPerformed(widget);
    }

    private BlockPos getInputPosition(){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        return inputPosition != null ? inputPosition : ((ContainerAmadronAddTrade)field_147002_h).getStack(0) != null ? ItemAmadronTablet.getItemProvidingLocation(player.func_71045_bC()) : ItemAmadronTablet.getLiquidProvidingLocation(player.func_71045_bC());
    }

    private BlockPos getOutputPosition(){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        return outputPosition != null ? outputPosition : ((ContainerAmadronAddTrade)field_147002_h).getStack(1) != null ? ItemAmadronTablet.getItemProvidingLocation(player.func_71045_bC()) : ItemAmadronTablet.getLiquidProvidingLocation(player.func_71045_bC());
    }

    private int getInputDimension(){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        return inputPosition != null ? player.field_70170_p.field_73011_w.func_177502_q() : ((ContainerAmadronAddTrade)field_147002_h).getStack(0) != null ? ItemAmadronTablet.getItemProvidingDimension(player.func_71045_bC()) : ItemAmadronTablet.getLiquidProvidingDimension(player.func_71045_bC());
    }

    private int getOutputDimension(){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        return outputPosition != null ? player.field_70170_p.field_73011_w.func_177502_q() : ((ContainerAmadronAddTrade)field_147002_h).getStack(1) != null ? ItemAmadronTablet.getItemProvidingDimension(player.func_71045_bC()) : ItemAmadronTablet.getLiquidProvidingDimension(player.func_71045_bC());
    }

    @Override
    protected Point getInvTextOffset(){
        return null;
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        ContainerAmadronAddTrade container = (ContainerAmadronAddTrade)field_147002_h;
        addButton.field_146124_l = inputNumber.getValue() > 0 && outputNumber.getValue() > 0 && (inputFluid.getFluid() != null || container.getStack(0) != null) && (outputFluid.getFluid() != null || container.getStack(1) != null) && getInputPosition() != null && getOutputPosition() != null;
    }

    @Override
    protected void addProblems(List curInfo){
        if(getInputPosition() == null || getOutputPosition() == null) {
            curInfo.add("gui.amadron.addTrade.problems.noSellingOrPayingBlock");
        }
        super.addProblems(curInfo);
    }
}
