package pneumaticCraft.client.gui;

import net.minecraft.item.ItemStack;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.common.inventory.ContainerChargingStationItemInventory;
import pneumaticCraft.common.recipes.CraftingRegistrator;
import pneumaticCraft.common.tileentity.TileEntityChargingStation;
import pneumaticCraft.lib.PneumaticValues;
import pneumaticCraft.lib.Textures;

public class GuiDrone extends GuiPneumaticInventoryItem{

    // private GuiAnimatedStat statusStat;

    public GuiDrone(ContainerChargingStationItemInventory container, TileEntityChargingStation te){
        super(container, te);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        // statusStat = new GuiAnimatedStat(this, "Helmet Status", new ItemStack(Items.pneumaticHelmet), xStart + xSize, 3, 0xFFFFAA00, pressureStat, false);
        ItemStack speedUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.SPEED);
        addAnimatedStat(speedUpgrade.func_82833_r(), speedUpgrade, 0xFF0000FF, false).setText("gui.tab.info.item.drone.speedUpgrade");
        ItemStack dispenserUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.DISPENSER);
        addAnimatedStat(dispenserUpgrade.func_82833_r(), dispenserUpgrade, 0xFF0000FF, false).setText("gui.tab.info.item.drone.dispenserUpgrade");
        ItemStack itemLifeUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.ITEM_LIFE);
        addAnimatedStat(itemLifeUpgrade.func_82833_r(), itemLifeUpgrade, 0xFF0000FF, false).setText("gui.tab.info.item.drone.itemLifeUpgrade");
        addAnimatedStat("gui.tab.info", Textures.GUI_INFO_LOCATION, 0xFF8888FF, true).setText("gui.tab.info.item.drone");
        ItemStack securityUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.SECURITY);
        addAnimatedStat(securityUpgrade.func_82833_r(), securityUpgrade, 0xFF0000FF, true).setText("gui.tab.info.item.drone.securityUpgrade");
        ItemStack volumeUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.VOLUME);
        addAnimatedStat(volumeUpgrade.func_82833_r(), volumeUpgrade, 0xFF0000FF, true).setText("gui.tab.info.item.drone.volumeUpgrade");
        ItemStack entityUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.ENTITY_TRACKER);
        addAnimatedStat(entityUpgrade.func_82833_r(), entityUpgrade, 0xFF0000FF, true).setText("gui.tab.info.item.drone.entityUpgrade");
        ItemStack rangeUpgrade = CraftingRegistrator.getUpgrade(EnumUpgrade.RANGE);
        addAnimatedStat(rangeUpgrade.func_82833_r(), rangeUpgrade, 0xFF0000FF, true).setText("gui.tab.info.item.drone.rangeUpgrade");
    }

    @Override
    protected int getDefaultVolume(){
        return PneumaticValues.DRONE_VOLUME;
    }
}
