package pneumaticCraft.client.gui;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ResourceLocation;
import pneumaticCraft.client.gui.widget.WidgetTextField;
import pneumaticCraft.client.gui.widget.WidgetTextFieldNumber;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketChangeGPSToolCoordinate;

public class GuiGPSTool extends GuiPneumaticScreenBase{

    private final WidgetTextFieldNumber[] textFields = new WidgetTextFieldNumber[3];
    private WidgetTextField variableField;
    private static final int TEXTFIELD_WIDTH = 40;
    private final BlockPos oldGPSLoc;
    private String oldVarName;
    private static final int[] BUTTON_ACTIONS = {-10, -1, 1, 10};

    public GuiGPSTool(BlockPos gpsLoc, String oldVarName){
        oldGPSLoc = gpsLoc;
        this.oldVarName = oldVarName;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();
        int[] oldText = new int[3];
        if(textFields[0] == null) {
            oldText[0] = oldGPSLoc.func_177958_n();
            oldText[1] = oldGPSLoc.func_177956_o();
            oldText[2] = oldGPSLoc.func_177952_p();
        } else {
            for(int i = 0; i < 3; i++)
                oldText[i] = textFields[i].getValue();
        }
        int xMiddle = field_146294_l / 2;
        int yMiddle = field_146295_m / 2;
        for(int i = 0; i < 3; i++) {
            textFields[i] = new WidgetTextFieldNumber(field_146289_q, xMiddle - TEXTFIELD_WIDTH / 2, yMiddle - 27 + i * 22, TEXTFIELD_WIDTH, field_146289_q.field_78288_b);
            textFields[i].setValue(oldText[i]);
            if(i == 1) {
                textFields[i].minValue = 0;
                textFields[i].maxValue = 255;
            }
            addWidget(textFields[i]);
        }

        for(int i = 0; i < 3; i++) {
            field_146292_n.add(new GuiButton(0 + i * 4, xMiddle - 49 - TEXTFIELD_WIDTH / 2, yMiddle - 32 + i * 22, 22, 20, "-10"));
            field_146292_n.add(new GuiButton(1 + i * 4, xMiddle - 25 - TEXTFIELD_WIDTH / 2, yMiddle - 32 + i * 22, 22, 20, "-1"));
            field_146292_n.add(new GuiButton(2 + i * 4, xMiddle + 3 + TEXTFIELD_WIDTH / 2, yMiddle - 32 + i * 22, 22, 20, "+1"));
            field_146292_n.add(new GuiButton(3 + i * 4, xMiddle + 27 + TEXTFIELD_WIDTH / 2, yMiddle - 32 + i * 22, 22, 20, "+10"));
        }

        if(variableField != null) oldVarName = variableField.func_146179_b();
        variableField = new WidgetTextField(field_146289_q, xMiddle - 50, yMiddle + 60, 100, field_146289_q.field_78288_b);
        variableField.func_146180_a(oldVarName);
        addWidget(variableField);

        String var = I18n.func_135052_a("gui.progWidget.coordinate.variable");
        addLabel(var, xMiddle - 62 - field_146289_q.func_78256_a(var), yMiddle + 61);
        addLabel("#", xMiddle - 60, yMiddle + 61);
    }

    @Override
    protected void func_146284_a(GuiButton button){
        textFields[button.field_146127_k / 4].setValue(textFields[button.field_146127_k / 4].getValue() + BUTTON_ACTIONS[button.field_146127_k % 4]);
    }

    @Override
    public void func_73863_a(int par1, int par2, float par3){
        func_146276_q_();
        super.func_73863_a(par1, par2, par3);

        int xMiddle = field_146294_l / 2;
        int yMiddle = field_146295_m / 2;
        int stringX = xMiddle - 60 - TEXTFIELD_WIDTH / 2;
        func_73732_a(field_146289_q, new ItemStack(Itemss.GPSTool).func_82833_r(), xMiddle, yMiddle - 44, 0xFFFFFFFF);
        func_73731_b(field_146289_q, "X:", stringX, yMiddle - 22 - field_146289_q.field_78288_b / 2, 0xFFFFFFFF);
        func_73731_b(field_146289_q, "Y:", stringX, yMiddle - field_146289_q.field_78288_b / 2, 0xFFFFFFFF);
        func_73731_b(field_146289_q, "Z:", stringX, yMiddle + 22 - field_146289_q.field_78288_b / 2, 0xFFFFFFFF);
    }

    @Override
    public void func_146281_b(){
        BlockPos newPos = new BlockPos(textFields[0].getValue(), textFields[1].getValue(), textFields[2].getValue());
        NetworkHandler.sendToServer(new PacketChangeGPSToolCoordinate(newPos.equals(oldGPSLoc) ? new BlockPos(-1, -1, -1) : newPos, variableField.func_146179_b()));
    }

    @Override
    protected ResourceLocation getTexture(){
        return null;
    }
}
