package pneumaticCraft.client.gui;

import java.io.IOException;
import java.util.List;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import pneumaticCraft.client.gui.widget.WidgetLabel;
import pneumaticCraft.client.gui.widget.WidgetTank;
import pneumaticCraft.client.gui.widget.WidgetTextFieldNumber;
import pneumaticCraft.common.inventory.ContainerKeroseneLamp;
import pneumaticCraft.common.tileentity.TileEntityKeroseneLamp;
import pneumaticCraft.lib.Textures;

public class GuiKeroseneLamp extends GuiPneumaticContainerBase<TileEntityKeroseneLamp>{
    private WidgetLabel rangeTextWidget;
    //   private WidgetLabel timeLeftWidget;
    private WidgetTextFieldNumber rangeWidget;

    public GuiKeroseneLamp(InventoryPlayer player, TileEntityKeroseneLamp te){
        super(new ContainerKeroseneLamp(player, te), te, Textures.GUI_KEROSENE_LAMP);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();
        addWidget(new WidgetTank(-1, field_147003_i + 152, field_147009_r + 15, te.getTank()));
        addWidget(rangeTextWidget = new WidgetLabel(field_147003_i + 5, field_147009_r + 38, ""));
        //  addWidget(timeLeftWidget = new WidgetLabel(guiLeft + 5, guiTop + 26, ""));
        String maxRange = I18n.func_135052_a("gui.keroseneLamp.maxRange");
        int maxRangeLength = field_146289_q.func_78256_a(maxRange);
        addLabel(maxRange, field_147003_i + 5, field_147009_r + 50);
        addLabel(I18n.func_135052_a("gui.keroseneLamp.blocks"), field_147003_i + maxRangeLength + 40, field_147009_r + 50);
        addWidget(rangeWidget = new WidgetTextFieldNumber(field_146289_q, field_147003_i + 7 + maxRangeLength, field_147009_r + 50, 30, field_146289_q.field_78288_b));
        rangeWidget.minValue = 1;
        rangeWidget.maxValue = 30;
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        if(!rangeWidget.func_146206_l()) rangeWidget.setValue(te.getTargetRange());
        rangeTextWidget.text = I18n.func_135052_a("gui.keroseneLamp.currentRange", te.getRange());

        /* if(te.getRange() > 0) {
             int ticksLeft = (int)(te.getTank().getFluidAmount() * TileEntityKeroseneLamp.FUEL_PER_MB * 5 / Math.pow(te.getRange(), 3));
             timeLeftWidget.text = I18n.format("gui.keroseneLamp.timeLeft", PneumaticCraftUtils.convertTicksToMinutesAndSeconds(ticksLeft, false));
         } else {
             timeLeftWidget.text = "";
         }*/
    }

    @Override
    public String getRedstoneButtonText(int mode){
        if(mode == 3) return "gui.tab.redstoneBehaviour.keroseneLamp.button.interpolate";
        return super.getRedstoneButtonText(mode);
    }

    @Override
    protected void func_73864_a(int par1, int par2, int par3) throws IOException{
        super.func_73864_a(par1, par2, par3);
        if(!rangeWidget.func_146206_l()) {
            sendPacketToServer(rangeWidget.getValue());
        }
    }

    @Override
    protected void addProblems(List<String> curInfo){
        super.addProblems(curInfo);
        if(te.getTank().getFluidAmount() == 0) {
            curInfo.add("gui.tab.problems.keroseneLamp.noFuel");
        } else if(te.getTank().getFluidAmount() < 30) {
            curInfo.add("gui.tab.problems.keroseneLamp.lowFuel");
        }
    }

}
