package pneumaticCraft.client.gui;

import java.awt.Point;
import java.awt.Rectangle;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.resources.I18n;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.client.gui.widget.GuiAnimatedStat;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.inventory.ContainerPressureChamberInterface;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketUpdateTextfield;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberInterface;
import pneumaticCraft.lib.Textures;

@SideOnly(Side.CLIENT)
public class GuiPressureChamberInterface extends GuiPneumaticContainerBase<TileEntityPressureChamberInterface>{
    private static final ResourceLocation guiTextureCreativeFilter = new ResourceLocation(Textures.GUI_PRESSURE_CHAMBER_INTERFACE_CREATIVE_FILTER_LOCATION);

    private GuiAnimatedStat statusStat;
    private GuiAnimatedStat filterStat;

    private GuiButtonSpecial filterButton;
    private GuiButton creativeTabButton;
    private GuiTextField nameFilterField;
    private boolean hasEnoughPressure = true;

    public GuiPressureChamberInterface(InventoryPlayer player, TileEntityPressureChamberInterface te){

        super(new ContainerPressureChamberInterface(player, te), te, Textures.GUI_PRESSURE_CHAMBER_INTERFACE_LOCATION);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        int xStart = (field_146294_l - field_146999_f) / 2;
        int yStart = (field_146295_m - field_147000_g) / 2;

        statusStat = addAnimatedStat("Interface Status", new ItemStack(Blockss.pressureChamberInterface), 0xFFFFAA00, false);
        filterStat = addAnimatedStat("Filter", new ItemStack(net.minecraft.init.Blocks.field_150438_bZ), 0xFF005500, false);
        filterStat.setTextWithoutCuttingString(getFilterText());

        Rectangle buttonRect = filterStat.getButtonScaledRectangle(5, 30, 170, 20);
        filterButton = new GuiButtonSpecial(1, buttonRect.x, buttonRect.y, buttonRect.width, buttonRect.height, "-");
        filterStat.addWidget(filterButton);

        creativeTabButton = new GuiButton(2, xStart + 91, yStart + 58, 78, 20, "-");
        nameFilterField = new GuiTextField(-1, field_146289_q, xStart + 91, yStart + 58, 78, 10);
        nameFilterField.func_146180_a(te.itemNameFilter);

        field_146292_n.add(creativeTabButton);
        if(te.filterMode != TileEntityPressureChamberInterface.EnumFilterMode.ITEM) {
            if(field_147002_h.field_75151_b.get(5).field_75223_e < 1000) {
                for(int i = 5; i < 14; i++) {
                    field_147002_h.field_75151_b.get(i).field_75223_e += 1000;
                }
            }
        } else {
            if(field_147002_h.field_75151_b.get(5).field_75223_e > 1000) {
                for(int i = 5; i < 14; i++) {
                    field_147002_h.field_75151_b.get(i).field_75223_e -= 1000;
                }
            }
        }
    }

    @Override
    protected void func_146979_b(int x, int y){

        super.func_146979_b(x, y);
        field_146289_q.func_78276_b("Item Filter", 115, 15, 4210752);
        field_146289_q.func_78276_b("Upgr.", 24, 16, 4210752);

        creativeTabButton.field_146125_m = false;
        switch(te.filterMode){
            case ITEM:
                filterButton.field_146126_j = "Items";
                nameFilterField.func_146195_b(false);
                nameFilterField.func_146189_e(false);
                break;
            case CREATIVE_TAB:
                filterButton.field_146126_j = "Creative Tab";
                field_146289_q.func_78276_b("Tab Name:", 106, 45, 4210752);
                String tabName = I18n.func_135052_a(CreativeTabs.field_78032_a[te.creativeTabID].func_78024_c());
                if(field_146289_q.func_78256_a(tabName) > 75) {
                    while(field_146289_q.func_78256_a(tabName) > 75) {
                        tabName = tabName.substring(0, tabName.length() - 2);
                    }
                    tabName = tabName + ".";
                }
                creativeTabButton.field_146126_j = tabName;
                creativeTabButton.field_146125_m = true;
                nameFilterField.func_146195_b(false);
                nameFilterField.func_146189_e(false);
                break;
            case NAME_BEGINS:
                filterButton.field_146126_j = "Item Name (begins with)";
                field_146289_q.func_78276_b("Item Name", 106, 35, 4210752);
                field_146289_q.func_78276_b("begins with:", 103, 45, 4210752);
                nameFilterField.func_146189_e(true);
                break;
            case NAME_CONTAINS:
                filterButton.field_146126_j = "Item Name (contains)";
                field_146289_q.func_78276_b("Item Name", 106, 35, 4210752);
                field_146289_q.func_78276_b("contains:", 108, 45, 4210752);
                nameFilterField.func_146189_e(true);

        }

        int inputShift = (int)((1F - (float)Math.cos((float)te.inputProgress / (float)TileEntityPressureChamberInterface.MAX_PROGRESS * Math.PI)) * 11);
        int outputShift = (int)((1F - (float)Math.cos((float)te.outputProgress / (float)TileEntityPressureChamberInterface.MAX_PROGRESS * Math.PI)) * 11);
        Gui.func_73734_a(63 + inputShift, 30, 87 + inputShift, 32, 0xFF5a62ff);
        Gui.func_73734_a(63 + outputShift, 54, 87 + outputShift, 56, 0xFFffa800);

    }

    @Override
    protected Point getInvNameOffset(){
        return new Point(0, -2);
    }

    @Override
    protected void bindGuiTexture(){
        if(te.filterMode == TileEntityPressureChamberInterface.EnumFilterMode.ITEM) {
            super.bindGuiTexture();
        } else {
            field_146297_k.func_110434_K().func_110577_a(guiTextureCreativeFilter);
        }
    }

    @Override
    protected void func_146976_a(float opacity, int x, int y){
        super.func_146976_a(opacity, x, y);
        nameFilterField.func_146194_f();
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        statusStat.setText(getStatusText());
        filterButton.field_146125_m = filterStat.isDoneExpanding();
        if(hasEnoughPressure && !te.hasEnoughPressure()) {
            hasEnoughPressure = false;
            problemTab.openWindow();
        } else if(te.hasEnoughPressure()) {
            hasEnoughPressure = true;
        }
    }

    private List<String> getStatusText(){
        List<String> text = new ArrayList<String>();
        text.add("\u00a77Interface Mode:");
        switch(te.interfaceMode.ordinal()){
            case 0:
                text.add("\u00a70None");
                break;
            case 1:
                text.add("\u00a70Import Mode");
                break;
            case 2:
                text.add("\u00a70Export Mode");
                break;
        }
        return text;
    }

    public List<String> getFilterText(){
        List<String> textList = new ArrayList<String>();
        textList.add("\u00a77Filter on                            "); // the
                                                                      // spaces
                                                                      // are there
                                                                      // to create
                                                                      // space for
                                                                      // the
                                                                      // button
        for(int i = 0; i < 3; i++)
            textList.add("");// create some space for the button
        return textList;
    }

    @Override
    protected void func_73864_a(int par1, int par2, int par3) throws IOException{
        super.func_73864_a(par1, par2, par3);

        if(te.filterMode == TileEntityPressureChamberInterface.EnumFilterMode.NAME_BEGINS || te.filterMode == TileEntityPressureChamberInterface.EnumFilterMode.NAME_CONTAINS) {
            nameFilterField.func_146192_a(par1, par2, par3);
        }
    }

    /**
     * Fired when a control is clicked. This is the equivalent of
     * ActionListener.actionPerformed(ActionEvent e).
     */

    @Override
    public void actionPerformed(IGuiWidget widget){
        if(widget.getID() == 1) {
            if(filterStat != null) {
                filterStat.closeWindow();
                if(te.filterMode == TileEntityPressureChamberInterface.EnumFilterMode.ITEM) {
                    for(int i = 5; i < 14; i++) {
                        field_147002_h.field_75151_b.get(i).field_75223_e += 1000;
                    }
                } else if(te.filterMode.ordinal() == TileEntityPressureChamberInterface.EnumFilterMode.values().length - 1) {
                    for(int i = 5; i < 14; i++) {
                        field_147002_h.field_75151_b.get(i).field_75223_e -= 1000;
                    }
                }
            }
        }
        super.actionPerformed(widget);
    }

    @Override
    protected void addProblems(List<String> curInfo){
        super.addProblems(curInfo);
        curInfo.addAll(te.getProblemStat());
    }

    @Override
    protected void func_73869_a(char par1, int par2) throws IOException{
        if(nameFilterField.func_146206_l() && par2 != 1) {
            nameFilterField.func_146201_a(par1, par2);
            te.itemNameFilter = nameFilterField.func_146179_b();
            NetworkHandler.sendToServer(new PacketUpdateTextfield(te, 0));
        } else {
            super.func_73869_a(par1, par2);
        }
    }
}
