package pneumaticCraft.client.gui;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.EnumFacing;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.gui.widget.WidgetTank;
import pneumaticCraft.client.gui.widget.WidgetTemperature;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.inventory.ContainerRefinery;
import pneumaticCraft.common.tileentity.TileEntityRefinery;
import pneumaticCraft.lib.Textures;

public class GuiRefinery extends GuiPneumaticContainerBase<TileEntityRefinery>{
    private List<TileEntityRefinery> refineries;

    public GuiRefinery(InventoryPlayer player, TileEntityRefinery te){
        super(new ContainerRefinery(player, te), te, Textures.GUI_REFINERY);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        addWidget(new WidgetTemperature(-1, field_147003_i + 32, field_147009_r + 20, 273, 673, te.getHeatExchangerLogic(null), 373));

        addWidget(new WidgetTank(-1, field_147003_i + 8, field_147009_r + 13, te.getOilTank()));

        int x = field_147003_i + 95;
        int y = field_147009_r + 17;
        addWidget(new WidgetTank(-1, x, y, te.getOutputTank()));

        refineries = new ArrayList<TileEntityRefinery>();
        refineries.add(te);
        TileEntityRefinery refinery = te;
        while(refinery.getTileCache()[EnumFacing.UP.ordinal()].getTileEntity() instanceof TileEntityRefinery) {
            refinery = (TileEntityRefinery)refinery.getTileCache()[EnumFacing.UP.ordinal()].getTileEntity();
            x += 20;
            y -= 4;
            if(refineries.size() < 4) addWidget(new WidgetTank(-1, x, y, refinery.getOutputTank()));
            refineries.add(refinery);
        }

        if(refineries.size() < 2 || refineries.size() > 4) {
            problemTab.openWindow();
        }
    }

    @Override
    protected void func_146979_b(int x, int y){
        field_146289_q.func_78276_b(I18n.func_135052_a(Blockss.refinery.func_149739_a() + ".name"), 28, 5, 4210752);
        super.func_146979_b(x, y);
    }

    @Override
    protected void func_146976_a(float f, int x, int y){
        super.func_146976_a(f, x, y);
        if(refineries.size() < 4) {
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            bindGuiTexture();
            func_73729_b(field_147003_i + 155, field_147009_r + 5, field_146999_f, 0, 16, 64);
            //drawTexturedModalRect(guiLeft + 48, guiTop + 22, xSize + 16, 0, 26, 10);
            if(refineries.size() < 3) {
                func_73729_b(field_147003_i + 135, field_147009_r + 9, field_146999_f, 0, 16, 64);
                // drawTexturedModalRect(guiLeft + 48, guiTop + 32, xSize + 42, 0, 26, 15);
            }
        }
    }

    @Override
    protected Point getInvTextOffset(){
        return new Point(20, -1);
    }

    @Override
    public void addProblems(List<String> curInfo){
        super.addProblems(curInfo);
        if(te.getHeatExchangerLogic(null).getTemperature() < 395) {
            curInfo.add("gui.tab.problems.notEnoughHeat");
        }
        if(te.getOilTank().getFluidAmount() < 10) {
            curInfo.add("gui.tab.problems.refinery.noOil");
        }
        if(refineries.size() < 2) {
            curInfo.add("gui.tab.problems.refinery.notEnoughRefineries");
        } else if(refineries.size() > 4) {
            curInfo.add("gui.tab.problems.refinery.tooManyRefineries");
        } else if(!te.refine(refineries, true)) {
            curInfo.add("gui.tab.problems.refinery.outputBlocked");
        }
    }
}
