package pneumaticCraft.client.gui;

import java.awt.Point;

import net.minecraft.item.ItemStack;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.common.inventory.ContainerRemote;
import pneumaticCraft.common.remote.ActionWidget;
import pneumaticCraft.common.remote.ActionWidgetVariable;
import pneumaticCraft.common.remote.RemoteLayout;
import pneumaticCraft.lib.Textures;

public class GuiRemote extends GuiPneumaticContainerBase{

    protected RemoteLayout remoteLayout;
    protected final ItemStack remote;

    public GuiRemote(ItemStack remote, String texture){
        super(new ContainerRemote(remote), null, texture);
        field_146999_f = 183;
        field_147000_g = 202;
        this.remote = remote;
    }

    public GuiRemote(ItemStack remote){
        this(remote, Textures.GUI_WIDGET_OPTIONS_STRING);
    }

    @Override
    public void func_73866_w_(){
        remoteLayout = null;
        super.func_73866_w_();
        if(remoteLayout == null) remoteLayout = new RemoteLayout(remote, field_147003_i, field_147009_r);
        addWidgets(remoteLayout.getWidgets(!(this instanceof GuiRemoteEditor)));
    }

    @Override
    protected Point getInvTextOffset(){
        return null;
    }

    @Override
    protected boolean shouldAddProblemTab(){
        return false;
    }

    @Override
    public void actionPerformed(IGuiWidget widget){
        for(ActionWidget actionWidget : remoteLayout.getActionWidgets()) {
            if(actionWidget.getWidget() == widget && actionWidget instanceof ActionWidgetVariable) {
                onActionPerformed((ActionWidgetVariable)actionWidget);
            }
        }
    }

    protected void onActionPerformed(ActionWidgetVariable actionWidget){
        actionWidget.onActionPerformed();
    }

    @Override
    public void onKeyTyped(IGuiWidget widget){
        super.onKeyTyped(widget);
        for(ActionWidget actionWidget : remoteLayout.getActionWidgets()) {
            if(actionWidget.getWidget() == widget && actionWidget instanceof ActionWidgetVariable) {
                onKeyTyped((ActionWidgetVariable)actionWidget);
            }
        }
    }

    protected void onKeyTyped(ActionWidgetVariable actionWidget){
        actionWidget.onKeyTyped();
    }

    @Override
    public boolean func_73868_f(){
        return false;
    }

    public void onGlobalVariableChange(String variable){
        widgets.clear();
        func_73866_w_();
        for(ActionWidget actionWidget : remoteLayout.getActionWidgets()) {
            if(actionWidget instanceof ActionWidgetVariable) {
                ((ActionWidgetVariable)actionWidget).onVariableChange();
            }
        }
    }

    /* @Override
     * TODO NEI dep
     @Optional.Method(modid = ModIds.NEI)
     public VisiblityData modifyVisiblity(GuiContainer gui, VisiblityData currentVisibility){
         currentVisibility.showNEI = false;
         return currentVisibility;
     }*/

}
