package pneumaticCraft.client.gui;

import java.awt.Rectangle;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ChatComponentTranslation;
import net.minecraftforge.fml.client.FMLClientHandler;

import org.lwjgl.input.Mouse;

import pneumaticCraft.client.gui.widget.GuiCheckBox;
import pneumaticCraft.client.gui.widget.WidgetComboBox;
import pneumaticCraft.common.item.ItemRemote;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketUpdateRemoteLayout;
import pneumaticCraft.common.remote.ActionWidget;
import pneumaticCraft.common.remote.ActionWidgetButton;
import pneumaticCraft.common.remote.ActionWidgetCheckBox;
import pneumaticCraft.common.remote.ActionWidgetDropdown;
import pneumaticCraft.common.remote.ActionWidgetLabel;
import pneumaticCraft.common.remote.ActionWidgetVariable;
import pneumaticCraft.common.remote.RemoteLayout;
import pneumaticCraft.common.remote.WidgetLabelVariable;
import pneumaticCraft.lib.Textures;

public class GuiRemoteEditor extends GuiRemote{
    private GuiInventorySearcher invSearchGui;
    private GuiPastebin pastebinGui;
    private final List<ActionWidget> visibleSpawnWidgets = new ArrayList<ActionWidget>();
    private boolean wasClicking;
    private ActionWidget draggingWidget;
    private int dragMouseStartX, dragMouseStartY;
    private int dragWidgetStartX, dragWidgetStartY;
    private int oldGuiLeft, oldGuiTop;

    public GuiRemoteEditor(ItemStack remote){
        super(remote, Textures.GUI_REMOTE_EDITOR);
        field_146999_f = 283;
    }

    @Override
    public void func_73866_w_(){
        if(pastebinGui != null && pastebinGui.outputTag != null) {
            NBTTagCompound tag = remote.func_77978_p();
            if(tag == null) {
                tag = new NBTTagCompound();
                remote.func_77982_d(tag);
            }
            tag.func_74782_a("actionWidgets", pastebinGui.outputTag.func_150295_c("main", 10));
        } else if(remoteLayout != null) {
            NBTTagCompound tag = remote.func_77978_p();
            if(tag == null) {
                tag = new NBTTagCompound();
                remote.func_77982_d(tag);
            }
            tag.func_74782_a("actionWidgets", remoteLayout.toNBT(oldGuiLeft, oldGuiTop).func_150295_c("actionWidgets", 10));
        }

        if(invSearchGui != null && invSearchGui.getSearchStack() != null && invSearchGui.getSearchStack().func_77973_b() == Itemss.remote) {
            if(ItemRemote.hasSameSecuritySettings(remote, invSearchGui.getSearchStack())) {
                remoteLayout = new RemoteLayout(invSearchGui.getSearchStack(), field_147003_i, field_147009_r);
            } else {
                field_146297_k.field_71439_g.func_146105_b(new ChatComponentTranslation("gui.remote.differentSecuritySettings"));
            }
        }
        super.func_73866_w_();
        oldGuiLeft = field_147003_i;
        oldGuiTop = field_147009_r;
        visibleSpawnWidgets.clear();
        visibleSpawnWidgets.add(new ActionWidgetCheckBox(new GuiCheckBox(-1, field_147003_i + 200, field_147009_r + 10, 0xFF000000, I18n.func_135052_a("remote.checkbox.name"))));
        visibleSpawnWidgets.add(new ActionWidgetLabel(new WidgetLabelVariable(field_147003_i + 200, field_147009_r + 25, I18n.func_135052_a("remote.label.name"))));
        visibleSpawnWidgets.add(new ActionWidgetButton(new GuiButtonSpecial(-1, field_147003_i + 200, field_147009_r + 40, 50, 20, I18n.func_135052_a("remote.button.name"))));
        visibleSpawnWidgets.add(new ActionWidgetDropdown(new WidgetComboBox(field_146289_q, field_147003_i + 200, field_147009_r + 70, 70, field_146289_q.field_78288_b + 1).setFixedOptions()));

        for(ActionWidget actionWidget : visibleSpawnWidgets) {
            addWidget(actionWidget.getWidget());
        }

        GuiButtonSpecial importRemoteButton = new GuiButtonSpecial(0, field_147003_i - 24, field_147009_r + 20, 20, 20, "");
        importRemoteButton.setTooltipText(I18n.func_135052_a("gui.remote.button.importRemoteButton"));
        importRemoteButton.setRenderStacks(new ItemStack(Itemss.remote));
        field_146292_n.add(importRemoteButton);

        GuiButtonSpecial pastebinButton = new GuiButtonSpecial(1, field_147003_i - 24, field_147009_r + 44, 20, 20, "");
        pastebinButton.setTooltipText(I18n.func_135052_a("gui.remote.button.pastebinButton"));
        //pastebinButton.setRenderStacks(new ItemStack(Itemss.advancedPCB));
        pastebinButton.setRenderedIcon(Textures.GUI_PASTEBIN_ICON_LOCATION);
        field_146292_n.add(pastebinButton);

    }

    @Override
    public void func_146284_a(GuiButton button){
        if(button.field_146127_k == 0) {
            invSearchGui = new GuiInventorySearcher(FMLClientHandler.instance().getClient().field_71439_g);
            FMLClientHandler.instance().showGuiScreen(invSearchGui);
        } else if(button.field_146127_k == 1) {
            NBTTagCompound mainTag = new NBTTagCompound();
            mainTag.func_74782_a("main", remote.func_77978_p() != null ? remote.func_77978_p().func_150295_c("actionWidgets", 10) : new NBTTagCompound());
            FMLClientHandler.instance().showGuiScreen(pastebinGui = new GuiPastebin(this, mainTag));
        }
    }

    @Override
    protected boolean shouldDrawBackground(){
        return false;
    }

    @Override
    protected void func_146976_a(float partialTicks, int x, int y){
        bindGuiTexture();
        Gui.func_146110_a(field_147003_i, field_147009_r, 0, 0, field_146999_f, field_147000_g, 320, 256);
        super.func_146976_a(partialTicks, x, y);

        x += field_147003_i;
        y += field_147009_r;

        boolean isLeftClicking = Mouse.isButtonDown(0);
        boolean isMiddleClicking = Mouse.isButtonDown(2);

        if(draggingWidget != null) {
            draggingWidget.setWidgetPos(x - dragMouseStartX + dragWidgetStartX - field_147003_i, y - dragMouseStartY + dragWidgetStartY - field_147009_r);
        }

        if(isLeftClicking && !wasClicking) {
            for(ActionWidget widget : visibleSpawnWidgets) {
                Rectangle bounds = widget.getWidget().getBounds();
                if(x >= bounds.x + field_147003_i && y >= bounds.y + field_147009_r && x <= bounds.x + field_147003_i + bounds.width && y <= bounds.y + field_147009_r + bounds.height) {
                    draggingWidget = widget.copy();
                    remoteLayout.addWidget(draggingWidget);
                    addWidget(draggingWidget.getWidget());
                    dragMouseStartX = x - field_147003_i;
                    dragMouseStartY = y - field_147009_r;
                    dragWidgetStartX = bounds.x;
                    dragWidgetStartY = bounds.y;
                    break;
                }
            }
            if(draggingWidget == null) {
                for(ActionWidget widget : remoteLayout.getActionWidgets()) {
                    Rectangle bounds = widget.getWidget().getBounds();
                    if(x >= bounds.x + field_147003_i && y >= bounds.y + field_147009_r && x <= bounds.x + field_147003_i + bounds.width && y <= bounds.y + field_147009_r + bounds.height) {
                        draggingWidget = widget;
                        dragMouseStartX = x - field_147003_i;
                        dragMouseStartY = y - field_147009_r;
                        dragWidgetStartX = bounds.x;
                        dragWidgetStartY = bounds.y;
                        break;
                    }
                }
            }
        } else if(isMiddleClicking && !wasClicking) {
            for(ActionWidget widget : remoteLayout.getActionWidgets()) {
                Rectangle bounds = widget.getWidget().getBounds();
                if(x >= bounds.x + field_147003_i && y >= bounds.y + field_147009_r && x <= bounds.x + field_147003_i + bounds.width && y <= bounds.y + field_147009_r + bounds.height) {
                    draggingWidget = widget.copy();
                    remoteLayout.addWidget(draggingWidget);
                    addWidget(draggingWidget.getWidget());
                    dragMouseStartX = 0;
                    dragMouseStartY = 0;
                    dragWidgetStartX = bounds.x - (x - field_147003_i);
                    dragWidgetStartY = bounds.y - (y - field_147009_r);
                    break;
                }
            }
        }

        if(!isLeftClicking && !isMiddleClicking && draggingWidget != null) {
            if(isOutsideProgrammingArea(draggingWidget)) {
                remoteLayout.getActionWidgets().remove(draggingWidget);
                removeWidget(draggingWidget.getWidget());
            }
            draggingWidget = null;
        }
        wasClicking = isLeftClicking || isMiddleClicking;
    }

    private boolean isOutsideProgrammingArea(ActionWidget widget){
        Rectangle bounds = widget.getWidget().getBounds();
        return !new Rectangle(field_147003_i, field_147009_r, 183, field_147000_g).contains(bounds);
    }

    @Override
    protected void func_73864_a(int x, int y, int par3) throws IOException{
        super.func_73864_a(x, y, par3);

        if(par3 == 1) {
            for(ActionWidget widget : remoteLayout.getActionWidgets()) {
                if(!isOutsideProgrammingArea(widget)) {
                    Rectangle bounds = widget.getWidget().getBounds();
                    if(x >= bounds.x && y >= bounds.y && x <= bounds.x + bounds.width && y <= bounds.y + bounds.height) {
                        GuiScreen screen = widget.getGui(this);
                        if(screen != null) field_146297_k.func_147108_a(screen);
                    }
                }
            }
        }
    }

    @Override
    protected void onActionPerformed(ActionWidgetVariable actionWidget){
        actionWidget.onVariableChange();
    }

    @Override
    public void onGlobalVariableChange(String variable){}

    @Override
    public void func_146281_b(){
        super.func_146281_b();
        NetworkHandler.sendToServer(new PacketUpdateRemoteLayout(remoteLayout.toNBT(field_147003_i, field_147009_r)));
    }
}
