package pneumaticCraft.client.gui;

import java.io.IOException;
import java.util.Iterator;

import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.renderer.InventoryEffectRenderer;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.inventory.InventoryBasic;
import net.minecraft.inventory.Slot;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.gui.pneumaticHelmet.GuiHelmetMainScreen;
import pneumaticCraft.common.inventory.ContainerSearcher;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.lib.Textures;

@SideOnly(Side.CLIENT)
public class GuiSearcher extends InventoryEffectRenderer{
    private static final ResourceLocation guiTexture = new ResourceLocation(Textures.GUI_ITEM_SEARCHER_LOCATION);
    private static final ResourceLocation scrollTexture = new ResourceLocation("textures/gui/container/creative_inventory/tabs.png");
    private final InventoryBasic inventory = new InventoryBasic("tmp", true, 49);
    private final GuiScreen parentScreen;

    /** Amount scrolled in Creative mode inventory (0 = top, 1 = bottom) */
    private float currentScroll;

    /** True if the scrollbar is being dragged */
    private boolean isScrolling;

    /**
     * True if the left mouse button was held down last time drawScreen was called.
     */
    private boolean wasClicking;
    private GuiTextField searchField;
    private boolean firstRun = true;

    /**
     * Used to back up the ContainerSearcher's inventory slots before filling it with the player's inventory slots for
     * the inventory tab.
     */
    //private List backupContainerSlots;
    private boolean field_74234_w;

    public GuiSearcher(EntityPlayer par1EntityPlayer){
        super(new ContainerSearcher());
        par1EntityPlayer.field_71070_bA = field_147002_h;
        field_146291_p = true;
        field_147000_g = 176;
        parentScreen = FMLClientHandler.instance().getClient().field_71462_r;
        ((ContainerSearcher)field_147002_h).init(this);
    }

    public ItemStack getSearchStack(){
        return inventory.func_70301_a(48);
    }

    public void setSearchStack(ItemStack stack){
        inventory.func_70299_a(48, stack);
    }

    @Override
    protected void func_146984_a(Slot par1Slot, int par2, int par3, int par4){
        if(par1Slot != null) {
            if(par1Slot.field_75222_d == 48) {
                par1Slot.func_75215_d(null);
            } else {
                inventory.func_70299_a(48, par1Slot.func_75211_c());
            }
        }
    }

    /**
     * Adds the buttons (and other controls) to the screen in question.
     */
    @Override
    public void func_73866_w_(){
        super.func_73866_w_();
        field_146292_n.clear();
        Keyboard.enableRepeatEvents(true);
        searchField = new GuiTextField(-1, field_146289_q, field_147003_i + 20, field_147009_r + 36, 89, field_146289_q.field_78288_b);
        searchField.func_146203_f(15);
        searchField.func_146185_a(true);
        searchField.func_146189_e(true);
        searchField.func_146195_b(true);
        searchField.func_146193_g(16777215);

        updateCreativeSearch();
    }

    /**
     * Called when the screen is unloaded. Used to disable keyboard repeat events
     */
    @Override
    public void func_146281_b(){
        super.func_146281_b();
        Keyboard.enableRepeatEvents(false);
    }

    @Override
    public void func_73876_c(){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        if(parentScreen instanceof GuiHelmetMainScreen) {
            if(player.func_82169_q(3) == null || player.func_82169_q(3).func_77973_b() != Itemss.pneumaticHelmet) {
                field_146297_k.func_147108_a(parentScreen);
                func_146281_b();
            }
        }
    }

    /**
     * Fired when a key is typed. This is the equivalent of KeyListener.keyTyped(KeyEvent e).
     */
    @Override
    protected void func_73869_a(char par1, int par2) throws IOException{
        if(field_74234_w) {
            field_74234_w = false;
            searchField.func_146180_a("");
        }

        if(par2 == 1)//esc
        {
            field_146297_k.func_147108_a(parentScreen);
            func_146281_b();
        } else {
            if(searchField.func_146201_a(par1, par2)) {
                updateCreativeSearch();
            } else {
                super.func_73869_a(par1, par2);
            }
        }
    }

    private void updateCreativeSearch(){
        ContainerSearcher containerSearcher = (ContainerSearcher)field_147002_h;
        containerSearcher.itemList.clear();

        Iterator iterator = Item.field_150901_e.iterator();

        while(iterator.hasNext()) {
            Item item = (Item)iterator.next();

            if(item != null && item.func_77640_w() != null) {
                item.func_150895_a(item, (CreativeTabs)null, containerSearcher.itemList);
            }
        }

        for(Enchantment enchantment : Enchantment.field_77331_b) {
            if(enchantment != null && enchantment.field_77351_y != null) {
                Items.field_151134_bR.func_92113_a(enchantment, containerSearcher.itemList);
            }
        }

        iterator = containerSearcher.itemList.iterator();
        String s = searchField.func_146179_b().toLowerCase();

        while(iterator.hasNext()) {
            ItemStack itemstack = (ItemStack)iterator.next();
            boolean flag = false;
            Iterator iterator1 = itemstack.func_82840_a(field_146297_k.field_71439_g, field_146297_k.field_71474_y.field_82882_x).iterator();

            while(true) {
                if(iterator1.hasNext()) {
                    String s1 = (String)iterator1.next();

                    if(!s1.toLowerCase().contains(s)) {
                        continue;
                    }

                    flag = true;
                }

                if(!flag) {
                    iterator.remove();
                }

                break;
            }
        }

        currentScroll = 0.0F;
        containerSearcher.scrollTo(0.0F);
    }

    /**
     * Draw the foreground layer for the GuiContainer (everything in front of the items)
     */
    @Override
    protected void func_146979_b(int par1, int par2){
        field_146289_q.func_78276_b("Item Searcher", 23, 5, 4210752);
        field_146289_q.func_78276_b("Search Box", 23, 25, 4210752);
        field_146289_q.func_78276_b("Target", 113, 10, 4210752);
    }

    /**
     * returns (if you are not on the inventoryTab) and (the flag isn't set) and( you have more than 1 page of items)
     */
    private boolean needsScrollBars(){
        return ((ContainerSearcher)field_147002_h).hasMoreThan1PageOfItemsInList();
    }

    /*
    private void setCurrentCreativeTab(CreativeTabs par1CreativeTabs){
        if(par1CreativeTabs == null) {
            return;
        }

        int i = selectedTabIndex;
        selectedTabIndex = par1CreativeTabs.getTabIndex();
        ContainerSearcher ContainerSearcher = (ContainerSearcher)inventorySlots;
        field_94077_p.clear();
        ContainerSearcher.itemList.clear();
        par1CreativeTabs.displayAllReleventItems(ContainerSearcher.itemList);

        if(par1CreativeTabs == CreativeTabs.tabInventory) {
            Container container = mc.thePlayer.inventoryContainer;

            if(backupContainerSlots == null) {
                backupContainerSlots = ContainerSearcher.inventorySlots;
            }

            ContainerSearcher.inventorySlots = new ArrayList();

            for(int j = 0; j < container.inventorySlots.size(); ++j) {
                SlotCreativeInventory slotcreativeinventory = new SlotCreativeInventory(this, (Slot)container.inventorySlots.get(j), j);
                ContainerSearcher.inventorySlots.add(slotcreativeinventory);
                int k;
                int l;
                int i1;

                if(j >= 5 && j < 9) {
                    k = j - 5;
                    l = k / 2;
                    i1 = k % 2;
                    slotcreativeinventory.xDisplayPosition = 9 + l * 54;
                    slotcreativeinventory.yDisplayPosition = 6 + i1 * 27;
                } else if(j >= 0 && j < 5) {
                    slotcreativeinventory.yDisplayPosition = -2000;
                    slotcreativeinventory.xDisplayPosition = -2000;
                } else if(j < container.inventorySlots.size()) {
                    k = j - 9;
                    l = k % 9;
                    i1 = k / 9;
                    slotcreativeinventory.xDisplayPosition = 9 + l * 18;

                    if(j >= 36) {
                        slotcreativeinventory.yDisplayPosition = 112;
                    } else {
                        slotcreativeinventory.yDisplayPosition = 54 + i1 * 18;
                    }
                }
            }

            field_74235_v = new Slot(inventory, 0, 173, 112);
            ContainerSearcher.inventorySlots.add(field_74235_v);
        } else if(i == CreativeTabs.tabInventory.getTabIndex()) {
            ContainerSearcher.inventorySlots = backupContainerSlots;
            backupContainerSlots = null;
        }

        if(searchField != null) {
            if(par1CreativeTabs == CreativeTabs.tabAllSearch) {
                searchField.setVisible(true);
                searchField.setCanLoseFocus(false);
                searchField.setFocused(true);
                searchField.setText("");
                updateCreativeSearch();
            } else {
                searchField.setVisible(false);
                searchField.setCanLoseFocus(true);
                searchField.setFocused(false);
            }
        }

        currentScroll = 0.0F;
        ContainerSearcher.scrollTo(0.0F);
    }
    */
    /**
     * Handles mouse input.
     */
    @Override
    public void func_146274_d() throws IOException{
        super.func_146274_d();
        int i = Mouse.getEventDWheel();

        if(i != 0 && needsScrollBars()) {
            int j = ((ContainerSearcher)field_147002_h).itemList.size() / 9 - 5 + 1;

            if(i > 0) {
                i = 1;
            }

            if(i < 0) {
                i = -1;
            }

            currentScroll = (float)(currentScroll - (double)i / (double)j);

            if(currentScroll < 0.0F) {
                currentScroll = 0.0F;
            }

            if(currentScroll > 1.0F) {
                currentScroll = 1.0F;
            }

            ((ContainerSearcher)field_147002_h).scrollTo(currentScroll);
        }
    }

    /**
     * Draws the screen and all the components in it.
     */
    @Override
    public void func_73863_a(int par1, int par2, float par3){
        boolean flag = Mouse.isButtonDown(0);
        int k = field_147003_i;
        int l = field_147009_r;
        int i1 = k + 156;
        int j1 = l + 48;
        int k1 = i1 + 14;
        int l1 = j1 + 112;
        if(!wasClicking && flag && par1 >= i1 && par2 >= j1 && par1 < k1 && par2 < l1) {
            isScrolling = needsScrollBars();
        }

        if(!flag) {
            isScrolling = false;
        }

        wasClicking = flag;

        if(isScrolling) {
            currentScroll = (par2 - j1 - 7.5F) / (l1 - j1 - 15.0F);

            if(currentScroll < 0.0F) {
                currentScroll = 0.0F;
            }

            if(currentScroll > 1.0F) {
                currentScroll = 1.0F;
            }

            ((ContainerSearcher)field_147002_h).scrollTo(currentScroll);
        }
        if(firstRun) {
            firstRun = false;
            ((ContainerSearcher)field_147002_h).scrollTo(0);
        }

        super.func_73863_a(par1, par2, par3);

        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        GL11.glDisable(GL11.GL_LIGHTING);
    }

    /**
     * Draw the background layer for the GuiContainer (everything behind the items)
     */
    @Override
    protected void func_146976_a(float par1, int par2, int par3){
        field_146297_k.func_110434_K().func_110577_a(guiTexture);
        int xStart = (field_146294_l - field_146999_f) / 2;
        int yStart = (field_146295_m - field_147000_g) / 2;
        func_73729_b(xStart, yStart, 0, 0, field_146999_f, field_147000_g);
        searchField.func_146194_f();

        int i1 = field_147003_i + 156;
        int k = field_147009_r + 48;
        int l = k + 112;
        field_146297_k.func_110434_K().func_110577_a(scrollTexture);
        func_73729_b(i1, k + (int)((l - k - 17) * currentScroll), 232 + (needsScrollBars() ? 0 : 12), 0, 12, 15);

    }

    /**
     * Returns the creative inventory
     */
    public InventoryBasic getInventory(){
        return inventory;
    }
}
