package pneumaticCraft.client.gui;

import java.awt.Point;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumChatFormatting;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.ClientTickHandler;
import pneumaticCraft.client.gui.widget.GuiAnimatedStat;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.inventory.ContainerSecurityStationHacking;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketSecurityStationFailedHack;
import pneumaticCraft.common.network.PacketUseItem;
import pneumaticCraft.common.tileentity.TileEntitySecurityStation;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.Textures;

@SideOnly(Side.CLIENT)
public class GuiSecurityStationHacking extends GuiSecurityStationBase{
    private GuiAnimatedStat statusStat;

    private NetworkConnectionBackground playerBackgroundBridges;
    private NetworkConnectionBackground aiBackgroundBridges;
    private NetworkConnectionPlayerHandler hackerBridges;
    private NetworkConnectionAIHandler aiBridges;

    private int stopWorms = 0;
    private int nukeViruses = 0;

    private final ItemStack stopWorm = new ItemStack(Itemss.stopWorm);
    private final ItemStack nukeVirus = new ItemStack(Itemss.nukeVirus);

    public GuiSecurityStationHacking(InventoryPlayer player, TileEntitySecurityStation te){

        super(new ContainerSecurityStationHacking(player, te), te, Textures.GUI_HACKING);
        field_147000_g = 238;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        int xStart = (field_146294_l - field_146999_f) / 2;
        int yStart = (field_146295_m - field_147000_g) / 2;

        statusStat = addAnimatedStat("Security Status", new ItemStack(Blockss.securityStation), 0xFFFFAA00, false);
        addAnimatedStat("gui.tab.info", Textures.GUI_INFO_LOCATION, 0xFF8888FF, true).setText("gui.tab.info.tile.securityStation.hacking");
        addAnimatedStat("gui.tab.upgrades", Textures.GUI_UPGRADES_LOCATION, 0xFF0000FF, true).setText("gui.tab.upgrades.tile.securityStation.hacking");
        addAnimatedStat(Itemss.nukeVirus.func_77658_a() + ".name", new ItemStack(Itemss.nukeVirus), 0xFF18c9e8, false).setText("gui.tab.info.tile.securityStation.nukeVirus");
        addAnimatedStat(Itemss.stopWorm.func_77658_a() + ".name", new ItemStack(Itemss.stopWorm), 0xFFc13232, false).setText("gui.tab.info.tile.securityStation.stopWorm");

        if(playerBackgroundBridges == null) {
            playerBackgroundBridges = new NetworkConnectionBackground(this, te, xStart + 21, yStart + 26, 31, 0xAA4444FF);
            aiBackgroundBridges = new NetworkConnectionBackground(this, te, xStart + 23, yStart + 27, 31, 0xAA4444FF);
            hackerBridges = new NetworkConnectionPlayerHandler(this, te, xStart + 21, yStart + 26, 31, 0xFF00FF00);
            aiBridges = new NetworkConnectionAIHandler(this, te, xStart + 23, yStart + 27, 31, 0xFFFF0000);
        } else {
            playerBackgroundBridges = new NetworkConnectionBackground(playerBackgroundBridges, xStart + 21, yStart + 26);
            aiBackgroundBridges = new NetworkConnectionBackground(aiBackgroundBridges, xStart + 23, yStart + 27);
            hackerBridges = new NetworkConnectionPlayerHandler(hackerBridges, xStart + 21, yStart + 26);
            aiBridges = new NetworkConnectionAIHandler(aiBridges, xStart + 23, yStart + 27);
        }
    }

    @Override
    protected boolean shouldAddInfoTab(){
        return false;
    }

    @Override
    protected boolean shouldAddUpgradeTab(){
        return false;
    }

    @Override
    protected boolean shouldAddRedstoneTab(){
        return false;
    }

    @Override
    protected Point getInvNameOffset(){
        return null;
    }

    @Override
    protected Point getInvTextOffset(){
        return null;
    }

    @Override
    protected void func_146979_b(int x, int y){
        super.func_146979_b(x, y);
        field_146289_q.func_78276_b((aiBridges.isTracing() ? EnumChatFormatting.RED : EnumChatFormatting.GREEN) + "Tracing: " + PneumaticCraftUtils.convertTicksToMinutesAndSeconds(aiBridges.getRemainingTraceTime(), true), 15, 7, 4210752);
        renderConsumables(x, y);
    }

    private void renderConsumables(int x, int y){
        stopWorms = 0;
        nukeViruses = 0;
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        for(ItemStack stack : player.field_71071_by.field_70462_a) {
            if(stack != null) {
                if(stack.func_77973_b() == Itemss.stopWorm) stopWorms += stack.field_77994_a;
                if(stack.func_77973_b() == Itemss.nukeVirus) nukeViruses += stack.field_77994_a;
            }
        }
        GuiUtils.drawItemStack(nukeVirus, 155, 30);
        GuiUtils.drawItemStack(stopWorm, 155, 55);
        field_146289_q.func_78276_b(PneumaticCraftUtils.convertAmountToString(nukeViruses), 155, 45, 0xFFFFFFFF);
        field_146289_q.func_78276_b(PneumaticCraftUtils.convertAmountToString(stopWorms), 155, 70, 0xFFFFFFFF);

    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        statusStat.setText(getStatusText());
    }

    @Override
    protected void func_146976_a(float opacity, int x, int y){
        super.func_146976_a(opacity, x, y);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);

        playerBackgroundBridges.render();
        aiBackgroundBridges.render();
        hackerBridges.render();
        aiBridges.render();

        if(x >= field_147003_i + 155 && x <= field_147003_i + 171 && y >= field_147009_r + 30 && y <= field_147009_r + 50) {
            List<String> text = new ArrayList<String>();
            text.add("Nuke Virus");
            if(hasNukeViruses()) {
                text.add(EnumChatFormatting.GRAY + "Middle-click a hackable node to use.");
            } else {
                text.add(EnumChatFormatting.RED + "You don't have any Nuke Viruses.");
            }
            drawHoveringString(text, x, y, field_146289_q);
        }
        if(x >= field_147003_i + 155 && x <= field_147003_i + 171 && y >= field_147009_r + 55 && y <= field_147009_r + 75) {
            List<String> text = new ArrayList<String>();
            text.add("STOP! Worm");
            if(stopWorms > 0) {
                if(aiBridges.isTracing()) {
                    text.add(EnumChatFormatting.GRAY + "Left-click to use.");
                } else {
                    text.add(EnumChatFormatting.GRAY + "STOP! Worms can only be used when being traced.");
                }
            } else {
                text.add(EnumChatFormatting.RED + "You don't have any STOP! Worms.");
            }
            drawHoveringString(text, x, y, field_146289_q);
        }
    }

    @Override
    protected void addProblems(List<String> text){
        super.addProblems(text);
        if(aiBridges.isTracing()) {
            text.add(EnumChatFormatting.GRAY + "Intrusion detected!");
            text.add(EnumChatFormatting.BLACK + "Time till trace: " + PneumaticCraftUtils.convertTicksToMinutesAndSeconds(aiBridges.getRemainingTraceTime(), false));
        }
    }

    private List<String> getStatusText(){
        List<String> text = new ArrayList<String>();
        text.add(EnumChatFormatting.GRAY + "Security Level");
        text.add(EnumChatFormatting.BLACK + "Level " + te.getSecurityLevel());
        text.add(EnumChatFormatting.GRAY + "Security Range");
        text.add(EnumChatFormatting.BLACK.toString() + te.getSecurityRange() + "m (square)");
        return text;
    }

    @Override
    protected void func_73864_a(int par1, int par2, int par3) throws IOException{
        if(par3 != 2) super.func_73864_a(par1, par2, par3);
        hackerBridges.mouseClicked(par1, par2, par3, getSlotAtPosition(par1, par2));
        if(aiBridges.isTracing() && par1 >= field_147003_i + 155 && par1 <= field_147003_i + 171 && par2 >= field_147009_r + 55 && par2 <= field_147009_r + 75) {
            EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
            NetworkHandler.sendToServer(new PacketUseItem(Itemss.stopWorm, 1));
            player.field_71071_by.func_146026_a(Itemss.stopWorm);
            aiBridges.applyStopWorm();
        }
    }

    /* @Override
     protected void drawItemStackTooltip(ItemStack par1ItemStack, int par2, int par3){
         List list = par1ItemStack.getTooltip(mc.thePlayer, mc.gameSettings.advancedItemTooltips);

         for(int k = 0; k < list.size(); ++k) {
             if(k == 0) {
                 list.set(k, "\u00a7" + Integer.toHexString(par1ItemStack.getRarity().rarityColor) + (String)list.get(k));
             } else {
                 list.set(k, EnumChatFormatting.GRAY + (String)list.get(k));
             }
         }

         handleItemTooltip(par1ItemStack, par2, par3, list);
         func_102021_a(list, par2, par3);
     }*/
    //TODO fix for without NEI
    public List<String> handleItemTooltip(ItemStack stack, int mousex, int mousey, List<String> currenttip){
        if(stack != null) {
            Slot slot = getSlotAtPosition(mousex, mousey);
            if(slot != null) {
                if(hackerBridges.slotHacked[slot.field_75222_d]) {
                    if(!hackerBridges.slotFortified[slot.field_75222_d]) {
                        currenttip.add(EnumChatFormatting.RED + "DETECTION: " + te.getDetectionChance() + "%");
                        currenttip.add(EnumChatFormatting.YELLOW + "Right-click to fortify");
                    }
                } else if(hackerBridges.canHackSlot(slot.field_75222_d)) {
                    currenttip.add(EnumChatFormatting.RED + "DETECTION: " + te.getDetectionChance() + "%");
                    currenttip.add(EnumChatFormatting.GREEN + "Left-click to hack");

                }
            }
        }
        return currenttip;
    }

    public boolean hasNukeViruses(){
        return nukeViruses > 0;
    }

    public void onSlotHack(int slot){
        if(Math.random() < te.getDetectionChance() / 100D) {
            aiBridges.setTracing(true);
        }
    }

    public void onSlotFortification(int slot){
        aiBridges.slotFortified[slot] = true;
        if(Math.random() < te.getDetectionChance() / 100D) {
            aiBridges.setTracing(true);
        }
    }

    @Override
    public void func_146281_b(){
        if(aiBridges.isTracing() && !hackerBridges.hackedSuccessfully) NetworkHandler.sendToServer(new PacketSecurityStationFailedHack(te.func_174877_v()));
        removeUpdatesOnConnectionHandlers();
        super.func_146281_b();
    }

    public void removeUpdatesOnConnectionHandlers(){
        ClientTickHandler.instance().removeUpdatedObject(hackerBridges);
        ClientTickHandler.instance().removeUpdatedObject(aiBridges);
    }

}
