package pneumaticCraft.client.gui;

import java.awt.Point;
import java.util.List;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.gui.widget.WidgetTank;
import pneumaticCraft.client.gui.widget.WidgetTemperature;
import pneumaticCraft.common.inventory.ContainerThermopneumaticProcessingPlant;
import pneumaticCraft.common.tileentity.TileEntityThermopneumaticProcessingPlant;
import pneumaticCraft.lib.Textures;

public class GuiThermopneumaticProcessingPlant extends
        GuiPneumaticContainerBase<TileEntityThermopneumaticProcessingPlant>{

    private WidgetTemperature tempWidget;

    public GuiThermopneumaticProcessingPlant(InventoryPlayer player, TileEntityThermopneumaticProcessingPlant te){
        super(new ContainerThermopneumaticProcessingPlant(player, te), te, Textures.GUI_THERMOPNEUMATIC_PROCESSING_PLANT);
        field_147000_g = 197;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();
        addWidget(new WidgetTank(-1, field_147003_i + 13, field_147009_r + 15, te.getInputTank()));
        addWidget(new WidgetTank(-1, field_147003_i + 79, field_147009_r + 15, te.getOutputTank()));
        addWidget(tempWidget = new WidgetTemperature(-1, field_147003_i + 98, field_147009_r + 15, 273, 673, te.getHeatExchangerLogic(null), (int)te.requiredTemperature));
    }

    @Override
    public void func_73876_c(){
        tempWidget.setScales((int)te.requiredTemperature);
        super.func_73876_c();
    }

    @Override
    protected void func_146976_a(float partialTicks, int x, int y){
        super.func_146976_a(partialTicks, x, y);
        //48 22
        double progress = te.getCraftingPercentage();
        int progressWidth = (int)(progress * 48);
        bindGuiTexture();
        func_73729_b(field_147003_i + 30, field_147009_r + 31, field_146999_f, 0, progressWidth, 22);
    }

    @Override
    protected void func_146979_b(int x, int y){
        field_146289_q.func_78276_b(I18n.func_135052_a("gui.tab.upgrades"), 91, 83, 4210752);
        String containerName = te.func_145818_k_() ? te.getName() : StatCollector.func_74838_a(te.getName() + ".name");
        GL11.glPushMatrix();
        GL11.glScaled(0.97, 0.97, 1);
        field_146289_q.func_78276_b(containerName, field_146999_f / 2 - field_146289_q.func_78256_a(containerName) / 2 + 1, 5, 4210752);
        GL11.glPopMatrix();
        super.func_146979_b(x, y);

    }

    @Override
    protected Point getInvNameOffset(){
        return null;
    }

    @Override
    protected Point getGaugeLocation(){
        int xStart = (field_146294_l - field_146999_f) / 2;
        int yStart = (field_146295_m - field_147000_g) / 2;
        return new Point(xStart + field_146999_f * 3 / 4 + 10, yStart + field_147000_g * 1 / 4);
    }

    @Override
    public void addProblems(List<String> curInfo){
        super.addProblems(curInfo);

        if(!te.hasRecipe) {
            curInfo.add("gui.tab.problems.thermopneumaticProcessingPlant.noSufficientIngredients");
        } else if(te.getHeatExchangerLogic(null).getTemperature() < te.requiredTemperature) {
            curInfo.add("gui.tab.problems.notEnoughHeat");
        }
    }

}
