package pneumaticCraft.client.gui;

import java.awt.Point;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumChatFormatting;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.api.universalSensor.ISensorSetting;
import pneumaticCraft.client.gui.widget.GuiAnimatedStat;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.inventory.ContainerUniversalSensor;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketUpdateTextfield;
import pneumaticCraft.common.sensor.SensorHandler;
import pneumaticCraft.common.tileentity.TileEntityUniversalSensor;
import pneumaticCraft.lib.PneumaticValues;
import pneumaticCraft.lib.Textures;

@SideOnly(Side.CLIENT)
public class GuiUniversalSensor extends GuiPneumaticContainerBase<TileEntityUniversalSensor>{
    private GuiAnimatedStat sensorInfoStat;
    private GuiTextField nameFilterField;
    private int page;
    private int maxPage;
    private static final int MAX_SENSORS_PER_PAGE = 4;
    private int ticksExisted;

    public GuiUniversalSensor(InventoryPlayer player, TileEntityUniversalSensor te){
        super(new ContainerUniversalSensor(player, te), te, Textures.GUI_UNIVERSAL_SENSOR);
        field_147000_g = 239;

    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        int xStart = (field_146294_l - field_146999_f) / 2;
        int yStart = (field_146295_m - field_147000_g) / 2;

        sensorInfoStat = addAnimatedStat("Sensor Info", new ItemStack(Blockss.universalSensor), 0xFFFFAA00, false);
        addAnimatedStat("gui.tab.upgrades", Textures.GUI_UPGRADES_LOCATION, 0xFF0000FF, true).setText(getUpgradeText());

        nameFilterField = new GuiTextField(-1, field_146289_q, xStart + 70, yStart + 58, 100, 10);
        nameFilterField.func_146180_a(te.getText(0));

        updateButtons();//also adds the redstoneButton.
    }

    @Override
    protected boolean shouldAddUpgradeTab(){
        return false;
    }

    @Override
    protected void func_146979_b(int x, int y){

        super.func_146979_b(x, y);
        if(maxPage > 1) field_146289_q.func_78276_b(page + "/" + maxPage, 110, 46 + 22 * MAX_SENSORS_PER_PAGE, 4210752);
        field_146289_q.func_78276_b("Upgr.", 23, 98, 4210752);

        String[] folders = te.getSensorSetting().split("/");
        if(folders.length == 1 && !folders[0].equals("")) {
            Set<Item> requiredItems = SensorHandler.getInstance().getRequiredStacksFromText(folders[0]);
            int curX = 102;
            for(Item requiredItem : requiredItems) {
                GuiUtils.drawItemStack(new ItemStack(requiredItem), curX, 20);
                curX += 18;
            }
        } else {
            field_146289_q.func_78276_b(folders[folders.length - 1], 102, 24, 4210752);
        }

    }

    @Override
    protected Point getInvTextOffset(){
        return new Point(0, 2);
    }

    @Override
    protected void func_146976_a(float opacity, int x, int y){
        super.func_146976_a(opacity, x, y);

        if(nameFilterField != null) nameFilterField.func_146194_f();

        ISensorSetting sensor = SensorHandler.getInstance().getSensorFromPath(te.getSensorSetting());
        if(sensor != null) {
            sensor.drawAdditionalInfo(field_146289_q);
        }
    }

    @Override
    public String getRedstoneButtonText(int mode){
        return te.invertedRedstone ? "gui.tab.redstoneBehaviour.universalSensor.button.inverted" : "gui.tab.redstoneBehaviour.universalSensor.button.normal";
    }

    @Override
    public String getRedstoneString(){
        return "gui.tab.redstoneBehaviour.universalSensor.redstoneEmission";
    }

    @Override
    protected Point getGaugeLocation(){
        int xStart = (field_146294_l - field_146999_f) / 2;
        int yStart = (field_146295_m - field_147000_g) / 2;
        return new Point(xStart + 34, yStart + field_147000_g * 1 / 4);
    }

    @Override
    protected void func_73864_a(int par1, int par2, int par3) throws IOException{
        super.func_73864_a(par1, par2, par3);

        nameFilterField.func_146192_a(par1, par2, par3);
    }

    @Override
    protected void func_73869_a(char par1, int par2) throws IOException{
        if(nameFilterField.func_146206_l() && par2 != 1) {
            nameFilterField.func_146201_a(par1, par2);
            te.setText(0, nameFilterField.func_146179_b());
            NetworkHandler.sendToServer(new PacketUpdateTextfield(te, 0));
        } else {
            super.func_73869_a(par1, par2);
        }
    }

    public void updateButtons(){
        field_146292_n.clear();
        field_146292_n.add(redstoneButton);
        if(!te.getSensorSetting().equals("")) {
            field_146292_n.add(new GuiButton(1, field_147003_i + 70, field_147009_r + 18, 30, 20, "back"));
        } else {
            field_146292_n.add(new GuiButton(-1, field_147003_i + 70, field_147009_r + 125, 98, 20, I18n.func_135052_a("gui.universalSensor.button.showRange")));
        }
        String[] directories = SensorHandler.getInstance().getDirectoriesAtLocation(te.getSensorSetting());
        maxPage = (directories.length - 1) / MAX_SENSORS_PER_PAGE + 1;
        if(page > maxPage) page = maxPage;
        if(page < 1) page = 1;
        if(maxPage > 1) {
            field_146292_n.add(new GuiButton(2, field_147003_i + 70, field_147009_r + 40 + 22 * MAX_SENSORS_PER_PAGE, 30, 20, "<--"));
            field_146292_n.add(new GuiButton(3, field_147003_i + 138, field_147009_r + 40 + 22 * MAX_SENSORS_PER_PAGE, 30, 20, "-->"));
        }

        int buttonsOnPage = MAX_SENSORS_PER_PAGE;
        if(page == maxPage && (directories.length % MAX_SENSORS_PER_PAGE > 0 || directories.length == 0)) {
            buttonsOnPage = directories.length % MAX_SENSORS_PER_PAGE;
        }
        for(int i = 0; i < buttonsOnPage; i++) {
            String buttonText = directories[i + (page - 1) * MAX_SENSORS_PER_PAGE];
            if(SensorHandler.getInstance().getSensorFromPath(te.getSensorSetting() + "/" + buttonText) != null) {
                buttonText = EnumChatFormatting.YELLOW + buttonText;
            }
            int buttonID = i * 10 + 10 + (page - 1) * MAX_SENSORS_PER_PAGE * 10;
            int buttonX = field_147003_i + 70;
            int buttonY = field_147009_r + 40 + i * 22;
            int buttonWidth = 98;
            int buttonHeight = 20;
            if(te.getSensorSetting().equals("")) {
                Set<Item> requiredItems = SensorHandler.getInstance().getRequiredStacksFromText(buttonText);
                GuiButtonSpecial button = new GuiButtonSpecial(buttonID, buttonX, buttonY, buttonWidth, buttonHeight, "");
                ItemStack[] requiredStacks = new ItemStack[requiredItems.size()];
                Iterator<Item> iterator = requiredItems.iterator();
                for(int j = 0; j < requiredStacks.length; j++) {
                    requiredStacks[j] = new ItemStack(iterator.next());
                }
                button.setRenderStacks(requiredStacks);
                button.field_146124_l = te.areGivenUpgradesInserted(requiredItems);
                field_146292_n.add(button);
            } else {
                field_146292_n.add(new GuiButton(buttonID, buttonX, buttonY, buttonWidth, buttonHeight, buttonText));
            }
        }
        sensorInfoStat.setText(getSensorInfo());
        ISensorSetting sensor = SensorHandler.getInstance().getSensorFromPath(te.getSensorSetting());
        boolean textboxEnabled = sensor != null && sensor.needsTextBox();
        nameFilterField.func_146189_e(textboxEnabled);
        if(!textboxEnabled) nameFilterField.func_146195_b(false);

    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        if(te.getSensorSetting().equals("") && ticksExisted++ > 5) {
            ticksExisted = 0;
            updateButtons();
        }
        if(!nameFilterField.func_146206_l()) {
            nameFilterField.func_146180_a(te.getText(0));
        }
    }

    private List<String> getUpgradeText(){
        List<String> upgradeInfo = new ArrayList<String>();
        upgradeInfo.add("gui.tab.upgrades.volume");
        upgradeInfo.add("gui.tab.upgrades.security");
        upgradeInfo.addAll(SensorHandler.getInstance().getUpgradeInfo());
        return upgradeInfo;
    }

    private List<String> getSensorInfo(){
        List<String> text = new ArrayList<String>();
        ISensorSetting sensor = SensorHandler.getInstance().getSensorFromPath(te.getSensorSetting());
        if(sensor != null) {
            String[] folders = te.getSensorSetting().split("/");
            text.add(EnumChatFormatting.GRAY + folders[folders.length - 1]);
            text.addAll(sensor.getDescription());
        } else {
            text.add(EnumChatFormatting.BLACK + "No sensor selected.");
        }
        return text;
    }

    @Override
    protected void addPressureStatInfo(List<String> pressureStatText){
        super.addPressureStatInfo(pressureStatText);
        if(te.isSensorActive) {
            pressureStatText.add(EnumChatFormatting.GRAY + "Usage:");
            pressureStatText.add(EnumChatFormatting.BLACK.toString() + PneumaticValues.USAGE_UNIVERSAL_SENSOR + "mL/tick");
        }
    }

    @Override
    protected void addProblems(List<String> textList){
        super.addProblems(textList);
        if(SensorHandler.getInstance().getSensorFromPath(te.getSensorSetting()) == null) {
            textList.add(EnumChatFormatting.GRAY + "No sensor selected!");
            textList.add(EnumChatFormatting.BLACK + "Insert upgrades and select the desired sensor.");
        }
        for(int i = TileEntityUniversalSensor.UPGRADE_SLOT_1; i <= TileEntityUniversalSensor.UPGRADE_SLOT_4; i++) {
            if(te.func_70301_a(i) != null && te.func_70301_a(i).func_77973_b() == Itemss.GPSTool) {
                if(te.func_70301_a(i).func_77942_o()) {
                    NBTTagCompound gpsTag = te.func_70301_a(i).func_77978_p();
                    int toolX = gpsTag.func_74762_e("x");
                    int toolY = gpsTag.func_74762_e("y");
                    int toolZ = gpsTag.func_74762_e("z");
                    if(toolX == 0 && toolY == 0 && toolZ == 0) {
                        textList.add(EnumChatFormatting.GRAY + "The inserted GPS Tool doesn't have a coordinate selected!");
                        textList.add(EnumChatFormatting.BLACK + "Insert a GPS Tool with stored coordinate.");
                        break;
                    }
                    int sensorRange = te.getRange();
                    if(Math.abs(toolX - te.func_174877_v().func_177958_n()) > sensorRange || Math.abs(toolY - te.func_174877_v().func_177956_o()) > sensorRange || Math.abs(toolZ - te.func_174877_v().func_177952_p()) > sensorRange) {
                        textList.add(EnumChatFormatting.GRAY + "The stored coordinate in the GPS Tool is out of the Sensor's range!");
                        textList.add(EnumChatFormatting.BLACK + "Move the sensor closer, select a closer coordinate or insert Range Upgrades.");
                    }
                } else {
                    textList.add(EnumChatFormatting.GRAY + "The inserted GPS Tool doesn't have a coordinate selected!");
                    textList.add(EnumChatFormatting.BLACK + "Insert a GPS Tool with stored coordinate.");
                }
                break;
            }
        }
    }

    /**
     * Fired when a control is clicked. This is the equivalent of
     * ActionListener.actionPerformed(ActionEvent e).
     */
    @Override
    protected void func_146284_a(GuiButton button){
        if(button.field_146127_k == 2) {
            page--;
            if(page <= 0) page = maxPage;
            updateButtons();
        } else if(button.field_146127_k == 3) {
            page++;
            if(page > maxPage) page = 1;
            updateButtons();
        } else if(button.field_146127_k == -1) {
            te.showRangeLines();
        } else {
            super.func_146284_a(button);
        }
    }
}
