package pneumaticCraft.client.gui.pneumaticHelmet;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.resources.I18n;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.FMLCommonHandler;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.api.client.pneumaticHelmet.IGuiScreen;
import pneumaticCraft.api.client.pneumaticHelmet.IOptionPage;
import pneumaticCraft.client.render.pneumaticArmor.EntityTrackUpgradeHandler;
import pneumaticCraft.common.item.ItemPneumaticArmor;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketUpdateEntityFilter;

public class GuiEntityTrackOptions implements IOptionPage{

    private final EntityTrackUpgradeHandler renderHandler;
    private GuiTextField textField;

    public GuiEntityTrackOptions(EntityTrackUpgradeHandler renderHandler){
        this.renderHandler = renderHandler;
    }

    @Override
    public String getPageName(){
        return "Entity Tracker";
    }

    @Override
    public void initGui(IGuiScreen gui){
        gui.getButtonList().add(new GuiButton(10, 30, 128, 150, 20, "Move Stat Screen..."));
        textField = new GuiTextField(-1, gui.getFontRenderer(), 35, 60, 140, 10);
        textField.func_146195_b(true);
        if(PneumaticCraft.proxy.getPlayer() != null) textField.func_146180_a(ItemPneumaticArmor.getEntityFilter(PneumaticCraft.proxy.getPlayer().func_82169_q(3)));
    }

    @Override
    public void actionPerformed(GuiButton button){
        if(button.field_146127_k == 10) {
            FMLClientHandler.instance().getClient().field_71439_g.func_71053_j();
            FMLCommonHandler.instance().showGuiScreen(new GuiMoveStat(renderHandler));
        }
    }

    @Override
    public void drawPreButtons(int x, int y, float partialTicks){}

    @Override
    public void drawScreen(int x, int y, float partialTicks){
        textField.func_146194_f();
        FontRenderer fontRenderer = Minecraft.func_71410_x().field_71466_p;
        fontRenderer.func_78276_b(I18n.func_135052_a("gui.entityFilter"), 35, 50, 0xFFFFFFFF);
    }

    @Override
    public void keyTyped(char ch, int key){
        if(textField != null && textField.func_146206_l() && key != 1) {
            textField.func_146201_a(ch, key);
            NetworkHandler.sendToServer(new PacketUpdateEntityFilter(textField.func_146179_b()));
        }
    }

    @Override
    public void mouseClicked(int x, int y, int button){}

    @Override
    public void handleMouseInput(){}

    @Override
    public boolean canBeTurnedOff(){
        return true;
    }

    @Override
    public boolean displaySettingsText(){
        return true;
    }
}
