package pneumaticCraft.client.gui.pneumaticHelmet;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.util.ChatComponentTranslation;
import net.minecraft.util.EnumChatFormatting;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.Loader;

import org.lwjgl.input.Keyboard;

import pneumaticCraft.api.client.pneumaticHelmet.IGuiScreen;
import pneumaticCraft.api.client.pneumaticHelmet.IOptionPage;
import pneumaticCraft.client.KeyHandler;
import pneumaticCraft.client.gui.widget.GuiAnimatedStat;
import pneumaticCraft.client.render.pneumaticArmor.MainHelmetHandler;
import pneumaticCraft.lib.ModIds;

public class GuiHelmetMainOptions implements IOptionPage{

    private final MainHelmetHandler renderHandler;
    private GuiButton changeKeybindingButton;
    private boolean changingKeybinding;

    public GuiHelmetMainOptions(MainHelmetHandler renderHandler){
        this.renderHandler = renderHandler;
    }

    @Override
    public String getPageName(){
        return "General Helmet Options";
    }

    @Override
    public void initGui(IGuiScreen gui){
        gui.getButtonList().add(new GuiButton(10, 30, 128, 150, 20, "Move Pressure Stat Screen..."));
        gui.getButtonList().add(new GuiButton(11, 30, 150, 150, 20, "Move Message Screen..."));
        if(!Loader.isModLoaded(ModIds.NOT_ENOUGH_KEYS)) {
            changeKeybindingButton = new GuiButton(12, 30, 172, 150, 20, "Change open menu key...");
            gui.getButtonList().add(changeKeybindingButton);
        }
    }

    @Override
    public void actionPerformed(GuiButton button){
        switch(button.field_146127_k){
            case 10:
                FMLClientHandler.instance().getClient().field_71439_g.func_71053_j();
                FMLCommonHandler.instance().showGuiScreen(new GuiMoveStat(renderHandler));
                break;
            case 11:
                FMLClientHandler.instance().getClient().field_71439_g.func_71053_j();
                renderHandler.testMessageStat = new GuiAnimatedStat(null, "Test Message, keep in mind messages can be long!", renderHandler.messagesStatX, renderHandler.messagesStatY, 0x7000AA00, null, renderHandler.messagesStatLeftSided);
                renderHandler.testMessageStat.openWindow();
                FMLCommonHandler.instance().showGuiScreen(new GuiMoveStat(renderHandler, renderHandler.testMessageStat));
                break;
            case 12:
                changingKeybinding = !changingKeybinding;
                updateKeybindingButtonText();
                break;
        }
    }

    private void updateKeybindingButtonText(){
        if(changingKeybinding) {
            changeKeybindingButton.field_146126_j = "Press button to set keybind.";
        } else {
            changeKeybindingButton.field_146126_j = "Change open menu key...";
        }
    }

    @Override
    public void keyTyped(char ch, int key){
        if(changingKeybinding) {
            changingKeybinding = false;
            updateKeybindingButtonText();

            KeyHandler.getInstance().keybindOpenOptions.func_151462_b(key);
            KeyBinding.func_74508_b();
            FMLClientHandler.instance().getClient().field_71439_g.func_146105_b(new ChatComponentTranslation(EnumChatFormatting.GREEN + "Bound the opening of this menu to the '" + Keyboard.getKeyName(key) + "' key."));
        }
    }

    @Override
    public void mouseClicked(int x, int y, int button){}

    @Override
    public void drawPreButtons(int x, int y, float partialTicks){}

    @Override
    public void drawScreen(int x, int y, float partialTicks){}

    @Override
    public void handleMouseInput(){}

    @Override
    public boolean canBeTurnedOff(){
        return true;
    }

    @Override
    public boolean displaySettingsText(){
        return true;
    }
}
