package pneumaticCraft.client.gui.pneumaticHelmet;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.resources.I18n;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.client.FMLClientHandler;
import pneumaticCraft.api.client.pneumaticHelmet.IGuiScreen;
import pneumaticCraft.api.client.pneumaticHelmet.IOptionPage;
import pneumaticCraft.api.client.pneumaticHelmet.IUpgradeRenderHandler;
import pneumaticCraft.client.gui.GuiPneumaticScreenBase;
import pneumaticCraft.client.gui.widget.GuiKeybindCheckBox;
import pneumaticCraft.client.render.pneumaticArmor.UpgradeRenderHandlerList;
import pneumaticCraft.common.CommonHUDHandler;

public class GuiHelmetMainScreen extends GuiPneumaticScreenBase implements IGuiScreen{

    private final List<IOptionPage> upgradePages = new ArrayList<IOptionPage>();
    private final List<String> upgradePageNames = new ArrayList<String>();
    private static int page;
    private boolean init = true;

    private static GuiHelmetMainScreen instance;//Creating a static instance, as we can use it to handle keybinds when the GUI is closed.

    public static GuiHelmetMainScreen getInstance(){
        return instance;
    }

    public static void init(){
        instance = new GuiHelmetMainScreen();
        Minecraft minecraft = FMLClientHandler.instance().getClient();
        ScaledResolution scaledresolution = new ScaledResolution(minecraft);
        int width = scaledresolution.func_78326_a();
        int height = scaledresolution.func_78328_b();
        instance.func_146280_a(minecraft, width, height);

        for(int i = 1; i < instance.upgradePages.size(); i++) {
            page = i;
            instance.func_73866_w_();
        }
        page = 0;
        instance.init = false;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();
        field_146292_n.clear();
        upgradePages.clear();
        upgradePageNames.clear();
        addPages();
        for(int i = 0; i < upgradePages.size(); i++) {
            GuiButton button = new GuiButton(100 + i, 210, 20 + i * 22, 200, 20, upgradePages.get(i).getPageName());
            if(page == i) button.field_146124_l = false;
            field_146292_n.add(button);
        }
        if(page > upgradePages.size() - 1) page = upgradePages.size() - 1;
        GuiKeybindCheckBox checkBox = new GuiKeybindCheckBox(100, 40, 12, 0xFFFFFFFF, I18n.func_135052_a("gui.enableModule", I18n.func_135052_a("pneumaticHelmet.upgrade." + upgradePageNames.get(page))), "pneumaticHelmet.upgrade." + upgradePageNames.get(page));
        if(upgradePages.get(page).canBeTurnedOff()) addWidget(checkBox);
        upgradePages.get(page).initGui(this);
    }

    @Override
    protected ResourceLocation getTexture(){
        return null;
    }

    private void addPages(){
        for(int i = 0; i < UpgradeRenderHandlerList.instance().upgradeRenderers.size(); i++) {
            if(init || CommonHUDHandler.getHandlerForPlayer().upgradeRenderersInserted[i]) {
                IUpgradeRenderHandler upgradeRenderHandler = UpgradeRenderHandlerList.instance().upgradeRenderers.get(i);
                IOptionPage optionPage = upgradeRenderHandler.getGuiOptionsPage();
                if(optionPage != null) {
                    upgradePageNames.add(upgradeRenderHandler.getUpgradeName());
                    upgradePages.add(optionPage);
                }
            }
        }
    }

    @Override
    public void func_73863_a(int x, int y, float partialTicks){
        func_146276_q_();
        IOptionPage optionPage = upgradePages.get(page);
        optionPage.drawPreButtons(x, y, partialTicks);
        super.func_73863_a(x, y, partialTicks);
        optionPage.drawScreen(x, y, partialTicks);
        func_73732_a(field_146289_q, upgradePages.get(page).getPageName(), 100, 25, 0xFFFFFFFF);
        if(optionPage.displaySettingsText()) func_73732_a(field_146289_q, "Settings", 100, 115, 0xFFFFFFFF);
    }

    @Override
    public void func_73869_a(char par1, int par2) throws IOException{
        super.func_73869_a(par1, par2);
        if(par2 != 1) {
            for(IOptionPage page : upgradePages) {
                page.keyTyped(par1, par2);
            }
        }
    }

    @Override
    public void func_146284_a(GuiButton button){
        if(button.field_146127_k >= 100 && button.field_146127_k < 100 + upgradePages.size()) {
            page = button.field_146127_k - 100;
            func_73866_w_();
        } else {
            upgradePages.get(page).actionPerformed(button);
        }
    }

    @Override
    public void func_146274_d() throws IOException{
        super.func_146274_d();
        upgradePages.get(page).handleMouseInput();
    }

    @Override
    protected void func_73864_a(int par1, int par2, int par3) throws IOException{
        super.func_73864_a(par1, par2, par3);
        upgradePages.get(page).mouseClicked(par1, par2, par3);
    }

    @Override
    public List getButtonList(){
        return field_146292_n;
    }

    @Override
    public FontRenderer getFontRenderer(){
        return field_146289_q;
    }

    @Override
    public boolean func_73868_f(){
        return false;
    }
}
