package pneumaticCraft.client.gui.pneumaticHelmet;

import net.minecraft.client.gui.GuiScreen;
import net.minecraftforge.fml.client.FMLClientHandler;
import pneumaticCraft.api.client.IGuiAnimatedStat;
import pneumaticCraft.api.client.pneumaticHelmet.IUpgradeRenderHandler;
import pneumaticCraft.client.gui.widget.GuiAnimatedStat;

public class GuiMoveStat extends GuiScreen{
    private final IGuiAnimatedStat movedStat;
    private final IUpgradeRenderHandler renderHandler;

    public GuiMoveStat(IUpgradeRenderHandler renderHandler){
        movedStat = renderHandler.getAnimatedStat();
        this.renderHandler = renderHandler;
        if(movedStat == null) {
            System.err.println("OPENING A MOVE STAT GUI WHILE THERE IS NO STAT TO MOVE!");
            FMLClientHandler.instance().getClient().field_71439_g.func_71053_j();
        }
    }

    public GuiMoveStat(IUpgradeRenderHandler renderHandler, GuiAnimatedStat movedStat){
        this.renderHandler = renderHandler;
        this.movedStat = movedStat;
    }

    @Override
    protected void func_146273_a(int x, int y, int lastButtonClicked, long timeSinceMouseClick){
        movedStat.setBaseX(x);
        movedStat.setBaseY(y);
        renderHandler.saveToConfig();
    }

    @Override
    protected void func_73864_a(int x, int y, int mouseButton){
        if(mouseButton == 2) movedStat.setLeftSided(!movedStat.isLeftSided());
        else {
            movedStat.setBaseX(x);
            movedStat.setBaseY(y);
        }
        renderHandler.saveToConfig();
    }

    @Override
    public void func_73863_a(int x, int y, float partialTicks){
        func_146276_q_();
        func_73731_b(field_146289_q, "Middle mouse click to switch between expansion to the right or left", 5, 5, 0xFFFFFFFF);
        movedStat.render(x, y, partialTicks);
        super.func_73863_a(x, y, partialTicks);
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        movedStat.update();
    }
}
