package pneumaticCraft.client.gui.programmer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.client.FMLClientHandler;
import pneumaticCraft.client.gui.GuiButtonSpecial;
import pneumaticCraft.client.gui.GuiInventorySearcher;
import pneumaticCraft.client.gui.GuiProgrammer;
import pneumaticCraft.client.gui.widget.GuiRadioButton;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.client.gui.widget.WidgetComboBox;
import pneumaticCraft.client.gui.widget.WidgetLabel;
import pneumaticCraft.client.gui.widget.WidgetTextFieldNumber;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.item.ItemGPSTool;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.progwidgets.ProgWidgetArea;
import pneumaticCraft.lib.Textures;

public class GuiProgWidgetArea extends GuiProgWidgetAreaShow<ProgWidgetArea>{
    private GuiInventorySearcher invSearchGui;
    private int pointSearched;
    private WidgetComboBox variableField1;
    private WidgetComboBox variableField2;
    private WidgetTextFieldNumber typeInfoField;

    public GuiProgWidgetArea(ProgWidgetArea widget, GuiProgrammer guiProgrammer){
        super(widget, guiProgrammer);
        xSize = 256;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        addLabel("Point 1", guiLeft + 50, guiTop + 10);
        addLabel("Point 2", guiLeft + 177, guiTop + 10);
        addLabel("Area Type:", guiLeft + 4, guiTop + 50);

        boolean advancedMode = Config.getProgrammerDifficulty() == 2;
        GuiButtonSpecial gpsButton1 = new GuiButtonSpecial(0, guiLeft + (advancedMode ? 6 : 55), guiTop + 20, 20, 20, "");
        GuiButtonSpecial gpsButton2 = new GuiButtonSpecial(1, guiLeft + (advancedMode ? 133 : 182), guiTop + 20, 20, 20, "");
        gpsButton1.setTooltipText(I18n.func_135052_a("gui.progWidget.area.selectGPS1"));
        gpsButton2.setTooltipText(I18n.func_135052_a("gui.progWidget.area.selectGPS2"));
        gpsButton1.setRenderStacks(new ItemStack(Itemss.GPSTool));
        gpsButton2.setRenderStacks(new ItemStack(Itemss.GPSTool));
        field_146292_n.add(gpsButton1);
        field_146292_n.add(gpsButton2);

        variableField1 = new WidgetComboBox(field_146289_q, guiLeft + 28, guiTop + 25, 88, field_146289_q.field_78288_b + 1);
        variableField2 = new WidgetComboBox(field_146289_q, guiLeft + 155, guiTop + 25, 88, field_146289_q.field_78288_b + 1);
        Set<String> variables = guiProgrammer.te.getAllVariables();
        variableField1.setElements(variables);
        variableField2.setElements(variables);
        variableField1.func_146180_a(widget.getCoord1Variable());
        variableField2.func_146180_a(widget.getCoord2Variable());
        typeInfoField = new WidgetTextFieldNumber(field_146289_q, guiLeft + 160, guiTop + 110, 20, field_146289_q.field_78288_b + 1);
        typeInfoField.setValue(widget.typeInfo);
        typeInfoField.setTooltip(I18n.func_135052_a("gui.progWidget.area.extraInfo.tooltip"));
        addWidget(typeInfoField);
        addWidget(new WidgetLabel(guiLeft + 160, guiTop + 100, I18n.func_135052_a("gui.progWidget.area.extraInfo")));
        if(advancedMode) {
            addWidget(variableField1);
            addWidget(variableField2);
        }

        List<GuiRadioButton> radioButtons = new ArrayList<GuiRadioButton>();
        ProgWidgetArea.EnumAreaType[] areaTypes = ProgWidgetArea.EnumAreaType.values();
        for(int i = 0; i < areaTypes.length; i++) {
            GuiRadioButton radioButton = new GuiRadioButton(i, guiLeft + 7 + i / 7 * 80, guiTop + 60 + i % 7 * 12, 0xFF000000, areaTypes[i].toString());
            radioButton.checked = areaTypes[i] == widget.type;
            addWidget(radioButton);
            radioButtons.add(radioButton);
            radioButton.otherChoices = radioButtons;
        }
        if(invSearchGui != null) {
            BlockPos pos = invSearchGui.getSearchStack() != null ? ItemGPSTool.getGPSLocation(invSearchGui.getSearchStack()) : null;
            if(pos != null) {
                if(pointSearched == 0) {
                    widget.x1 = pos.func_177958_n();
                    widget.y1 = pos.func_177956_o();
                    widget.z1 = pos.func_177952_p();
                } else {
                    widget.x2 = pos.func_177958_n();
                    widget.y2 = pos.func_177956_o();
                    widget.z2 = pos.func_177952_p();
                }
            } else {
                if(pointSearched == 0) {
                    widget.x1 = widget.y1 = widget.z1 = 0;
                } else {
                    widget.x2 = widget.y2 = widget.z2 = 0;
                }
            }
        }
    }

    @Override
    public void actionPerformed(IGuiWidget guiWidget){
        if(guiWidget instanceof GuiRadioButton) {
            widget.type = ProgWidgetArea.EnumAreaType.values()[guiWidget.getID()];
            typeInfoField.func_146184_c(widget.type.utilizesTypeInfo);
        }
        super.actionPerformed(guiWidget);
    }

    @Override
    public void func_146284_a(GuiButton button) throws IOException{
        if(button.field_146127_k == 0 || button.field_146127_k == 1) {
            invSearchGui = new GuiInventorySearcher(FMLClientHandler.instance().getClient().field_71439_g);
            ItemStack gps = new ItemStack(Itemss.GPSTool);
            if(button.field_146127_k == 0) {
                ItemGPSTool.setGPSLocation(gps, new BlockPos(widget.x1, widget.y1, widget.z1));
            } else {
                ItemGPSTool.setGPSLocation(gps, new BlockPos(widget.x2, widget.y2, widget.z2));
            }
            invSearchGui.setSearchStack(ItemGPSTool.getGPSLocation(gps) != null ? gps : null);
            FMLClientHandler.instance().showGuiScreen(invSearchGui);
            pointSearched = button.field_146127_k;
        }
        super.func_146284_a(button);
    }

    @Override
    protected ResourceLocation getTexture(){
        return Textures.GUI_WIDGET_AREA;
    }

    @Override
    public void func_73869_a(char key, int keyCode) throws IOException{
        if(keyCode == 1) {
            widget.setCoord1Variable(variableField1.func_146179_b());
            widget.setCoord2Variable(variableField2.func_146179_b());
            widget.typeInfo = typeInfoField.getValue();
        }
        super.func_73869_a(key, keyCode);
    }

}
