package pneumaticCraft.client.gui.programmer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraftforge.fml.client.FMLClientHandler;
import pneumaticCraft.client.gui.GuiButtonSpecial;
import pneumaticCraft.client.gui.GuiInventorySearcher;
import pneumaticCraft.client.gui.GuiProgrammer;
import pneumaticCraft.client.gui.widget.GuiRadioButton;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.client.gui.widget.WidgetComboBox;
import pneumaticCraft.client.gui.widget.WidgetTextField;
import pneumaticCraft.client.gui.widget.WidgetTextFieldNumber;
import pneumaticCraft.common.item.ItemGPSTool;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.progwidgets.ProgWidgetCoordinate;

public class GuiProgWidgetCoordinate extends GuiProgWidgetAreaShow<ProgWidgetCoordinate>{
    private GuiInventorySearcher invSearchGui;
    private WidgetTextFieldNumber[] coordFields;
    private WidgetComboBox variableField;
    private GuiButtonSpecial gpsButton;

    public GuiProgWidgetCoordinate(ProgWidgetCoordinate widget, GuiProgrammer guiProgrammer){
        super(widget, guiProgrammer);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        if(invSearchGui != null) {
            BlockPos pos = invSearchGui.getSearchStack() != null ? ItemGPSTool.getGPSLocation(invSearchGui.getSearchStack()) : null;
            widget.setCoordinate(pos);
        }

        List<GuiRadioButton> radioButtons = new ArrayList<GuiRadioButton>();
        GuiRadioButton radioButton = new GuiRadioButton(0, guiLeft + 7, guiTop + 51, 0xFF000000, I18n.func_135052_a("gui.progWidget.coordinate.constant"));
        if(!widget.isUsingVariable()) radioButton.checked = true;
        radioButtons.add(radioButton);
        radioButton.otherChoices = radioButtons;
        addWidget(radioButton);
        radioButton = new GuiRadioButton(1, guiLeft + 7, guiTop + 100, 0xFF000000, I18n.func_135052_a("gui.progWidget.coordinate.variable"));
        if(widget.isUsingVariable()) radioButton.checked = true;
        radioButtons.add(radioButton);
        radioButton.otherChoices = radioButtons;
        addWidget(radioButton);

        gpsButton = new GuiButtonSpecial(0, guiLeft + 100, guiTop + 20, 20, 20, "");
        gpsButton.setRenderStacks(new ItemStack[]{new ItemStack(Itemss.GPSTool)});
        gpsButton.setTooltipText(I18n.func_135052_a("gui.progWidget.coordinate.selectFromGPS"));
        gpsButton.field_146124_l = !widget.isUsingVariable();
        field_146292_n.add(gpsButton);
        coordFields = new WidgetTextFieldNumber[3];
        for(int i = 0; i < 3; i++) {
            coordFields[i] = new WidgetTextFieldNumber(field_146289_q, guiLeft + 100, guiTop + 50 + 13 * i, 40, field_146289_q.field_78288_b + 1);
            addWidget(coordFields[i]);
            coordFields[i].func_146184_c(gpsButton.field_146124_l);
        }
        coordFields[0].setValue(widget.getRawCoordinate().func_177958_n());
        coordFields[1].setValue(widget.getRawCoordinate().func_177956_o());
        coordFields[2].setValue(widget.getRawCoordinate().func_177952_p());

        variableField = new WidgetComboBox(field_146289_q, guiLeft + 90, guiTop + 112, 80, field_146289_q.field_78288_b + 1);
        variableField.setElements(guiProgrammer.te.getAllVariables());
        addWidget(variableField);
        variableField.func_146180_a(widget.getVariable());
        variableField.func_146184_c(widget.isUsingVariable());
    }

    @Override
    public void actionPerformed(IGuiWidget guiWidget){
        if(guiWidget.getID() == 0 || guiWidget.getID() == 1) {
            widget.setUsingVariable(guiWidget.getID() == 1);
            gpsButton.field_146124_l = guiWidget.getID() == 0;
            for(WidgetTextField textField : coordFields) {
                textField.func_146184_c(gpsButton.field_146124_l);
            }

            variableField.func_146184_c(!gpsButton.field_146124_l);
        }
        // super.actionPerformed(guiWidget);
    }

    @Override
    public void func_146284_a(GuiButton button) throws IOException{
        if(button.field_146127_k == 0) {
            invSearchGui = new GuiInventorySearcher(FMLClientHandler.instance().getClient().field_71439_g);
            BlockPos area = widget.getRawCoordinate();
            ItemStack gps = new ItemStack(Itemss.GPSTool);
            ItemGPSTool.setGPSLocation(gps, area);
            invSearchGui.setSearchStack(ItemGPSTool.getGPSLocation(gps) != null ? gps : null);
            FMLClientHandler.instance().showGuiScreen(invSearchGui);
        }
        super.func_146284_a(button);
    }

    @Override
    public void func_73869_a(char chr, int keyCode) throws IOException{
        if(keyCode == 1) {
            widget.setCoordinate(new BlockPos(coordFields[0].getValue(), coordFields[1].getValue(), coordFields[2].getValue()));
            widget.setVariable(variableField.func_146179_b());
        }
        super.func_73869_a(chr, keyCode);
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partialTicks){
        super.func_73863_a(mouseX, mouseY, partialTicks);
        field_146289_q.func_78276_b("x:", guiLeft + 90, guiTop + 51, 0xFF000000);
        field_146289_q.func_78276_b("y:", guiLeft + 90, guiTop + 64, 0xFF000000);
        field_146289_q.func_78276_b("z:", guiLeft + 90, guiTop + 77, 0xFF000000);
        field_146289_q.func_78276_b(I18n.func_135052_a("gui.progWidget.coordinate.variableName"), guiLeft + 90, guiTop + 100, 0xFF000000);
    }
}
