package pneumaticCraft.client.gui.programmer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.resources.I18n;
import pneumaticCraft.client.gui.GuiProgrammer;
import pneumaticCraft.client.gui.widget.GuiRadioButton;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.client.gui.widget.WidgetComboBox;
import pneumaticCraft.common.progwidgets.ProgWidgetCoordinateOperator;
import pneumaticCraft.common.progwidgets.ProgWidgetCoordinateOperator.EnumOperator;

public class GuiProgWidgetCoordinateOperator extends GuiProgWidgetAreaShow<ProgWidgetCoordinateOperator>{

    private WidgetComboBox variableField;

    public GuiProgWidgetCoordinateOperator(ProgWidgetCoordinateOperator widget, GuiProgrammer guiProgrammer){
        super(widget, guiProgrammer);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        List<GuiRadioButton> radioButtons = new ArrayList<GuiRadioButton>();
        for(int i = 0; i < EnumOperator.values().length; i++) {
            GuiRadioButton radioButton = new GuiRadioButton(i, guiLeft + 7, guiTop + 42 + 12 * i, 0xFF000000, I18n.func_135052_a(EnumOperator.values()[i].getUnlocalizedName()));
            radioButtons.add(radioButton);
            radioButton.checked = widget.getOperator().ordinal() == i;
            radioButton.otherChoices = radioButtons;
            addWidget(radioButton);
        }

        variableField = new WidgetComboBox(field_146289_q, guiLeft + 90, guiTop + 42, 80, field_146289_q.field_78288_b + 1);
        variableField.setElements(guiProgrammer.te.getAllVariables());
        addWidget(variableField);
        variableField.func_146180_a(widget.getVariable());
    }

    @Override
    public void actionPerformed(IGuiWidget guiWidget){
        if(guiWidget.getID() >= 0 && guiWidget.getID() < EnumOperator.values().length) {
            widget.setOperator(EnumOperator.values()[guiWidget.getID()]);
        }
        super.actionPerformed(guiWidget);
    }

    @Override
    public void func_73869_a(char chr, int keyCode) throws IOException{
        if(keyCode == 1) {
            widget.setVariable(variableField.func_146179_b());
        }
        super.func_73869_a(chr, keyCode);
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partialTicks){
        super.func_73863_a(mouseX, mouseY, partialTicks);
        field_146289_q.func_78276_b(I18n.func_135052_a("gui.progWidget.coordinate.variableName"), guiLeft + 90, guiTop + 30, 0xFF000000);
        field_146289_q.func_78276_b(I18n.func_135052_a("gui.progWidget.coordinateOperator.operator"), guiLeft + 7, guiTop + 30, 0xFF000000);
    }
}
