package pneumaticCraft.client.gui.remote;

import java.io.IOException;

import net.minecraft.client.resources.I18n;
import net.minecraft.util.ResourceLocation;
import pneumaticCraft.client.gui.GuiPneumaticScreenBase;
import pneumaticCraft.client.gui.GuiRemoteEditor;
import pneumaticCraft.client.gui.widget.WidgetComboBox;
import pneumaticCraft.client.gui.widget.WidgetTextField;
import pneumaticCraft.client.gui.widget.WidgetTextFieldNumber;
import pneumaticCraft.common.inventory.ContainerRemote;
import pneumaticCraft.common.remote.ActionWidget;
import pneumaticCraft.common.remote.IActionWidgetLabeled;
import pneumaticCraft.lib.Textures;

public class GuiRemoteOptionBase<Widget extends ActionWidget> extends GuiPneumaticScreenBase{
    protected Widget widget;
    protected GuiRemoteEditor guiRemote;
    private WidgetTextField labelField, tooltipField;
    private WidgetComboBox enableField;
    private WidgetTextFieldNumber xValueField, yValueField, zValueField;

    public GuiRemoteOptionBase(Widget widget, GuiRemoteEditor guiRemote){
        this.widget = widget;
        this.guiRemote = guiRemote;
        xSize = 183;
        ySize = 202;
    }

    @Override
    public void func_73869_a(char key, int keyCode) throws IOException{
        if(keyCode == 1) {
            func_146281_b();
            field_146297_k.func_147108_a(guiRemote);
        } else {
            super.func_73869_a(key, keyCode);
        }
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partialTicks){
        func_146276_q_();
        super.func_73863_a(mouseX, mouseY, partialTicks);

    }

    @Override
    protected ResourceLocation getTexture(){
        return Textures.GUI_WIDGET_OPTIONS;
    }

    @Override
    public boolean func_73868_f(){
        return false;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        String title = I18n.func_135052_a("remote." + widget.getId() + ".name");
        addLabel(I18n.func_135052_a("gui.remote.enable"), guiLeft + 10, guiTop + 150);
        addLabel(title, field_146294_l / 2 - field_146289_q.func_78256_a(title) / 2, guiTop + 5);
        addLabel("#", guiLeft + 10, guiTop + 161);

        if(widget instanceof IActionWidgetLabeled) {
            addLabel(I18n.func_135052_a("gui.remote.text"), guiLeft + 10, guiTop + 20);
            addLabel(I18n.func_135052_a("gui.remote.tooltip"), guiLeft + 10, guiTop + 46);
        }

        addLabel(I18n.func_135052_a("gui.remote.enableValue"), guiLeft + 10, guiTop + 175);
        addLabel("X:", guiLeft + 10, guiTop + 186);
        addLabel("Y:", guiLeft + 67, guiTop + 186);
        addLabel("Z:", guiLeft + 124, guiTop + 186);

        enableField = new WidgetComboBox(field_146289_q, guiLeft + 18, guiTop + 160, 152, 10);
        enableField.setElements(((ContainerRemote)guiRemote.field_147002_h).variables);
        enableField.func_146180_a(widget.getEnableVariable());
        enableField.setTooltip(I18n.func_135052_a("gui.remote.enable.tooltip"));
        addWidget(enableField);

        String valueTooltip = I18n.func_135052_a("gui.remote.enableValue.tooltip");

        xValueField = new WidgetTextFieldNumber(field_146289_q, guiLeft + 20, guiTop + 185, 38, 10);
        xValueField.setValue(widget.getEnablingValue().func_177958_n());
        xValueField.setTooltip(valueTooltip);
        addWidget(xValueField);

        yValueField = new WidgetTextFieldNumber(field_146289_q, guiLeft + 78, guiTop + 185, 38, 10);
        yValueField.setValue(widget.getEnablingValue().func_177956_o());
        yValueField.setTooltip(valueTooltip);
        addWidget(yValueField);

        zValueField = new WidgetTextFieldNumber(field_146289_q, guiLeft + 136, guiTop + 185, 38, 10);
        zValueField.setValue(widget.getEnablingValue().func_177952_p());
        zValueField.setTooltip(valueTooltip);
        addWidget(zValueField);

        if(widget instanceof IActionWidgetLabeled) {
            labelField = new WidgetTextField(field_146289_q, guiLeft + 10, guiTop + 30, 160, 10);
            labelField.func_146180_a(((IActionWidgetLabeled)widget).getText());
            labelField.setTooltip(I18n.func_135052_a("gui.remote.label.tooltip"));
            labelField.func_146203_f(1000);
            addWidget(labelField);

            tooltipField = new WidgetTextField(field_146289_q, guiLeft + 10, guiTop + 56, 160, 10);
            tooltipField.func_146180_a(((IActionWidgetLabeled)widget).getTooltip());
            addWidget(tooltipField);
        }
    }

    @Override
    public void func_146281_b(){
        super.func_146281_b();
        widget.setEnableVariable(enableField.func_146179_b());
        widget.setEnablingValue(xValueField.getValue(), yValueField.getValue(), zValueField.getValue());
        if(widget instanceof IActionWidgetLabeled) {
            ((IActionWidgetLabeled)widget).setText(labelField.func_146179_b());
            ((IActionWidgetLabeled)widget).setTooltip(tooltipField.func_146179_b());
        }
    }
}
