package pneumaticCraft.client.gui.semiblock;

import java.util.Arrays;

import net.minecraft.client.Minecraft;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidTank;

import org.apache.commons.lang3.text.WordUtils;
import org.lwjgl.input.Mouse;

import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.client.gui.GuiPneumaticContainerBase;
import pneumaticCraft.client.gui.GuiSearcher;
import pneumaticCraft.client.gui.widget.GuiCheckBox;
import pneumaticCraft.client.gui.widget.IGuiWidget;
import pneumaticCraft.client.gui.widget.WidgetFluidStack;
import pneumaticCraft.client.gui.widget.WidgetLabel;
import pneumaticCraft.common.inventory.ContainerLogistics;
import pneumaticCraft.common.inventory.SlotPhantom;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketSetLogisticsFilterStack;
import pneumaticCraft.common.network.PacketSetLogisticsFluidFilterStack;
import pneumaticCraft.common.semiblock.SemiBlockLogistics;
import pneumaticCraft.common.semiblock.SemiBlockManager;
import pneumaticCraft.lib.Textures;

public class GuiLogisticsBase<Logistics extends SemiBlockLogistics> extends GuiPneumaticContainerBase{
    protected final Logistics logistics;
    private GuiSearcher searchGui;
    private GuiLogisticsLiquidFilter fluidSearchGui;
    private int editingSlot; //either fluid or item search.
    private GuiCheckBox invisible;

    public GuiLogisticsBase(InventoryPlayer invPlayer, Logistics requester){
        super(new ContainerLogistics(invPlayer, requester), null, Textures.GUI_LOGISTICS_REQUESTER);
        logistics = (Logistics)((ContainerLogistics)field_147002_h).logistics;
        field_147000_g = 216;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        if(searchGui != null) {
            field_147002_h.func_75139_a(editingSlot).func_75215_d(searchGui.getSearchStack());
            NetworkHandler.sendToServer(new PacketSetLogisticsFilterStack(logistics, searchGui.getSearchStack(), editingSlot));
            searchGui = null;
        }
        if(fluidSearchGui != null && fluidSearchGui.getFilter() != null) {
            FluidStack filter = new FluidStack(fluidSearchGui.getFilter(), 1000);
            logistics.setFilter(editingSlot, filter);
            NetworkHandler.sendToServer(new PacketSetLogisticsFluidFilterStack(logistics, filter, editingSlot));
            fluidSearchGui = null;
        }
        String invisibleText = I18n.func_135052_a("gui.logisticFrame.invisible");
        addWidget(invisible = new GuiCheckBox(9, field_147003_i + field_146999_f - 15 - field_146289_q.func_78256_a(invisibleText), field_147009_r + 7, 0xFF000000, invisibleText));
        invisible.setTooltip(Arrays.asList(WordUtils.wrap(I18n.func_135052_a("gui.logisticFrame.invisible.tooltip"), 40).split(System.getProperty("line.separator"))));
        addWidget(new WidgetLabel(field_147003_i + 8, field_147009_r + 18, I18n.func_135052_a(String.format("gui.%s.filters", SemiBlockManager.getKeyForSemiBlock(logistics)))));
        addWidget(new WidgetLabel(field_147003_i + 8, field_147009_r + 90, I18n.func_135052_a("gui.logisticFrame.liquid")));
        for(int i = 0; i < 9; i++) {
            addWidget(new WidgetFluidStack(i, field_147003_i + i * 18 + 8, field_147009_r + 101, logistics.getTankFilter(i)));
        }
        addInfoTab(I18n.func_135052_a("gui.tab.info." + SemiBlockManager.getKeyForSemiBlock(logistics)));
    }

    @Override
    protected boolean shouldAddProblemTab(){
        return false;
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        invisible.checked = logistics.isInvisible();
    }

    @Override
    public void actionPerformed(IGuiWidget widget){
        super.actionPerformed(widget);
        if(widget instanceof WidgetFluidStack) {
            boolean leftClick = Mouse.isButtonDown(0);
            boolean middleClick = Mouse.isButtonDown(2);
            boolean shift = PneumaticCraft.proxy.isSneakingInGui();
            IFluidTank tank = logistics.getTankFilter(widget.getID());
            if(tank.getFluidAmount() > 0) {
                if(middleClick) {
                    logistics.setFilter(widget.getID(), (FluidStack)null);
                } else if(leftClick) {
                    tank.drain(shift ? tank.getFluidAmount() / 2 : 1000, true);
                    if(tank.getFluidAmount() < 1000) {
                        tank.drain(1000, true);
                    }
                } else {
                    tank.fill(new FluidStack(tank.getFluid().getFluid(), shift ? tank.getFluidAmount() : 1000), true);
                }
                NetworkHandler.sendToServer(new PacketSetLogisticsFluidFilterStack(logistics, tank.getFluid(), widget.getID()));
            } else {
                fluidSearchGui = new GuiLogisticsLiquidFilter(this);
                editingSlot = widget.getID();
                field_146297_k.func_147108_a(fluidSearchGui);
            }
        }
    }

    @Override
    protected void func_146984_a(Slot slot, int x, int mouse, int y){
        if(slot instanceof SlotPhantom && Minecraft.func_71410_x().field_71439_g.field_71071_by.func_70445_o() == null && !slot.func_75216_d() && mouse == 1) {
            editingSlot = slot.getSlotIndex();
            Minecraft.func_71410_x().func_147108_a(searchGui = new GuiSearcher(Minecraft.func_71410_x().field_71439_g));
        } else {
            super.func_146984_a(slot, x, mouse, y);
        }
    }
}
