package pneumaticCraft.client.render;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.util.RenderUtils;
import pneumaticCraft.common.util.PneumaticCraftUtils;

public class RenderRing extends RenderProgressingLine{
    private final int color;

    public RenderRing(double startX, double startY, double startZ, double endX, double endY, double endZ, int color){
        super(startX, startY, startZ, endX, endY, endZ);
        this.color = color;
    }

    @SideOnly(Side.CLIENT)
    public void renderInterpolated(RenderProgressingLine lastTickLine, float partialTick, float rotationYaw, float rotationPitch){
        GL11.glPushMatrix();
        double renderProgress = getInter(progress, lastTickLine.progress, partialTick);
        GL11.glTranslated((getInter(endX, lastTickLine.endX, partialTick) - startX) * renderProgress, (getInter(endY, lastTickLine.endY, partialTick) - startY) * renderProgress, (getInter(endZ, lastTickLine.endZ, partialTick) - startZ) * renderProgress);
        GL11.glRotatef(rotationYaw, 0.0F, 1.0F, 0.0F);
        GL11.glRotatef(rotationPitch, 0.0F, 0.0F, 1.0F);
        WorldRenderer wr = Tessellator.func_178181_a().func_178180_c();
        GL11.glEnable(GL11.GL_LINE_SMOOTH);
        wr.func_181668_a(GL11.GL_LINE_LOOP, DefaultVertexFormats.field_181705_e);
        RenderUtils.glColorHex(color);
        double size = 5 / 16D;
        for(int i = 0; i < PneumaticCraftUtils.circlePoints; i++) {
            wr.func_181662_b(0, PneumaticCraftUtils.sin[i] * size, PneumaticCraftUtils.cos[i] * size).func_181675_d();
        }
        Tessellator.func_178181_a().func_78381_a();
        GL11.glDisable(GL11.GL_LINE_SMOOTH);
        GL11.glPopMatrix();
    }
}
