package pneumaticCraft.client.render.entity;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.client.renderer.entity.RenderEntity;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.entity.Entity;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import pneumaticCraft.common.entity.projectile.EntityVortex;
import pneumaticCraft.lib.Textures;

@SideOnly(Side.CLIENT)
public class RenderEntityVortex extends RenderEntity{

    private static final ResourceLocation texture = new ResourceLocation("pneumaticcraft:textures/items/" + Textures.ITEM_VORTEX + ".png");

    public RenderEntityVortex(){
        super(Minecraft.func_71410_x().func_175598_ae());
    }

    public void renderVortex(EntityVortex entity, double x, double y, double z, float var1, float partialTicks){

        int circlePoints = 200;
        double radius = 0.5D;
        GL11.glPushMatrix();
        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
        GL11.glDisable(GL11.GL_TEXTURE_2D);
        GL11.glColor4d(0.8, 0.8, 0.8D, 0.7D);
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        GL11.glTranslatef((float)x, (float)y, (float)z);
        GL11.glRotatef(entity.field_70127_C + (entity.field_70125_A - entity.field_70127_C) * partialTicks, 0.0F, 0.0F, 1.0F);

        GL11.glRotatef(entity.field_70126_B + (entity.field_70177_z - entity.field_70126_B) * partialTicks, 0.0F, 1.0F, 0.0F);

        for(int i = 0; i < circlePoints; i++) {
            float angleRadians = (float)i / (float)circlePoints * 2F * (float)Math.PI;
            GL11.glPushMatrix();
            GL11.glTranslated(radius * Math.sin(angleRadians), radius * Math.cos(angleRadians), 0);
            renderGust();
            GL11.glPopMatrix();
        }

        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
        GL11.glDisable(GL11.GL_BLEND);
        GL11.glEnable(GL11.GL_TEXTURE_2D);
        GL11.glPopMatrix();

    }

    /*
     * private void renderGust(Icon icon){ float f3 = icon.getMinU(); float f4 =
     * icon.getMaxU(); float f5 = icon.getMinV(); float f6 = icon.getMaxV();
     * float f7 = 1.0F; float f8 = 0.5F; float f9 = 0.25F; Tessellator
     * tessellator = Tessellator.instance; wr.begin(GL11.GL_QUADS, DefaultVertexFormats.POSITION);
     * tessellator.setNormal(0.0F, 1.0F, 0.0F);
     * wr.pos((double)(0.0F - f8), (double)(0.0F - f9),
     * 0.0D, (double)f3, (double)f6); wr.pos((double)(f7 -
     * f8), (double)(0.0F - f9), 0.0D, (double)f4, (double)f6);
     * wr.pos((double)(f7 - f8), (double)(1.0F - f9), 0.0D,
     * (double)f4, (double)f5); wr.pos((double)(0.0F - f8),
     * (double)(1.0F - f9), 0.0D, (double)f3, (double)f5); Tessellator.getInstance().draw(); }
     */

    private void renderGust(){
        byte b0 = 0;
        //float f2 = 0.0F;
        //float f3 = 0.5F;
        //float f4 = (0 + b0 * 10) / 16.0F;
        // float f5 = (5 + b0 * 10) / 16.0F;
        float f6 = 0.0F;
        float f7 = 0.15625F;
        float f8 = (5 + b0 * 10) / 16.0F;
        float f9 = (10 + b0 * 10) / 16.0F;
        float f10 = 0.05625F;
        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);

        GL11.glRotatef(45.0F, 1.0F, 0.0F, 0.0F);
        GL11.glScalef(f10, f10, f10);
        GL11.glTranslatef(-4.0F, 0.0F, 0.0F);
        GL11.glNormal3f(f10, 0.0F, 0.0F);
        WorldRenderer wr = Tessellator.func_178181_a().func_178180_c();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);

        wr.func_181662_b(-7.0D, -2.0D, -2.0D).func_181673_a(f6, f8).func_181675_d();
        wr.func_181662_b(-7.0D, -2.0D, 2.0D).func_181673_a(f7, f8).func_181675_d();
        wr.func_181662_b(-7.0D, 2.0D, 2.0D).func_181673_a(f7, f9).func_181675_d();
        wr.func_181662_b(-7.0D, 2.0D, -2.0D).func_181673_a(f6, f9).func_181675_d();

        double start = 0d;
        double end = 1 / 16d;
        wr.func_181662_b(-7.0D, -2.0D, -2.0D).func_181673_a(start, start).func_181675_d();
        wr.func_181662_b(-7.0D, -2.0D, 2.0D).func_181673_a(start, end).func_181675_d();
        wr.func_181662_b(-7.0D, 2.0D, 2.0D).func_181673_a(end, end).func_181675_d();
        wr.func_181662_b(-7.0D, 2.0D, -2.0D).func_181673_a(end, start).func_181675_d();
        Tessellator.func_178181_a().func_78381_a();
        GL11.glNormal3f(-f10, 0.0F, 0.0F);

        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);
        wr.func_181662_b(-7.0D, 2.0D, -2.0D).func_181673_a(f6, f8).func_181675_d();
        wr.func_181662_b(-7.0D, 2.0D, 2.0D).func_181673_a(f7, f8).func_181675_d();
        wr.func_181662_b(-7.0D, -2.0D, 2.0D).func_181673_a(f7, f9).func_181675_d();
        wr.func_181662_b(-7.0D, -2.0D, -2.0D).func_181673_a(f6, f9).func_181675_d();
        Tessellator.func_178181_a().func_78381_a();

    }

    @Override
    public void func_76986_a(Entity par1Entity, double par2, double par4, double par6, float par8, float par9){
        renderVortex((EntityVortex)par1Entity, par2, par4, par6, par8, par9);
    }

    @Override
    protected ResourceLocation func_110775_a(Entity par1Entity){
        return texture;
    }
}
