package pneumaticCraft.client.render.pneumaticArmor;

import java.util.List;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.client.FMLClientHandler;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.common.item.ItemPneumaticArmor;
import pneumaticCraft.common.util.PneumaticCraftUtils;

public class RenderSearchItemBlock{

    private final BlockPos pos;
    private final World world;

    public RenderSearchItemBlock(World world, BlockPos pos){
        this.world = world;
        this.pos = pos;
    }

    private int getSearchedItemCount(){
        if(world.func_175625_s(pos) instanceof IInventory) {
            int itemCount = 0;
            IInventory inventory = (IInventory)world.func_175625_s(pos);
            ItemStack searchStack = ItemPneumaticArmor.getSearchedStack(FMLClientHandler.instance().getClient().field_71439_g.func_82169_q(3));
            if(searchStack == null) return 0;
            for(int l = 0; l < inventory.func_70302_i_(); l++) {
                if(inventory.func_70301_a(l) != null) {
                    itemCount += getSearchedItemCount(inventory.func_70301_a(l), searchStack);
                }
            }
            return itemCount;
        }
        return 0;
    }

    public static int getSearchedItemCount(ItemStack stack, ItemStack searchStack){
        int itemCount = 0;
        if(stack.func_77969_a(searchStack)) {
            itemCount += stack.field_77994_a;
        }
        List<ItemStack> inventoryItems = PneumaticCraftUtils.getStacksInItem(stack);
        for(ItemStack s : inventoryItems) {
            itemCount += getSearchedItemCount(s, searchStack);
        }
        return itemCount;
    }

    public boolean isAlreadyTrackingCoord(BlockPos pos){
        return pos.equals(this.pos);
    }

    public boolean renderSearchBlock(int totalCount){
        int itemCount = getSearchedItemCount();
        renderSearch(pos.func_177958_n() + 0.5D, pos.func_177956_o() + 0.5D, pos.func_177952_p() + 0.5D, itemCount, totalCount);
        return itemCount > 0;
    }

    public static void renderSearch(double x, double y, double z, int itemCount, int totalCount){
        GL11.glPushMatrix();
        GL11.glTranslated(x, y, z);
        GL11.glColor4d(0, 1, 0, 0.5D);
        GL11.glRotatef(180.0F - Minecraft.func_71410_x().func_175598_ae().field_78735_i, 0.0F, 1.0F, 0.0F);
        GL11.glRotatef(180.0F - Minecraft.func_71410_x().func_175598_ae().field_78732_j, 1.0F, 0.0F, 0.0F);
        // GL11.glLineWidth(1.0F);
        double ratio = (double)itemCount / totalCount;
        double diff = (1 - ratio) / 1.5D;
        double size = 1 - diff;
        /*
        for(double i = size; i > 0; i -= 0.06D) {
            GL11.glPushMatrix();
            GL11.glScaled(i, i, i);
            renderCircle();
            GL11.glPopMatrix();
        }
        */
        WorldRenderer wr = Tessellator.func_178181_a().func_178180_c();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);
        wr.func_181662_b(-size, size, 0).func_181673_a(0, 1).func_181675_d();
        wr.func_181662_b(-size, -size, 0).func_181673_a(0, 0).func_181675_d();
        wr.func_181662_b(size, -size, 0).func_181673_a(1, 0).func_181675_d();
        wr.func_181662_b(size, size, 0).func_181673_a(1, 1).func_181675_d();

        Tessellator.func_178181_a().func_78381_a();

        GL11.glPopMatrix();
    }
    /*
        private static void renderCircle(){

            WorldRenderer wr = Tessellator.getInstance().getWorldRenderer();
            tess.startDrawing(GL11.GL_POLYGON);
            for(int i = 0; i < PneumaticCraftUtils.circlePoints; i++) {
                wr.pos(PneumaticCraftUtils.sin[i], PneumaticCraftUtils.cos[i], 0);
            }

            Tessellator.getInstance().draw();

        }
        */
}
