package pneumaticCraft.client.render.pneumaticArmor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.MathHelper;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import pneumaticCraft.api.client.pneumaticHelmet.IOptionPage;
import pneumaticCraft.api.client.pneumaticHelmet.IUpgradeRenderHandler;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.client.KeyHandler;
import pneumaticCraft.client.gui.pneumaticHelmet.GuiSearchUpgradeOptions;
import pneumaticCraft.client.gui.widget.GuiAnimatedStat;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.item.ItemPneumaticArmor;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.recipes.CraftingRegistrator;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.PneumaticValues;
import pneumaticCraft.lib.Textures;

public class SearchUpgradeHandler implements IUpgradeRenderHandler{
    private int totalSearchedItemCount;
    public int searchedItemCounter;
    private int ticksExisted;
    private final Map<EntityItem, Integer> searchedItems = new HashMap<EntityItem, Integer>();
    private final List<RenderSearchItemBlock> searchedBlocks = new ArrayList<RenderSearchItemBlock>();
    @SideOnly(Side.CLIENT)
    private GuiAnimatedStat searchInfo;
    private int statX;
    private int statY;
    private boolean statLeftSided;

    @Override
    @SideOnly(Side.CLIENT)
    public String getUpgradeName(){
        return "itemSearcher";
    }

    @Override
    public void initConfig(Configuration config){
        statX = config.get("Helmet_Options" + Configuration.CATEGORY_SPLITTER + "Item_Search", "stat X", -1).getInt();
        statY = config.get("Helmet_Options" + Configuration.CATEGORY_SPLITTER + "Item_Search", "stat Y", 17).getInt();
        statLeftSided = config.get("Helmet_Options" + Configuration.CATEGORY_SPLITTER + "Item_Search", "stat leftsided", true).getBoolean(true);
    }

    @Override
    public void saveToConfig(){
        Configuration config = Config.config;
        config.load();
        config.get("Helmet_Options" + Configuration.CATEGORY_SPLITTER + "Item_Search", "stat X", -1).set(searchInfo.getBaseX());
        config.get("Helmet_Options" + Configuration.CATEGORY_SPLITTER + "Item_Search", "stat Y", 17).set(searchInfo.getBaseY());
        config.get("Helmet_Options" + Configuration.CATEGORY_SPLITTER + "Item_Search", "stat leftsided", true).set(searchInfo.isLeftSided());
        config.save();
        statX = searchInfo.getBaseX();
        statY = searchInfo.getBaseY();
        statLeftSided = searchInfo.isLeftSided();
    }

    public void addToSearchedItemCounter(int amount){
        searchedItemCounter += amount;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void update(EntityPlayer player, int rangeUpgrades){
        ticksExisted++;
        ItemStack searchStack = ItemPneumaticArmor.getSearchedStack(player.func_82169_q(3));

        if(ticksExisted % 20 == 0) {
            List<EntityItem> items = player.field_70170_p.func_72872_a(EntityItem.class, EntityTrackUpgradeHandler.getAABBFromRange(player, rangeUpgrades));
            searchedItems.clear();
            for(EntityItem item : items) {
                if(item.func_92059_d() != null && searchStack != null) {
                    if(item.func_92059_d().func_77969_a(searchStack)) searchedItems.put(item, item.func_92059_d().field_77994_a);
                    else {
                        List<ItemStack> inventoryItems = PneumaticCraftUtils.getStacksInItem(item.func_92059_d());
                        int itemCount = 0;
                        for(ItemStack inventoryItem : inventoryItems) {
                            if(inventoryItem.func_77969_a(searchStack)) {
                                itemCount += inventoryItem.field_77994_a;
                            }
                        }
                        if(itemCount > 0) searchedItems.put(item, itemCount);
                    }
                }
            }

            totalSearchedItemCount = searchedItemCounter;
            searchedItemCounter = 0;
            for(Integer itemCount : searchedItems.values()) {
                searchedItemCounter += itemCount;
            }
        }
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void render3D(float partialTicks){
        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
        GL11.glEnable(GL11.GL_TEXTURE_2D);
        GL11.glDepthMask(false);
        GL11.glDisable(GL11.GL_DEPTH_TEST);
        GL11.glDisable(GL11.GL_CULL_FACE);
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        Minecraft.func_71410_x().func_175598_ae().field_78724_e.func_110577_a(Textures.GLOW_RESOURCE);
        //  mc.func_110434_K().func_110577_a(Textures.GLOW_RESOURCE);
        for(Map.Entry<EntityItem, Integer> entry : searchedItems.entrySet()) {
            EntityItem item = entry.getKey();
            float height = MathHelper.func_76126_a((item.func_174872_o() + partialTicks) / 10.0F + item.field_70290_d) * 0.1F + 0.2F;
            RenderSearchItemBlock.renderSearch(item.field_70142_S + (item.field_70165_t - item.field_70142_S) * partialTicks, item.field_70137_T + (item.field_70163_u - item.field_70137_T) * partialTicks + height, item.field_70136_U + (item.field_70161_v - item.field_70136_U) * partialTicks, entry.getValue(), totalSearchedItemCount);
        }
        for(int i = 0; i < searchedBlocks.size(); i++) {
            if(!searchedBlocks.get(i).renderSearchBlock(totalSearchedItemCount)) {
                searchedBlocks.remove(i);
                i--;
            }
        }
        GL11.glEnable(GL11.GL_CULL_FACE);
        GL11.glEnable(GL11.GL_DEPTH_TEST);
        GL11.glDisable(GL11.GL_BLEND);
        GL11.glDepthMask(true);
        GL11.glEnable(GL11.GL_TEXTURE_2D);
        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void render2D(float partialTicks, boolean helmetEnabled){
        ItemStack searchStack = ItemPneumaticArmor.getSearchedStack(FMLClientHandler.instance().getClient().field_71439_g.func_82169_q(3));
        List<String> textList = new ArrayList<String>();
        if(searchStack == null) {
            textList.add("press '" + Keyboard.getKeyName(KeyHandler.getInstance().keybindOpenOptions.func_151463_i()) + "' to configure");
        } else {
            textList.add(searchStack.func_82833_r() + " (" + totalSearchedItemCount + " found)");
        }
        searchInfo.setText(textList);
    }

    @Override
    public Item[] getRequiredUpgrades(){
        return new Item[]{Itemss.upgrades.get(EnumUpgrade.SEARCH)};
    }

    /**
     * This method will be called by the BlockTrackUpgradeHandler when it finds inventories while scanning blocks.
     * @param te TileEntity that already has been checked on if it implements IInventory, so it's save to cast it to IInventory.
     */
    public void checkInventoryForItems(TileEntity te){
        try {
            ItemStack searchStack = ItemPneumaticArmor.getSearchedStack(FMLClientHandler.instance().getClient().field_71439_g.func_82169_q(3));
            IInventory inventory = (IInventory)te;
            boolean hasFoundItem = false;
            if(searchStack != null) {
                for(int l = 0; l < inventory.func_70302_i_(); l++) {
                    if(inventory.func_70301_a(l) != null) {
                        int items = RenderSearchItemBlock.getSearchedItemCount(inventory.func_70301_a(l), searchStack);
                        if(items > 0) {
                            hasFoundItem = true;
                            searchedItemCounter += items;
                        }
                    }
                }
            }
            if(hasFoundItem) {
                boolean inList = false;
                for(RenderSearchItemBlock trackedBlock : searchedBlocks) {
                    if(trackedBlock.isAlreadyTrackingCoord(te.func_174877_v())) {
                        inList = true;
                        break;
                    }
                }
                if(!inList) searchedBlocks.add(new RenderSearchItemBlock(te.func_145831_w(), te.func_174877_v()));
            }
        } catch(Throwable e) {

        }
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void reset(){
        searchedBlocks.clear();
        searchedItemCounter = 0;
        searchedItems.clear();
        ticksExisted = 0;
        searchInfo = null;
    }

    @Override
    public float getEnergyUsage(int rangeUpgrades, EntityPlayer player){
        return PneumaticValues.USAGE_ITEM_SEARCHER;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public IOptionPage getGuiOptionsPage(){
        return new GuiSearchUpgradeOptions(this);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public GuiAnimatedStat getAnimatedStat(){
        if(searchInfo == null) {
            Minecraft minecraft = Minecraft.func_71410_x();
            ScaledResolution sr = new ScaledResolution(minecraft);
            searchInfo = new GuiAnimatedStat(null, "Currently searching for:", CraftingRegistrator.getUpgrade(EnumUpgrade.SEARCH), statX != -1 ? statX : sr.func_78326_a() - 2, statY, 0x3000AA00, null, statLeftSided);
            searchInfo.setMinDimensionsAndReset(0, 0);
        }
        return searchInfo;
    }

}
