package pneumaticCraft.client.render.pneumaticArmor.hacking.block;

import java.util.List;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.MobSpawnerBaseLogic;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityMobSpawner;
import net.minecraft.util.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.api.client.pneumaticHelmet.IHackableBlock;

public class HackableMobSpawner implements IHackableBlock{
    @Override
    public String getId(){
        return "mobSpawner";
    }

    @Override
    public boolean canHack(IBlockAccess world, BlockPos pos, EntityPlayer player){
        return !isHacked(world, pos);
    }

    public static boolean isHacked(IBlockAccess world, BlockPos pos){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityMobSpawner) {
            return ((TileEntityMobSpawner)te).func_145881_a().field_98289_l == 0;
        }
        return false;
    }

    @Override
    public void addInfo(World world, BlockPos pos, List<String> curInfo, EntityPlayer player){
        curInfo.add("pneumaticHelmet.hacking.result.neutralize");
    }

    @Override
    public void addPostHackInfo(World world, BlockPos pos, List<String> curInfo, EntityPlayer player){
        curInfo.add("pneumaticHelmet.hacking.finished.neutralized");
    }

    @Override
    public int getHackTime(IBlockAccess world, BlockPos pos, EntityPlayer player){
        return 200;
    }

    @Override
    public void onHackFinished(World world, BlockPos pos, EntityPlayer player){
        if(!world.field_72995_K) {
            NBTTagCompound tag = new NBTTagCompound();
            TileEntity te = world.func_175625_s(pos);
            te.func_145841_b(tag);
            tag.func_74777_a("RequiredPlayerRange", (short)0);
            te.func_145839_a(tag);
            world.func_175689_h(pos);
        }

    }

    @Override
    public boolean afterHackTick(World world, BlockPos pos){
        MobSpawnerBaseLogic spawner = ((TileEntityMobSpawner)world.func_175625_s(pos)).func_145881_a();
        spawner.field_98284_d = spawner.field_98287_c;//oldRotation = rotation, to stop render glitching
        spawner.field_98286_b = 10;
        return false;
    }
}
