package pneumaticCraft.client.render.tileentity;

import java.util.Arrays;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.util.MovingObjectPosition;
import net.minecraftforge.fml.client.FMLClientHandler;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.common.block.BlockPressureTube;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.block.tubes.TubeModule;
import pneumaticCraft.common.tileentity.TileEntityPressureTube;

public class PressureTubeModuleRenderer extends TileEntitySpecialRenderer<TileEntityPressureTube>{

    @Override
    public void func_180535_a(TileEntityPressureTube tile, double x, double y, double z, float partialTicks, int destroyStage){
        GL11.glPushMatrix();

        FMLClientHandler.instance().getClient().func_110434_K().func_110577_a(TextureMap.field_110575_b);
        GlStateManager.func_179140_f();
        GlStateManager.func_179098_w();
        GlStateManager.func_179118_c();
        GlStateManager.func_179124_c(1, 1, 1);

        GL11.glTranslatef((float)x + 0.5F, (float)y + 1.5F, (float)z + 0.5F);
        GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);

        GL11.glScalef(1.0F, -1F, -1F);
        attachFakeModule(tile);
        boolean[] renderSides = Arrays.copyOf(tile.sidesConnected, tile.sidesConnected.length);
        for(int i = 0; i < 6; i++) {
            if(tile.modules[i] != null && tile.modules[i].isInline()) {
                renderSides[i] = true;
            }
        }
        GL11.glPopMatrix();

        for(int i = 0; i < tile.modules.length; i++) {
            TubeModule module = tile.modules[i];
            if(module != null) {
                if(module.isFake()) {
                    /*      GL11.glEnable(GL11.GL_BLEND);
                          GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_DST_ALPHA);
                          GL11.glColor4d(1, 1, 1, 0.3);*/
                }

                module.renderDynamic(x, y, z, partialTicks, 0, false);
                if(module.isFake()) {
                    tile.modules[i] = null;
                    GL11.glDisable(GL11.GL_BLEND);
                    GL11.glColor4d(1, 1, 1, 1);
                }
            }
        }
        GL11.glColor4d(1, 1, 1, 1);

        GlStateManager.func_179145_e();
        GlStateManager.func_179141_d();
    }

    private void attachFakeModule(TileEntityPressureTube tile){
        MovingObjectPosition pos = Minecraft.func_71410_x().field_71476_x;
        if(pos != null && pos.func_178782_a() != null && pos.func_178782_a().equals(tile.func_174877_v())) {
            ((BlockPressureTube)Blockss.pressureTube).tryPlaceModule(Minecraft.func_71410_x().field_71439_g, Minecraft.func_71410_x().field_71441_e, tile.func_174877_v(), pos.field_178784_b, true);
        }
    }
}
