package pneumaticCraft.client.semiblock;

import net.minecraft.client.Minecraft;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.model.semiblocks.ModelHeatFrame;
import pneumaticCraft.common.semiblock.SemiBlockHeatFrame;
import pneumaticCraft.common.tileentity.TileEntityCompressedIronBlock;
import pneumaticCraft.lib.Textures;

public class SemiBlockRendererHeatFrame implements ISemiBlockRenderer<SemiBlockHeatFrame>{
    private final ModelHeatFrame model = new ModelHeatFrame();

    @Override
    public void render(SemiBlockHeatFrame semiBlock, float partialTick){
        GL11.glPushMatrix();
        Minecraft.func_71410_x().field_71446_o.func_110577_a(Textures.MODEL_HEAT_FRAME);
        int heatLevel = semiBlock.getHeatLevel();
        double[] color = TileEntityCompressedIronBlock.getColorForHeatLevel(heatLevel);
        GL11.glColor4d(color[0], color[1], color[2], 1);

        AxisAlignedBB aabb;
        if(semiBlock.getWorld() != null) {
            semiBlock.getBlockState().func_177230_c().func_180654_a(semiBlock.getWorld(), semiBlock.getPos());
            aabb = semiBlock.getBlockState().func_177230_c().func_180646_a(semiBlock.getWorld(), semiBlock.getPos());
            BlockPos p = semiBlock.getPos();
            aabb = new AxisAlignedBB(aabb.field_72340_a - p.func_177958_n(), aabb.field_72338_b - p.func_177956_o(), aabb.field_72339_c - p.func_177952_p(), aabb.field_72336_d - p.func_177958_n(), aabb.field_72337_e - p.func_177956_o(), aabb.field_72334_f - p.func_177952_p());
        } else {
            aabb = new AxisAlignedBB(1 / 16D, 1 / 16D, 1 / 16D, 15 / 16D, 15 / 16D, 15 / 16D);
        }
        GL11.glTranslated(aabb.field_72340_a, aabb.field_72338_b, aabb.field_72339_c);
        GL11.glScaled(aabb.field_72336_d - aabb.field_72340_a, aabb.field_72337_e - aabb.field_72338_b, aabb.field_72334_f - aabb.field_72339_c);
        GL11.glTranslated(0.5, -0.5, 0.5);
        model.func_78088_a(null, 0, 0, 0, 0, 0, 1 / 16F);
        GL11.glPopMatrix();
        GL11.glColor4d(1, 1, 1, 1);
    }
}
