package pneumaticCraft.client.semiblock;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.AxisAlignedBB;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.client.util.RenderUtils;
import pneumaticCraft.common.semiblock.SemiBlockLogistics;

public class SemiBlockRendererLogistics implements ISemiBlockRenderer<SemiBlockLogistics>{

    @Override
    public void render(SemiBlockLogistics semiBlock, float partialTick){
        int alpha = semiBlock.getAlpha();
        if(alpha == 0) return;
        GL11.glDisable(GL11.GL_TEXTURE_2D);
        //GL11.glEnable(GL11.GL_LIGHTING);
        //GL11.glColor4d(1, 0, 0, 1);
        if(alpha < 255) GL11.glEnable(GL11.GL_BLEND);
        RenderUtils.glColorHex((alpha << 24 | 0x00FFFFFF) & semiBlock.getColor());
        double fw = 1 / 32D;
        AxisAlignedBB aabb;
        if(semiBlock.getWorld() != null) {
            semiBlock.getBlockState().func_177230_c().func_180654_a(semiBlock.getWorld(), semiBlock.getPos());
            aabb = semiBlock.getBlockState().func_177230_c().func_180646_a(semiBlock.getWorld(), semiBlock.getPos());
        } else {
            aabb = new AxisAlignedBB(0 + fw, 0 + fw, 0 + fw, 1 - fw, 1 - fw, 1 - fw);
        }

        if(semiBlock.getPos() != null) GL11.glTranslated(-semiBlock.getPos().func_177958_n(), -semiBlock.getPos().func_177956_o(), -semiBlock.getPos().func_177952_p());

        renderFrame(aabb, fw);
        GL11.glEnable(GL11.GL_TEXTURE_2D);
        GL11.glDisable(GL11.GL_BLEND);
        GL11.glColor4d(1, 1, 1, 1);
    }

    public static void renderFrame(AxisAlignedBB aabb, double fw){
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a + fw, aabb.field_72338_b - fw, aabb.field_72339_c - fw, aabb.field_72336_d - fw, aabb.field_72338_b + fw, aabb.field_72339_c + fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a + fw, aabb.field_72337_e - fw, aabb.field_72339_c - fw, aabb.field_72336_d - fw, aabb.field_72337_e + fw, aabb.field_72339_c + fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a + fw, aabb.field_72338_b - fw, aabb.field_72334_f - fw, aabb.field_72336_d - fw, aabb.field_72338_b + fw, aabb.field_72334_f + fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a + fw, aabb.field_72337_e - fw, aabb.field_72334_f - fw, aabb.field_72336_d - fw, aabb.field_72337_e + fw, aabb.field_72334_f + fw), 0, 0, 0);

        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a - fw, aabb.field_72338_b - fw, aabb.field_72339_c + fw, aabb.field_72340_a + fw, aabb.field_72338_b + fw, aabb.field_72334_f - fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a - fw, aabb.field_72337_e - fw, aabb.field_72339_c + fw, aabb.field_72340_a + fw, aabb.field_72337_e + fw, aabb.field_72334_f - fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72336_d - fw, aabb.field_72338_b - fw, aabb.field_72339_c + fw, aabb.field_72336_d + fw, aabb.field_72338_b + fw, aabb.field_72334_f - fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72336_d - fw, aabb.field_72337_e - fw, aabb.field_72339_c + fw, aabb.field_72336_d + fw, aabb.field_72337_e + fw, aabb.field_72334_f - fw), 0, 0, 0);

        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a - fw, aabb.field_72338_b - fw, aabb.field_72339_c - fw, aabb.field_72340_a + fw, aabb.field_72337_e + fw, aabb.field_72339_c + fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72336_d - fw, aabb.field_72338_b - fw, aabb.field_72339_c - fw, aabb.field_72336_d + fw, aabb.field_72337_e + fw, aabb.field_72339_c + fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72340_a - fw, aabb.field_72338_b - fw, aabb.field_72334_f - fw, aabb.field_72340_a + fw, aabb.field_72337_e + fw, aabb.field_72334_f + fw), 0, 0, 0);
        renderOffsetAABB(new AxisAlignedBB(aabb.field_72336_d - fw, aabb.field_72338_b - fw, aabb.field_72334_f - fw, aabb.field_72336_d + fw, aabb.field_72337_e + fw, aabb.field_72334_f + fw), 0, 0, 0);
    }

    public static void renderOffsetAABB(AxisAlignedBB p_76978_0_, double p_76978_1_, double p_76978_3_, double p_76978_5_){
        WorldRenderer wr = Tessellator.func_178181_a().func_178180_c();
        wr.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181708_h);
        wr.func_178969_c(p_76978_1_, p_76978_3_, p_76978_5_);

        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72337_e, p_76978_0_.field_72339_c).func_181663_c(0, 0, -1).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72337_e, p_76978_0_.field_72339_c).func_181663_c(0, 0, -1).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72338_b, p_76978_0_.field_72339_c).func_181663_c(0, 0, -1).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72338_b, p_76978_0_.field_72339_c).func_181663_c(0, 0, -1).func_181675_d();

        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72338_b, p_76978_0_.field_72334_f).func_181663_c(0, 0, 1).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72338_b, p_76978_0_.field_72334_f).func_181663_c(0, 0, 1).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72337_e, p_76978_0_.field_72334_f).func_181663_c(0, 0, 1).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72337_e, p_76978_0_.field_72334_f).func_181663_c(0, 0, 1).func_181675_d();

        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72338_b, p_76978_0_.field_72339_c).func_181663_c(0, -1, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72338_b, p_76978_0_.field_72339_c).func_181663_c(0, -1, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72338_b, p_76978_0_.field_72334_f).func_181663_c(0, -1, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72338_b, p_76978_0_.field_72334_f).func_181663_c(0, -1, 0).func_181675_d();

        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72337_e, p_76978_0_.field_72334_f).func_181663_c(0, 1, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72337_e, p_76978_0_.field_72334_f).func_181663_c(0, 1, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72337_e, p_76978_0_.field_72339_c).func_181663_c(0, 1, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72337_e, p_76978_0_.field_72339_c).func_181663_c(0, 1, 0).func_181675_d();

        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72338_b, p_76978_0_.field_72334_f).func_181663_c(-1, 0, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72337_e, p_76978_0_.field_72334_f).func_181663_c(-1, 0, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72337_e, p_76978_0_.field_72339_c).func_181663_c(-1, 0, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72340_a, p_76978_0_.field_72338_b, p_76978_0_.field_72339_c).func_181663_c(-1, 0, 0).func_181675_d();

        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72338_b, p_76978_0_.field_72339_c).func_181663_c(1, 0, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72337_e, p_76978_0_.field_72339_c).func_181663_c(1, 0, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72337_e, p_76978_0_.field_72334_f).func_181663_c(1, 0, 0).func_181675_d();
        wr.func_181662_b(p_76978_0_.field_72336_d, p_76978_0_.field_72338_b, p_76978_0_.field_72334_f).func_181663_c(1, 0, 0).func_181675_d();
        wr.func_178969_c(0.0D, 0.0D, 0.0D);
        Tessellator.func_178181_a().func_78381_a();
    }
}
