package pneumaticCraft.common;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.monster.EntityGolem;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.StatCollector;
import net.minecraft.world.World;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.ServerChatEvent;
import net.minecraftforge.event.entity.EntityEvent.EntityConstructing;
import net.minecraftforge.event.entity.living.EnderTeleportEvent;
import net.minecraftforge.event.entity.living.LivingSetAttackTargetEvent;
import net.minecraftforge.event.entity.player.EntityItemPickupEvent;
import net.minecraftforge.event.entity.player.FillBucketEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.event.world.ExplosionEvent;
import net.minecraftforge.event.world.WorldEvent;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.event.FMLMissingMappingsEvent.MissingMapping;
import net.minecraftforge.fml.common.eventhandler.Event.Result;
import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.api.block.IPneumaticWrenchable;
import pneumaticCraft.api.client.pneumaticHelmet.EntityTrackEvent;
import pneumaticCraft.api.client.pneumaticHelmet.InventoryTrackEvent;
import pneumaticCraft.api.drone.AmadronRetrievalEvent;
import pneumaticCraft.api.drone.DroneConstructingEvent;
import pneumaticCraft.api.drone.DroneSuicideEvent;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.api.item.IPressurizable;
import pneumaticCraft.client.gui.widget.GuiKeybindCheckBox;
import pneumaticCraft.client.render.pneumaticArmor.EntityTrackUpgradeHandler;
import pneumaticCraft.client.render.pneumaticArmor.HUDHandler;
import pneumaticCraft.client.render.pneumaticArmor.hacking.HackableHandler;
import pneumaticCraft.client.render.pneumaticArmor.hacking.entity.HackableEnderman;
import pneumaticCraft.common.ai.IDroneBase;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.entity.EntityProgrammableController;
import pneumaticCraft.common.entity.living.EntityDrone;
import pneumaticCraft.common.fluid.Fluids;
import pneumaticCraft.common.item.ItemAmadronTablet;
import pneumaticCraft.common.item.ItemPneumaticArmor;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketPlaySound;
import pneumaticCraft.common.network.PacketSetMobTarget;
import pneumaticCraft.common.recipes.AmadronOffer;
import pneumaticCraft.common.recipes.AmadronOfferCustom;
import pneumaticCraft.common.recipes.AmadronOfferManager;
import pneumaticCraft.common.remote.GlobalVariableManager;
import pneumaticCraft.common.thirdparty.ModInteractionUtilImplementation;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;
import pneumaticCraft.common.util.FluidUtils;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.TileEntityConstants;

public class EventHandlerPneumaticCraft{

    private static ItemStack IRON_INGOT = new ItemStack(Items.field_151042_j);
    private static ItemStack IRON_BLOCK = new ItemStack(Blocks.field_150339_S);

    public void missingMappings(MissingMapping event){
        if(event.type == GameRegistry.Type.ITEM) {
            if(event.name.equals("pneumaticcraft:machineUpgrade")) {
                event.ignore();
            } else if(event.name.equals("pneumaticcraft:pneumaticCilinder")) {
                event.remap(Itemss.pneumaticCylinder);
            }
        }
    }

    @SubscribeEvent
    public void handleIronExplosions(ExplosionEvent.Detonate event){
        Iterator<Entity> iterator = event.getAffectedEntities().iterator();
        while(iterator.hasNext()) {
            Entity entity = iterator.next();
            if(entity instanceof EntityItem) {
                ItemStack stack = ((EntityItem)entity).func_92059_d();
                if(stack != null && !entity.field_70128_L && PneumaticCraftUtils.isSameOreDictStack(stack, IRON_INGOT) || PneumaticCraftUtils.isSameOreDictStack(stack, IRON_BLOCK)) {
                    Random rand = new Random();
                    if(stack.field_77994_a >= 3 || rand.nextDouble() >= Config.configCompressedIngotLossRate / 100D) {
                        Item newItem = PneumaticCraftUtils.isSameOreDictStack(stack, IRON_INGOT) ? Itemss.ingotIronCompressed : Item.func_150898_a(Blockss.compressedIron);
                        ItemStack newStack = new ItemStack(newItem, stack.field_77994_a, stack.func_77952_i());
                        if(stack.field_77994_a >= 3) {
                            newStack.field_77994_a = (int)(stack.field_77994_a * (rand.nextDouble() * Math.min(Config.configCompressedIngotLossRate * 0.02D, 0.2D) + (Math.max(0.9D, 1D - Config.configCompressedIngotLossRate * 0.01D) - Config.configCompressedIngotLossRate * 0.01D)));
                        }
                        ((EntityItem)entity).func_92058_a(newStack);
                        iterator.remove();
                        for(EntityPlayer player : event.world.func_72872_a(EntityPlayer.class, new AxisAlignedBB(event.explosion.getPosition().field_72450_a - 32, event.explosion.getPosition().field_72448_b - 32, event.explosion.getPosition().field_72449_c - 32, event.explosion.getPosition().field_72450_a + 32, event.explosion.getPosition().field_72448_b + 32, event.explosion.getPosition().field_72449_c + 32))) {
                            AchievementHandler.giveAchievement(player, newStack);
                        }
                    }
                }
            }
        }
    }

    @SubscribeEvent
    public void onEntityConstruction(EntityConstructing event){
        HackableHandler.onEntityConstruction(event.entity);
        if(event.entity instanceof IDroneBase) {
            MinecraftForge.EVENT_BUS.post(new DroneConstructingEvent((IDroneBase)event.entity));
        }
    }

    @SubscribeEvent
    public void onPlayerPickup(EntityItemPickupEvent event){
        if(event.item != null && event.entityPlayer != null) AchievementHandler.giveAchievement(event.entityPlayer, event.item.func_92059_d());
    }

    @SubscribeEvent(priority = EventPriority.LOWEST)
    public void onEnderTeleport(EnderTeleportEvent event){
        if(!HackableEnderman.onEndermanTeleport(event.entity)) {
            event.setCanceled(true);
        }
    }

    @SubscribeEvent
    public void FillBucket(FillBucketEvent event){
        MovingObjectPosition p = event.target;
        if(event.current == null || event.current.func_77973_b() != Items.field_151133_ar || !FluidUtils.isSourceBlock(event.world, p.func_178782_a())) return;
        ItemStack result = attemptFill(event.world, event.target);
        if(result != null) {
            event.result = result;
            AchievementHandler.giveAchievement(event.entityPlayer, result);
            event.setResult(Result.ALLOW);
        }
    }

    private ItemStack attemptFill(World world, MovingObjectPosition p){
        Block id = world.func_180495_p(p.func_178782_a()).func_177230_c();
        for(Map.Entry<Block, Item> entry : Fluids.fluidBlockToBucketMap.entrySet()) {
            if(id == entry.getKey()) {
                world.func_175698_g(p.func_178782_a());
                return new ItemStack(entry.getValue());
            }
        }
        return null;
    }

    @SubscribeEvent
    public void onPlayerClick(PlayerInteractEvent event){
        if(event.action == PlayerInteractEvent.Action.RIGHT_CLICK_AIR) return;
        IBlockState interactedBlockState = event.world.func_180495_p(event.pos);
        Block interactedBlock = interactedBlockState.func_177230_c();
        if(!event.entityPlayer.field_71075_bZ.field_75098_d || !event.entityPlayer.func_70003_b(2, "securityStation")) {
            if(event.world != null && !event.world.field_72995_K) {
                if(interactedBlock != Blockss.securityStation || event.action == PlayerInteractEvent.Action.LEFT_CLICK_BLOCK) {
                    ItemStack heldItem = event.entityPlayer.func_71045_bC();
                    boolean tryingToPlaceSecurityStation = heldItem != null && heldItem.func_77973_b() instanceof ItemBlock && ((ItemBlock)heldItem.func_77973_b()).func_179223_d() == Blockss.securityStation;
                    int blockingStations = PneumaticCraftUtils.getProtectingSecurityStations(event.entity.field_70170_p, event.pos, event.entityPlayer, true, tryingToPlaceSecurityStation);
                    if(blockingStations > 0) {
                        event.setCanceled(true);
                        event.entityPlayer.func_146105_b(new ChatComponentText(StatCollector.func_74837_a(tryingToPlaceSecurityStation ? "message.securityStation.stationPlacementPrevented" : "message.securityStation.accessPrevented", blockingStations)));
                    }
                }
            }
        }

        /**
         * Due to some weird quirk that causes Block#onBlockActivated not getting called on the server when the player is sneaking, this is a workaround.
         */
        if(!event.isCanceled() && event.action == PlayerInteractEvent.Action.RIGHT_CLICK_BLOCK && !event.world.field_72995_K) {
            if(event.entityPlayer.func_70093_af() && (interactedBlock == Blockss.elevatorCaller || interactedBlock == Blockss.chargingStation)) {
                event.setCanceled(interactedBlock.func_180639_a(event.world, event.pos, interactedBlockState, event.entityPlayer, event.face, 0, 0, 0));
            } else if(event.entityPlayer.func_71045_bC() != null && ModInteractionUtilImplementation.getInstance().isModdedWrench(event.entityPlayer.func_71045_bC().func_77973_b())) {
                if(interactedBlock instanceof IPneumaticWrenchable) {
                    ((IPneumaticWrenchable)interactedBlock).rotateBlock(event.world, event.entityPlayer, event.pos, event.face);
                }
            }
        }

        if(!event.isCanceled() && interactedBlock == Blocks.field_150347_e) {
            AchievementHandler.checkFor9x9(event.entityPlayer, event.pos);
        }
    }

    /**
     * Used by PneumaticHelmet
     * @param event
     */
    @SubscribeEvent
    public void onMobTargetSet(LivingSetAttackTargetEvent event){
        if(event.entity instanceof EntityCreature) {
            if(!event.entity.field_70170_p.field_72995_K) {
                NetworkHandler.sendToAllAround(new PacketSetMobTarget((EntityCreature)event.entity, event.target), new NetworkRegistry.TargetPoint(event.entity.field_70170_p.field_73011_w.func_177502_q(), event.entity.field_70165_t, event.entity.field_70163_u, event.entity.field_70161_v, TileEntityConstants.PACKET_UPDATE_DISTANCE));
            } else {
                warnPlayerIfNecessary(event);
            }
        }
    }

    @SideOnly(Side.CLIENT)
    private void warnPlayerIfNecessary(LivingSetAttackTargetEvent event){
        EntityPlayer player = FMLClientHandler.instance().getClient().field_71439_g;
        if(event.target == player && (event.entityLiving instanceof EntityGolem || event.entityLiving instanceof EntityMob)) {
            ItemStack helmetStack = player.func_82169_q(3);
            if(helmetStack != null && helmetStack.func_77973_b() == Itemss.pneumaticHelmet && ((IPressurizable)helmetStack.func_77973_b()).getPressure(helmetStack) > 0 && ItemPneumaticArmor.getUpgrades(EnumUpgrade.ENTITY_TRACKER, helmetStack) > 0 && GuiKeybindCheckBox.trackedCheckboxes.get("pneumaticHelmet.upgrade.coreComponents").checked && GuiKeybindCheckBox.trackedCheckboxes.get("pneumaticHelmet.upgrade." + EntityTrackUpgradeHandler.UPGRADE_NAME).checked) {
                HUDHandler.instance().getSpecificRenderer(EntityTrackUpgradeHandler.class).warnIfNecessary(event.entityLiving);
            }
        } else {
            HUDHandler.instance().getSpecificRenderer(EntityTrackUpgradeHandler.class).removeTargetingEntity(event.entityLiving);
        }
    }

    @SubscribeEvent
    public void quetziMoo(ServerChatEvent event){
        if(event.username.equals("Quetzz") && event.message.equals("m00")) {
            for(int i = 0; i < 4; i++)
                NetworkHandler.sendTo(new PacketPlaySound("mob.cow.say", event.player.field_70165_t, event.player.field_70163_u, event.player.field_70161_v, 1, 1, true), event.player);
        }
    }

    @SubscribeEvent
    public void onWorldLoad(WorldEvent.Load event){
        if(!event.world.field_72995_K) {
            if(event.world.field_73011_w.func_177502_q() == 0) {
                GlobalVariableManager.overworld = event.world;
                event.world.func_72943_a(GlobalVariableManager.class, GlobalVariableManager.DATA_KEY);
            }
        }
    }

    @SubscribeEvent
    public void onEntityTracking(EntityTrackEvent event){
        if(event.trackingEntity instanceof EntityProgrammableController) event.setCanceled(true);
    }

    @SubscribeEvent
    public void onInventoryTracking(InventoryTrackEvent event){
        if(event.getTileEntity() instanceof TileEntityProgrammer) event.setCanceled(true);
    }

    @SubscribeEvent
    public void onDroneSuicide(DroneSuicideEvent event){
        if(event.drone instanceof EntityDrone) {
            EntityDrone drone = (EntityDrone)event.drone;
            AmadronOffer offer = drone.getHandlingOffer();
            if(offer != null) {
                int times = drone.getOfferTimes();
                if(offer.getInput() instanceof ItemStack) {
                    int requiredCount = ((ItemStack)offer.getInput()).field_77994_a * times;
                    for(int i = 0; i < drone.getInv().func_70302_i_(); i++) {
                        if(drone.getInv().func_70301_a(i) != null) {
                            requiredCount -= drone.getInv().func_70301_a(i).field_77994_a;
                        }
                    }
                    if(requiredCount <= 0) {
                        for(int i = 0; i < drone.getInv().func_70302_i_(); i++) {
                            drone.getInv().func_70299_a(i, null);
                        }
                        MinecraftForge.EVENT_BUS.post(new AmadronRetrievalEvent(event.drone));
                    }
                } else {
                    int requiredCount = ((FluidStack)offer.getInput()).amount * times;
                    if(drone.getTank().getFluidAmount() >= requiredCount) {
                        MinecraftForge.EVENT_BUS.post(new AmadronRetrievalEvent(event.drone));
                    }
                }
            }
        }
    }

    @SubscribeEvent
    public void onAmadronSuccess(AmadronRetrievalEvent event){
        EntityDrone drone = (EntityDrone)event.drone;
        AmadronOffer offer = drone.getHandlingOffer();

        boolean shouldDeliver = false;
        if(offer instanceof AmadronOfferCustom) {
            AmadronOffer realOffer = AmadronOfferManager.getInstance().get(offer);
            if(realOffer != null) {//If we find the non-inverted offer, that means the Drone just has completed trading with a different player.
                ((AmadronOfferCustom)realOffer).addPayment(drone.getOfferTimes());
                ((AmadronOfferCustom)realOffer).addStock(-drone.getOfferTimes());
                realOffer.onTrade(drone.getOfferTimes(), drone.getBuyingPlayer());
                shouldDeliver = true;
            }
            realOffer = AmadronOfferManager.getInstance().get(((AmadronOfferCustom)offer).copy().invert());
            if(realOffer != null) {//If we find the inverted offer, that means the Drone has just restocked.
                ((AmadronOfferCustom)realOffer).addStock(drone.getOfferTimes());
            }
        } else {
            shouldDeliver = true;
        }
        if(shouldDeliver) {
            ItemStack usedTablet = drone.getUsedTablet();
            if(offer.getOutput() instanceof ItemStack) {
                ItemStack offeringItems = (ItemStack)offer.getOutput();
                int producedItems = offeringItems.field_77994_a * drone.getOfferTimes();
                List<ItemStack> stacks = new ArrayList<ItemStack>();
                while(producedItems > 0) {
                    ItemStack stack = offeringItems.func_77946_l();
                    stack.field_77994_a = Math.min(producedItems, stack.func_77976_d());
                    stacks.add(stack);
                    producedItems -= stack.field_77994_a;
                }
                BlockPos pos = ItemAmadronTablet.getItemProvidingLocation(usedTablet);
                if(pos != null) {
                    World world = PneumaticCraftUtils.getWorldForDimension(ItemAmadronTablet.getItemProvidingDimension(usedTablet));
                    DroneRegistry.getInstance().deliverItemsAmazonStyle(world, pos, stacks.toArray(new ItemStack[stacks.size()]));
                }
            } else {
                FluidStack offeringFluid = ((FluidStack)offer.getOutput()).copy();
                offeringFluid.amount *= drone.getOfferTimes();
                BlockPos pos = ItemAmadronTablet.getLiquidProvidingLocation(usedTablet);
                if(pos != null) {
                    World world = PneumaticCraftUtils.getWorldForDimension(ItemAmadronTablet.getLiquidProvidingDimension(usedTablet));
                    DroneRegistry.getInstance().deliverFluidAmazonStyle(world, pos, offeringFluid);
                }
            }
        }
    }
}
