package pneumaticCraft.common;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.server.MinecraftServer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import pneumaticCraft.common.ai.DroneClaimManager;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.config.AmadronOfferPeriodicConfig;
import pneumaticCraft.common.network.AbstractPacket;
import pneumaticCraft.common.network.DescPacketHandler;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketServerTickTime;
import pneumaticCraft.common.recipes.AmadronOfferManager;
import pneumaticCraft.common.tileentity.TileEntityElectrostaticCompressor;
import pneumaticCraft.lib.PneumaticValues;

public class TickHandlerPneumaticCraft{

    @SubscribeEvent
    public void tickEnd(TickEvent.WorldTickEvent event){
        if(event.phase == TickEvent.Phase.END) {
            World world = event.world;
            checkLightning(world);
            DroneClaimManager.getInstance(world).update();
            if(!event.world.field_72995_K && event.world.field_73011_w.func_177502_q() == 0 && event.world.func_72820_D() % (24000 / AmadronOfferPeriodicConfig.timesPerDay) == 1) {
                AmadronOfferManager.getInstance().shufflePeriodicOffers();
            }
            if(!event.world.field_72995_K && event.world.func_82737_E() % 100 == 0) {
                double tickTime = net.minecraft.util.MathHelper.func_76127_a(MinecraftServer.func_71276_C().field_71311_j) * 1.0E-6D;//In case world are going to get their own thread: MinecraftServer.getServer().worldTickTimes.get(event.world.provider.getDimensionId())
                NetworkHandler.sendToDimension(new PacketServerTickTime(tickTime), event.world.field_73011_w.func_177502_q());
                if(event.world.func_82737_E() % 600 == 0) AmadronOfferManager.getInstance().tryRestockCustomOffers();
            }
        }
    }

    @SubscribeEvent
    public void serverTick(TickEvent.ClientTickEvent event){
        if(event.phase == TickEvent.Phase.END) {
            DescPacketHandler.processPackets();
            AbstractPacket.processPackets();
        }
    }

    private void checkLightning(World world){
        if(world.field_72995_K) return;

        for(int i = 0; i < world.field_73007_j.size(); i++) {
            Entity entity = world.field_73007_j.get(i);
            if(entity.field_70173_aa == 1 && entity instanceof EntityLightningBolt) {
                handleElectrostaticGeneration(world, entity);
            }
        }
    }

    //TODO 1.8 test Electrostatic compressor
    private void handleElectrostaticGeneration(World world, Entity entity){
        Set<BlockPos> posList = new HashSet<BlockPos>();
        getElectrostaticGrid(posList, world, new BlockPos(Math.round(entity.field_70165_t), Math.round(entity.field_70163_u), Math.round(entity.field_70161_v)));
        List<TileEntityElectrostaticCompressor> compressors = new ArrayList<TileEntityElectrostaticCompressor>();
        for(BlockPos pos : posList) {
            if(world.func_180495_p(pos).func_177230_c() == Blockss.electrostaticCompressor) {
                TileEntity te = world.func_175625_s(pos);
                if(te instanceof TileEntityElectrostaticCompressor) {
                    compressors.add((TileEntityElectrostaticCompressor)te);
                }
            }
        }
        for(TileEntityElectrostaticCompressor compressor : compressors) {
            compressor.addAir(PneumaticValues.PRODUCTION_ELECTROSTATIC_COMPRESSOR / compressors.size());
            compressor.onStruckByLightning();
        }
    }

    /**
     * All Iron bar blocks blocks will be added to the given arraylist of coordinates. This method
     * will be recursively called until the whole grid of iron bars is on the list.
     * @param set
     * @param world
     * @param x
     * @param y
     * @param z
     */
    public static void getElectrostaticGrid(Set<BlockPos> set, World world, BlockPos pos){
        for(EnumFacing d : EnumFacing.field_82609_l) {
            BlockPos newPos = pos.func_177972_a(d);
            Block block = world.func_180495_p(newPos).func_177230_c();
            if((block == net.minecraft.init.Blocks.field_150411_aY || block == Blockss.electrostaticCompressor) && set.add(newPos)) {
                getElectrostaticGrid(set, world, newPos);
            }
        }
    }
}
