package pneumaticCraft.common.ai;

import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.ai.EntityAIAttackOnCollide;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.common.entity.living.EntityDrone;
import pneumaticCraft.common.item.Itemss;

public class DroneAIAttackEntity extends EntityAIAttackOnCollide{
    private final EntityDrone attacker;
    private final boolean isRanged;
    private final double rangedAttackRange;

    public DroneAIAttackEntity(EntityDrone attacker, double speed, boolean p_i1636_4_){
        super(attacker, speed, p_i1636_4_);
        this.attacker = attacker;
        isRanged = attacker.hasMinigun();
        rangedAttackRange = 16 + Math.min(16, ((IDroneBase)attacker).getUpgrades(Itemss.upgrades.get(EnumUpgrade.RANGE)));
    }

    @Override
    public boolean func_75250_a(){
        if(isRanged && attacker.getAmmo() == null) {
            attacker.addDebugEntry("gui.progWidget.entityAttack.debug.noAmmo");
            return false;
        }

        EntityLivingBase entitylivingbase = attacker.func_70638_az();
        if(entitylivingbase == null) {
            attacker.addDebugEntry("gui.progWidget.entityAttack.debug.noEntityToAttack");
        }

        return super.func_75250_a();
    }

    @Override
    public boolean func_75253_b(){
        if(isRanged) {
            EntityLivingBase entitylivingbase = attacker.func_70638_az();
            if(entitylivingbase == null) return false;
            double dist = attacker.func_70092_e(entitylivingbase.field_70165_t, entitylivingbase.func_174813_aQ().field_72338_b, entitylivingbase.field_70161_v);
            if(attacker.getAmmo() == null) return false;
            if(dist < Math.pow(rangedAttackRange, 2) && attacker.func_70635_at().func_75522_a(entitylivingbase)) return true;
        }
        return super.func_75253_b();
    }

    @Override
    public void func_75251_c(){

    }

    /**
     * Updates the task
     */
    @Override
    public void func_75246_d(){
        boolean needingSuper = true;
        if(isRanged) {
            EntityLivingBase entitylivingbase = attacker.func_70638_az();
            double dist = attacker.func_70092_e(entitylivingbase.field_70165_t, entitylivingbase.func_174813_aQ().field_72338_b, entitylivingbase.field_70161_v);
            if(dist < Math.pow(rangedAttackRange, 2) && attacker.func_70635_at().func_75522_a(entitylivingbase)) {
                attacker.getFakePlayer().field_70165_t = attacker.field_70165_t;//Knockback direction
                attacker.getFakePlayer().field_70163_u = attacker.field_70163_u;
                attacker.getFakePlayer().field_70161_v = attacker.field_70161_v;
                attacker.tryFireMinigun(entitylivingbase);
                needingSuper = false;
                if(dist < Math.pow(rangedAttackRange - 4, 2)) {
                    attacker.func_70661_as().func_75499_g();
                }
            }
        }
        if(needingSuper) super.func_75246_d();
    }
}
