package pneumaticCraft.common.ai;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemRedstone;
import net.minecraft.item.ItemReed;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import net.minecraftforge.event.ForgeEventFactory;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent.Action;
import pneumaticCraft.common.progwidgets.IBlockRightClicker;
import pneumaticCraft.common.progwidgets.ISidedWidget;
import pneumaticCraft.common.progwidgets.ProgWidgetAreaItemBase;
import pneumaticCraft.common.progwidgets.ProgWidgetPlace;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.Log;

public class DroneAIBlockInteract extends DroneAIBlockInteraction{

    private final List<BlockPos> visitedPositions = new ArrayList<BlockPos>();

    public DroneAIBlockInteract(IDroneBase drone, ProgWidgetAreaItemBase widget){
        super(drone, widget);
        drone.getFakePlayer().func_70095_a(((IBlockRightClicker)widget).isSneaking());
    }

    @Override
    protected boolean isValidPosition(BlockPos pos){
        return !visitedPositions.contains(pos) && (widget.isItemFilterEmpty() || DroneAIDig.isBlockValidForFilter(drone.getWorld(), drone, pos, widget));
    }

    @Override
    protected boolean doBlockInteraction(BlockPos pos, double distToBlock){
        visitedPositions.add(pos);
        boolean result = rightClick(pos);
        if(drone.getFakePlayer().func_71045_bC() != null && drone.getFakePlayer().func_71045_bC().field_77994_a <= 0) {
            drone.getFakePlayer().func_70062_b(0, null);
        }
        transferToDroneFromFakePlayer(drone);
        return result;
    }

    public static void transferToDroneFromFakePlayer(IDroneBase drone){
        //transfer items
        for(int j = 1; j < drone.getFakePlayer().field_71071_by.field_70462_a.length; j++) {
            ItemStack excessStack = drone.getFakePlayer().field_71071_by.field_70462_a[j];
            if(excessStack != null) {
                ItemStack remainder = PneumaticCraftUtils.exportStackToInventory(drone.getInv(), excessStack, null);
                if(remainder != null) {
                    drone.dropItem(remainder);
                }
                drone.getFakePlayer().field_71071_by.field_70462_a[j] = null;
            }
        }

    }

    private boolean rightClick(BlockPos pos){

        EnumFacing faceDir = ProgWidgetPlace.getDirForSides(((ISidedWidget)widget).getSides());
        EntityPlayer player = drone.getFakePlayer();
        World worldObj = drone.getWorld();
        int dx = faceDir.func_82601_c();
        int dy = faceDir.func_96559_d();
        int dz = faceDir.func_82599_e();

        player.func_70107_b(pos.func_177958_n() + 0.5, pos.func_177956_o() + 0.5 - player.eyeHeight, pos.func_177952_p() + 0.5);
        player.field_70125_A = faceDir.func_96559_d() * -90;
        switch(faceDir){
            case NORTH:
                player.field_70177_z = 180;
                break;
            case SOUTH:
                player.field_70177_z = 0;
                break;
            case WEST:
                player.field_70177_z = 90;
                break;
            case EAST:
                player.field_70177_z = -90;
        }

        try {
            PlayerInteractEvent event = ForgeEventFactory.onPlayerInteract(player, Action.RIGHT_CLICK_AIR, worldObj, pos, faceDir);
            if(event.isCanceled()) return false;

            IBlockState state = worldObj.func_180495_p(pos);
            Block block = state.func_177230_c();

            ItemStack stack = player.func_71045_bC();
            if(stack != null && stack.func_77973_b().onItemUseFirst(stack, player, worldObj, pos, faceDir, dx, dy, dz)) return false;

            if(!worldObj.func_175623_d(pos) && block.func_180639_a(worldObj, pos, state, player, faceDir, dx, dy, dz)) return false;

            if(stack != null) {
                boolean isGoingToShift = false;
                if(stack.func_77973_b() instanceof ItemReed || stack.func_77973_b() instanceof ItemRedstone) {
                    isGoingToShift = true;
                }
                if(stack.func_77973_b().func_180614_a(stack, player, worldObj, pos, faceDir, dx, dy, dz)) return false;

                ItemStack copy = stack.func_77946_l();
                player.func_70062_b(0, stack.func_77973_b().func_77659_a(stack, worldObj, player));
                if(!copy.func_77969_a(stack)) return true;
            }
            return false;
        } catch(Throwable e) {
            Log.error("DroneAIBlockInteract crashed! Stacktrace: ");
            e.printStackTrace();
            return false;
        }
    }

}
