package pneumaticCraft.common.ai;

import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import pneumaticCraft.common.progwidgets.ICountWidget;
import pneumaticCraft.common.progwidgets.ISidedWidget;
import pneumaticCraft.common.progwidgets.ProgWidgetAreaItemBase;
import pneumaticCraft.common.util.IOHelper;
import pneumaticCraft.lib.PneumaticValues;

public class DroneEntityAIInventoryExport extends DroneAIImExBase{

    public DroneEntityAIInventoryExport(IDroneBase drone, ProgWidgetAreaItemBase widget){
        super(drone, widget);
    }

    @Override
    protected boolean isValidPosition(BlockPos pos){
        return export(pos, true);
    }

    @Override
    protected boolean doBlockInteraction(BlockPos pos, double distToBlock){
        return export(pos, false) && super.doBlockInteraction(pos, distToBlock);
    }

    private boolean export(BlockPos pos, boolean simulate){
        IInventory inv = IOHelper.getInventoryForTE(drone.getWorld().func_175625_s(pos));
        if(inv != null) {
            for(int i = 0; i < drone.getInv().func_70302_i_(); i++) {
                ItemStack droneStack = drone.getInv().func_70301_a(i);
                if(droneStack != null) {
                    if(widget.isItemValidForFilters(droneStack)) {
                        for(int side = 0; side < 6; side++) {
                            droneStack = drone.getInv().func_70301_a(i);
                            if(((ISidedWidget)widget).getSides()[side] && droneStack != null) {
                                droneStack = droneStack.func_77946_l();
                                int oldCount = droneStack.field_77994_a;
                                if(((ICountWidget)widget).useCount()) droneStack.field_77994_a = Math.min(droneStack.field_77994_a, getRemainingCount());
                                ItemStack remainder = IOHelper.insert(inv, droneStack.func_77946_l(), EnumFacing.func_82600_a(side), simulate);
                                int stackSize = drone.getInv().func_70301_a(i).field_77994_a - (remainder == null ? droneStack.field_77994_a : droneStack.field_77994_a - remainder.field_77994_a);
                                droneStack.field_77994_a = stackSize;
                                int exportedItems = oldCount - stackSize;
                                if(!simulate) {
                                    drone.getInv().func_70299_a(i, stackSize > 0 ? droneStack : null);
                                    decreaseCount(exportedItems);
                                }
                                if(simulate && exportedItems > 0) return true;
                                if(!(inv instanceof ISidedInventory)) break; //doing it for every side for no side sensitive inventories would be a waste.
                            }
                        }
                        if(droneStack == null && !simulate) drone.addAir(null, -PneumaticValues.DRONE_USAGE_INV);
                        else drone.addDebugEntry("gui.progWidget.inventoryExport.debug.filledToMax", pos);
                    } else {
                        drone.addDebugEntry("gui.progWidget.inventoryExport.debug.stackdoesntPassFilter", pos);
                    }
                }
            }
        } else {
            drone.addDebugEntry("gui.progWidget.inventory.debug.noInventory", pos);
        }
        return false;
    }
}
