package pneumaticCraft.common.ai;

import java.util.Set;

import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import pneumaticCraft.common.progwidgets.ICountWidget;
import pneumaticCraft.common.progwidgets.ISidedWidget;
import pneumaticCraft.common.progwidgets.ProgWidgetAreaItemBase;
import pneumaticCraft.common.util.IOHelper;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.PneumaticValues;

public class DroneEntityAIInventoryImport extends DroneAIImExBase{

    public DroneEntityAIInventoryImport(IDroneBase drone, ProgWidgetAreaItemBase widget){
        super(drone, widget);
    }

    @Override
    protected boolean isValidPosition(BlockPos pos){
        return importItems(pos, true);
    }

    @Override
    protected boolean doBlockInteraction(BlockPos pos, double distToBlock){
        return importItems(pos, false) && super.doBlockInteraction(pos, distToBlock);
    }

    private boolean importItems(BlockPos pos, boolean simulate){
        IInventory inv = IOHelper.getInventoryForTE(drone.getWorld().func_175625_s(pos));
        if(inv != null) {
            Set<Integer> accessibleSlots = PneumaticCraftUtils.getAccessibleSlotsForInventoryAndSides(inv, ((ISidedWidget)widget).getSides());
            for(Integer i : accessibleSlots) {
                ItemStack stack = inv.func_70301_a(i);
                if(stack != null && IOHelper.canExtractItemFromInventory(inv, stack, i, ((ISidedWidget)widget).getSides())) {
                    if(widget.isItemValidForFilters(stack)) {
                        ItemStack importedStack = stack.func_77946_l();
                        if(((ICountWidget)widget).useCount()) importedStack.field_77994_a = Math.min(importedStack.field_77994_a, getRemainingCount());
                        ItemStack remainder = IOHelper.insert(drone.getInv(), importedStack.func_77946_l(), EnumFacing.UP, simulate);
                        int removedItems = importedStack.field_77994_a - (remainder != null ? remainder.field_77994_a : 0);
                        if(!simulate) {
                            ItemStack newStack = stack.func_77946_l();
                            newStack.field_77994_a = stack.field_77994_a - removedItems;
                            inv.func_70299_a(i, newStack.field_77994_a > 0 ? newStack : null);
                            decreaseCount(removedItems);
                            drone.addAir(null, -PneumaticValues.DRONE_USAGE_INV);
                            if(((ICountWidget)widget).useCount() && getRemainingCount() <= 0) return false;
                        } else if(removedItems > 0) {
                            return true;
                        } else {
                            drone.addDebugEntry("gui.progWidget.inventoryImport.debug.filledToMax", pos);
                        }
                    } else {
                        drone.addDebugEntry("gui.progWidget.inventoryImport.debug.stackdoesntPassFilter", pos);
                    }
                }
            }
        } else {
            drone.addDebugEntry("gui.progWidget.inventory.debug.noInventory", pos);
        }

        return false;
    }

}
