package pneumaticCraft.common.block;

import java.util.List;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.common.tileentity.TileEntityAphorismTile;
import pneumaticCraft.lib.BBConstants;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

import net.minecraft.util.EnumFacing.Axis;
public class BlockAphorismTile extends BlockPneumaticCraft{
    public BlockAphorismTile(Material par2Material){
        super(par2Material);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityAphorismTile.class;
    }

    @Override
    public boolean func_149662_c(){
        return false;
    }

    @Override
    public void func_180654_a(IBlockAccess blockAccess, BlockPos pos){
        EnumFacing dir = getRotation(blockAccess, pos);
        func_149676_a(dir.func_82601_c() <= 0 ? 0 : 1F - BBConstants.APHORISM_TILE_THICKNESS, dir.func_96559_d() <= 0 ? 0 : 1F - BBConstants.APHORISM_TILE_THICKNESS, dir.func_82599_e() <= 0 ? 0 : 1F - BBConstants.APHORISM_TILE_THICKNESS, dir.func_82601_c() >= 0 ? 1 : BBConstants.APHORISM_TILE_THICKNESS, dir.func_96559_d() >= 0 ? 1 : BBConstants.APHORISM_TILE_THICKNESS, dir.func_82599_e() >= 0 ? 1 : BBConstants.APHORISM_TILE_THICKNESS);
    }

    @Override
    public void func_180638_a(World world, BlockPos pos, IBlockState state, AxisAlignedBB axisalignedbb, List arraylist, Entity par7Entity){
        func_180654_a(world, pos);
        super.func_180638_a(world, pos, state, axisalignedbb, arraylist, par7Entity);
    }

    @Override
    public void func_149683_g(){
        func_149676_a(0, 0, 0.5F - BBConstants.APHORISM_TILE_THICKNESS / 2, 1, 1, 0.5F + BBConstants.APHORISM_TILE_THICKNESS / 2);
    }

    /**
     * Called when the block is placed in the world.
     */
    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entityLiving, ItemStack iStack){
        super.func_180633_a(world, pos, state, entityLiving, iStack);
        EnumFacing rotation = getRotation(world, pos);
        if(rotation.func_176740_k() == Axis.Y) {
            TileEntity te = world.func_175625_s(pos);
            if(te instanceof TileEntityAphorismTile) {
                ((TileEntityAphorismTile)te).textRotation = (((int)entityLiving.field_70177_z + 45) / 90 + 2) % 4;
            }
        }
        if(world.field_72995_K && entityLiving instanceof EntityPlayer) {
            ((EntityPlayer)entityLiving).openGui(PneumaticCraft.instance, EnumGuiId.APHORISM_TILE.ordinal(), world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
        }
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected boolean canRotateToTopOrBottom(){
        return true;
    }

    @Override
    public boolean rotateBlock(World world, EntityPlayer player, BlockPos pos, EnumFacing face){
        if(player.func_70093_af()) {
            TileEntity tile = world.func_175625_s(pos);
            if(tile instanceof TileEntityAphorismTile) {
                TileEntityAphorismTile teAt = (TileEntityAphorismTile)tile;
                if(++teAt.textRotation > 3) teAt.textRotation = 0;
                return true;
            } else {
                return false;
            }
        } else {
            return super.rotateBlock(world, player, pos, face);
        }
    }

    @Override
    protected boolean rotateForgeWay(){
        return false;
    }
}
