package pneumaticCraft.common.block;

import java.util.List;
import java.util.Random;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.common.tileentity.TileEntityAssemblyIOUnit;
import pneumaticCraft.lib.BBConstants;

public class BlockAssemblyIOUnit extends BlockPneumaticCraftModeled{

    public BlockAssemblyIOUnit(Material par2Material){
        super(par2Material);

    }

    @Override
    public boolean rotateBlock(World world, EntityPlayer player, BlockPos pos, EnumFacing side){
        if(player.func_70093_af()) {
            return super.rotateBlock(world, player, pos, side);
        } else {
            return ((TileEntityAssemblyIOUnit)world.func_175625_s(pos)).switchMode();
        }
    }

    @Override
    public void func_180654_a(IBlockAccess par1IBlockAccess, BlockPos pos){
        func_149676_a(BBConstants.ASSEMBLY_ROBOT_MIN_POS, 0F, BBConstants.ASSEMBLY_ROBOT_MIN_POS, BBConstants.ASSEMBLY_ROBOT_MAX_POS, BBConstants.ASSEMBLY_ROBOT_MAX_POS_TOP, BBConstants.ASSEMBLY_ROBOT_MAX_POS);
    }

    @Override
    public void func_180638_a(World world, BlockPos pos, IBlockState state, AxisAlignedBB axisalignedbb, List arraylist, Entity par7Entity){
        func_149676_a(BBConstants.ASSEMBLY_ROBOT_MIN_POS, BBConstants.ASSEMBLY_ROBOT_MIN_POS, BBConstants.ASSEMBLY_ROBOT_MIN_POS, BBConstants.ASSEMBLY_ROBOT_MAX_POS, BBConstants.ASSEMBLY_ROBOT_MAX_POS_TOP, BBConstants.ASSEMBLY_ROBOT_MAX_POS);
        super.func_180638_a(world, pos, state, axisalignedbb, arraylist, par7Entity);
        func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityAssemblyIOUnit.class;
    }

    @Override
    //Overriden here because the IOUnit isn't implementing IInventory (intentionally).
    protected void dropInventory(World world, BlockPos pos){

        TileEntity tileEntity = world.func_175625_s(pos);

        if(!(tileEntity instanceof TileEntityAssemblyIOUnit)) return;

        TileEntityAssemblyIOUnit inventory = (TileEntityAssemblyIOUnit)tileEntity;
        Random rand = new Random();

        ItemStack itemStack = inventory.inventory[0];

        if(itemStack != null && itemStack.field_77994_a > 0) {
            float dX = rand.nextFloat() * 0.8F + 0.1F;
            float dY = rand.nextFloat() * 0.8F + 0.1F;
            float dZ = rand.nextFloat() * 0.8F + 0.1F;

            EntityItem entityItem = new EntityItem(world, pos.func_177958_n() + dX, pos.func_177956_o() + dY, pos.func_177952_p() + dZ, new ItemStack(itemStack.func_77973_b(), itemStack.field_77994_a, itemStack.func_77952_i()));

            if(itemStack.func_77942_o()) {
                entityItem.func_92059_d().func_77982_d((NBTTagCompound)itemStack.func_77978_p().func_74737_b());
            }

            float factor = 0.05F;
            entityItem.field_70159_w = rand.nextGaussian() * factor;
            entityItem.field_70181_x = rand.nextGaussian() * factor + 0.2F;
            entityItem.field_70179_y = rand.nextGaussian() * factor;
            world.func_72838_d(entityItem);
            itemStack.field_77994_a = 0;
        }
    }

}
