package pneumaticCraft.common.block;

import java.util.List;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemBlock;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.common.tileentity.TileEntityChargingStation;
import pneumaticCraft.lib.BBConstants;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class BlockChargingStation extends BlockPneumaticCraftModeled{

    public BlockChargingStation(Material par2Material){
        super(par2Material);

    }

    @Override
    public void func_180654_a(IBlockAccess world, BlockPos pos){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityChargingStation && ((TileEntityChargingStation)te).getUpgrades(EnumUpgrade.DISPENSER) > 0) {
            func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
        } else {
            func_149676_a(BBConstants.CHARGING_STATION_MIN_POS, 0F, BBConstants.CHARGING_STATION_MIN_POS, BBConstants.CHARGING_STATION_MAX_POS, BBConstants.CHARGING_STATION_MAX_POS_TOP, BBConstants.CHARGING_STATION_MAX_POS);
        }
    }

    @Override
    public void func_180638_a(World world, BlockPos pos, IBlockState state, AxisAlignedBB axisalignedbb, List arraylist, Entity par7Entity){
        func_180654_a(world, pos);
        super.func_180638_a(world, pos, state, axisalignedbb, arraylist, par7Entity);
        func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityChargingStation.class;
    }

    @Override
    public EnumGuiId getGuiID(){
        return EnumGuiId.CHARGING_STATION;
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected int getInventoryDropEndSlot(IInventory inventory){
        return 5;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumFacing side, float par7, float par8, float par9){
        if(!world.field_72995_K && player.func_70093_af()) {
            TileEntityChargingStation station = (TileEntityChargingStation)world.func_175625_s(pos);
            station.setCamoStack(player.func_71045_bC());
            return player.func_71045_bC() != null && player.func_71045_bC().func_77973_b() instanceof ItemBlock;
        } else return super.func_180639_a(world, pos, state, player, side, par7, par8, par9);
    }

}
