package pneumaticCraft.common.block;

import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import pneumaticCraft.common.tileentity.TileEntityElevatorBase;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class BlockElevatorBase extends BlockPneumaticCraftModeled{

    public BlockElevatorBase(Material par2Material){
        super(par2Material);
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state){
        super.func_176213_c(world, pos, state);
        TileEntityElevatorBase elevatorBase = getCoreTileEntity(world, pos);
        if(elevatorBase != null) {
            elevatorBase.updateMaxElevatorHeight();
        }
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityElevatorBase.class;
    }

    @Override
    public EnumGuiId getGuiID(){
        return EnumGuiId.ELEVATOR;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumFacing side, float par7, float par8, float par9){
        return super.func_180639_a(world, getCoreElevatorPos(world, pos), state, player, side, par7, par8, par9);
    }

    @Override
    public void func_176204_a(World world, BlockPos pos, IBlockState state, Block block){
        super.func_176204_a(world, pos, state, block);
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityElevatorBase) {
            TileEntityElevatorBase thisTe = (TileEntityElevatorBase)te;
            if(thisTe.isCoreElevator()) {
                TileEntityElevatorBase teAbove = getCoreTileEntity(world, pos);
                if(teAbove != null && teAbove != thisTe) {
                    for(int i = 0; i < thisTe.func_70302_i_(); i++) {
                        ItemStack item = thisTe.func_70301_a(i);
                        if(item != null) {
                            ItemStack leftover = PneumaticCraftUtils.exportStackToInventory((IInventory)teAbove, item, null);
                            thisTe.func_70299_a(i, null);
                            if(leftover != null) {
                                EntityItem entity = new EntityItem(world, teAbove.func_174877_v().func_177958_n() + 0.5, teAbove.func_174877_v().func_177956_o() + 1.5, teAbove.func_174877_v().func_177952_p() + 0.5, leftover);
                                world.func_72838_d(entity);
                            }
                        }
                    }
                }
            }
        }
    }

    public static BlockPos getCoreElevatorPos(World world, BlockPos pos){

        if(world.func_180495_p(pos.func_177972_a(EnumFacing.UP)).func_177230_c() == Blockss.elevatorBase) {
            return getCoreElevatorPos(world, pos.func_177972_a(EnumFacing.UP));
        } else {
            return pos;
        }
    }

    public static TileEntityElevatorBase getCoreTileEntity(World world, BlockPos pos){
        return (TileEntityElevatorBase)world.func_175625_s(getCoreElevatorPos(world, pos));
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        if(world.func_180495_p(pos.func_177972_a(EnumFacing.DOWN)).func_177230_c() == Blockss.elevatorBase) {
            TileEntity te = world.func_175625_s(pos.func_177972_a(EnumFacing.DOWN));
            ((TileEntityElevatorBase)te).moveInventoryToThis();
        }
        TileEntityElevatorBase elevatorBase = getCoreTileEntity(world, pos);
        if(elevatorBase != null) {
            elevatorBase.updateMaxElevatorHeight();
        }
        super.func_180663_b(world, pos, state);
    }

    @Override
    protected void dropInventory(World world, BlockPos pos){

        TileEntity tileEntity = world.func_175625_s(pos);

        if(!(tileEntity instanceof TileEntityElevatorBase)) return;

        TileEntityElevatorBase inventory = (TileEntityElevatorBase)tileEntity;
        Random rand = new Random();
        for(int i = getInventoryDropStartSlot(inventory); i < getInventoryDropEndSlot(inventory); i++) {

            ItemStack itemStack = inventory.getRealStackInSlot(i);

            if(itemStack != null && itemStack.field_77994_a > 0) {
                float dX = rand.nextFloat() * 0.8F + 0.1F;
                float dY = rand.nextFloat() * 0.8F + 0.1F;
                float dZ = rand.nextFloat() * 0.8F + 0.1F;

                EntityItem entityItem = new EntityItem(world, pos.func_177958_n() + dX, pos.func_177956_o() + dY, pos.func_177952_p() + dZ, new ItemStack(itemStack.func_77973_b(), itemStack.field_77994_a, itemStack.func_77952_i()));

                if(itemStack.func_77942_o()) {
                    entityItem.func_92059_d().func_77982_d((NBTTagCompound)itemStack.func_77978_p().func_74737_b());
                }

                float factor = 0.05F;
                entityItem.field_70159_w = rand.nextGaussian() * factor;
                entityItem.field_70181_x = rand.nextGaussian() * factor + 0.2F;
                entityItem.field_70179_y = rand.nextGaussian() * factor;
                world.func_72838_d(entityItem);
                itemStack.field_77994_a = 0;
            }
        }
    }
}
