package pneumaticCraft.common.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.common.tileentity.TileEntityElevatorBase;
import pneumaticCraft.common.tileentity.TileEntityElevatorFrame;

public class BlockElevatorFrame extends BlockPneumaticCraftModeled{

    public BlockElevatorFrame(Material par2Material){
        super(par2Material);
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state){
        super.func_176213_c(world, pos, state);
        TileEntityElevatorBase elevatorBase = getElevatorTE(world, pos);
        if(elevatorBase != null) {
            elevatorBase.updateMaxElevatorHeight();
        }
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityElevatorFrame.class;
    }

    @Override
    public MovingObjectPosition func_180636_a(World world, BlockPos pos, Vec3 origin, Vec3 direction){
        if(world.field_72995_K) {
            ItemStack playerStack = PneumaticCraft.proxy.getPlayer().func_71045_bC();
            if(playerStack != null && playerStack.func_77973_b() == Item.func_150898_a(this)) {
                return super.func_180636_a(world, pos, origin, direction);
            }
        }
        boolean frameXPos = world.func_180495_p(pos.func_177982_a(1, 0, 0)).func_177230_c() == Blockss.elevatorFrame;
        boolean frameXNeg = world.func_180495_p(pos.func_177982_a(-1, 0, 0)).func_177230_c() == Blockss.elevatorFrame;
        boolean frameZPos = world.func_180495_p(pos.func_177982_a(0, 0, 1)).func_177230_c() == Blockss.elevatorFrame;
        boolean frameZNeg = world.func_180495_p(pos.func_177982_a(0, 0, -1)).func_177230_c() == Blockss.elevatorFrame;

        boolean isColliding = false;

        if(!frameXNeg && !frameZNeg) {
            func_149676_a(0, 0, 0, 2 / 16F, 1, 2 / 16F);
            if(super.func_180636_a(world, pos, origin, direction) != null) isColliding = true;
        }
        if(!frameXNeg && !frameZPos) {
            func_149676_a(0, 0, 14 / 16F, 2 / 16F, 1, 1);
            if(super.func_180636_a(world, pos, origin, direction) != null) isColliding = true;
        }
        if(!frameXPos && !frameZPos) {
            func_149676_a(14 / 16F, 0, 14 / 16F, 1, 1, 1);
            if(super.func_180636_a(world, pos, origin, direction) != null) isColliding = true;
        }
        if(!frameXPos && !frameZNeg) {
            func_149676_a(14 / 16F, 0, 0, 1, 1, 2 / 16F);
            if(super.func_180636_a(world, pos, origin, direction) != null) isColliding = true;
        }

        func_149676_a(0, 0, 0, 1, 1, 1);
        return isColliding ? super.func_180636_a(world, pos, origin, direction) : null;
    }

    @Override
    public AxisAlignedBB func_180640_a(World par1World, BlockPos pos, IBlockState state){
        float blockHeight = getElevatorBlockHeight(par1World, pos);
        if(blockHeight > 0F) {
            // this.setBlockBounds(0, 0, 0, 1, blockHeight, 1);
            // return super.getCollisionBoundingBoxFromPool(par1World, par2,
            // par3, par4);
            int x = pos.func_177958_n();
            int y = pos.func_177956_o();
            int z = pos.func_177952_p();
            return new AxisAlignedBB(x, y, z, x + 1, y + blockHeight, z + 1);
        } else {
            return null;
        }
        // return null;
    }

    /**
     * Triggered whenever an entity collides with this block (enters into the block). Args: world, x, y, z, entity
     */
    @Override
    public void func_176199_a(World world, BlockPos pos, Entity entity){
        //  float blockHeight = getElevatorBlockHeight(world, x, y, z);
        //   if(blockHeight > 0) {
        // if(entity.posY < y + blockHeight) {
        //     entity.setPosition(entity.posX, y + blockHeight + 2, entity.posZ);
        TileEntityElevatorBase te = getElevatorTE(world, pos);
        if(te != null && te.oldExtension != te.extension) {
            entity.func_70107_b(entity.field_70165_t, te.func_174877_v().func_177956_o() + te.extension + entity.func_70033_W() + entity.field_70131_O + 1, entity.field_70161_v);
        }
        entity.field_70143_R = 0;
        //}
        //   }
    }

    public static TileEntityElevatorBase getElevatorTE(IBlockAccess world, BlockPos pos){
        while(true) {
            pos = pos.func_177972_a(EnumFacing.DOWN);
            if(world.func_180495_p(pos).func_177230_c() == Blockss.elevatorBase) break;
            if(world.func_180495_p(pos).func_177230_c() != Blockss.elevatorFrame || pos.func_177956_o() <= 0) return null;
        }
        return (TileEntityElevatorBase)world.func_175625_s(pos);
    }

    private float getElevatorBlockHeight(World world, BlockPos pos){
        TileEntityElevatorBase te = getElevatorTE(world, pos);
        if(te == null) return 0F;
        float blockHeight = te.extension - (pos.func_177956_o() - te.func_174877_v().func_177956_o()) + 1;
        // System.out.println("blockHeight (" + x + ", " + y + ", " + z + "): " + blockHeight);
        // + blockHeight);
        if(blockHeight < 0F) return 0F;
        if(blockHeight > 1F) return 1F;
        return blockHeight;
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        TileEntityElevatorBase elevatorBase = getElevatorTE(world, pos);
        if(elevatorBase != null) {
            elevatorBase.updateMaxElevatorHeight();
        }
        super.func_180663_b(world, pos, state);
    }
}
