package pneumaticCraft.common.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockState;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.common.tileentity.TileEntityOmnidirectionalHopper;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class BlockOmnidirectionalHopper extends BlockPneumaticCraftModeled{

    public static final PropertyEnum<EnumFacing> INPUT = PropertyEnum.<EnumFacing> func_177709_a("input", EnumFacing.class);

    public BlockOmnidirectionalHopper(Material par2Material){
        super(par2Material);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityOmnidirectionalHopper.class;
    }

    @Override
    public EnumGuiId getGuiID(){
        return EnumGuiId.OMNIDIRECTIONAL_HOPPER;
    }

    @Override
    protected BlockState func_180661_e(){
        return new BlockState(this, ROTATION, INPUT);
    }

    @Override
    public IBlockState func_176203_a(int meta){
        return super.func_176203_a(meta).func_177226_a(INPUT, EnumFacing.field_82609_l[meta / 6 % 6]);
    }

    @Override
    public int func_176201_c(IBlockState state){
        return 0;//super.getMetaFromState(state) + state.getValue(OUTPUT).ordinal() * 6;
    }

    @Override
    public IBlockState func_176221_a(IBlockState state, IBlockAccess worldIn, BlockPos pos){
        state = super.func_176221_a(state, worldIn, pos);
        TileEntityOmnidirectionalHopper te = (TileEntityOmnidirectionalHopper)worldIn.func_175625_s(pos);
        return state.func_177226_a(INPUT, te.getDirection()).func_177226_a(ROTATION, te.getRotation());
    }

    @Override
    protected EnumFacing getRotation(IBlockAccess world, BlockPos pos){
        TileEntityOmnidirectionalHopper hopper = (TileEntityOmnidirectionalHopper)world.func_175625_s(pos);
        return hopper.getRotation();
    }

    @Override
    protected void setRotation(World world, BlockPos pos, EnumFacing rotation){
        TileEntityOmnidirectionalHopper hopper = (TileEntityOmnidirectionalHopper)world.func_175625_s(pos);
        hopper.setRotation(rotation);
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase par5EntityLiving, ItemStack par6ItemStack){
        TileEntityOmnidirectionalHopper hopper = (TileEntityOmnidirectionalHopper)world.func_175625_s(pos);
        hopper.setDirection(PneumaticCraftUtils.getDirectionFacing(par5EntityLiving, true).func_176734_d());
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected boolean canRotateToTopOrBottom(){
        return true;
    }

    @Override
    public boolean rotateBlock(World world, EntityPlayer player, BlockPos pos, EnumFacing face){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityOmnidirectionalHopper) {
            TileEntityOmnidirectionalHopper teOh = (TileEntityOmnidirectionalHopper)te;
            if(player != null && player.func_70093_af()) {
                EnumFacing rotation = getRotation(world, pos);
                rotation = EnumFacing.func_82600_a(rotation.ordinal() + 1);
                if(rotation == teOh.getDirection()) rotation = EnumFacing.func_82600_a(rotation.ordinal() + 1);
                setRotation(world, pos, rotation);
            } else {
                EnumFacing rotation = teOh.getDirection();
                rotation = EnumFacing.func_82600_a(rotation.ordinal() + 1);
                if(rotation == getRotation(world, pos)) rotation = EnumFacing.func_82600_a(rotation.ordinal() + 1);
                teOh.setDirection(rotation);
            }
            return true;
        }
        return false;
    }

    @Override
    public MovingObjectPosition func_180636_a(World world, BlockPos pos, Vec3 origin, Vec3 direction){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityOmnidirectionalHopper) {
            EnumFacing o = ((TileEntityOmnidirectionalHopper)te).getDirection();
            boolean isColliding = false;
            func_149676_a(o.func_82601_c() == 1 ? 10 / 16F : 0, o.func_96559_d() == 1 ? 10 / 16F : 0, o.func_82599_e() == 1 ? 10 / 16F : 0, o.func_82601_c() == -1 ? 6 / 16F : 1, o.func_96559_d() == -1 ? 6 / 16F : 1, o.func_82599_e() == -1 ? 6 / 16F : 1);
            if(super.func_180636_a(world, pos, origin, direction) != null) isColliding = true;
            func_149676_a(4 / 16F, 4 / 16F, 4 / 16F, 12 / 16F, 12 / 16F, 12 / 16F);
            if(super.func_180636_a(world, pos, origin, direction) != null) isColliding = true;
            func_149676_a(0, 0, 0, 1, 1, 1);
            return isColliding ? super.func_180636_a(world, pos, origin, direction) : null;
        }
        return null;
    }
}
