package pneumaticCraft.common.block;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Set;

import net.minecraft.block.Block;
import net.minecraft.block.BlockContainer;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockState;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.Loader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.api.block.IPneumaticWrenchable;
import pneumaticCraft.api.item.IUpgradeAcceptor;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.thirdparty.ModInteractionUtils;
import pneumaticCraft.common.tileentity.IComparatorSupport;
import pneumaticCraft.common.tileentity.TileEntityBase;
import pneumaticCraft.common.tileentity.TileEntityPneumaticBase;
import pneumaticCraft.common.util.FluidUtils;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.ModIds;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

import net.minecraft.util.EnumFacing.Axis;
//TODO Computercraft dep @Optional.Interface(iface = "dan200.computercraft.api.peripheral.IPeripheralProvider", modid = ModIds.COMPUTERCRAFT)
public abstract class BlockPneumaticCraft extends BlockContainer implements IPneumaticWrenchable, IUpgradeAcceptor/*, IPeripheralProvider*/{

    public static final PropertyEnum<EnumFacing> ROTATION = PropertyEnum.<EnumFacing> func_177709_a("facing", EnumFacing.class);

    protected BlockPneumaticCraft(Material par2Material){
        super(par2Material);
        func_149647_a(PneumaticCraft.tabPneumaticCraft);
        func_149711_c(3.0F);
        func_149752_b(10.0F);
    }

    @Override
    public TileEntity func_149915_a(World world, int metadata){
        try {
            TileEntity te = getTileEntityClass().newInstance();
            te.func_145834_a(world);
            return te;
        } catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    protected abstract Class<? extends TileEntity> getTileEntityClass();

    public EnumGuiId getGuiID(){
        return null;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumFacing face, float par7, float par8, float par9){
        if(player.func_70093_af() || getGuiID() == null || isRotatable() && player.func_71045_bC() != null && (player.func_71045_bC().func_77973_b() == Itemss.manometer || ModInteractionUtils.getInstance().isModdedWrench(player.func_71045_bC().func_77973_b()))) return false;
        else {
            if(!world.field_72995_K) {
                TileEntity te = world.func_175625_s(pos);

                List<ItemStack> returnedItems = new ArrayList<ItemStack>();
                if(te != null && !FluidUtils.tryInsertingLiquid(te, player.func_71045_bC(), player.field_71075_bZ.field_75098_d, returnedItems)) {
                    player.openGui(PneumaticCraft.instance, getGuiID().ordinal(), world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
                } else {
                    if(player.func_71045_bC() != null && player.func_71045_bC().field_77994_a <= 0) {
                        player.func_70062_b(0, null);
                    }
                    for(ItemStack returnedItem : returnedItems) {
                        returnedItem = returnedItem.func_77946_l();
                        if(player.func_71045_bC() == null) {
                            player.func_70062_b(0, returnedItem);
                        } else {
                            player.field_71071_by.func_70441_a(returnedItem);
                        }
                    }
                }
            }

            return true;
        }
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity, ItemStack stack){
        if(isRotatable()) {
            EnumFacing rotation = PneumaticCraftUtils.getDirectionFacing(entity, canRotateToTopOrBottom());
            setRotation(world, pos, rotation, state);
        }
    }

    protected void setRotation(World world, BlockPos pos, EnumFacing rotation){
        setRotation(world, pos, rotation, world.func_180495_p(pos));
    }

    protected EnumFacing getRotation(IBlockAccess world, BlockPos pos){
        return getRotation(world.func_180495_p(pos));
    }

    protected EnumFacing getRotation(IBlockState state){
        return state.func_177229_b(ROTATION);
    }

    private void setRotation(World world, BlockPos pos, EnumFacing rotation, IBlockState state){
        world.func_175656_a(pos, state.func_177226_a(ROTATION, rotation));
    }

    public boolean isRotatable(){
        return false;
    }

    protected boolean canRotateToTopOrBottom(){
        return false;
    }

    @Override
    protected BlockState func_180661_e(){
        if(isRotatable()) {
            return new BlockState(this, new IProperty[]{ROTATION});
        } else {
            return super.func_180661_e();
        }
    }

    @Override
    public int func_176201_c(IBlockState state){
        if(isRotatable()) {
            return state.func_177229_b(ROTATION).ordinal();
        } else {
            return super.func_176201_c(state);
        }
    }

    @Override
    public IBlockState func_176203_a(int meta){
        if(isRotatable()) {
            return super.func_176203_a(meta).func_177226_a(ROTATION, EnumFacing.func_82600_a(meta));
        } else {
            return super.func_176203_a(meta);
        }
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        dropInventory(world, pos);
        super.func_180663_b(world, pos, state);
    }

    protected void dropInventory(World world, BlockPos pos){

        TileEntity tileEntity = world.func_175625_s(pos);

        if(!(tileEntity instanceof IInventory)) return;

        IInventory inventory = (IInventory)tileEntity;
        Random rand = new Random();
        for(int i = getInventoryDropStartSlot(inventory); i < getInventoryDropEndSlot(inventory); i++) {

            ItemStack itemStack = inventory.func_70301_a(i);

            if(itemStack != null && itemStack.field_77994_a > 0) {
                float dX = rand.nextFloat() * 0.8F + 0.1F;
                float dY = rand.nextFloat() * 0.8F + 0.1F;
                float dZ = rand.nextFloat() * 0.8F + 0.1F;

                EntityItem entityItem = new EntityItem(world, pos.func_177958_n() + dX, pos.func_177956_o() + dY, pos.func_177952_p() + dZ, new ItemStack(itemStack.func_77973_b(), itemStack.field_77994_a, itemStack.func_77952_i()));

                if(itemStack.func_77942_o()) {
                    entityItem.func_92059_d().func_77982_d((NBTTagCompound)itemStack.func_77978_p().func_74737_b());
                }

                float factor = 0.05F;
                entityItem.field_70159_w = rand.nextGaussian() * factor;
                entityItem.field_70181_x = rand.nextGaussian() * factor + 0.2F;
                entityItem.field_70179_y = rand.nextGaussian() * factor;
                world.func_72838_d(entityItem);
                itemStack.field_77994_a = 0;
            }
        }
    }

    protected int getInventoryDropStartSlot(IInventory inventory){
        return 0;
    }

    protected int getInventoryDropEndSlot(IInventory inventory){
        return inventory.func_70302_i_();
    }

    @Override
    public boolean rotateBlock(World world, EntityPlayer player, BlockPos pos, EnumFacing side){
        if(player.func_70093_af()) {
            if(!player.field_71075_bZ.field_75098_d) func_176226_b(world, pos, world.func_180495_p(pos), 0);
            world.func_175698_g(pos);
            return true;
        } else {
            if(isRotatable()) {
                IBlockState state = world.func_180495_p(pos);
                if(!rotateCustom(world, pos, state, side)) {
                    TileEntityBase te = (TileEntityBase)world.func_175625_s(pos);
                    if(rotateForgeWay()) {
                        if(!canRotateToTopOrBottom()) side = EnumFacing.UP;
                        if(getRotation(world, pos).func_176740_k() != side.func_176740_k()) setRotation(world, pos, getRotation(world, pos).func_176732_a(side.func_176740_k()));
                    } else {
                        do {
                            setRotation(world, pos, EnumFacing.func_82600_a(getRotation(world, pos).ordinal() + 1));
                        } while(canRotateToTopOrBottom() || getRotation(world, pos).func_176740_k() != Axis.Y);
                    }
                    te.onBlockRotated();
                }
                return true;
            } else {
                return false;
            }
        }
    }

    protected boolean rotateForgeWay(){
        return true;
    }

    protected boolean rotateCustom(World world, BlockPos pos, IBlockState state, EnumFacing side){
        return false;
    }

    /**
     * Called when a tile entity on a side of this block changes is created or is destroyed.
     * @param world The world
     * @param x The x position of this block instance
     * @param y The y position of this block instance
     * @param z The z position of this block instance
     * @param tileX The x position of the tile that changed
     * @param tileY The y position of the tile that changed
     * @param tileZ The z position of the tile that changed
     */
    @Override
    public void onNeighborChange(IBlockAccess world, BlockPos pos, BlockPos tilePos){
        if(world instanceof World && !((World)world).field_72995_K) {
            TileEntity te = world.func_175625_s(pos);
            if(te instanceof TileEntityBase) {
                ((TileEntityBase)te).onNeighborTileUpdate();
            }
        }
    }

    @Override
    public void func_176204_a(World world, BlockPos pos, IBlockState state, Block block){
        if(!world.field_72995_K) {
            TileEntity te = world.func_175625_s(pos);
            if(te instanceof TileEntityBase) {
                ((TileEntityBase)te).onNeighborBlockUpdate();
            }
        }
    }

    /**
     * Produce an peripheral implementation from a block location.
     * @see dan200.computercraft.api.ComputerCraftAPI#registerPeripheralProvider(IPeripheralProvider)
     * @return a peripheral, or null if there is not a peripheral here you'd like to handle.
     */
    /*  @Override
      @Optional.Method(modid = ModIds.COMPUTERCRAFT)
      public IPeripheral getPeripheral(World world, int x, int y, int z, int side){
          TileEntity te = world.getTileEntity(x, y, z);
          return te instanceof IPeripheral ? (IPeripheral)te : null;
      }*/

    @SideOnly(Side.CLIENT)
    public void addInformation(ItemStack stack, EntityPlayer player, List curInfo, boolean extraInfo){
        if(PneumaticCraft.proxy.isSneakingInGui()) {
            TileEntity te = func_149915_a(player.field_70170_p, 0);
            if(te instanceof TileEntityPneumaticBase) {
                float pressure = ((TileEntityPneumaticBase)te).dangerPressure;
                curInfo.add(EnumChatFormatting.YELLOW + I18n.func_135052_a("gui.tooltip.maxPressure", pressure));
            }
        }

        String info = "gui.tab.info." + stack.func_77977_a();
        String translatedInfo = I18n.func_135052_a(info);
        if(!translatedInfo.equals(info)) {
            if(PneumaticCraft.proxy.isSneakingInGui()) {
                translatedInfo = EnumChatFormatting.AQUA + translatedInfo.substring(2);
                if(!Loader.isModLoaded(ModIds.IGWMOD)) translatedInfo += " \\n \\n" + I18n.func_135052_a("gui.tab.info.assistIGW");
                curInfo.addAll(PneumaticCraftUtils.convertStringIntoList(translatedInfo, 40));
            } else {
                curInfo.add(EnumChatFormatting.AQUA + I18n.func_135052_a("gui.tooltip.sneakForInfo"));
            }
        }
    }

    /**
     * If this returns true, then comparators facing away from this block will use the value from
     * getComparatorInputOverride instead of the actual redstone signal strength.
     */
    @Override
    public boolean func_149740_M(){
        return IComparatorSupport.class.isAssignableFrom(getTileEntityClass());
    }

    /**
     * If hasComparatorInputOverride returns true, the return value from this is used instead of the redstone signal
     * strength when this block inputs to a comparator.
     */
    @Override
    public int func_180641_l(World world, BlockPos pos){
        return ((IComparatorSupport)world.func_175625_s(pos)).getComparatorValue();
    }

    @Override
    public Set<Item> getApplicableUpgrades(){
        return ((IUpgradeAcceptor)func_149915_a(null, 0)).getApplicableUpgrades();
    }

    @Override
    public String getName(){
        return func_149739_a() + ".name";
    }

    @Override
    public int func_149645_b(){
        return 3;
    }
}
