package pneumaticCraft.common.block;

import java.util.List;
import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockState;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import pneumaticCraft.common.tileentity.TileEntityPneumaticDoor;
import pneumaticCraft.common.tileentity.TileEntityPneumaticDoorBase;
import pneumaticCraft.lib.PneumaticValues;

public class BlockPneumaticDoor extends BlockPneumaticCraftModeled{
    public boolean isTrackingPlayerEye;//will be true when the Pneumatic Door Base is determining if it should open the door dependant
                                       //on the player watched block.
    private static final PropertyBool TOP_DOOR = PropertyBool.func_177716_a("topDoor");

    public BlockPneumaticDoor(Material par2Material){
        super(par2Material);

    }

    @Override
    protected BlockState func_180661_e(){
        return new BlockState(this, TOP_DOOR, ROTATION);
    }

    /**
     * Convert the given metadata into a BlockState for this Block
     */
    @Override
    public IBlockState func_176203_a(int meta){
        return func_176223_P().func_177226_a(TOP_DOOR, meta == 1);
    }

    /**
     * Convert the BlockState into the correct metadata value
     */
    @Override
    public int func_176201_c(IBlockState state){
        return state.func_177229_b(TOP_DOOR) ? 1 : 0;
    }

    public static boolean isTopDoor(IBlockState state){
        return state.func_177229_b(TOP_DOOR);
    }

    @Override
    public void func_180654_a(IBlockAccess blockAccess, BlockPos pos){
        if(isTrackingPlayerEye) {
            func_149676_a(0, 0, 0, 1, 1, 1);
        } else {
            float xMin = 0;
            float zMin = 0;
            float xMax = 1;
            float zMax = 1;
            TileEntity te = blockAccess.func_175625_s(pos);
            EnumFacing rotation = getRotation(blockAccess, pos);
            if(te instanceof TileEntityPneumaticDoor) {
                TileEntityPneumaticDoor door = (TileEntityPneumaticDoor)te;
                float cosinus = 13 / 16F - (float)Math.sin(Math.toRadians(door.rotation)) * 13 / 16F;
                float sinus = 13 / 16F - (float)Math.cos(Math.toRadians(door.rotation)) * 13 / 16F;
                if(door.rightGoing) {
                    switch(rotation){
                        case NORTH:
                            zMin = cosinus;
                            xMax = 1 - sinus;
                            break;
                        case WEST:
                            xMin = cosinus;
                            zMin = sinus;
                            break;
                        case SOUTH:
                            zMax = 1 - cosinus;
                            xMin = sinus;
                            break;
                        case EAST:
                            xMax = 1 - cosinus;
                            zMax = 1 - sinus;
                            break;

                    }
                } else {
                    switch(rotation){
                        case NORTH:
                            zMin = cosinus;
                            xMin = sinus;
                            break;
                        case WEST:
                            xMin = cosinus;
                            zMax = 1 - sinus;
                            break;
                        case SOUTH:
                            zMax = 1 - cosinus;
                            xMax = 1 - sinus;
                            break;
                        case EAST:
                            xMax = 1 - cosinus;
                            zMin = sinus;
                            break;

                    }
                }
            }
            boolean topDoor = isTopDoor(blockAccess.func_180495_p(pos));
            func_149676_a(xMin, topDoor ? -1 : 0, zMin, xMax, topDoor ? 1 : 2, zMax);
        }
    }

    @Override
    public void func_180638_a(World world, BlockPos pos, IBlockState state, AxisAlignedBB axisalignedbb, List arraylist, Entity par7Entity){
        func_180654_a(world, pos);
        super.func_180638_a(world, pos, state, axisalignedbb, arraylist, par7Entity);
        func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityPneumaticDoor.class;
    }

    /**
     * Checks to see if its valid to put this block at the specified coordinates. Args: world, x, y, z
     */
    @Override
    public boolean func_176196_c(World par1World, BlockPos pos){
        return !super.func_176196_c(par1World, pos) ? false : par1World.func_175623_d(pos.func_177972_a(EnumFacing.UP));
    }

    @Override
    public void func_180633_a(World par1World, BlockPos pos, IBlockState state, EntityLivingBase par5EntityLiving, ItemStack par6ItemStack){
        super.func_180633_a(par1World, pos, state, par5EntityLiving, par6ItemStack);
        par1World.func_180501_a(pos.func_177972_a(EnumFacing.UP), state.func_177226_a(TOP_DOOR, true), 3);
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    public boolean rotateBlock(World world, EntityPlayer player, BlockPos pos, EnumFacing face){
        IBlockState state = world.func_180495_p(pos);
        if(!isTopDoor(state)) {
            super.rotateBlock(world, player, pos, face);
            world.func_180501_a(pos.func_177972_a(EnumFacing.UP), state.func_177226_a(TOP_DOOR, true), 3);
            TileEntity te = world.func_175625_s(pos);
            if(te instanceof TileEntityPneumaticDoor) {
                ((TileEntityPneumaticDoor)te).rightGoing = true;
                ((TileEntityPneumaticDoor)te).setRotation(0);
                TileEntity topDoor = world.func_175625_s(pos.func_177972_a(EnumFacing.UP));
                if(topDoor instanceof TileEntityPneumaticDoor) {
                    ((TileEntityPneumaticDoor)topDoor).sendDescriptionPacket();
                }
            }
        } else {
            return rotateBlock(world, player, pos.func_177972_a(EnumFacing.DOWN), face);
        }
        return true;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumFacing side, float par7, float par8, float par9){
        TileEntityPneumaticDoorBase doorBase = getDoorBase(world, pos);
        if(!world.field_72995_K && doorBase != null && doorBase.redstoneMode == 2 && doorBase.getPressure() >= PneumaticValues.MIN_PRESSURE_PNEUMATIC_DOOR) {
            doorBase.setOpening(!doorBase.isOpening());
            doorBase.setNeighborOpening(doorBase.isOpening());
            return true;
        }
        return false;
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        if(!isTopDoor(state)) {
            BlockPos lowerPos = pos.func_177972_a(EnumFacing.DOWN);
            if(world.func_180495_p(lowerPos).func_177230_c() == Blockss.pneumaticDoor) func_176226_b(world, lowerPos, state, 0);
            world.func_175698_g(lowerPos);
        } else {
            world.func_175698_g(pos.func_177972_a(EnumFacing.UP));
        }
        super.func_180663_b(world, pos, state);
    }

    @Override
    public int quantityDropped(IBlockState state, int fortune, Random random){
        return isTopDoor(state) ? 0 : 1;
    }

    @Override
    public void func_176204_a(World world, BlockPos pos, IBlockState state, Block block){
        boolean powered = world.func_175687_A(pos) > 0;
        if(!powered) {
            powered = world.func_175687_A(pos.func_177972_a(isTopDoor(state) ? EnumFacing.DOWN : EnumFacing.UP)) > 0;
        }
        TileEntityPneumaticDoorBase doorBase = getDoorBase(world, pos);
        if(!world.field_72995_K && doorBase != null && doorBase.getPressure() >= PneumaticValues.MIN_PRESSURE_PNEUMATIC_DOOR) {
            if(powered != doorBase.wasPowered) {
                doorBase.wasPowered = powered;
                doorBase.setOpening(powered);
            }
        }
    }

    private TileEntityPneumaticDoorBase getDoorBase(World world, BlockPos pos){
        if(world.func_180495_p(pos).func_177230_c() != this) return null;
        if(!isTopDoor(world.func_180495_p(pos))) {
            return getDoorBase(world, pos.func_177972_a(EnumFacing.UP));
        } else {
            EnumFacing dir = getRotation(world, pos);
            TileEntity te1 = world.func_175625_s(pos.func_177972_a(dir.func_176746_e()));
            if(te1 instanceof TileEntityPneumaticDoorBase) {
                TileEntityPneumaticDoorBase door = (TileEntityPneumaticDoorBase)te1;
                if(door.getRotation() == dir.func_176735_f()) {
                    return door;
                }
            }
            TileEntity te2 = world.func_175625_s(pos.func_177972_a(dir.func_176735_f()));
            if(te2 instanceof TileEntityPneumaticDoorBase) {
                TileEntityPneumaticDoorBase door = (TileEntityPneumaticDoorBase)te2;
                if(door.getRotation() == dir.func_176746_e()) {
                    return door;
                }
            }
            return null;
        }
    }
}
