package pneumaticCraft.common.block;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.common.tileentity.TileEntityPneumaticDoor;
import pneumaticCraft.common.tileentity.TileEntityPneumaticDoorBase;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class BlockPneumaticDoorBase extends BlockPneumaticCraftModeled{

    public BlockPneumaticDoorBase(Material par2Material){
        super(par2Material);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public int func_149645_b(){
        return 0;
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityPneumaticDoorBase.class;
    }

    @Override
    public EnumGuiId getGuiID(){
        return EnumGuiId.PNEUMATIC_DOOR;
    }

    /**
     * Called when the block is placed in the world.
     */
    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity, ItemStack stack){
        super.func_180633_a(world, pos, state, entity, stack);
        TileEntityPneumaticDoorBase doorBase = (TileEntityPneumaticDoorBase)world.func_175625_s(pos);
        updateDoorSide(doorBase);
    }

    @Override
    public void func_176204_a(World world, BlockPos pos, IBlockState state, Block block){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityPneumaticDoorBase) {
            updateDoorSide((TileEntityPneumaticDoorBase)te);
            EnumFacing dir = ((TileEntityPneumaticDoorBase)te).getRotation();
            if(world.func_180495_p(pos.func_177972_a(dir)).func_177230_c() == Blockss.pneumaticDoor) {
                Blockss.pneumaticDoor.func_176204_a(world, pos.func_177972_a(dir), world.func_180495_p(pos.func_177972_a(dir)), block);
            }
        }
    }

    private void updateDoorSide(TileEntityPneumaticDoorBase doorBase){
        TileEntity teDoor = doorBase.func_145831_w().func_175625_s(doorBase.func_174877_v().func_177972_a(doorBase.getRotation()));
        if(teDoor instanceof TileEntityPneumaticDoor) {
            TileEntityPneumaticDoor door = (TileEntityPneumaticDoor)teDoor;
            if(doorBase.getRotation().func_176746_e() == door.getRotation() && door.rightGoing || doorBase.getRotation().func_176735_f() == door.getRotation() && !door.rightGoing) {
                door.rightGoing = !door.rightGoing;
                door.setRotation(0);
            }
        }
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected boolean canRotateToTopOrBottom(){
        return false;
    }

    @Override
    public boolean func_176225_a(IBlockAccess world, BlockPos pos, EnumFacing side){
        TileEntityPneumaticDoorBase te = (TileEntityPneumaticDoorBase)world.func_175625_s(pos.func_177967_a(side, -1));
        ItemStack camoStack = te.func_70301_a(TileEntityPneumaticDoorBase.CAMO_SLOT);
        if(camoStack != null && camoStack.func_77973_b() instanceof ItemBlock) {
            Block block = ((ItemBlock)camoStack.func_77973_b()).func_179223_d();
            if(PneumaticCraftUtils.isRenderIDCamo(block.func_149645_b())) {
                return true;
            }
        }
        return false;
    }
}
