package pneumaticCraft.common.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberInterface;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberValve;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class BlockPressureChamberInterface extends BlockPneumaticCraftModeled implements IBlockPressureChamber{

    public BlockPressureChamberInterface(Material par2Material){
        super(par2Material);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityPressureChamberInterface.class;
    }

    @Override
    public EnumGuiId getGuiID(){
        return EnumGuiId.PRESSURE_CHAMBER_INTERFACE;
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected boolean canRotateToTopOrBottom(){
        return true;
    }

    @Override
    protected int getInventoryDropEndSlot(IInventory inventory){
        return 5;
    }

    /**
     * Called when the block is placed in the world.
     */
    @Override
    public void func_180633_a(World par1World, BlockPos pos, IBlockState state, EntityLivingBase par5EntityLiving, ItemStack iStack){
        super.func_180633_a(par1World, pos, state, par5EntityLiving, iStack);
        TileEntityPressureChamberValve.checkIfProperlyFormed(par1World, pos);
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityPressureChamberInterface && !world.field_72995_K) {
            ((TileEntityPressureChamberInterface)te).onBlockBreak();
        }
        super.func_180663_b(world, pos, state);

    }
}
