package pneumaticCraft.common.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockState;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberValve;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class BlockPressureChamberValve extends BlockPneumaticCraft implements IBlockPressureChamber{

    public static final PropertyBool FORMED = PropertyBool.func_177716_a("formed");

    public BlockPressureChamberValve(Material par2Material){
        super(par2Material);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityPressureChamberValve.class;
    }

    /**
     * Called when the block is placed in the world.
     */
    @Override
    public void func_180633_a(World par1World, BlockPos pos, IBlockState state, EntityLivingBase par5EntityLiving, ItemStack iStack){
        super.func_180633_a(par1World, pos, state, par5EntityLiving, iStack);
        TileEntityPressureChamberValve.checkIfProperlyFormed(par1World, pos);
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected boolean canRotateToTopOrBottom(){
        return true;
    }

    @Override
    protected BlockState func_180661_e(){
        return new BlockState(this, ROTATION, FORMED);
    }

    @Override
    public IBlockState func_176203_a(int meta){
        return super.func_176203_a(meta).func_177226_a(FORMED, meta >= 6);
    }

    @Override
    public int func_176201_c(IBlockState state){
        return super.func_176201_c(state) + (state.func_177229_b(FORMED) ? 6 : 0);
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumFacing side, float par7, float par8, float par9){
        if(player.func_70093_af()) return false;
        TileEntity te = world.func_175625_s(pos);
        if(!world.field_72995_K && te instanceof TileEntityPressureChamberValve) {
            if(((TileEntityPressureChamberValve)te).multiBlockSize > 0) {
                player.openGui(PneumaticCraft.instance, EnumGuiId.PRESSURE_CHAMBER.ordinal(), world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
            } else if(((TileEntityPressureChamberValve)te).accessoryValves.size() > 0) { // when
                                                                                         // this
                                                                                         // isn't
                                                                                         // the
                                                                                         // core
                                                                                         // Valve,
                                                                                         // track
                                                                                         // down
                                                                                         // the
                                                                                         // core
                                                                                         // Valve.
                //  System.out.println("size: " + ((TileEntityPressureChamberValve)te).accessoryValves.size());
                for(TileEntityPressureChamberValve valve : ((TileEntityPressureChamberValve)te).accessoryValves) {
                    if(valve.multiBlockSize > 0) {
                        player.openGui(PneumaticCraft.instance, EnumGuiId.PRESSURE_CHAMBER.ordinal(), world, valve.func_174877_v().func_177958_n(), valve.func_174877_v().func_177956_o(), valve.func_174877_v().func_177952_p());
                        break;
                    }
                }
            } else {
                return false;
            }
            return true;
        }
        return true;
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        invalidateMultiBlock(world, pos);
        super.func_180663_b(world, pos, state);
    }

    private void invalidateMultiBlock(World world, BlockPos pos){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityPressureChamberValve && !world.field_72995_K) {
            if(((TileEntityPressureChamberValve)te).multiBlockSize > 0) {
                ((TileEntityPressureChamberValve)te).onMultiBlockBreak();
            } else if(((TileEntityPressureChamberValve)te).accessoryValves.size() > 0) {
                for(TileEntityPressureChamberValve valve : ((TileEntityPressureChamberValve)te).accessoryValves) {
                    if(valve.multiBlockSize > 0) {
                        valve.onMultiBlockBreak();
                        break;
                    }
                }
            }
        }
    }

}
