package pneumaticCraft.common.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberValve;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberWall;

public class BlockPressureChamberWallBase extends BlockPneumaticCraft implements IBlockPressureChamber{
    public BlockPressureChamberWallBase(Material par2Material){
        super(par2Material);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityPressureChamberWall.class;
    }

    /**
     * Called when the block is placed in the world.
     */
    @Override
    public void func_180633_a(World par1World, BlockPos pos, IBlockState state, EntityLivingBase par5EntityLiving, ItemStack iStack){
        super.func_180633_a(par1World, pos, state, par5EntityLiving, iStack);
        TileEntityPressureChamberValve.checkIfProperlyFormed(par1World, pos);
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumFacing side, float par7, float par8, float par9){
        if(world.field_72995_K) return true;
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityPressureChamberWall) {
            TileEntityPressureChamberValve valve = ((TileEntityPressureChamberWall)te).getCore();
            if(valve != null) {
                return valve.func_145838_q().func_180639_a(world, valve.func_174877_v(), world.func_180495_p(valve.func_174877_v()), player, side, par7, par8, par9);
            }
        }
        return false;
    }

    @Override
    public void func_180663_b(World world, BlockPos pos, IBlockState state){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityPressureChamberWall && !world.field_72995_K) {
            ((TileEntityPressureChamberWall)te).onBlockBreak();
        }
        super.func_180663_b(world, pos, state);

    }

}
