package pneumaticCraft.common.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import pneumaticCraft.api.tileentity.IPneumaticMachine;
import pneumaticCraft.common.thirdparty.ModInteractionUtils;
import pneumaticCraft.common.tileentity.TileEntityVortexTube;

public class BlockVortexTube extends BlockPneumaticCraftModeled{

    protected BlockVortexTube(Material par2Material){
        super(par2Material);
    }

    @Override
    protected Class<? extends TileEntity> getTileEntityClass(){
        return TileEntityVortexTube.class;
    }

    @Override
    public boolean isRotatable(){
        return true;
    }

    @Override
    protected boolean canRotateToTopOrBottom(){
        return true;
    }

    @Override
    protected boolean rotateCustom(World world, BlockPos pos, IBlockState state, EnumFacing side){
        EnumFacing rotation = getRotation(world, pos);
        if(rotation.func_176740_k() == side.func_176740_k()) {
            TileEntityVortexTube te = (TileEntityVortexTube)world.func_175625_s(pos);
            te.rotateRoll(rotation == side ? 1 : -1);
            return true;
        } else {
            return false;
        }
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase par5EntityLiving, ItemStack par6ItemStack){
        super.func_180633_a(world, pos, state, par5EntityLiving, par6ItemStack);
        TileEntityVortexTube te = (TileEntityVortexTube)world.func_175625_s(pos);
        for(int i = 0; i < 4; i++) {
            te.rotateRoll(1);
            EnumFacing d = te.getTubeDirection();
            IPneumaticMachine pneumaticMachine = ModInteractionUtils.getInstance().getMachine(world.func_175625_s(pos.func_177972_a(d)));
            if(pneumaticMachine != null && pneumaticMachine.getAirHandler(d.func_176734_d()) != null) break;
        }
    }
}
