package pneumaticCraft.common.block;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.oredict.OreDictionary;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.itemBlock.ItemBlockOmnidirectionalHopper;
import pneumaticCraft.common.itemBlock.ItemBlockPneumaticCraft;
import pneumaticCraft.common.thirdparty.ThirdPartyManager;
import pneumaticCraft.lib.Names;
import pneumaticCraft.lib.PneumaticValues;

public class Blockss{

    public static Block pressureTube;
    public static Block airCompressor;
    public static Block airCannon;
    public static Block pressureChamberWall;
    public static Block pressureChamberGlass;
    public static Block pressureChamberValve;
    public static Block pressureChamberInterface;
    public static Block chargingStation;
    public static Block elevatorBase;
    public static Block elevatorFrame;
    public static Block vacuumPump;
    public static Block pneumaticDoorBase;
    public static Block pneumaticDoor;
    public static Block assemblyPlatform;
    public static Block assemblyIOUnit;
    public static Block assemblyDrill;
    public static Block assemblyLaser;
    public static Block assemblyController;
    public static Block advancedPressureTube;
    public static Block compressedIron;
    public static Block uvLightBox;
    public static Block securityStation;
    public static Block universalSensor;
    public static Block universalActuator;
    public static Block aerialInterface;
    public static Block electrostaticCompressor;
    public static Block aphorismTile;
    public static Block omnidirectionalHopper;
    public static Block elevatorCaller;
    public static Block programmer;
    public static Block creativeCompressor;
    public static Block plasticMixer;
    public static Block liquidCompressor;
    public static Block advancedLiquidCompressor;
    public static Block advancedAirCompressor;
    public static Block liquidHopper;
    public static Block droneRedstoneEmitter;
    public static Block heatSink;
    public static Block vortexTube;
    public static Block programmableController;
    public static Block gasLift;
    public static Block refinery;
    public static Block thermopneumaticProcessingPlant;
    public static Block keroseneLamp;
    public static Block keroseneLampLight;
    public static Block sentryTurret;
    public static List<Block> blocks = new ArrayList<Block>();

    public static void init(){
        pressureTube = new BlockPressureTube(Material.field_151573_f, PneumaticValues.DANGER_PRESSURE_PRESSURE_TUBE, PneumaticValues.MAX_PRESSURE_PRESSURE_TUBE, PneumaticValues.VOLUME_PRESSURE_TUBE).func_149663_c("pressureTube");
        advancedPressureTube = new BlockPressureTube(Material.field_151573_f, PneumaticValues.DANGER_PRESSURE_ADVANCED_PRESSURE_TUBE, PneumaticValues.MAX_PRESSURE_ADVANCED_PRESSURE_TUBE, PneumaticValues.VOLUME_ADVANCED_PRESSURE_TUBE).func_149663_c("advancedPressureTube");
        airCompressor = new BlockAirCompressor(Material.field_151573_f).func_149663_c("airCompressor");
        advancedAirCompressor = new BlockAdvancedAirCompressor(Material.field_151573_f).func_149663_c("advancedAirCompressor");
        airCannon = new BlockAirCannon(Material.field_151573_f).func_149663_c("airCannon");
        pressureChamberWall = new BlockPressureChamberWall(Material.field_151573_f).func_149752_b(2000.0F).func_149663_c("pressureChamberWall");
        pressureChamberGlass = new BlockPressureChamberGlass(Material.field_151573_f).func_149752_b(2000.0F).func_149663_c("pressureChamberGlass");
        pressureChamberValve = new BlockPressureChamberValve(Material.field_151573_f).func_149752_b(2000.0F).func_149663_c("pressureChamberValve");
        chargingStation = new BlockChargingStation(Material.field_151573_f).func_149663_c("chargingStation");
        elevatorBase = new BlockElevatorBase(Material.field_151573_f).func_149663_c("elevatorBase");
        elevatorFrame = new BlockElevatorFrame(Material.field_151573_f).func_149663_c("elevatorFrame");
        pressureChamberInterface = new BlockPressureChamberInterface(Material.field_151573_f).func_149752_b(2000.0F).func_149663_c("pressureChamberInterface");
        vacuumPump = new BlockVacuumPump(Material.field_151573_f).func_149663_c("vacuumPump");
        pneumaticDoorBase = new BlockPneumaticDoorBase(Material.field_151573_f).func_149663_c("pneumaticDoorBase");
        pneumaticDoor = new BlockPneumaticDoor(Material.field_151573_f).func_149663_c("pneumaticDoor");
        assemblyIOUnit = new BlockAssemblyIOUnit(Material.field_151573_f).func_149663_c("assemblyIOUnit");
        assemblyPlatform = new BlockAssemblyPlatform(Material.field_151573_f).func_149663_c("assemblyPlatform");
        assemblyDrill = new BlockAssemblyDrill(Material.field_151573_f).func_149663_c("assemblyDrill");
        assemblyLaser = new BlockAssemblyLaser(Material.field_151573_f).func_149663_c("assemblyLaser");
        assemblyController = new BlockAssemblyController(Material.field_151573_f).func_149663_c("assemblyController");
        compressedIron = new BlockCompressedIron(Material.field_151573_f).func_149672_a(Block.field_149777_j).func_149663_c("compressedIronBlock");
        uvLightBox = new BlockUVLightBox(Material.field_151573_f).func_149663_c("uvLightBox");
        securityStation = new BlockSecurityStation(Material.field_151573_f).func_149663_c("securityStation");
        universalSensor = new BlockUniversalSensor(Material.field_151573_f).func_149663_c("universalSensor");
        universalActuator = new BlockUniversalActuator(Material.field_151573_f).func_149663_c("universalActuator");
        aerialInterface = new BlockAerialInterface(Material.field_151573_f).func_149663_c("aerialInterface");
        electrostaticCompressor = new BlockElectrostaticCompressor(Material.field_151573_f).func_149663_c("electrostaticCompressor");
        aphorismTile = new BlockAphorismTile(Material.field_151576_e).func_149711_c(1.5F).func_149752_b(4.0F).func_149663_c("aphorismTile");
        omnidirectionalHopper = new BlockOmnidirectionalHopper(Material.field_151573_f).func_149663_c("omnidirectionalHopper");
        liquidHopper = new BlockLiquidHopper(Material.field_151573_f).func_149663_c("liquidHopper");
        elevatorCaller = new BlockElevatorCaller(Material.field_151573_f).func_149663_c("elevatorCaller");
        programmer = new BlockProgrammer(Material.field_151573_f).func_149663_c("programmer");
        creativeCompressor = new BlockCreativeCompressor(Material.field_151573_f).func_149663_c("creativeCompressor");
        plasticMixer = new BlockPlasticMixer(Material.field_151573_f).func_149663_c("plasticMixer");
        liquidCompressor = new BlockLiquidCompressor(Material.field_151573_f).func_149663_c("liquidCompressor");
        advancedLiquidCompressor = new BlockAdvancedLiquidCompressor(Material.field_151573_f).func_149663_c("advancedLiquidCompressor");
        droneRedstoneEmitter = new BlockDroneRedstoneEmitter().func_149663_c("droneRedstoneEmitter");
        heatSink = new BlockHeatSink(Material.field_151573_f).func_149663_c("heatSink");
        vortexTube = new BlockVortexTube(Material.field_151573_f).func_149663_c("vortexTube");
        programmableController = new BlockProgrammableController(Material.field_151573_f).func_149663_c("programmableController");
        gasLift = new BlockGasLift(Material.field_151573_f).func_149663_c("gasLift");
        refinery = new BlockRefinery(Material.field_151573_f).func_149663_c("refinery");
        thermopneumaticProcessingPlant = new BlockThermopneumaticProcessingPlant(Material.field_151573_f).func_149663_c("thermopneumaticProcessingPlant");
        keroseneLamp = new BlockKeroseneLamp(Material.field_151573_f).func_149663_c("keroseneLamp");
        keroseneLampLight = new BlockKeroseneLampLight().func_149663_c("keroseneLampLight");
        sentryTurret = new BlockSentryTurret(Material.field_151573_f).func_149663_c("sentryTurret");

        registerBlocks();

        OreDictionary.registerOre(Names.BLOCK_IRON_COMPRESSED, compressedIron);
    }

    private static void registerBlocks(){
        registerBlock(pressureTube);
        registerBlock(airCompressor);
        registerBlock(advancedAirCompressor);
        registerBlock(airCannon);
        registerBlock(pressureChamberWall);
        registerBlock(pressureChamberGlass);
        registerBlock(pressureChamberValve);
        registerBlock(chargingStation);
        registerBlock(elevatorBase);
        registerBlock(elevatorFrame);
        registerBlock(pressureChamberInterface);
        registerBlock(vacuumPump);
        registerBlock(pneumaticDoorBase);
        registerBlock(pneumaticDoor);
        registerBlock(assemblyIOUnit);
        registerBlock(assemblyPlatform);
        registerBlock(assemblyDrill);
        registerBlock(assemblyLaser);
        registerBlock(assemblyController);
        registerBlock(advancedPressureTube);
        registerBlock(compressedIron);
        registerBlock(uvLightBox);
        registerBlock(securityStation);
        registerBlock(universalSensor);
        //     registerBlock(universalActuator);
        registerBlock(aerialInterface);
        registerBlock(electrostaticCompressor);
        registerBlock(aphorismTile);
        registerBlock(omnidirectionalHopper, ItemBlockOmnidirectionalHopper.class);
        registerBlock(liquidHopper, ItemBlockOmnidirectionalHopper.class);
        registerBlock(elevatorCaller);
        registerBlock(programmer);
        registerBlock(creativeCompressor);
        registerBlock(plasticMixer);
        registerBlock(liquidCompressor);
        registerBlock(advancedLiquidCompressor);
        registerBlock(droneRedstoneEmitter);
        registerBlock(heatSink);
        registerBlock(vortexTube);
        registerBlock(programmableController);
        registerBlock(gasLift);
        registerBlock(refinery);
        registerBlock(thermopneumaticProcessingPlant);
        registerBlock(keroseneLamp);
        if(!Config.disableKeroseneLampFakeAirBlock) registerBlock(keroseneLampLight);
        registerBlock(sentryTurret);
    }

    public static void registerBlock(Block block){
        registerBlock(block, ItemBlockPneumaticCraft.class);
    }

    private static void registerBlock(Block block, Class<? extends ItemBlockPneumaticCraft> itemBlockClass){
        GameRegistry.registerBlock(block, itemBlockClass, block.func_149739_a().substring("tile.".length()));
        ThirdPartyManager.instance().onBlockRegistry(block);
        blocks.add(block);
    }
}
