package pneumaticCraft.common.block.tubes;

import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import pneumaticCraft.api.item.IPressurizable;
import pneumaticCraft.api.tileentity.IAirHandler;
import pneumaticCraft.common.util.IOHelper;
import pneumaticCraft.common.util.TileEntityCache;
import pneumaticCraft.lib.Names;
import pneumaticCraft.lib.PneumaticValues;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public class ModuleCharging extends TubeModule{
    private TileEntityCache connectedInventory;

    @Override
    public String getType(){
        return Names.MODULE_CHARGING;
    }

    @Override
    public String getModelName(){
        return "charging";
    }

    @Override
    protected EnumGuiId getGuiId(){
        return null;
    }

    @Override
    public void update(){
        super.update();
        IInventory inv = getConnectedInventory();
        if(inv != null) {
            int[] accessibleSlots = IOHelper.getAccessibleSlotsForInventory(inv, dir.func_176734_d());
            for(int i = 0; i < (upgraded ? 10 : 1) * PneumaticValues.CHARGING_STATION_CHARGE_RATE; i++) {
                boolean charged = false;
                for(int slot : accessibleSlots) {
                    ItemStack chargedItem = inv.func_70301_a(slot);
                    if(chargedItem != null && chargedItem.func_77973_b() instanceof IPressurizable) {
                        IPressurizable chargingItem = (IPressurizable)chargedItem.func_77973_b();
                        IAirHandler airHandler = pressureTube.getAirHandler(null);

                        if(chargingItem.getPressure(chargedItem) > airHandler.getPressure() + 0.01F && chargingItem.getPressure(chargedItem) > 0F) {
                            chargingItem.addAir(chargedItem, -1);
                            airHandler.addAir(1);
                            charged = true;
                        } else if(chargingItem.getPressure(chargedItem) < airHandler.getPressure() - 0.01F && chargingItem.getPressure(chargedItem) < chargingItem.maxPressure(chargedItem)) {// if there is pressure, and the item isn't fully charged yet..
                            chargingItem.addAir(chargedItem, 1);
                            airHandler.addAir(-1);
                            charged = true;
                        }
                    }
                }
                if(!charged) break;
            }
        }
    }

    @Override
    public void onNeighborTileUpdate(){
        connectedInventory = null;
    }

    private IInventory getConnectedInventory(){
        if(connectedInventory == null) {
            connectedInventory = new TileEntityCache(pressureTube.world(), pressureTube.pos().func_177972_a(dir));
        }
        return connectedInventory.getTileEntity() instanceof IInventory ? (IInventory)connectedInventory.getTileEntity() : null;
    }
}
