package pneumaticCraft.common.block.tubes;

import java.util.List;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.EnumFacing;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.proxy.CommonProxy.EnumGuiId;

public abstract class TubeModuleRedstoneReceiving extends TubeModule{
    protected int redstoneLevel;

    @Override
    public void readFromNBT(NBTTagCompound tag){
        super.readFromNBT(tag);
        redstoneLevel = tag.func_74762_e("redstone");
    }

    @Override
    public void writeToNBT(NBTTagCompound tag){
        super.writeToNBT(tag);
        tag.func_74768_a("redstone", redstoneLevel);
    }

    @Override
    public void addInfo(List<String> curInfo){
        curInfo.add("Applied redstone: " + EnumChatFormatting.WHITE + redstoneLevel);
    }

    @Override
    public void onNeighborBlockUpdate(){
        redstoneLevel = 0;
        for(EnumFacing side : EnumFacing.field_82609_l) {
            if(dir == side || isInline() && side != dir.func_176734_d()) redstoneLevel = Math.max(redstoneLevel, PneumaticCraftUtils.getRedstoneLevel(pressureTube.world(), pressureTube.pos().func_177972_a(side), side));
        }
    }

    public int getReceivingRedstoneLevel(){
        return redstoneLevel;
    }

    public float getThreshold(){
        return getThreshold(redstoneLevel);
    }

    @Override
    protected EnumGuiId getGuiId(){
        return EnumGuiId.PRESSURE_MODULE;
    }

    @Override
    public void update(){
        if(upgraded && !advancedConfig && higherBound != lowerBound) {
            higherBound = lowerBound;
            if(!getTube().world().field_72995_K) sendDescriptionPacket();
        }
    }
}
