package pneumaticCraft.common.commands;

import java.util.List;

import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.command.WrongUsageException;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketCommandGetGlobalVariableOutput;
import pneumaticCraft.common.remote.GlobalVariableManager;

public class CommandGetGlobalVariable extends CommandBase{

    @Override
    public boolean func_71519_b(ICommandSender par1ICommandSender){
        return true;
    }

    @Override
    public String func_71517_b(){
        return "getGlobalVariable";
    }

    @Override
    public String func_71518_a(ICommandSender p_71518_1_){
        return "getGlobalVariable <variableName>";
    }

    @Override
    public void func_71515_b(ICommandSender sender, String[] args) throws CommandException{
        if(sender instanceof EntityPlayerMP) {
            if(args.length != 1) throw new WrongUsageException("command.deliverAmazon.args");
            String varName = args[0].startsWith("#") ? args[0].substring(1) : args[0];
            BlockPos pos = GlobalVariableManager.getInstance().getPos(varName);
            ItemStack stack = GlobalVariableManager.getInstance().getItem(varName);
            NetworkHandler.sendTo(new PacketCommandGetGlobalVariableOutput(varName, pos, stack), (EntityPlayerMP)sender);
        }
    }

    /**
     * Adds the strings available in this command to the given list of tab completion options.
     */
    @Override
    public List<String> func_180525_a(ICommandSender p_71516_1_, String[] p_71516_2_, BlockPos pos){
        return p_71516_2_.length >= 1 ? func_71530_a(p_71516_2_, GlobalVariableManager.getInstance().getAllActiveVariableNames()) : null;
    }

}
