package pneumaticCraft.common.entity;

import net.minecraft.entity.Entity;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.MathHelper;
import net.minecraft.world.World;
import pneumaticCraft.client.render.RenderRing;

public class EntityRing extends Entity{

    public RenderRing ring, oldRing;
    private final Entity targetEntity;
    public final int color;

    public EntityRing(World par1World, double startX, double startY, double startZ, Entity targetEntity, int color){
        super(par1World);
        field_70165_t = field_70142_S = startX;
        field_70163_u = field_70137_T = startY;
        field_70161_v = field_70136_U = startZ;
        this.targetEntity = targetEntity;
        this.color = color;

        double dx = targetEntity.field_70165_t - field_70165_t;
        double dy = targetEntity.field_70163_u - field_70163_u;
        double dz = targetEntity.field_70161_v - field_70161_v;
        float f = MathHelper.func_76133_a(dx * dx + dz * dz);
        field_70126_B = field_70177_z = (float)(Math.atan2(dx, dz) * 180.0D / Math.PI);
        field_70127_C = field_70125_A = (float)(Math.atan2(dy, f) * 180.0D / Math.PI);
        field_70155_l = 10.0D;
        field_70158_ak = true;
    }

    @Override
    public void func_70071_h_(){
        double endX = targetEntity.field_70165_t;
        double endY = targetEntity.field_70163_u;
        double endZ = targetEntity.field_70161_v;
        field_70126_B = field_70177_z;
        field_70127_C = field_70125_A;

        if(ring == null) {
            ring = new RenderRing(field_70165_t, field_70163_u, field_70161_v, endX, endY, endZ, color);
        } else {
            if(oldRing == null) {
                oldRing = new RenderRing(ring.startX, ring.startY, ring.startZ, ring.endX, ring.endY, ring.endZ, color);
            } else {
                oldRing.endX = ring.endX;
                oldRing.endY = ring.endY;
                oldRing.endZ = ring.endZ;
            }
            ring.endX = endX;
            ring.endY = endY;
            ring.endZ = endZ;

            double dx = endX - field_70165_t;
            double dy = endY - field_70163_u;
            double dz = endZ - field_70161_v;
            float f = MathHelper.func_76133_a(dx * dx + dz * dz);
            field_70177_z = (float)(Math.atan2(dx, dz) * 180.0D / Math.PI);
            field_70125_A = (float)(Math.atan2(dy, f) * 180.0D / Math.PI);

            oldRing.setProgress(ring.getProgress());
            if(ring.incProgress(0.05F)) {
                func_70106_y();
            }
        }
    }

    @Override
    protected void func_70088_a(){}

    @Override
    protected void func_70037_a(NBTTagCompound var1){}

    @Override
    protected void func_70014_b(NBTTagCompound var1){}

}
