package pneumaticCraft.common.entity.living;

import io.netty.buffer.ByteBuf;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.UUID;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.ai.EntityAITasks;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.item.EntityXPOrb;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.InventoryBasic;
import net.minecraft.item.Item;
import net.minecraft.item.ItemDye;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.network.EnumPacketDirection;
import net.minecraft.network.NetHandlerPlayServer;
import net.minecraft.network.NetworkManager;
import net.minecraft.pathfinding.PathEntity;
import net.minecraft.pathfinding.PathNavigate;
import net.minecraft.pathfinding.PathPoint;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.management.ItemInWorldManager;
import net.minecraft.stats.StatBase;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ChatComponentTranslation;
import net.minecraft.util.DamageSource;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.IChatComponent;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraftforge.common.IExtendedEntityProperties;
import net.minecraftforge.fluids.FluidTank;
import net.minecraftforge.fluids.IFluidTank;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.registry.IEntityAdditionalSpawnData;
import net.minecraftforge.fml.relauncher.ReflectionHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import org.lwjgl.opengl.GL11;

import pneumaticCraft.api.block.IPneumaticWrenchable;
import pneumaticCraft.api.client.pneumaticHelmet.IHackableEntity;
import pneumaticCraft.api.drone.IPathNavigator;
import pneumaticCraft.api.drone.IPathfindHandler;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.api.tileentity.IManoMeasurable;
import pneumaticCraft.client.render.RenderProgressingLine;
import pneumaticCraft.common.DroneRegistry;
import pneumaticCraft.common.NBTUtil;
import pneumaticCraft.common.ai.DroneAIManager;
import pneumaticCraft.common.ai.DroneAIManager.EntityAITaskEntry;
import pneumaticCraft.common.ai.DroneGoToChargingStation;
import pneumaticCraft.common.ai.DroneGoToOwner;
import pneumaticCraft.common.ai.DroneMoveHelper;
import pneumaticCraft.common.ai.EntityPathNavigateDrone;
import pneumaticCraft.common.ai.FakePlayerItemInWorldManager;
import pneumaticCraft.common.ai.IDroneBase;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.item.ItemGPSTool;
import pneumaticCraft.common.item.ItemProgrammingPuzzle;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.minigun.Minigun;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketSendDroneDebugEntry;
import pneumaticCraft.common.network.PacketShowWireframe;
import pneumaticCraft.common.network.PacketSyncDroneEntityProgWidgets;
import pneumaticCraft.common.progwidgets.IProgWidget;
import pneumaticCraft.common.progwidgets.ProgWidgetGoToLocation;
import pneumaticCraft.common.recipes.AmadronOffer;
import pneumaticCraft.common.recipes.AmadronOfferCustom;
import pneumaticCraft.common.tileentity.TileEntityPlasticMixer;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.NBTKeys;
import pneumaticCraft.lib.PneumaticValues;

import com.mojang.authlib.GameProfile;

public class EntityDrone extends EntityDroneBase implements IManoMeasurable, IInventoryHolder, IPneumaticWrenchable,
        IEntityAdditionalSpawnData, IHackableEntity, IDroneBase{

    private static final HashMap<String, Integer> colorMap = new HashMap<String, Integer>();

    static {
        colorMap.put("aureylian", 0xff69b4);
        colorMap.put("loneztar", 0x00a0a0);
        colorMap.put("jadedcat", 0xa020f0);
    }

    public boolean isChangingCurrentStack;//used when syncing up the stacks of the drone with the fake player. Without it they'll keep syncing resulting in a stackoverflow.
    private IInventory inventory = new InventoryDrone("Drone Inventory", true, 0);
    private final FluidTank tank = new FluidTank(Integer.MAX_VALUE);
    private ItemStack[] upgradeInventory = new ItemStack[9];
    private final int[] emittingRedstoneValues = new int[6];
    private float propSpeed;
    private static final float LASER_EXTEND_SPEED = 0.05F;

    protected float currentAir; //the current held energy of the Drone;
    private float volume;
    private RenderProgressingLine targetLine;
    private RenderProgressingLine oldTargetLine;
    public List<IProgWidget> progWidgets = new ArrayList<IProgWidget>();

    private DroneFakePlayer fakePlayer;
    public String playerName = "Drone";
    private String playerUUID;

    public DroneGoToChargingStation chargeAI;
    public DroneGoToOwner gotoOwnerAI;
    private final DroneAIManager aiManager = new DroneAIManager(this);

    private boolean firstTick = true;
    public boolean naturallySpawned = true;//determines if it should drop a drone when it dies.
    public boolean hasLiquidImmunity;
    private double speed;
    private int lifeUpgrades;
    private int suffocationCounter = 40;//Drones are invincible for suffocation for this time.
    private boolean isSuffocating;
    private boolean disabledByHacking;
    private boolean standby;//If true, the drone's propellors stop, the drone will fall down, and won't use pressure.
    private Minigun minigun;

    private AmadronOffer handlingOffer;
    private int offerTimes;
    private ItemStack usedTablet;//Tablet used to place the order.
    private String buyingPlayer;
    private final SortedSet<DebugEntry> debugEntries = new TreeSet<DebugEntry>();
    private final Set<EntityPlayerMP> syncedPlayers = new HashSet<EntityPlayerMP>();

    public EntityDrone(World world){
        super(world);
        func_70105_a(0.7F, 0.35F);
        ReflectionHelper.setPrivateValue(EntityLiving.class, this, new DroneMoveHelper(this), "moveHelper", "field_70765_h");
        field_70714_bg.func_75776_a(1, chargeAI = new DroneGoToChargingStation(this));
    }

    public EntityDrone(World world, EntityPlayer player){
        this(world);
        playerUUID = player.func_146103_bH().getId().toString();
        playerName = player.func_70005_c_();
    }

    @Override
    protected PathNavigate func_175447_b(World worldIn){
        return new EntityPathNavigateDrone(this, worldIn);
    }

    private void initializeFakePlayer(){
        fakePlayer = new DroneFakePlayer((WorldServer)field_70170_p, new GameProfile(playerUUID != null ? UUID.fromString(playerUUID) : null, playerName), new FakePlayerItemInWorldManager(field_70170_p, fakePlayer, this), this);
        fakePlayer.field_71135_a = new NetHandlerPlayServer(MinecraftServer.func_71276_C(), new NetworkManager(EnumPacketDirection.SERVERBOUND), fakePlayer);
        fakePlayer.field_71071_by = new InventoryFakePlayer(fakePlayer);
    }

    @Override
    protected void func_70088_a(){
        super.func_70088_a();
        field_70180_af.func_75682_a(12, 0F);
        field_70180_af.func_75682_a(13, (byte)0);
        //15 is reserved for AI/NO AI
        field_70180_af.func_75682_a(17, "");
        field_70180_af.func_75682_a(18, 0);
        field_70180_af.func_75682_a(19, 0);
        field_70180_af.func_75682_a(20, 0);
        field_70180_af.func_75682_a(21, (byte)0);
        field_70180_af.func_75682_a(22, 0);
        field_70180_af.func_75682_a(23, (byte)0);
        field_70180_af.func_75682_a(24, (byte)0);
        field_70180_af.func_82709_a(25, 5);
        field_70180_af.func_75682_a(26, "Main");
        field_70180_af.func_75682_a(27, 0);
        field_70180_af.func_75682_a(28, 0);
        field_70180_af.func_75682_a(29, 0);
        field_70180_af.func_75682_a(30, 0);
    }

    @Override
    protected void func_110147_ax(){
        super.func_110147_ax();
        func_110140_aT().func_111150_b(SharedMonsterAttributes.field_111264_e).func_111128_a(3.0D);
        func_110148_a(SharedMonsterAttributes.field_111267_a).func_111128_a(40F);
        func_110148_a(SharedMonsterAttributes.field_111265_b).func_111128_a(getRange());
    }

    @Override
    public void writeSpawnData(ByteBuf data){
        ByteBufUtils.writeUTF8String(data, getFakePlayer().func_70005_c_());
    }

    @Override
    public void readSpawnData(ByteBuf data){
        playerName = ByteBufUtils.readUTF8String(data);
    }

    /**
     * Determines if an entity can be despawned, used on idle far away entities
     */
    @Override
    protected boolean func_70692_ba(){
        return false;
    }

    @Override
    protected float func_70599_aP(){
        return 0.2F;
    }

    @Override
    protected String func_70621_aR(){
        return "pneumaticcraft:drone.hurt";
    }

    /**
     * Returns the sound this mob makes on death.
     */
    @Override
    protected String func_70673_aS(){
        return "pneumaticcraft:drone.death";
    }

    @Override
    public void func_70071_h_(){
        if(firstTick) {
            firstTick = false;
            volume = PneumaticValues.DRONE_VOLUME + getUpgrades(EnumUpgrade.VOLUME) * PneumaticValues.VOLUME_VOLUME_UPGRADE;
            hasLiquidImmunity = getUpgrades(EnumUpgrade.SECURITY) > 0;
            if(hasLiquidImmunity) {
                ((EntityPathNavigateDrone)getPathNavigator()).pathThroughLiquid = true;
            }
            speed = 0.1 + Math.min(10, getUpgrades(EnumUpgrade.SPEED)) * 0.01;
            lifeUpgrades = getUpgrades(EnumUpgrade.ITEM_LIFE);
            if(!field_70170_p.field_72995_K) setHasMinigun(getUpgrades(EnumUpgrade.ENTITY_TRACKER) > 0);
            aiManager.setWidgets(progWidgets);
        }
        boolean enabled = !disabledByHacking && getPressure(null) > 0.01F;
        if(!field_70170_p.field_72995_K) {
            setAccelerating(!standby && enabled);
            if(isAccelerating()) {
                field_70143_R = 0;
            }
            if(lifeUpgrades > 0) {
                int interval = 10 / lifeUpgrades;
                if(interval == 0 || field_70173_aa % interval == 0) {
                    func_70691_i(1);
                }
            }
            if(!isSuffocating) {
                suffocationCounter = 40;
            }
            isSuffocating = false;
            PathEntity path = func_70661_as().func_75505_d();
            if(path != null) {
                PathPoint target = path.func_75870_c();
                if(target != null) {
                    setTargetedBlock(new BlockPos(target.field_75839_a, target.field_75837_b, target.field_75838_c));
                } else {
                    setTargetedBlock(null);
                }
            } else {
                setTargetedBlock(null);
            }
            if(field_70170_p.func_82737_E() % 20 == 0) {
                updateSyncedPlayers();
            }
        } else {
            if(digLaser != null) digLaser.update();
            oldLaserExtension = laserExtension;
            if(getActiveProgramKey().equals("dig")) {
                laserExtension = Math.min(1, laserExtension + LASER_EXTEND_SPEED);
            } else {
                laserExtension = Math.max(0, laserExtension - LASER_EXTEND_SPEED);
            }

            if(isAccelerating()) {
                int x = (int)Math.floor(field_70165_t);
                int y = (int)Math.floor(field_70163_u - 1);
                int z = (int)Math.floor(field_70161_v);
                BlockPos pos = new BlockPos(x, y, z);
                Block block = null;
                for(int i = 0; i < 3; i++) {
                    block = field_70170_p.func_180495_p(pos).func_177230_c();
                    if(block.func_149688_o() != Material.field_151579_a) break;
                    y--;
                }

                if(block.func_149688_o() != Material.field_151579_a) {
                    Vec3 vec = new Vec3(field_70163_u - y, 0, 0);
                    vec = vec.func_178785_b((float)(field_70146_Z.nextFloat() * Math.PI * 2));
                    field_70170_p.func_175688_a(EnumParticleTypes.BLOCK_CRACK, field_70165_t + vec.field_72450_a, y + 1, field_70161_v + vec.field_72449_c, vec.field_72450_a, 0, vec.field_72449_c, Block.func_176210_f(field_70170_p.func_180495_p(pos)));
                }
            }
        }
        if(hasLiquidImmunity) {
            for(int x = (int)field_70165_t - 1; x <= (int)(field_70165_t + field_70130_N); x++) {
                for(int y = (int)field_70163_u - 1; y <= (int)(field_70163_u + field_70131_O + 1); y++) {
                    for(int z = (int)field_70161_v - 2; z <= (int)(field_70161_v + field_70130_N); z++) {
                        if(PneumaticCraftUtils.isBlockLiquid(field_70170_p.func_180495_p(new BlockPos(x, y, z)).func_177230_c())) {
                            field_70170_p.func_180501_a(new BlockPos(x, y, z), Blocks.field_150350_a.func_176223_P(), 2);
                        }
                    }
                }
            }
        }
        if(isAccelerating()) {
            field_70159_w *= 0.3D;
            field_70181_x *= 0.3D;
            field_70179_y *= 0.3D;
            propSpeed = Math.min(1, propSpeed + 0.04F);
            addAir(null, -1);
        } else {
            propSpeed = Math.max(0, propSpeed - 0.04F);
        }
        oldPropRotation = propRotation;
        propRotation += propSpeed;

        if(!field_70170_p.field_72995_K && func_70089_S()/*((FakePlayerItemInWorldManager)fakePlayer.theItemInWorldManager).isDigging()*/) {
            for(int i = 0; i < 4; i++) {
                getFakePlayer().field_71134_c.func_73075_a();
            }
        }
        super.func_70071_h_();
        if(hasMinigun()) getMinigun().setAttackTarget(func_70638_az()).update(field_70165_t, field_70163_u, field_70161_v);
        if(!field_70170_p.field_72995_K && func_70089_S()) {
            if(enabled) aiManager.onUpdateTasks();
            for(EnumFacing d : EnumFacing.field_82609_l) {
                if(getEmittingRedstone(d) > 0) {
                    if(field_70170_p.func_175623_d(new BlockPos((int)Math.floor(field_70165_t + field_70130_N / 2), (int)Math.floor(field_70163_u), (int)Math.floor(field_70161_v + field_70130_N / 2)))) {
                        field_70170_p.func_175656_a(new BlockPos((int)Math.floor(field_70165_t + field_70130_N / 2), (int)Math.floor(field_70163_u), (int)Math.floor(field_70161_v + field_70130_N / 2)), Blockss.droneRedstoneEmitter.func_176223_P());
                    }
                    break;
                }
            }
        }
    }

    public BlockPos getTargetedBlock(){
        int x = field_70180_af.func_75679_c(28);
        int y = field_70180_af.func_75679_c(29);
        int z = field_70180_af.func_75679_c(30);
        return x != 0 || y != 0 || z != 0 ? new BlockPos(x, y, z) : null;
    }

    private void setTargetedBlock(BlockPos pos){
        field_70180_af.func_75692_b(28, pos != null ? pos.func_177958_n() : 0);
        field_70180_af.func_75692_b(29, pos != null ? pos.func_177956_o() : 0);
        field_70180_af.func_75692_b(30, pos != null ? pos.func_177952_p() : 0);
    }

    @Override
    public int getLaserColor(){
        if(colorMap.containsKey(func_95999_t().toLowerCase())) {
            return colorMap.get(func_95999_t().toLowerCase());
        } else if(colorMap.containsKey(playerName.toLowerCase())) {
            return colorMap.get(playerName.toLowerCase());
        }
        return super.getLaserColor();
    }

    @Override
    protected BlockPos getDugBlock(){
        int x = field_70180_af.func_75679_c(18);
        int y = field_70180_af.func_75679_c(19);
        int z = field_70180_af.func_75679_c(20);
        return x != 0 || y != 0 || z != 0 ? new BlockPos(x, y, z) : null;
    }

    @Override
    public void setDugBlock(BlockPos pos){
        field_70180_af.func_75692_b(18, pos != null ? pos.func_177958_n() : 0);
        field_70180_af.func_75692_b(19, pos != null ? pos.func_177956_o() : 0);
        field_70180_af.func_75692_b(20, pos != null ? pos.func_177952_p() : 0);
    }

    public List<EntityAITaskEntry> getRunningTasks(){
        return aiManager.getRunningTasks();
    }

    public EntityAIBase getRunningTargetAI(){
        return aiManager.getTargetAI();
    }

    public void setVariable(String varName, BlockPos pos){
        aiManager.setCoordinate(varName, pos);
    }

    public BlockPos getVariable(String varName){
        return aiManager.getCoordinate(varName);
    }

    public ItemStack getActiveProgram(){
        String key = getActiveProgramKey();
        if(key.equals("")) {
            return null;
        } else {
            return ItemProgrammingPuzzle.getStackForWidgetKey(key);
        }
    }

    private String getActiveProgramKey(){
        return field_70180_af.func_75681_e(17);
    }

    /**
     * Can only be called when the drone is being debugged, so the client has a synced progWidgets array.
     * @return
     */
    public IProgWidget getActiveWidget(){
        int index = getActiveWidgetIndex();
        if(index >= 0 && index < progWidgets.size()) {
            return progWidgets.get(index);
        } else {
            return null;
        }
    }

    private int getActiveWidgetIndex(){
        return field_70180_af.func_75679_c(27);
    }

    @Override
    public void setActiveProgram(IProgWidget widget){
        field_70180_af.func_75692_b(17, widget.getWidgetString());
        field_70180_af.func_75692_b(27, progWidgets.indexOf(widget));
    }

    private void setAccelerating(boolean accelerating){
        field_70180_af.func_75692_b(13, (byte)(accelerating ? 1 : 0));
    }

    @Override
    public boolean isAccelerating(){
        return field_70180_af.func_75683_a(13) == 1;
    }

    private void setDroneColor(int color){
        field_70180_af.func_75692_b(22, color);
    }

    @Override
    public int getDroneColor(){
        return field_70180_af.func_75679_c(22);
    }

    public void setMinigunActivated(boolean activated){
        field_70180_af.func_75692_b(23, (byte)(activated ? 1 : 0));
    }

    public boolean isMinigunActivated(){
        return field_70180_af.func_75683_a(23) == 1;
    }

    public void setHasMinigun(boolean hasMinigun){
        field_70180_af.func_75692_b(24, (byte)(hasMinigun ? 1 : 0));
    }

    public boolean hasMinigun(){
        return field_70180_af.func_75683_a(24) == 1;
    }

    public int getAmmoColor(){
        ItemStack ammo = field_70180_af.func_82710_f(25);
        return ammo != null ? ammo.func_77973_b().func_82790_a(ammo, 1) : 0xFF313131;
    }

    public void setAmmoColor(ItemStack color){
        field_70180_af.func_75692_b(25, color);
    }

    /**
     * Returns true if the newer Entity AI code should be run
     */
    /*  @Override //TODO 1.8 test
      public boolean isAIEnabled(){
          return true;
      }*/

    /**
     * Decrements the entity's air supply when underwater
     */
    @Override
    protected int func_70682_h(int par1){
        return -20;//make drones insta drown.
    }

    /**
     * Moves the entity based on the specified heading.  Args: strafe, forward
     */
    @Override
    public void func_70612_e(float par1, float par2){
        if(field_70170_p.field_72995_K) {
            EntityLivingBase targetEntity = func_70638_az();
            if(targetEntity != null) {
                if(targetLine == null) targetLine = new RenderProgressingLine(0, -field_70131_O / 2, 0, 0, 0, 0);
                if(oldTargetLine == null) oldTargetLine = new RenderProgressingLine(0, -field_70131_O / 2, 0, 0, 0, 0);

                targetLine.endX = targetEntity.field_70165_t - field_70165_t;
                targetLine.endY = targetEntity.field_70163_u + targetEntity.field_70131_O / 2 - field_70163_u;
                targetLine.endZ = targetEntity.field_70161_v - field_70161_v;
                oldTargetLine.endX = targetEntity.field_70169_q - field_70169_q;
                oldTargetLine.endY = targetEntity.field_70167_r + targetEntity.field_70131_O / 2 - field_70167_r;
                oldTargetLine.endZ = targetEntity.field_70166_s - field_70166_s;

                oldTargetLine.setProgress(targetLine.getProgress());
                targetLine.incProgressByDistance(0.3D);
                field_70158_ak = true; //don't stop rendering the drone when it goes out of the camera frustrum, as we need to render the target lines as well.
            } else {
                field_70158_ak = false; //don't stop rendering the drone when it goes out of the camera frustrum, as we need to render the target lines as well.
            }
        }
        if(field_70154_o == null && isAccelerating()) {
            double d3 = field_70181_x;
            super.func_70612_e(par1, par2);
            field_70181_x = d3 * 0.60D;
        } else {
            super.func_70612_e(par1, par2);
        }
        field_70122_E = true;//set onGround to true so AI pathfinding will keep updating.
    }

    /**
     * Method that's being called to render anything that has to for the Drone. The matrix is already translated to the drone's position.
     * @param partialTicks
     */
    @Override
    @SideOnly(Side.CLIENT)
    public void renderExtras(double transX, double transY, double transZ, float partialTicks){
        if(targetLine != null && oldTargetLine != null) {
            GL11.glPushMatrix();
            GL11.glScaled(1, -1, 1);
            GL11.glDisable(GL11.GL_TEXTURE_2D);
            //GL11.glDisable(GL11.GL_LIGHTING);
            GL11.glColor4d(1, 0, 0, 1);
            targetLine.renderInterpolated(oldTargetLine, partialTicks);
            GL11.glColor4d(1, 1, 1, 1);
            // GL11.glEnable(GL11.GL_LIGHTING);
            GL11.glEnable(GL11.GL_TEXTURE_2D);
            GL11.glPopMatrix();
        }

        double x = field_70142_S + (field_70165_t - field_70142_S) * partialTicks;
        double y = field_70137_T + (field_70163_u - field_70137_T) * partialTicks;
        double z = field_70136_U + (field_70161_v - field_70136_U) * partialTicks;
        getMinigun().render(x, y, z, 0.6);
    }

    public double getRange(){
        return 75;
    }

    @Override
    public boolean func_70085_c(EntityPlayer player){
        ItemStack equippedItem = player.func_71045_bC();
        if(!field_70170_p.field_72995_K && equippedItem != null) {
            if(equippedItem.func_77973_b() == Itemss.GPSTool) {
                BlockPos gpsLoc = ItemGPSTool.getGPSLocation(equippedItem);
                if(gpsLoc != null) {
                    func_70661_as().func_75492_a(gpsLoc.func_177958_n(), gpsLoc.func_177956_o(), gpsLoc.func_177952_p(), 0.1D);
                }
            } else {
                int dyeIndex = TileEntityPlasticMixer.getDyeIndex(equippedItem);
                if(dyeIndex >= 0) {
                    setDroneColor(ItemDye.field_150922_c[dyeIndex]);
                    equippedItem.field_77994_a--;
                    if(equippedItem.field_77994_a <= 0) {
                        player.func_70062_b(0, null);
                    }
                }
            }
        }
        return false;
    }

    /**
     * Called when a drone is hit by a Pneumatic Wrench.
     */
    @Override
    public boolean rotateBlock(World world, EntityPlayer player, BlockPos pos, EnumFacing side){
        if(!naturallySpawned) {
            if(player.field_71075_bZ.field_75098_d) naturallySpawned = true;//don't drop the drone in creative.
            func_70097_a(DamageSource.field_76380_i, 2000.0F);
            return true;
        } else {
            return false;
        }
    }

    @Override
    public void func_70645_a(DamageSource par1DamageSource){
        for(int i = 0; i < inventory.func_70302_i_(); i++) {
            if(inventory.func_70301_a(i) != null) {
                func_70099_a(inventory.func_70301_a(i), 0);
                inventory.func_70299_a(i, null);
            }
        }
        if(naturallySpawned) {

        } else {
            ItemStack drone = getDroppedStack();
            if(func_145818_k_()) drone.func_151001_c(func_95999_t());
            func_70099_a(drone, 0);

            if(!field_70170_p.field_72995_K) {
                EntityPlayer owner = getOwner();
                if(owner != null) {
                    int x = (int)Math.floor(field_70165_t);
                    int y = (int)Math.floor(field_70163_u);
                    int z = (int)Math.floor(field_70161_v);
                    if(func_145818_k_()) {
                        owner.func_146105_b(new ChatComponentTranslation("death.drone.named", func_95999_t(), x, y, z));
                    } else {
                        owner.func_146105_b(new ChatComponentTranslation("death.drone", x, y, z));
                    }
                }
            }
        }
        if(!field_70170_p.field_72995_K) ((FakePlayerItemInWorldManager)getFakePlayer().field_71134_c).cancelDigging();
        super.func_70645_a(par1DamageSource);
    }

    protected ItemStack getDroppedStack(){
        NBTTagCompound tag = new NBTTagCompound();
        func_70014_b(tag);
        tag.func_74782_a("UpgradeInventory", tag.func_74781_a("Inventory"));
        tag.func_82580_o("Inventory");
        ItemStack drone = new ItemStack(Itemss.drone);
        drone.func_77982_d(tag);
        return drone;
    }

    @Override
    public void func_70624_b(EntityLivingBase entity){
        super.func_70624_b(entity);
        if(field_70170_p.field_72995_K && targetLine != null && oldTargetLine != null) {
            targetLine.setProgress(0);
            oldTargetLine.setProgress(0);
        }
    }

    @Override
    public float getPressure(ItemStack iStack){
        return field_70180_af.func_111145_d(12);
    }

    @Override
    public void addAir(ItemStack iStack, int amount){
        if(!field_70170_p.field_72995_K) {
            currentAir += amount;
            field_70180_af.func_75692_b(12, currentAir / volume);
        }
    }

    @Override
    public float maxPressure(ItemStack iStack){
        return PneumaticValues.DRONE_MAX_PRESSURE;
    }

    @Override
    public void printManometerMessage(EntityPlayer player, List<String> curInfo){
        if(func_145818_k_()) curInfo.add(EnumChatFormatting.AQUA + func_95999_t());
        curInfo.add("Owner: " + getFakePlayer().func_70005_c_());
        curInfo.add("Current pressure: " + PneumaticCraftUtils.roundNumberTo(getPressure(null), 1) + " bar.");
        /*for(int i = 0; i < 9; i++) {
            if(upgradeInventory[i] != null) {
                player.addChatMessage("inv " + i + ": " + upgradeInventory[i].stackSize + "x " + upgradeInventory[i].getDisplayName());
            }
        }*/
    }

    @Override
    public void func_70014_b(NBTTagCompound tag){
        super.func_70014_b(tag);
        TileEntityProgrammer.setWidgetsToNBT(progWidgets, tag);
        tag.func_74757_a("naturallySpawned", naturallySpawned);
        tag.func_74776_a("currentAir", currentAir);
        tag.func_74776_a("propSpeed", propSpeed);
        tag.func_74757_a("disabledByHacking", disabledByHacking);
        tag.func_74757_a("hackedByOwner", gotoOwnerAI != null);
        tag.func_74768_a("color", getDroneColor());
        tag.func_74757_a("standby", standby);
        tag.func_74776_a("volume", volume);

        NBTTagCompound variableTag = new NBTTagCompound();
        aiManager.writeToNBT(variableTag);
        tag.func_74782_a("variables", variableTag);

        NBTTagCompound inv = new NBTTagCompound();
        // Write the ItemStacks in the inventory to NBT
        NBTTagList tagList = new NBTTagList();
        for(int currentIndex = 0; currentIndex < inventory.func_70302_i_(); ++currentIndex) {
            if(inventory.func_70301_a(currentIndex) != null) {
                NBTTagCompound tagCompound = new NBTTagCompound();
                tagCompound.func_74774_a("Slot", (byte)currentIndex);
                inventory.func_70301_a(currentIndex).func_77955_b(tagCompound);
                tagList.func_74742_a(tagCompound);
            }
        }
        inv.func_74782_a("Inv", tagList);

        NBTTagList upgradeList = new NBTTagList();
        for(int i = 0; i < 9; i++) {
            if(upgradeInventory[i] != null) {
                NBTTagCompound slotEntry = new NBTTagCompound();
                slotEntry.func_74774_a("Slot", (byte)i);
                upgradeInventory[i].func_77955_b(slotEntry);
                upgradeList.func_74742_a(slotEntry);
            }
        }
        // save content in Inventory->Items
        inv.func_74782_a("Items", upgradeList);
        tag.func_74782_a("Inventory", inv);

        tank.writeToNBT(tag);

        if(handlingOffer != null) {
            NBTTagCompound subTag = new NBTTagCompound();
            subTag.func_74757_a("isCustom", handlingOffer instanceof AmadronOfferCustom);
            handlingOffer.writeToNBT(subTag);
            tag.func_74782_a("amadronOffer", subTag);
            tag.func_74768_a("offerTimes", offerTimes);
            if(usedTablet != null) usedTablet.func_77955_b(subTag);
            tag.func_74778_a("buyingPlayer", buyingPlayer);
        }
    }

    @Override
    public void func_70037_a(NBTTagCompound tag){
        super.func_70037_a(tag);
        progWidgets = TileEntityProgrammer.getWidgetsFromNBT(tag);
        naturallySpawned = tag.func_74767_n("naturallySpawned");
        currentAir = tag.func_74760_g("currentAir");
        volume = tag.func_74760_g("volume");
        field_70180_af.func_75692_b(12, currentAir / volume);
        propSpeed = tag.func_74760_g("propSpeed");
        disabledByHacking = tag.func_74767_n("disabledByHacking");
        setGoingToOwner(tag.func_74767_n("hackedByOwner"));
        setDroneColor(tag.func_74762_e("color"));
        aiManager.readFromNBT(tag.func_74775_l("variables"));
        standby = tag.func_74767_n("standby");

        // Read in the ItemStacks in the inventory from NBT
        NBTTagCompound inv = tag.func_74775_l("Inventory");
        if(inv != null) {
            NBTTagList tagList = inv.func_150295_c("Inv", 10);

            upgradeInventory = new ItemStack[9];
            NBTTagList upgradeList = inv.func_150295_c("Items", 10);
            for(int i = 0; i < upgradeList.func_74745_c(); i++) {
                NBTTagCompound slotEntry = upgradeList.func_150305_b(i);
                int j = slotEntry.func_74771_c("Slot");

                if(j >= 0 && j < 9) {
                    upgradeInventory[j] = ItemStack.func_77949_a(slotEntry);
                }
            }

            inventory = new InventoryDrone("Drone Inventory", true, 1 + getUpgrades(EnumUpgrade.DISPENSER));
            for(int i = 0; i < tagList.func_74745_c(); ++i) {
                NBTTagCompound tagCompound = tagList.func_150305_b(i);
                byte slot = tagCompound.func_74771_c("Slot");
                if(slot >= 0 && slot < inventory.func_70302_i_()) {
                    inventory.func_70299_a(slot, ItemStack.func_77949_a(tagCompound));
                }
            }
        }

        tank.setCapacity(PneumaticValues.DRONE_TANK_SIZE * (1 + getUpgrades(EnumUpgrade.DISPENSER)));
        tank.readFromNBT(tag);

        if(tag.func_74764_b("amadronOffer")) {
            NBTTagCompound subTag = tag.func_74775_l("amadronOffer");
            if(subTag.func_74767_n("isCustom")) {
                handlingOffer = AmadronOffer.loadFromNBT(subTag);
            } else {
                handlingOffer = AmadronOfferCustom.loadFromNBT(subTag);
            }
            if(subTag.func_74764_b("id")) {
                usedTablet = ItemStack.func_77949_a(subTag);
            } else {
                usedTablet = null;
            }
            buyingPlayer = subTag.func_74779_i("buyingPlayer");
        } else {
            handlingOffer = null;
            usedTablet = null;
            buyingPlayer = null;
        }
        offerTimes = tag.func_74762_e("offerTimes");
    }

    /**
     * This and readFromNBT are _not_ being transfered from/to the Drone item.
     */
    @Override
    public void func_70109_d(NBTTagCompound tag){
        super.func_70109_d(tag);
        if(fakePlayer != null) {
            tag.func_74778_a("owner", fakePlayer.func_70005_c_());
            if(fakePlayer.func_146103_bH().getId() != null) tag.func_74778_a("ownerUUID", fakePlayer.func_146103_bH().getId().toString());
        }
    }

    @Override
    public void func_70020_e(NBTTagCompound tag){
        super.func_70020_e(tag);
        if(tag.func_74764_b("owner")) {
            playerName = tag.func_74779_i("owner");
            playerUUID = tag.func_74764_b("ownerUUID") ? tag.func_74779_i("ownerUUID") : null;
        }
    }

    private int getUpgrades(EnumUpgrade upgrade){
        return getUpgrades(Itemss.upgrades.get(upgrade));
    }

    @Override
    public int getUpgrades(Item upgrade){
        int upgrades = 0;
        for(ItemStack stack : upgradeInventory) {
            if(stack != null && stack.func_77973_b() == upgrade) {
                upgrades += stack.field_77994_a;
            }
        }
        return upgrades;
    }

    @Override
    public DroneFakePlayer getFakePlayer(){
        if(fakePlayer == null && !field_70170_p.field_72995_K) {
            initializeFakePlayer();
        }
        return fakePlayer;
    }

    public Minigun getMinigun(){
        if(minigun == null) {
            minigun = new MinigunDrone().setPlayer(getFakePlayer()).setWorld(field_70170_p).setPressurizable(this, PneumaticValues.DRONE_USAGE_ATTACK);
        }
        return minigun;
    }

    @Override
    public boolean func_70652_k(Entity entity){
        getFakePlayer().func_71059_n(entity);
        addAir(null, -PneumaticValues.DRONE_USAGE_ATTACK);
        return true;
    }

    @Override
    public boolean func_70097_a(DamageSource damageSource, float damage){
        if(damageSource == DamageSource.field_76368_d) {
            isSuffocating = true;
            if(suffocationCounter-- > 0 || !Config.enableDroneSuffocationDamage) {
                return false;
            }
        }
        return super.func_70097_a(damageSource, damage);
    }

    @Override
    public IInventory getInv(){
        return inventory;
    }

    public double getSpeed(){
        return speed;
    }

    public int getEmittingRedstone(EnumFacing side){
        return emittingRedstoneValues[side.ordinal()];
    }

    @Override
    public void setEmittingRedstone(EnumFacing side, int value){
        if(emittingRedstoneValues[side.ordinal()] != value) {
            emittingRedstoneValues[side.ordinal()] = value;
            field_70170_p.func_180496_d(new BlockPos((int)Math.floor(field_70165_t + field_70130_N / 2), (int)Math.floor(field_70163_u), (int)Math.floor(field_70161_v + field_70130_N / 2)), Blockss.droneRedstoneEmitter);
        }
    }

    @Override
    public boolean isBlockValidPathfindBlock(BlockPos pos){
        if(field_70170_p.func_175623_d(pos)) return true;
        Block block = field_70170_p.func_180495_p(pos).func_177230_c();
        if(PneumaticCraftUtils.isBlockLiquid(block)) {
            return hasLiquidImmunity;
        }
        if(block.func_176205_b(field_70170_p, pos) && block != Blocks.field_150468_ap) return true;
        if(DroneRegistry.getInstance().pathfindableBlocks.containsKey(block)) {
            IPathfindHandler pathfindHandler = DroneRegistry.getInstance().pathfindableBlocks.get(block);
            return pathfindHandler == null || pathfindHandler.canPathfindThrough(field_70170_p, pos);
        } else {
            return false;
        }
    }

    @Override
    public void sendWireframeToClient(BlockPos pos){
        NetworkHandler.sendToAllAround(new PacketShowWireframe(this, pos), field_70170_p);
    }

    private class InventoryDrone extends InventoryBasic{
        ItemStack oldStack;

        public InventoryDrone(String inventoryName, boolean isNameLocalized, int slots){
            super(inventoryName, isNameLocalized, slots);
        }

        @Override
        public void func_70299_a(int slot, ItemStack stack){
            super.func_70299_a(slot, stack);
            if(slot == 0 && !isChangingCurrentStack) {
                isChangingCurrentStack = true;
                getFakePlayer().field_71071_by.func_70299_a(slot, stack);
                isChangingCurrentStack = false;
                if(oldStack != null) {
                    getFakePlayer().func_110140_aT().func_111148_a(oldStack.func_111283_C());
                }

                if(stack != null) {
                    getFakePlayer().func_110140_aT().func_111147_b(stack.func_111283_C());
                }
                oldStack = stack;
            }
        }
    }

    private class InventoryFakePlayer extends InventoryPlayer{
        public InventoryFakePlayer(EntityPlayer par1EntityPlayer){
            super(par1EntityPlayer);
        }

        @Override
        public void func_70299_a(int slot, ItemStack stack){
            super.func_70299_a(slot, stack);
            if(slot == 0 && !isChangingCurrentStack) {
                isChangingCurrentStack = true;
                getInv().func_70299_a(slot, stack);
                isChangingCurrentStack = false;
            }
        }
    }

    public static class DroneFakePlayer extends EntityPlayerMP{
        private final IDroneBase drone;
        private boolean sneaking;

        public DroneFakePlayer(WorldServer world, GameProfile name, ItemInWorldManager itemManager, IDroneBase drone){
            super(FMLCommonHandler.instance().getMinecraftServerInstance(), world, name, itemManager);
            this.drone = drone;
        }

        @Override
        public void func_71023_q(int amount){
            Vec3 pos = drone.getDronePos();
            EntityXPOrb orb = new EntityXPOrb(drone.getWorld(), pos.field_72450_a, pos.field_72448_b, pos.field_72449_c, amount);
            drone.getWorld().func_72838_d(orb);
        }

        @Override
        public void func_70062_b(int p_70062_1_, ItemStack p_70062_2_){

            if(p_70062_1_ == 0) {
                field_71071_by.func_70299_a(field_71071_by.field_70461_c, p_70062_2_);
            } else {
                field_71071_by.field_70460_b[p_70062_1_ - 1] = p_70062_2_;
            }
        }

        @Override
        public boolean func_70003_b(int i, String s){
            return false;
        }

        /*   @Override TODO 1.8 verify not necessary
           public ChunkCoordinates getPlayerCoordinates(){
               return new ChunkCoordinates(0, 0, 0);
           }*/

        @Override
        public void func_146105_b(IChatComponent chatmessagecomponent){}

        @Override
        public void func_71064_a(StatBase par1StatBase, int par2){}

        @Override
        public void openGui(Object mod, int modGuiId, World world, int x, int y, int z){}

        /* @Override TODO 1.8 verify not necessary
         public boolean isEntityInvulnerable(){
             return true;
         }*/

        @Override
        public boolean func_96122_a(EntityPlayer player){
            return false;
        }

        @Override
        public void func_70645_a(DamageSource source){
            return;
        }

        @Override
        public void func_70071_h_(){
            return;
        }

        @Override
        public void func_71027_c(int dim){
            return;
        }

        /* @Override TODO 1.8 verify not necessary
        public void func_147100_a(C15PacketClientSettings pkt){
            return;
        }*/

        @Override
        public boolean func_70093_af(){
            return sneaking;
        }

        @Override
        public void func_70095_a(boolean sneaking){
            this.sneaking = sneaking;
        }
    }

    /**
     * IHackableEntity
     */

    @Override
    public String getId(){
        return null;
    }

    @Override
    public boolean canHack(Entity entity, EntityPlayer player){
        return isAccelerating();
    }

    @Override
    public void addInfo(Entity entity, List<String> curInfo, EntityPlayer player){
        if(playerName.equals(player.func_70005_c_())) {
            if(isGoingToOwner()) {
                curInfo.add("pneumaticHelmet.hacking.result.resumeTasks");
            } else {
                curInfo.add("pneumaticHelmet.hacking.result.callBack");
            }
        } else {
            curInfo.add("pneumaticHelmet.hacking.result.disable");
        }
    }

    @Override
    public void addPostHackInfo(Entity entity, List<String> curInfo, EntityPlayer player){
        if(playerName.equals(player.func_70005_c_())) {
            if(isGoingToOwner()) {
                curInfo.add("pneumaticHelmet.hacking.finished.calledBack");
            } else {
                curInfo.add("pneumaticHelmet.hacking.finished.resumedTasks");
            }
        } else {
            curInfo.add("pneumaticHelmet.hacking.finished.disabled");
        }
    }

    @Override
    public int getHackTime(Entity entity, EntityPlayer player){
        return playerName.equals(player.func_70005_c_()) ? 20 : 100;
    }

    @Override
    public void onHackFinished(Entity entity, EntityPlayer player){
        if(!field_70170_p.field_72995_K && player.func_146103_bH().equals(getFakePlayer().func_146103_bH())) {
            setGoingToOwner(gotoOwnerAI == null);//toggle the state
        } else {
            disabledByHacking = true;
        }
    }

    @Override
    public boolean afterHackTick(Entity entity){
        return false;
    }

    private void setGoingToOwner(boolean state){
        if(state && gotoOwnerAI == null) {
            gotoOwnerAI = new DroneGoToOwner(this);
            field_70714_bg.func_75776_a(2, gotoOwnerAI);
            field_70180_af.func_75692_b(21, (byte)1);
            setActiveProgram(new ProgWidgetGoToLocation());
        } else if(!state && gotoOwnerAI != null) {
            field_70714_bg.func_85156_a(gotoOwnerAI);
            gotoOwnerAI = null;
            field_70180_af.func_75692_b(21, (byte)0);
        }
    }

    private boolean isGoingToOwner(){
        return field_70180_af.func_75683_a(21) == (byte)1;
    }

    @Override
    public IFluidTank getTank(){
        return tank;
    }

    /**
     * Returns the owning player. Returns null when the player is not online.
     * @return
     */
    public EntityPlayer getOwner(){
        return MinecraftServer.func_71276_C().func_71203_ab().func_152612_a(playerName);
    }

    public void setStandby(boolean standby){
        this.standby = standby;
    }

    @Override
    public World getWorld(){
        return field_70170_p;
    }

    @Override
    public Vec3 getDronePos(){
        return new Vec3(field_70165_t, field_70163_u, field_70161_v);
    }

    @Override
    public void dropItem(ItemStack stack){
        func_70099_a(stack, 0);
    }

    @Override
    public List<IProgWidget> getProgWidgets(){
        return progWidgets;
    }

    @Override
    public EntityAITasks getTargetAI(){
        return field_70715_bh;
    }

    @Override
    public boolean isProgramApplicable(IProgWidget widget){
        return true;
    }

    @Override
    public IExtendedEntityProperties getProperty(String key){
        return getExtendedProperties(key);
    }

    @Override
    public void setProperty(String key, IExtendedEntityProperties property){
        registerExtendedProperties(key, property);
    }

    @Override
    public void setName(String string){
        func_96094_a(string);
    }

    @Override
    public void setCarryingEntity(Entity entity){
        if(entity == null) {
            if(getCarryingEntity() != null) getCarryingEntity().func_70078_a(null);
        } else {
            entity.func_70078_a(this);
        }
    }

    @Override
    public Entity getCarryingEntity(){
        return field_70153_n;
    }

    @Override
    public boolean isAIOverriden(){
        return chargeAI.isExecuting || gotoOwnerAI != null;
    }

    @Override
    public void onItemPickupEvent(EntityItem curPickingUpEntity, int stackSize){
        func_71001_a(curPickingUpEntity, stackSize);
    }

    @Override
    public IPathNavigator getPathNavigator(){
        return (IPathNavigator)func_70661_as();
    }

    public void tryFireMinigun(EntityLivingBase target){
        ItemStack ammo = getAmmo();
        if(getMinigun().setAmmo(ammo).tryFireMinigun(target)) {
            for(int i = 0; i < getInv().func_70302_i_(); i++) {
                if(getInv().func_70301_a(i) == ammo) {
                    getInv().func_70299_a(i, null);
                }
            }
        }
    }

    public ItemStack getAmmo(){
        for(int i = 0; i < getInv().func_70302_i_(); i++) {
            ItemStack stack = getInv().func_70301_a(i);
            if(stack != null && stack.func_77973_b() == Itemss.gunAmmo) {
                return stack;
            }
        }
        return null;
    }

    public void setHandlingOffer(AmadronOffer offer, int times, ItemStack usedTablet, String buyingPlayer){
        handlingOffer = offer;
        offerTimes = times;
        this.usedTablet = usedTablet != null ? usedTablet.func_77946_l() : null;
        this.buyingPlayer = buyingPlayer;
    }

    public AmadronOffer getHandlingOffer(){
        return handlingOffer;
    }

    public int getOfferTimes(){
        return offerTimes;
    }

    public ItemStack getUsedTablet(){
        return usedTablet;
    }

    public String getBuyingPlayer(){
        return buyingPlayer;
    }

    @Override
    public void overload(){
        func_70097_a(DamageSource.field_76380_i, 2000.0F);
    }

    @Override
    public DroneAIManager getAIManager(){
        return aiManager;
    }

    @Override
    public void updateLabel(){
        field_70180_af.func_75692_b(26, getAIManager() != null ? getAIManager().getLabel() : "Main");
    }

    public String getLabel(){
        return field_70180_af.func_75681_e(26);
    }

    public SortedSet<DebugEntry> getDebugEntries(){
        return debugEntries;
    }

    @Override
    public void addDebugEntry(String message){
        addDebugEntry(message, null);
    }

    @Override
    public void addDebugEntry(String message, BlockPos pos){

        DebugEntry entry = new DebugEntry(message, getActiveWidgetIndex(), pos);
        addDebugEntry(entry);

        PacketSendDroneDebugEntry packet = new PacketSendDroneDebugEntry(entry, this);
        for(EntityPlayerMP player : syncedPlayers) {
            NetworkHandler.sendTo(packet, player);
        }
    }

    public void addDebugEntry(DebugEntry entry){
        if(!debugEntries.isEmpty()) {
            DebugEntry previous = debugEntries.last();
            if(previous.getProgWidgetId() != entry.getProgWidgetId()) {//When we've jumped to another piece
                Iterator<DebugEntry> iterator = debugEntries.iterator();
                while(iterator.hasNext()) {
                    if(iterator.next().getProgWidgetId() == entry.getProgWidgetId()) {
                        iterator.remove(); //Remove the data from last cycle.
                    }
                }
            }
        }
        debugEntries.add(entry);
    }

    public void trackAsDebugged(EntityPlayerMP player){
        NetworkHandler.sendTo(new PacketSyncDroneEntityProgWidgets(this), player);

        for(DebugEntry entry : debugEntries) {
            NetworkHandler.sendTo(new PacketSendDroneDebugEntry(entry, this), player);
        }

        syncedPlayers.add(player);
    }

    public void updateSyncedPlayers(){
        Iterator<EntityPlayerMP> iterator = syncedPlayers.iterator();
        while(iterator.hasNext()) {
            EntityPlayerMP player = iterator.next();
            if(player.field_70128_L || player.func_82169_q(3) == null || NBTUtil.getInteger(player.func_82169_q(3), NBTKeys.PNEUMATIC_HELMET_DEBUGGING_DRONE) != func_145782_y()) {
                iterator.remove();
            }
        }
    }

    private class MinigunDrone extends Minigun{

        public MinigunDrone(){
            super(true);
        }

        @Override
        public boolean isMinigunActivated(){
            return EntityDrone.this.isMinigunActivated();
        }

        @Override
        public void setMinigunActivated(boolean activated){
            EntityDrone.this.setMinigunActivated(activated);
        }

        @Override
        public void setAmmoColorStack(ItemStack ammo){
            setAmmoColor(ammo);
        }

        @Override
        public int getAmmoColor(){
            return EntityDrone.this.getAmmoColor();
        }

        @Override
        public void playSound(String soundName, float volume, float pitch){
            field_70170_p.func_72956_a(EntityDrone.this, soundName, volume, pitch);
        }

    }
}
