package pneumaticCraft.common.entity.projectile;

import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.BlockLeaves;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.projectile.EntityThrowable;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.world.World;
import net.minecraftforge.common.IPlantable;
import net.minecraftforge.common.IShearable;
import pneumaticCraft.common.util.PneumaticCraftUtils;

public class EntityVortex extends EntityThrowable{

    private int hitCounter = 0;
    private double oldMotionX;
    private double oldMotionY;
    private double oldMotionZ;

    public EntityVortex(World par1World){
        super(par1World);
    }

    public EntityVortex(World par1World, EntityLivingBase par2EntityLiving){
        super(par1World, par2EntityLiving);
    }

    public EntityVortex(World par1World, double par2, double par4, double par6){
        super(par1World, par2, par4, par6);
    }

    @Override
    protected void func_70088_a(){}

    @Override
    public void func_70071_h_(){
        oldMotionX = field_70159_w;
        oldMotionY = field_70181_x;
        oldMotionZ = field_70179_y;
        super.func_70071_h_();
        //blowOtherEntities();
        field_70159_w *= 0.95D;// equal to the potion effect friction. 0.95F
        field_70181_x *= 0.95D;
        field_70179_y *= 0.95D;
        if(field_70159_w * field_70159_w + field_70181_x * field_70181_x + field_70179_y * field_70179_y < 0.1D) {
            func_70106_y();
        }
        if(!field_70170_p.field_72995_K) {
            BlockPos pos = new BlockPos(field_70165_t, field_70163_u, field_70161_v);
            tryCutPlants(pos);
            for(EnumFacing dir : EnumFacing.field_82609_l) {
                tryCutPlants(pos.func_177972_a(dir));
            }
        }

    }

    private void tryCutPlants(BlockPos pos){
        Block block = field_70170_p.func_180495_p(pos).func_177230_c();
        if(block instanceof IPlantable || block instanceof BlockLeaves) {
            field_70170_p.func_175655_b(pos, true);
        }
    }

    /*   private void blowOtherEntities(){
           List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(this, boundingBox.addCoord(motionX, motionY, motionZ).expand(1.0D, 1.0D, 1.0D));
           for(Entity e : list) {
               if(e != getThrower() || ticksExisted >= 5) {
                   if(e instanceof EntityPlayer || e instanceof EntityItem) {
                       e.motionX += motionX;
                       e.motionY += motionY;
                       e.motionZ += motionZ;
                   }
               }
           }
       }*/

    @Override
    public float func_70185_h(){
        return 0;
    }

    @Override
    protected void func_70184_a(MovingObjectPosition objectPosition){
        if(objectPosition.field_72308_g != null) {
            Entity entity = objectPosition.field_72308_g;
            entity.field_70159_w += field_70159_w;
            entity.field_70181_x += field_70181_x;
            entity.field_70179_y += field_70179_y;
            if(!entity.field_70170_p.field_72995_K && entity instanceof IShearable) {
                IShearable shearable = (IShearable)entity;
                BlockPos pos = new BlockPos(field_70165_t, field_70163_u, field_70161_v);
                if(shearable.isShearable(null, field_70170_p, pos)) {
                    List<ItemStack> drops = shearable.onSheared(null, field_70170_p, pos, 0);
                    for(ItemStack stack : drops) {
                        PneumaticCraftUtils.dropItemOnGround(stack, field_70170_p, entity.field_70165_t, entity.field_70163_u, entity.field_70161_v);
                    }
                }
            }

        } else {
            Block block = field_70170_p.func_180495_p(objectPosition.func_178782_a()).func_177230_c();
            if(block instanceof IPlantable || block instanceof BlockLeaves) {
                field_70159_w = oldMotionX;
                field_70181_x = oldMotionY;
                field_70179_y = oldMotionZ;
            } else {
                func_70106_y();
            }
        }
        hitCounter++;
        if(hitCounter > 20) func_70106_y();
    }
}
