package pneumaticCraft.common.event;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import pneumaticCraft.api.drone.IDrone;
import pneumaticCraft.api.drone.SpecialVariableRetrievalEvent;
import pneumaticCraft.common.entity.living.EntityDrone;

public class DroneSpecialVariableHandler{

    @SubscribeEvent
    public void onSpecialVariableRetrieving(SpecialVariableRetrievalEvent.CoordinateVariable.Drone event){
        if(event.specialVarName.equalsIgnoreCase("owner")) {
            EntityDrone drone = (EntityDrone)event.drone;
            EntityPlayer player = drone.getOwner();
            if(player != null) event.coordinate = getPosForEntity(player);
        } else if(event.specialVarName.equalsIgnoreCase("drone")) {
            event.coordinate = getPosForEntity(event.drone);
        } else if(event.specialVarName.toLowerCase().startsWith("player=")) {
            EntityPlayer player = MinecraftServer.func_71276_C().func_71203_ab().func_152612_a(event.specialVarName.substring("player=".length()));
            if(player != null) event.coordinate = getPosForEntity(player);
        }
    }

    private BlockPos getPosForEntity(Entity entity){
        return new BlockPos(entity).func_177972_a(EnumFacing.UP); //TODO 1.8 check what's with the offset
    }

    private BlockPos getPosForEntity(IDrone entity){
        return new BlockPos(entity.getDronePos()).func_177972_a(EnumFacing.UP);//TODO 1.8 check what's with the offset
    }
}
