package pneumaticCraft.common.heat.behaviour;

import net.minecraft.block.BlockFurnace;
import net.minecraft.tileentity.TileEntityFurnace;
import pneumaticCraft.api.heat.HeatBehaviour;
import pneumaticCraft.lib.Names;

public class HeatBehaviourFurnace extends HeatBehaviour<TileEntityFurnace>{
    @Override
    public String getId(){
        return Names.MOD_ID + ":furnace";
    }

    @Override
    public boolean isApplicable(){
        return getTileEntity() instanceof TileEntityFurnace;
    }

    @Override
    public void update(){
        TileEntityFurnace furnace = getTileEntity();
        if(getHeatExchanger().getTemperature() > 373) {
            int furnaceBurnTime = furnace.func_174887_a_(0);
            int furnaceCookTime = furnace.func_174887_a_(2);
            if(furnaceBurnTime < 190 && furnace.func_70301_a(0) != null) {
                if(furnaceBurnTime == 0) BlockFurnace.func_176446_a(true, furnace.func_145831_w(), furnace.func_174877_v());
                furnace.func_174885_b(1, 200); //currentItemBurnTime
                furnace.func_174885_b(0, furnaceBurnTime + 10);
                getHeatExchanger().addHeat(-1);
            }
            if(furnaceCookTime > 0) {//Easy performance saver, the Furnace won't be ticked unnecessary when there's nothing to cook (or when just started cooking).
                int progress = Math.max(0, ((int)getHeatExchanger().getTemperature() - 343) / 30);
                progress = Math.min(5, progress);
                for(int i = 0; i < progress; i++) {
                    furnace.func_73660_a();
                }
            }
        }
    }

}
