package pneumaticCraft.common.inventory;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import pneumaticCraft.common.item.ItemLogisticsFrame;
import pneumaticCraft.common.semiblock.SemiBlockLogistics;
import pneumaticCraft.common.semiblock.SemiBlockManager;
import pneumaticCraft.common.tileentity.IGUIButtonSensitive;

public class ContainerLogistics extends ContainerPneumaticBase{
    public final SemiBlockLogistics logistics;
    private final boolean itemContainer;

    public ContainerLogistics(InventoryPlayer inventoryPlayer, SemiBlockLogistics logistics){
        super(null);
        itemContainer = logistics == null;
        if(itemContainer) {
            logistics = getLogistics(inventoryPlayer.field_70458_d, inventoryPlayer.func_70448_g());
        }
        this.logistics = logistics;
        if(logistics != null) {
            addSyncedFields(logistics);
            IInventory requests = logistics.getFilters();
            for(int y = 0; y < 3; y++) {
                for(int x = 0; x < 9; x++) {
                    func_75146_a(logistics.canFilterStack() ? new SlotPhantom(requests, y * 9 + x, x * 18 + 8, y * 18 + 29) : new SlotPhantomUnstackable(requests, y * 9 + x, x * 18 + 8, y * 18 + 29));
                }
            }

            // Add the player's inventory slots to the container
            for(int inventoryRowIndex = 0; inventoryRowIndex < 3; ++inventoryRowIndex) {
                for(int inventoryColumnIndex = 0; inventoryColumnIndex < 9; ++inventoryColumnIndex) {
                    func_75146_a(new Slot(inventoryPlayer, inventoryColumnIndex + inventoryRowIndex * 9 + 9, 8 + inventoryColumnIndex * 18, 134 + inventoryRowIndex * 18));
                }
            }

            // Add the player's action bar slots to the container
            for(int actionBarSlotIndex = 0; actionBarSlotIndex < 9; ++actionBarSlotIndex) {
                func_75146_a(new Slot(inventoryPlayer, actionBarSlotIndex, 8 + actionBarSlotIndex * 18, 192));
            }
        }
    }

    public static SemiBlockLogistics getLogistics(EntityPlayer player, ItemStack itemRequester){
        if(itemRequester != null && itemRequester.func_77973_b() instanceof ItemLogisticsFrame) {
            SemiBlockLogistics logistics = (SemiBlockLogistics)SemiBlockManager.getSemiBlockForKey(((ItemLogisticsFrame)itemRequester.func_77973_b()).semiBlockId);
            logistics.initialize(player.field_70170_p, new BlockPos(0, 0, 0));
            logistics.onPlaced(player, itemRequester);
            return logistics;
        } else {
            return null;
        }
    }

    /**
     * Called when the container is closed.
     */
    @Override
    public void func_75134_a(EntityPlayer player){
        if(itemContainer && logistics != null) {
            List<ItemStack> drops = new ArrayList<ItemStack>();
            logistics.addDrops(drops);
            NBTTagCompound settingTag = drops.get(0).func_77978_p();
            if(player.func_71045_bC().func_77942_o()) {
                NBTTagCompound itemTag = player.func_71045_bC().func_77978_p();
                if(settingTag != null) {
                    itemTag.func_74782_a("filters", settingTag.func_150295_c("filters", 10));
                    itemTag.func_74782_a("fluidFilters", settingTag.func_150295_c("fluidFilters", 10));
                    itemTag.func_74757_a("invisible", settingTag.func_74767_n("invisible"));
                } else {
                    itemTag.func_82580_o("filters");
                    itemTag.func_82580_o("fluidFilters");
                    itemTag.func_82580_o("invisible");

                }
            } else {
                player.func_71045_bC().func_77982_d(settingTag);
            }
        }
    }

    @Override
    public void handleGUIButtonPress(int guiID, EntityPlayer player){
        super.handleGUIButtonPress(guiID, player);
        if(logistics instanceof IGUIButtonSensitive) {
            ((IGUIButtonSensitive)logistics).handleGUIButtonPress(guiID, player);
        }
    }

    @Override
    public boolean func_75145_c(EntityPlayer player){
        return logistics != null && !logistics.isInvalid();
    }

    @Override
    public ItemStack func_82846_b(EntityPlayer par1EntityPlayer, int par2){

        Slot var4 = (Slot)field_75151_b.get(par2);

        if(par2 >= 27 && var4 != null && var4.func_75216_d()) {
            ItemStack var5 = var4.func_75211_c();
            for(int i = 0; i < 27; i++) {
                Slot slot = (Slot)field_75151_b.get(i);
                if(!slot.func_75216_d()) {
                    slot.func_75215_d(var5.func_77946_l());
                    slot.func_75211_c().field_77994_a = slot.func_75219_a();
                    break;
                }
            }
        }

        return null;
    }

}
