package pneumaticCraft.common.inventory;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import pneumaticCraft.api.item.IProgrammable;
import pneumaticCraft.common.network.PacketSendNBTPacket;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;

public class ContainerProgrammer extends ContainerPneumaticBase<TileEntityProgrammer>{

    public ContainerProgrammer(InventoryPlayer inventoryPlayer, TileEntityProgrammer te){
        super(te);
        // add the upgrade slots
        func_75146_a(new Slot(te, 0, 326, 15){
            @Override
            public boolean func_75214_a(ItemStack stack){
                return isProgrammableItem(stack);
            }
        });

        // Add the player's inventory slots to the container
        for(int inventoryRowIndex = 0; inventoryRowIndex < 3; ++inventoryRowIndex) {
            for(int inventoryColumnIndex = 0; inventoryColumnIndex < 9; ++inventoryColumnIndex) {
                func_75146_a(new Slot(inventoryPlayer, inventoryColumnIndex + inventoryRowIndex * 9 + 9, 95 + inventoryColumnIndex * 18, 174 + inventoryRowIndex * 18));
            }
        }

        // Add the player's action bar slots to the container
        for(int actionBarSlotIndex = 0; actionBarSlotIndex < 9; ++actionBarSlotIndex) {
            func_75146_a(new Slot(inventoryPlayer, actionBarSlotIndex, 95 + actionBarSlotIndex * 18, 232));
        }
    }

    private static boolean isProgrammableItem(ItemStack stack){
        if(stack == null) return false;
        return stack.func_77973_b() instanceof IProgrammable && ((IProgrammable)stack.func_77973_b()).canProgram(stack);
    }

    @Override
    public void func_75142_b(){
        super.func_75142_b();
        if(te.func_145831_w().func_82737_E() % 20 == 0) {
            for(EnumFacing d : EnumFacing.field_82609_l) {
                TileEntity neighbor = te.func_145831_w().func_175625_s(te.func_174877_v().func_177972_a(d));
                if(neighbor instanceof IInventory) {
                    sendToCrafters(new PacketSendNBTPacket(neighbor));
                }
            }
        }
    }

    @Override
    public ItemStack func_82846_b(EntityPlayer par1EntityPlayer, int par2){

        ItemStack var3 = null;
        Slot var4 = field_75151_b.get(par2);

        if(var4 != null && var4.func_75216_d()) {
            ItemStack var5 = var4.func_75211_c();
            var3 = var5.func_77946_l();

            if(par2 == 0) {
                if(!func_75135_a(var5, 1, 36, false)) return null;
                var4.func_75220_a(var5, var3);
            } else if(isProgrammableItem(var3)) {
                if(!func_75135_a(var5, 0, 1, false)) return null;
                var4.func_75220_a(var5, var3);
            }
            if(var5.field_77994_a == 0) {
                var4.func_75215_d((ItemStack)null);
            } else {
                var4.func_75218_e();
            }

            if(var5.field_77994_a == var3.field_77994_a) return null;

            var4.func_82870_a(par1EntityPlayer, var5);
        }

        return var3;
    }

}
