package pneumaticCraft.common.inventory;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.BlockPos;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketSetGlobalVariable;
import pneumaticCraft.common.remote.GlobalVariableManager;
import pneumaticCraft.common.remote.TextVariableParser;

public class ContainerRemote extends ContainerPneumaticBase{
    private final List<String> syncedVars;
    private final BlockPos[] lastValues;
    public String[] variables = new String[0];

    public ContainerRemote(ItemStack remote){
        super(null);
        syncedVars = new ArrayList<String>(getRelevantVariableNames(remote));
        lastValues = new BlockPos[syncedVars.size()];
    }

    private static Set<String> getRelevantVariableNames(ItemStack remote){
        Set<String> variables = new HashSet<String>();
        NBTTagCompound tag = remote.func_77978_p();
        if(tag != null) {
            NBTTagList tagList = tag.func_150295_c("actionWidgets", 10);
            for(int i = 0; i < tagList.func_74745_c(); i++) {
                NBTTagCompound widgetTag = tagList.func_150305_b(i);
                variables.add(widgetTag.func_74779_i("variableName"));
                variables.add(widgetTag.func_74779_i("enableVariable"));
                TextVariableParser parser = new TextVariableParser(widgetTag.func_74779_i("text"));
                parser.parse();
                variables.addAll(parser.getRelevantVariables());
            }
        }
        return variables;
    }

    @Override
    public void func_75142_b(){
        super.func_75142_b();
        for(int i = 0; i < lastValues.length; i++) {
            BlockPos newValue = GlobalVariableManager.getInstance().getPos(syncedVars.get(i));
            if(!newValue.equals(lastValues[i])) {
                lastValues[i] = newValue;
                for(Object o : field_75149_d) {
                    if(o instanceof EntityPlayerMP) NetworkHandler.sendTo(new PacketSetGlobalVariable(syncedVars.get(i), newValue), (EntityPlayerMP)o);
                }
            }
        }
    }

    @Override
    public boolean func_75145_c(EntityPlayer player){
        return player.func_71045_bC() != null && player.func_71045_bC().func_77973_b() == Itemss.remote;
    }
}
