package pneumaticCraft.common.item;

import java.util.List;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.recipes.programs.AssemblyProgram;
import pneumaticCraft.common.recipes.programs.ProgramDrill;
import pneumaticCraft.common.recipes.programs.ProgramDrillLaser;
import pneumaticCraft.common.recipes.programs.ProgramLaser;

public class ItemAssemblyProgram extends ItemPneumatic{
    public static final int PROGRAMS_AMOUNT = 3;

    public static final int DRILL_DAMAGE = 0;
    public static final int LASER_DAMAGE = 1;
    public static final int DRILL_LASER_DAMAGE = 2;

    private AssemblyProgram[] referencePrograms;

    public ItemAssemblyProgram(){
        func_77627_a(true);
    }

    @Override
    public String func_77667_c(ItemStack is){
        return super.func_77667_c(is) + is.func_77952_i();
    }

    @Override
    public int func_77647_b(int meta){
        return meta;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_150895_a(Item par1, CreativeTabs tab, List subItems){
        for(int i = 0; i < PROGRAMS_AMOUNT; i++) {
            subItems.add(new ItemStack(this, 1, i));
        }
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_77624_a(ItemStack stack, EntityPlayer player, List infoList, boolean par4){
        infoList.add("Required Machines:");
        infoList.add("-" + Blockss.assemblyController.func_149732_F());

        if(referencePrograms == null) {
            referencePrograms = new AssemblyProgram[PROGRAMS_AMOUNT];
            for(int i = 0; i < PROGRAMS_AMOUNT; i++) {
                referencePrograms[i] = getProgramFromItem(i);
            }
        }
        AssemblyProgram program = referencePrograms[Math.min(stack.func_77952_i(), PROGRAMS_AMOUNT - 1)];
        AssemblyProgram.EnumMachine[] requiredMachines = program.getRequiredMachines();
        for(AssemblyProgram.EnumMachine machine : requiredMachines) {
            switch(machine){
                case PLATFORM:
                    infoList.add("-" + Blockss.assemblyPlatform.func_149732_F());
                    break;
                case DRILL:
                    infoList.add("-" + Blockss.assemblyDrill.func_149732_F());
                    break;
                case LASER:
                    infoList.add("-" + Blockss.assemblyLaser.func_149732_F());
                    break;
                case IO_UNIT_EXPORT:
                    infoList.add("-" + Blockss.assemblyIOUnit.func_149732_F() + " (export)");//TODO localize
                    break;
                case IO_UNIT_IMPORT:
                    infoList.add("-" + Blockss.assemblyIOUnit.func_149732_F() + " (import)");
                    break;
            }
        }
    }

    public static AssemblyProgram getProgramFromItem(int meta){
        switch(meta){
            case DRILL_DAMAGE:
                return new ProgramDrill();
            case LASER_DAMAGE:
                return new ProgramLaser();
            case DRILL_LASER_DAMAGE:
                return new ProgramDrillLaser();
        }
        return null;
    }

}
