package pneumaticCraft.common.item;

import java.util.List;
import java.util.Random;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.common.fluid.Fluids;
import pneumaticCraft.lib.TileEntityConstants;

public class ItemEmptyPCB extends ItemNonDespawning{
    private static Random rand = new Random();

    public ItemEmptyPCB(){
        func_77625_d(1);
        func_77656_e(100);
        setNoRepair();
    }

    @Override
    @SideOnly(Side.CLIENT)
    /**
     * returns a list of items with the same ID, but different meta (eg: dye returns 16 items)
     */
    public void func_150895_a(Item par1, CreativeTabs par2CreativeTabs, List par3List){
        par3List.add(new ItemStack(par1, 1, 0));
        par3List.add(new ItemStack(par1, 1, func_77612_l()));
    }

    @Override
    public void func_77624_a(ItemStack stack, EntityPlayer player, List infoList, boolean par4){
        super.func_77624_a(stack, player, infoList, par4);
        if(stack.func_77952_i() < 100) {
            infoList.add("Etch success chance: " + (100 - stack.func_77952_i()) + "%");
        } else {
            infoList.add("Put in a UV Light Box to progress...");
        }
        if(stack.func_77942_o()) {
            infoList.add("Etching progress: " + stack.func_77978_p().func_74762_e("etchProgress") + "%");
        } else if(stack.func_77952_i() < 100) {
            infoList.add("Throw in Etching Acid to develop...");
        }
    }

    @Override
    public boolean onEntityItemUpdate(EntityItem entityItem){
        super.onEntityItemUpdate(entityItem);
        ItemStack stack = entityItem.func_92059_d();
        if(Fluids.areFluidsEqual(FluidRegistry.lookupFluidForBlock(entityItem.field_70170_p.func_180495_p(new BlockPos(entityItem)).func_177230_c()), Fluids.etchingAcid)) {
            if(!stack.func_77942_o()) {
                stack.func_77982_d(new NBTTagCompound());
            }
            int etchProgress = stack.func_77978_p().func_74762_e("etchProgress");
            if(etchProgress < 100) {
                if(entityItem.field_70173_aa % (TileEntityConstants.PCB_ETCH_TIME / 5) == 0) stack.func_77978_p().func_74768_a("etchProgress", etchProgress + 1);
            } else {
                entityItem.func_92058_a(new ItemStack(rand.nextInt(100) >= stack.func_77952_i() ? Itemss.unassembledPCB : Itemss.failedPCB));
            }
        }
        return false;
    }
}
