package pneumaticCraft.common.item;

import java.util.List;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ChatComponentTranslation;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.relauncher.Side;
import pneumaticCraft.client.gui.GuiGPSTool;
import pneumaticCraft.common.NBTUtil;
import pneumaticCraft.common.remote.GlobalVariableManager;

public class ItemGPSTool extends ItemPneumatic{
    public ItemGPSTool(){
        func_77625_d(1);
    }

    @Override
    public boolean func_180614_a(ItemStack IStack, EntityPlayer player, World world, BlockPos pos, EnumFacing side, float par8, float par9, float par10){
        setGPSLocation(IStack, pos);
        if(!world.field_72995_K) player.func_146105_b(new ChatComponentTranslation(EnumChatFormatting.GREEN + "[GPS Tool] Set Coordinates to " + pos.func_177958_n() + ", " + pos.func_177956_o() + ", " + pos.func_177952_p() + "."));
        return true; // we don't want to use the item.

    }

    /**
     * Called whenever this item is equipped and the right mouse button is pressed. Args: itemStack, world, entityPlayer
     */
    @Override
    public ItemStack func_77659_a(ItemStack stack, World world, EntityPlayer player){
        if(world.field_72995_K) {
            BlockPos pos = getGPSLocation(stack);
            FMLCommonHandler.instance().showGuiScreen(new GuiGPSTool(pos != null ? pos : new BlockPos(0, 0, 0), getVariable(stack)));
        }
        return stack;
    }

    // the information displayed as tooltip info. (saved coordinates in this
    // case)
    @Override
    public void func_77624_a(ItemStack stack, EntityPlayer player, List infoList, boolean par4){
        super.func_77624_a(stack, player, infoList, par4);
        NBTTagCompound compound = stack.func_77978_p();
        if(compound != null) {
            int x = compound.func_74762_e("x");
            int y = compound.func_74762_e("y");
            int z = compound.func_74762_e("z");
            if(x != 0 || y != 0 || z != 0) {
                infoList.add("\u00a72Set to " + x + ", " + y + ", " + z);
            }
            String varName = getVariable(stack);
            if(!varName.equals("")) {
                infoList.add(I18n.func_135052_a("gui.tooltip.gpsTool.variable", varName));
            }
        }
    }

    @Override
    public void func_77663_a(ItemStack stack, World world, Entity entity, int slot, boolean heldItem){
        String var = getVariable(stack);
        if(!var.equals("") && !world.field_72995_K) {
            BlockPos pos = GlobalVariableManager.getInstance().getPos(var);
            setGPSLocation(stack, pos);
        }
    }

    public static BlockPos getGPSLocation(ItemStack gpsTool){
        NBTTagCompound compound = gpsTool.func_77978_p();
        if(compound != null) {
            String var = getVariable(gpsTool);
            if(!var.equals("") && FMLCommonHandler.instance().getEffectiveSide() == Side.SERVER) {
                BlockPos pos = GlobalVariableManager.getInstance().getPos(var);
                setGPSLocation(gpsTool, pos);
            }
            int x = compound.func_74762_e("x");
            int y = compound.func_74762_e("y");
            int z = compound.func_74762_e("z");
            if(x != 0 || y != 0 || z != 0) {
                return new BlockPos(x, y, z);
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    public static void setGPSLocation(ItemStack gpsTool, BlockPos pos){
        NBTUtil.setPos(gpsTool, pos);
        String var = getVariable(gpsTool);
        if(!var.equals("")) GlobalVariableManager.getInstance().set(var, pos);
    }

    public static void setVariable(ItemStack gpsTool, String variable){
        NBTUtil.setString(gpsTool, "variable", variable);
    }

    public static String getVariable(ItemStack gpsTool){
        return gpsTool.func_77942_o() ? gpsTool.func_77978_p().func_74779_i("variable") : "";
    }
}
