package pneumaticCraft.common.item;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.resources.I18n;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.common.NBTUtil;

public class ItemGunAmmo extends ItemPneumatic{

    public ItemGunAmmo(){
        super("gunAmmo");
        func_77625_d(1);
        func_77656_e(1000);
    }

    public static ItemStack getPotion(ItemStack ammo){
        if(ammo.func_77978_p() != null && ammo.func_77978_p().func_74764_b("potion")) {
            return ItemStack.func_77949_a(ammo.func_77978_p().func_74775_l("potion"));
        } else {
            return null;
        }
    }

    public static void setPotion(ItemStack ammo, ItemStack potion){
        NBTTagCompound tag = new NBTTagCompound();
        potion.func_77955_b(tag);
        NBTUtil.setCompoundTag(ammo, "potion", tag);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public int func_82790_a(ItemStack itemStack, int renderPass){
        ItemStack potion = getPotion(itemStack);
        return renderPass == 0 ? super.func_82790_a(itemStack, renderPass) : potion != null ? Items.field_151068_bn.func_82790_a(potion, 0) : 0x00FFFF00;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_77624_a(ItemStack stack, EntityPlayer player, List infoList, boolean extraInfo){
        infoList.add(I18n.func_135052_a("gui.tooltip.gunAmmo.combineWithPotion"));
        ItemStack potion = getPotion(stack);
        if(potion != null) {
            potion.func_77973_b().func_77624_a(potion, player, infoList, extraInfo);
            if(infoList.size() > 2) infoList.set(2, I18n.func_135052_a("gui.tooltip.gunAmmo") + " " + infoList.get(2));
        }
        super.func_77624_a(stack, player, infoList, extraInfo);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_150895_a(Item item, CreativeTabs tab, List list){
        super.func_150895_a(item, tab, list);
        List<ItemStack> potions = new ArrayList<ItemStack>();
        Items.field_151068_bn.func_150895_a(Items.field_151068_bn, tab, potions);
        for(ItemStack potion : potions) {
            ItemStack ammo = new ItemStack(item);
            setPotion(ammo, potion);
            list.add(ammo);
        }
    }
}
