package pneumaticCraft.common.item;

import java.util.List;

import net.minecraft.entity.IEntityLivingData;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import pneumaticCraft.common.entity.living.EntityDrone;
import pneumaticCraft.common.entity.living.EntityLogisticsDrone;
import pneumaticCraft.common.progwidgets.IProgWidget;
import pneumaticCraft.common.progwidgets.ProgWidgetArea;
import pneumaticCraft.common.progwidgets.ProgWidgetLogistics;
import pneumaticCraft.common.progwidgets.ProgWidgetStart;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;

public class ItemLogisticsDrone extends ItemDrone{

    public ItemLogisticsDrone(){
        func_77625_d(64);
    }

    @Override
    public boolean func_180614_a(ItemStack iStack, EntityPlayer player, World world, BlockPos pos, EnumFacing side, float vecX, float vecY, float vecZ){
        if(!world.field_72995_K) {
            EntityDrone drone = new EntityLogisticsDrone(world, player);

            BlockPos placePos = pos.func_177972_a(side);
            drone.func_70107_b(placePos.func_177958_n() + 0.5, placePos.func_177956_o() + 0.5, placePos.func_177952_p() + 0.5);
            world.func_72838_d(drone);

            NBTTagCompound stackTag = iStack.func_77978_p();
            NBTTagCompound entityTag = new NBTTagCompound();
            drone.func_70014_b(entityTag);
            if(stackTag != null) {
                entityTag.func_74776_a("currentAir", stackTag.func_74760_g("currentAir"));
                entityTag.func_74768_a("color", stackTag.func_74762_e("color"));
                NBTTagCompound invTag = stackTag.func_74775_l("UpgradeInventory");
                if(invTag != null) entityTag.func_74782_a("Inventory", invTag.func_74737_b());
            }
            drone.func_70037_a(entityTag);
            addLogisticsProgram(pos, drone.progWidgets);
            if(iStack.func_82837_s()) drone.func_96094_a(iStack.func_82833_r());

            drone.naturallySpawned = false;
            //TODO 1.8 check if valid replacement drone.onSpawnWithEgg(null);
            drone.func_180482_a(world.func_175649_E(placePos), (IEntityLivingData)null);
            iStack.field_77994_a--;
        }
        return true;
    }

    private void addLogisticsProgram(BlockPos pos, List<IProgWidget> widgets){
        ProgWidgetStart start = new ProgWidgetStart();
        start.setX(0);
        start.setY(0);
        widgets.add(start);

        ProgWidgetLogistics logistics = new ProgWidgetLogistics();
        logistics.setX(0);
        logistics.setY(11);
        widgets.add(logistics);

        ProgWidgetArea area = new ProgWidgetArea();
        area.setX(15);
        area.setY(11);
        area.x1 = pos.func_177958_n() - 16;
        area.y1 = pos.func_177956_o() - 16;
        area.z1 = pos.func_177952_p() - 16;
        area.x2 = pos.func_177958_n() + 16;
        area.y2 = pos.func_177956_o() + 16;
        area.z2 = pos.func_177952_p() + 16;
        widgets.add(area);
        TileEntityProgrammer.updatePuzzleConnections(widgets);
    }

    @Override
    public boolean canProgram(ItemStack stack){
        return false;
    }
}
