package pneumaticCraft.common.item;

import java.util.List;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.StatCollector;
import net.minecraft.world.World;
import net.minecraftforge.fluids.FluidStack;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.common.semiblock.ItemSemiBlockBase;
import pneumaticCraft.common.semiblock.SemiBlockLogistics;
import pneumaticCraft.common.semiblock.SemiBlockManager;
import pneumaticCraft.common.semiblock.SemiBlockRequester;
import pneumaticCraft.common.util.PneumaticCraftUtils;

public class ItemLogisticsFrame extends ItemSemiBlockBase{

    public ItemLogisticsFrame(String semiBlockId){
        super(semiBlockId);
    }

    /**
     * Called whenever this item is equipped and the right mouse button is pressed. Args: itemStack, world, entityPlayer
     */
    @Override
    public ItemStack func_77659_a(ItemStack stack, World world, EntityPlayer player){
        if(!world.field_72995_K) {
            player.openGui(PneumaticCraft.instance, ((SemiBlockLogistics)getSemiBlock(world, null, stack)).getGuiID().ordinal(), world, 0, 0, 0);
        }
        return stack;
    }

    @Override
    public void func_77624_a(ItemStack stack, EntityPlayer player, List curInfo, boolean extraInfo){
        super.func_77624_a(stack, player, curInfo, extraInfo);
        addTooltip(stack, player, curInfo, PneumaticCraft.proxy.isSneakingInGui());
        ItemPneumatic.addTooltip(stack, player, curInfo);
    }

    public static void addTooltip(ItemStack stack, EntityPlayer player, List<String> curInfo, boolean sneaking){

        if(stack.func_77978_p() != null) {
            if(stack.func_77978_p().func_74767_n("invisible")) curInfo.add(I18n.func_135052_a("gui.logisticFrame.invisible"));
            if(stack.func_77978_p().func_74764_b("filters") && stack.func_77978_p().func_150295_c("filters", 10).func_74745_c() > 0 || stack.func_77978_p().func_74764_b("fluidFilters") && stack.func_77978_p().func_150295_c("fluidFilters", 10).func_74745_c() > 0) {
                String key = SemiBlockManager.getKeyForSemiBlock(SemiBlockManager.getSemiBlockForItem(stack.func_77973_b()));
                if(sneaking) {
                    curInfo.add(StatCollector.func_74838_a(String.format("gui.%s.filters", key)));
                    SemiBlockRequester requester = new SemiBlockRequester();
                    requester.onPlaced(player, stack);
                    ItemStack[] stacks = new ItemStack[requester.getFilters().func_70302_i_()];
                    for(int i = 0; i < stacks.length; i++) {
                        stacks[i] = requester.getFilters().func_70301_a(i);
                    }
                    PneumaticCraftUtils.sortCombineItemStacksAndToString(curInfo, stacks);
                    for(int i = 0; i < 9; i++) {
                        FluidStack fluid = requester.getTankFilter(i).getFluid();
                        if(fluid != null) {
                            curInfo.add("-" + fluid.amount / 1000 + "B " + fluid.getLocalizedName());
                        }
                    }
                } else {
                    curInfo.add(StatCollector.func_74838_a(String.format("gui.%s.hasFilters", key)));
                }
            }
        }
    }

}
