package pneumaticCraft.common.item;

import java.util.List;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.api.item.IPressurizable;

public class ItemPressurizable extends ItemPneumatic implements IPressurizable{
    private final int volume;

    public ItemPressurizable(String textureLocation, int maxAir, int volume){
        super(textureLocation);
        func_77625_d(1);
        func_77656_e(maxAir);
        this.volume = volume;
        setNoRepair();
    }

    @Override
    @SideOnly(Side.CLIENT)
    /**
     * returns a list of items with the same ID, but different meta (eg: dye returns 16 items)
     */
    public void func_150895_a(Item par1, CreativeTabs par2CreativeTabs, List par3List){
        par3List.add(new ItemStack(par1, 1, 0));
        par3List.add(new ItemStack(par1, 1, func_77612_l()));
    }

    @Override
    public float getPressure(ItemStack iStack){
        return (float)(func_77612_l() - iStack.func_77952_i()) / (float)volume;
    }

    // the information displayed as tooltip info. (saved coordinates in this
    // case)
    @Override
    public void func_77624_a(ItemStack stack, EntityPlayer player, List infoList, boolean par4){
        infoList.add("Pressure: " + Math.round(getPressure(stack) * 10D) / 10D + " bar");
        super.func_77624_a(stack, player, infoList, par4);
    }

    @Override
    public void addAir(ItemStack iStack, int amount){
        iStack.func_77964_b(iStack.func_77952_i() - amount);
    }

    @Override
    public float maxPressure(ItemStack iStack){
        return 10F;
    }

}
