package pneumaticCraft.common.item;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import pneumaticCraft.common.entity.projectile.EntityVortex;
import pneumaticCraft.lib.PneumaticValues;
import pneumaticCraft.lib.Sounds;

public class ItemVortexCannon extends ItemPressurizable{

    public ItemVortexCannon(String textureLocation){
        super(textureLocation, PneumaticValues.VORTEX_CANNON_MAX_AIR, PneumaticValues.VORTEX_CANNON_VOLUME);
    }

    /**
     * Called whenever this item is equipped and the right mouse button is
     * pressed. Args: itemStack, world, entityPlayer
     */
    @Override
    public ItemStack func_77659_a(ItemStack iStack, World world, EntityPlayer player){
        if(iStack.func_77952_i() < func_77612_l()) {
            double factor = 0.2D * getPressure(iStack);
            world.func_72956_a(player, Sounds.CANNON_SOUND, 1.0F, 0.7F + (float)factor * 0.2F /* 1.0F */);
            EntityVortex vortex = new EntityVortex(world, player);
            vortex.field_70159_w *= factor;
            vortex.field_70181_x *= factor;
            vortex.field_70179_y *= factor;
            if(!world.field_72995_K) world.func_72838_d(vortex);

            iStack.func_77964_b(iStack.func_77952_i() + PneumaticValues.USAGE_VORTEX_CANNON);
            if(iStack.func_77952_i() > func_77612_l()) {
                iStack.func_77964_b(func_77612_l());
            }
        }

        return iStack;
    }
}
