package pneumaticCraft.common.item;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.minecraft.item.Item;
import net.minecraft.item.ItemArmor;
import net.minecraftforge.fml.common.Loader;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.oredict.OreDictionary;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.common.semiblock.SemiBlockActiveProvider;
import pneumaticCraft.common.thirdparty.ThirdPartyManager;
import pneumaticCraft.lib.ModIds;
import pneumaticCraft.lib.Names;
import pneumaticCraft.lib.PneumaticValues;
import pneumaticCraft.lib.Textures;

public class Itemss{

    public static Item GPSTool;
    public static Item ingotIronCompressed;
    public static Item pressureGauge;
    public static Item stoneBase;
    public static Item cannonBarrel;
    public static Item turbineBlade;
    public static Item plastic;
    public static Item airCanister;
    public static Item vortexCannon;
    public static Item pneumaticCylinder;
    public static Item pneumaticHelmet;
    public static Item manometer;
    public static Item turbineRotor;
    public static Item assemblyProgram;
    public static Item emptyPCB;
    public static Item unassembledPCB;
    public static Item PCBBlueprint;
    public static Item transistor;
    public static Item capacitor;
    public static Item printedCircuitBoard;
    public static Item failedPCB;
    public static Item networkComponent;
    public static Item stopWorm;
    public static Item nukeVirus;
    public static Item compressedIronGear;
    public static Item pneumaticWrench;
    public static Item drone;
    public static Item programmingPuzzle;
    public static Item advancedPCB;
    public static Item remote;
    public static Item seismicSensor;
    public static Item logisticsConfigurator;
    public static Item logisticsFrameRequester;
    public static Item logisticsFrameStorage;
    public static Item logisticsFrameDefaultStorage;
    public static Item logisticsFramePassiveProvider;
    public static Item logisticsFrameActiveProvider;
    public static Item logisticsDrone;
    public static Item gunAmmo;
    public static Item amadronTablet;
    public static Item minigun;
    public static List<Item> items = new ArrayList<Item>();
    public static Map<EnumUpgrade, Item> upgrades = new HashMap<EnumUpgrade, Item>();

    public static void init(){
        GPSTool = new ItemGPSTool().func_77655_b("gpsTool");
        ingotIronCompressed = new ItemPneumatic(Textures.ITEM_COMPRESSED_IRON_INGOT).func_77655_b("ingotIronCompressed");
        pressureGauge = new ItemPneumatic(Textures.ITEM_PRESSURE_GAUGE).func_77655_b("pressureGauge");
        stoneBase = new ItemPneumatic().func_77655_b("stoneBase");
        cannonBarrel = new ItemPneumatic().func_77655_b("cannonBarrel");
        turbineBlade = new ItemPneumatic(Textures.ITEM_TURBINE_BLADE).func_77655_b("turbineBlade");
        plastic = new ItemPlastic().func_77655_b("plastic");
        airCanister = new ItemPressurizable(Textures.ITEM_AIR_CANISTER, PneumaticValues.AIR_CANISTER_MAX_AIR, PneumaticValues.AIR_CANISTER_VOLUME).func_77655_b("airCanister");
        vortexCannon = new ItemVortexCannon(Textures.ITEM_VORTEX).func_77655_b("vortexCannon");
        pneumaticCylinder = new ItemPneumatic(Textures.ITEM_CANNON_BARREL).func_77655_b("pneumaticCylinder");
        pneumaticHelmet = new ItemPneumaticArmor(ItemArmor.ArmorMaterial.IRON, PneumaticCraft.proxy.getArmorRenderID(Textures.ARMOR_PNEUMATIC), 0, PneumaticValues.PNEUMATIC_HELMET_MAX_AIR).func_77655_b("pneumaticHelmet");
        manometer = new pneumaticCraft.common.item.ItemManometer(Textures.ITEM_MANOMETER).func_77655_b("manometer");
        turbineRotor = new pneumaticCraft.common.item.ItemPneumatic(Textures.ITEM_TURBINE_ROTOR).func_77655_b("turbineRotor");
        assemblyProgram = new ItemAssemblyProgram().func_77655_b("assemblyProgram");
        emptyPCB = new ItemEmptyPCB().func_77655_b("emptyPCB");
        unassembledPCB = new ItemNonDespawning(Textures.ITEM_UNASSEMBLED_PCB).func_77655_b("unassembledPCB");
        PCBBlueprint = new ItemPneumatic(Textures.ITEM_PCB_BLUEPRINT).func_77655_b("pcbBlueprint");
        transistor = new ItemPneumatic(Textures.ITEM_TRANSISTOR).func_77655_b("transistor");
        capacitor = new ItemPneumatic(Textures.ITEM_CAPACITOR).func_77655_b("capacitor");
        printedCircuitBoard = new ItemPneumatic(Textures.ITEM_PRINTED_CIRCUIT_BOARD).func_77655_b("printedCircuitBoard");
        failedPCB = new ItemNonDespawning(Textures.ITEM_FAILED_PCB).func_77655_b("failedPCB");
        networkComponent = new ItemNetworkComponents().func_77655_b("networkComponent");
        stopWorm = new ItemPneumatic(Textures.ITEM_STOP_WORM).func_77655_b("stopWorm");
        nukeVirus = new ItemPneumatic(Textures.ITEM_NUKE_VIRUS).func_77655_b("nukeVirus");
        compressedIronGear = new ItemPneumatic(Textures.ITEM_COMPRESSED_IRON_GEAR).func_77655_b("compressedIronGear");
        pneumaticWrench = new ItemPneumaticWrench(Textures.ITEM_PNEUMATIC_WRENCH, PneumaticValues.PNEUMATIC_WRENCH_MAX_AIR, PneumaticValues.PNEUMATIC_WRENCH_VOLUME).func_77655_b("pneumaticWrench");
        drone = new ItemDrone().func_77655_b("drone");
        programmingPuzzle = new ItemProgrammingPuzzle().func_77655_b("programmingPuzzle")/*.setTextureName("pneumaticcraft:programmingPuzzles/entityAttack")*/;
        advancedPCB = new ItemPneumatic(Textures.ITEM_ADVANCED_PCB).func_77655_b("advancedPCB");
        remote = new ItemRemote("remote").func_77655_b("remote");
        seismicSensor = new ItemSeismicSensor();
        logisticsConfigurator = new ItemLogisticsConfigurator("logisticsConfigurator", PneumaticValues.AIR_CANISTER_MAX_AIR, PneumaticValues.AIR_CANISTER_VOLUME).func_77655_b("logisticsConfigurator");
        logisticsFrameRequester = new ItemLogisticsFrameRequester().func_77637_a(PneumaticCraft.tabPneumaticCraft);
        logisticsFrameStorage = new ItemLogisticsFrameStorage().func_77637_a(PneumaticCraft.tabPneumaticCraft);
        logisticsFrameDefaultStorage = new ItemLogisticsFrameDefaultStorage().func_77637_a(PneumaticCraft.tabPneumaticCraft);
        logisticsFramePassiveProvider = new ItemLogisticsFramePassiveProvider().func_77637_a(PneumaticCraft.tabPneumaticCraft);
        logisticsFrameActiveProvider = new ItemLogisticsFrame(SemiBlockActiveProvider.ID).func_77637_a(PneumaticCraft.tabPneumaticCraft);
        logisticsDrone = new ItemLogisticsDrone().func_77655_b("logisticDrone");
        gunAmmo = new ItemGunAmmo().func_77655_b("gunAmmo");
        amadronTablet = new ItemAmadronTablet("amadronTablet", PneumaticValues.AIR_CANISTER_MAX_AIR, PneumaticValues.AIR_CANISTER_VOLUME).func_77655_b("amadronTablet");
        minigun = new ItemMinigun(PneumaticValues.AIR_CANISTER_MAX_AIR, PneumaticValues.AIR_CANISTER_VOLUME);

        registerItems();
        registerUpgrades();

        OreDictionary.registerOre(Names.INGOT_IRON_COMPRESSED, ingotIronCompressed);
    }

    private static void registerUpgrades(){
        for(EnumUpgrade upgrade : EnumUpgrade.values()) {
            if(upgrade != EnumUpgrade.THAUMCRAFT || Loader.isModLoaded(ModIds.THAUMCRAFT)) {
                String unlocalizedName = upgrade.toString().toLowerCase() + "_upgrade";
                Item upgradeItem = new ItemMachineUpgrade().func_77655_b(unlocalizedName);
                registerItem(upgradeItem);
                upgrades.put(upgrade, upgradeItem);
            }
        }
    }

    private static void registerItems(){
        registerItem(GPSTool);
        registerItem(ingotIronCompressed);
        registerItem(pressureGauge);
        registerItem(stoneBase);
        registerItem(cannonBarrel);
        registerItem(turbineBlade);
        registerItem(plastic);
        registerItem(airCanister);
        registerItem(vortexCannon);
        registerItem(pneumaticCylinder);
        registerItem(pneumaticHelmet);
        registerItem(manometer);
        registerItem(turbineRotor);
        registerItem(assemblyProgram);
        registerItem(emptyPCB);
        registerItem(unassembledPCB);
        registerItem(PCBBlueprint);
        registerItem(transistor);
        registerItem(capacitor);
        registerItem(printedCircuitBoard);
        registerItem(failedPCB);
        registerItem(networkComponent);
        registerItem(stopWorm);
        registerItem(nukeVirus);
        registerItem(compressedIronGear);
        registerItem(pneumaticWrench);
        registerItem(drone);
        registerItem(programmingPuzzle);
        registerItem(advancedPCB);
        registerItem(remote);
        registerItem(seismicSensor);
        registerItem(logisticsConfigurator);
        registerItem(logisticsFrameRequester);
        registerItem(logisticsFrameDefaultStorage);
        registerItem(logisticsFrameStorage);
        registerItem(logisticsFramePassiveProvider);
        registerItem(logisticsFrameActiveProvider);
        registerItem(logisticsDrone);
        registerItem(gunAmmo);
        registerItem(amadronTablet);
        registerItem(minigun);
    }

    public static void registerItem(Item item){
        registerItem(item, item.func_77658_a().substring("item.".length()));
    }

    public static void registerItem(Item item, String registerName){
        GameRegistry.registerItem(item, registerName, Names.MOD_ID);
        ThirdPartyManager.instance().onItemRegistry(item);
        //GameData.newItemAdded(item);
        items.add(item);
    }
}
