package pneumaticCraft.common.itemBlock;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.BlockAir;
import net.minecraft.client.Minecraft;
import net.minecraft.client.resources.model.ModelBakery;
import net.minecraft.client.resources.model.ModelResourceLocation;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fluids.BlockFluidBase;
import pneumaticCraft.common.block.BlockPneumaticCraft;
import pneumaticCraft.lib.Log;
import pneumaticCraft.lib.Names;

public class ItemBlockPneumaticCraft extends ItemBlock{
    private BlockPneumaticCraft block;

    public ItemBlockPneumaticCraft(Block block){
        super(block);
        if(block instanceof BlockPneumaticCraft) {
            this.block = (BlockPneumaticCraft)block;
        } else {
            if(!(block instanceof BlockAir) && !(block instanceof BlockFluidBase)) {
                Log.warning("Block " + block.func_149739_a() + " does not extend BlockPneumaticCraft! No tooltip displayed");
            }
        }
    }

    @Override
    public void func_77624_a(ItemStack stack, EntityPlayer player, List info, boolean extraInfo){
        super.func_77624_a(stack, player, info, extraInfo);
        if(block != null) block.addInformation(stack, player, info, extraInfo);
    }

    public void registerItemVariants(){
        List<ItemStack> stacks = new ArrayList<ItemStack>();
        func_150895_a(this, null, stacks);
        for(ItemStack stack : stacks) {
            ResourceLocation resLoc = new ResourceLocation(Names.MOD_ID, getModelLocation(stack));
            ModelBakery.registerItemVariants(this, resLoc);
            Minecraft.func_71410_x().func_175599_af().func_175037_a().func_178086_a(this, stack.func_77952_i(), new ModelResourceLocation(resLoc, "inventory"));
        }
    }

    protected String getModelLocation(ItemStack stack){
        return stack.func_77977_a().substring(5);
    }

}
