package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

import java.util.EnumMap;
import java.util.LinkedList;
import java.util.Queue;

import net.minecraft.network.PacketBuffer;
import net.minecraftforge.fml.common.network.FMLEmbeddedChannel;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.internal.FMLProxyPacket;
import net.minecraftforge.fml.relauncher.Side;
import pneumaticCraft.PneumaticCraft;

@Sharable
public class DescPacketHandler extends SimpleChannelInboundHandler<FMLProxyPacket>{
    public final static String CHANNEL = "PneumaticCraftDesc";
    private final static EnumMap<Side, FMLEmbeddedChannel> channels = NetworkRegistry.INSTANCE.newChannel(DescPacketHandler.CHANNEL, new DescPacketHandler());
    private static final Queue<PacketDescription> pending = new LinkedList<PacketDescription>();
    private static int timeoutTimer;

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, FMLProxyPacket msg) throws Exception{
        PacketDescription packet = new PacketDescription();
        packet.fromBytes(msg.payload());
        //packet.handleClientSide(packet, PneumaticCraft.proxy.getPlayer());
        pending.add(packet);
    }

    public static FMLProxyPacket getPacket(PacketDescription packet){
        ByteBuf buf = Unpooled.buffer();
        packet.toBytes(buf);
        return new FMLProxyPacket(new PacketBuffer(buf), CHANNEL);
    }

    public static void processPackets(){
        synchronized(pending) {
            while(!pending.isEmpty()) {
                PacketDescription packet = pending.peek();
                if(packet.getTileEntity(PneumaticCraft.proxy.getClientWorld()) != null) {
                    timeoutTimer = 0;
                    packet.handleClientSide(packet, PneumaticCraft.proxy.getPlayer());
                    pending.remove();
                } else {
                    timeoutTimer++;
                    if(timeoutTimer > 40) {
                        pending.remove();
                    }
                }
            }
        }
    }

}
