package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.ChatComponentText;
import net.minecraftforge.fml.common.network.ByteBufUtils;

public class PacketCommandGetGlobalVariableOutput extends AbstractPacket<PacketCommandGetGlobalVariableOutput>{
    private String varName;
    private BlockPos pos;
    private ItemStack stack;

    public PacketCommandGetGlobalVariableOutput(){}

    public PacketCommandGetGlobalVariableOutput(String varName, BlockPos pos, ItemStack stack){
        this.varName = varName;
        this.pos = pos;
        this.stack = stack;
    }

    @Override
    public void fromBytes(ByteBuf buf){
        varName = ByteBufUtils.readUTF8String(buf);
        pos = new BlockPos(buf.readInt(), buf.readInt(), buf.readInt());
        stack = ByteBufUtils.readItemStack(buf);
    }

    @Override
    public void toBytes(ByteBuf buf){
        ByteBufUtils.writeUTF8String(buf, varName);
        buf.writeInt(pos.func_177958_n());
        buf.writeInt(pos.func_177956_o());
        buf.writeInt(pos.func_177952_p());
        ByteBufUtils.writeItemStack(buf, stack);
    }

    @Override
    public void handleClientSide(PacketCommandGetGlobalVariableOutput message, EntityPlayer player){
        player.func_145747_a(new ChatComponentText(I18n.func_135052_a("command.getGlobalVariable.output", message.varName, message.pos.func_177958_n(), message.pos.func_177956_o(), message.pos.func_177952_p(), message.stack != null ? message.stack.func_82833_r() : "-")));
    }

    @Override
    public void handleServerSide(PacketCommandGetGlobalVariableOutput message, EntityPlayer player){}

}
