package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;
import pneumaticCraft.common.NBTUtil;

public class PacketCoordTrackUpdate extends LocationIntPacket<PacketCoordTrackUpdate>{

    int dimensionID;

    public PacketCoordTrackUpdate(){}

    public PacketCoordTrackUpdate(World world, BlockPos pos){
        super(pos);
        dimensionID = world.field_73011_w.func_177502_q();
    }

    @Override
    public void toBytes(ByteBuf buffer){
        super.toBytes(buffer);
        buffer.writeInt(dimensionID);
    }

    @Override
    public void fromBytes(ByteBuf buffer){
        super.fromBytes(buffer);
        dimensionID = buffer.readInt();
    }

    @Override
    public void handleClientSide(PacketCoordTrackUpdate message, EntityPlayer player){}

    @Override
    public void handleServerSide(PacketCoordTrackUpdate message, EntityPlayer player){
        ItemStack stack = player.field_71071_by.func_70440_f(3);
        if(stack != null) {
            NBTTagCompound tag = NBTUtil.getCompoundTag(stack, "CoordTracker");
            tag.func_74768_a("dimID", message.dimensionID);
            NBTUtil.setPos(tag, message.pos);
        }
    }

}
