package pneumaticCraft.common.network;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.BlockPos;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.api.client.pneumaticHelmet.IHackableBlock;
import pneumaticCraft.client.render.pneumaticArmor.hacking.HackableHandler;
import pneumaticCraft.common.CommonHUDHandler;
import pneumaticCraft.common.util.WorldAndCoord;

public class PacketHackingBlockFinish extends LocationIntPacket<PacketHackingBlockFinish>{

    public PacketHackingBlockFinish(){}

    public PacketHackingBlockFinish(BlockPos pos){
        super(pos);
    }

    public PacketHackingBlockFinish(WorldAndCoord coord){
        super(coord.pos);
    }

    @Override
    public void handleClientSide(PacketHackingBlockFinish message, EntityPlayer player){
        IHackableBlock hackableBlock = HackableHandler.getHackableForCoord(player.field_70170_p, message.pos, player);
        if(hackableBlock != null) {
            hackableBlock.onHackFinished(player.field_70170_p, message.pos, player);
            PneumaticCraft.proxy.getHackTickHandler().trackBlock(new WorldAndCoord(player.field_70170_p, message.pos), hackableBlock);
            CommonHUDHandler.getHandlerForPlayer(player).setHackedBlock(null);
            player.field_70170_p.func_72980_b(message.pos.func_177958_n(), message.pos.func_177956_o(), message.pos.func_177952_p(), "PneumaticCraft:helmetHackFinish", 1.0F, 1.0F, false);
        }
    }

    @Override
    public void handleServerSide(PacketHackingBlockFinish message, EntityPlayer player){}

}
