package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.BlockPos;
import net.minecraftforge.fml.common.FMLCommonHandler;
import pneumaticCraft.PneumaticCraft;
import pneumaticCraft.common.block.BlockPressureTube;

public class PacketOpenTubeModuleGui extends LocationIntPacket<PacketOpenTubeModuleGui>{
    private int guiID;

    public PacketOpenTubeModuleGui(){}

    public PacketOpenTubeModuleGui(int guiID, BlockPos pos){
        super(pos);
        this.guiID = guiID;

    }

    @Override
    public void fromBytes(ByteBuf buf){
        super.fromBytes(buf);
        guiID = buf.readInt();
    }

    @Override
    public void toBytes(ByteBuf buf){
        super.toBytes(buf);
        buf.writeInt(guiID);
    }

    @Override
    public void handleClientSide(PacketOpenTubeModuleGui message, EntityPlayer player){
        if(BlockPressureTube.getLookedModule(player.field_70170_p, message.pos, player) != null) {
            Object o = PneumaticCraft.proxy.getClientGuiElement(message.guiID, player, player.field_70170_p, message.pos.func_177958_n(), message.pos.func_177956_o(), message.pos.func_177952_p());
            FMLCommonHandler.instance().showGuiScreen(o);
        }
    }

    @Override
    public void handleServerSide(PacketOpenTubeModuleGui message, EntityPlayer player){}

}
