package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;

import java.util.List;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.PacketBuffer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;

public class PacketProgrammerUpdate extends LocationIntPacket<PacketProgrammerUpdate>{
    private NBTTagCompound progWidgets;

    public PacketProgrammerUpdate(){}

    public PacketProgrammerUpdate(TileEntityProgrammer te){
        super(te.func_174877_v());
        progWidgets = new NBTTagCompound();
        te.writeProgWidgetsToNBT(progWidgets);
    }

    @Override
    public void toBytes(ByteBuf buffer){
        super.toBytes(buffer);
        try {
            new PacketBuffer(buffer).func_150786_a(progWidgets);
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void fromBytes(ByteBuf buffer){
        super.fromBytes(buffer);
        try {
            progWidgets = new PacketBuffer(buffer).func_150793_b();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void handleClientSide(PacketProgrammerUpdate message, EntityPlayer player){
        handleServerSide(null, player);
    }

    @Override
    public void handleServerSide(PacketProgrammerUpdate message, EntityPlayer player){
        TileEntity te = message.getTileEntity(player.func_130014_f_());
        if(te instanceof TileEntityProgrammer) {
            ((TileEntityProgrammer)te).readProgWidgetsFromNBT(message.progWidgets);
            ((TileEntityProgrammer)te).saveToHistory();
            if(!player.field_70170_p.field_72995_K) {
                message.updateOtherWatchingPlayers((TileEntityProgrammer)te, player);
            }
        }
    }

    private void updateOtherWatchingPlayers(TileEntityProgrammer te, EntityPlayer changingPlayer){
        List<EntityPlayerMP> players = changingPlayer.field_70170_p.func_72872_a(EntityPlayerMP.class, new AxisAlignedBB(pos.func_177982_a(-5, -5, -5), pos.func_177982_a(6, 6, 6)));
        for(EntityPlayerMP player : players) {
            if(player != changingPlayer) {
                NetworkHandler.sendTo(new PacketProgrammerUpdate(te), player);
            }
        }
    }

}
