package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;

public class PacketSetEntityMotion extends LocationDoublePacket<PacketSetEntityMotion>{

    private int entityId;

    public PacketSetEntityMotion(){}

    public PacketSetEntityMotion(Entity entity, double dx, double dy, double dz){
        super(dx, dy, dz);
        entityId = entity.func_145782_y();
    }

    @Override
    public void toBytes(ByteBuf buf){
        super.toBytes(buf);
        buf.writeInt(entityId);
    }

    @Override
    public void fromBytes(ByteBuf buf){
        super.fromBytes(buf);
        entityId = buf.readInt();
    }

    @Override
    public void handleClientSide(PacketSetEntityMotion message, EntityPlayer player){
        Entity entity = player.field_70170_p.func_73045_a(message.entityId);
        if(entity != null) {
            entity.field_70159_w = message.x;
            entity.field_70181_x = message.y;
            entity.field_70179_y = message.z;

            entity.field_70122_E = false;
            entity.field_70132_H = false;
            entity.field_70123_F = false;
            entity.field_70124_G = false;
            if(entity instanceof EntityLivingBase) ((EntityLivingBase)entity).func_70637_d(true);
        }
    }

    @Override
    public void handleServerSide(PacketSetEntityMotion message, EntityPlayer player){}

}
