package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;

public class PacketSetMobTarget extends AbstractPacket<PacketSetMobTarget>{
    private int mobId, targetId;

    public PacketSetMobTarget(){}

    public PacketSetMobTarget(EntityCreature mob, EntityLivingBase target){
        mobId = mob.func_145782_y();
        targetId = target != null ? target.func_145782_y() : -1;
    }

    @Override
    public void toBytes(ByteBuf buffer){
        buffer.writeInt(mobId);
        buffer.writeInt(targetId);
    }

    @Override
    public void fromBytes(ByteBuf buffer){
        mobId = buffer.readInt();
        targetId = buffer.readInt();
    }

    @Override
    public void handleClientSide(PacketSetMobTarget message, EntityPlayer player){
        Entity mob = player.field_70170_p.func_73045_a(message.mobId);
        Entity target = player.field_70170_p.func_73045_a(message.targetId);
        if(mob instanceof EntityCreature) {
            ((EntityCreature)mob).func_70624_b(target instanceof EntityLivingBase ? (EntityLivingBase)target : null);
        }
    }

    @Override
    public void handleServerSide(PacketSetMobTarget message, EntityPlayer player){

    }
}
