package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import pneumaticCraft.common.NBTUtil;

public class PacketUpdateEntityFilter extends AbstractPacket<PacketUpdateEntityFilter>{

    private String filter;

    public PacketUpdateEntityFilter(){}

    public PacketUpdateEntityFilter(String filter){
        this.filter = filter;
    }

    @Override
    public void toBytes(ByteBuf buffer){
        ByteBufUtils.writeUTF8String(buffer, filter);
    }

    @Override
    public void fromBytes(ByteBuf buffer){
        filter = ByteBufUtils.readUTF8String(buffer);
    }

    @Override
    public void handleClientSide(PacketUpdateEntityFilter message, EntityPlayer player){}

    @Override
    public void handleServerSide(PacketUpdateEntityFilter message, EntityPlayer player){
        ItemStack stack = player.field_71071_by.func_70440_f(3);
        if(stack != null) {
            NBTUtil.setString(stack, "entityFilter", message.filter);
        }
    }

}
