package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import pneumaticCraft.common.item.Itemss;

public class PacketUpdateRemoteLayout extends AbstractPacket<PacketUpdateRemoteLayout>{

    private NBTTagCompound layout;

    public PacketUpdateRemoteLayout(){}

    public PacketUpdateRemoteLayout(NBTTagCompound layout){
        this.layout = layout;
    }

    @Override
    public void fromBytes(ByteBuf buf){
        layout = ByteBufUtils.readTag(buf);
    }

    @Override
    public void toBytes(ByteBuf buf){
        ByteBufUtils.writeTag(buf, layout);
    }

    @Override
    public void handleClientSide(PacketUpdateRemoteLayout message, EntityPlayer player){

    }

    @Override
    public void handleServerSide(PacketUpdateRemoteLayout message, EntityPlayer player){
        ItemStack remote = player.func_71045_bC();
        if(remote != null && remote.func_77973_b() == Itemss.remote) {
            NBTTagCompound tag = remote.func_77978_p();
            if(tag == null) {
                tag = new NBTTagCompound();
                remote.func_77982_d(tag);
            }
            tag.func_74782_a("actionWidgets", message.layout.func_150295_c("actionWidgets", 10));
        }
    }

}
