package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import pneumaticCraft.common.NBTUtil;

public class PacketUpdateSearchStack extends AbstractPacket<PacketUpdateSearchStack>{

    private int itemId, itemDamage;

    public PacketUpdateSearchStack(){}

    public PacketUpdateSearchStack(ItemStack stack){
        if(stack != null) {
            itemId = Item.func_150891_b(stack.func_77973_b());
            itemDamage = stack.func_77952_i();
        } else {
            itemId = itemDamage = -1;
        }
    }

    @Override
    public void toBytes(ByteBuf buffer){
        buffer.writeInt(itemId);
        buffer.writeInt(itemDamage);
    }

    @Override
    public void fromBytes(ByteBuf buffer){
        itemId = buffer.readInt();
        itemDamage = buffer.readInt();
    }

    @Override
    public void handleClientSide(PacketUpdateSearchStack message, EntityPlayer player){}

    @Override
    public void handleServerSide(PacketUpdateSearchStack message, EntityPlayer player){
        ItemStack helmetStack = player.field_71071_by.func_70440_f(3);
        if(helmetStack != null) {
            NBTTagCompound tag = NBTUtil.getCompoundTag(helmetStack, "SearchStack");
            tag.func_74768_a("itemID", message.itemId);
            tag.func_74768_a("itemDamage", message.itemDamage);
        }
    }

}
