package pneumaticCraft.common.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumFacing;
import pneumaticCraft.common.block.tubes.TubeModule;
import pneumaticCraft.common.thirdparty.ModInteractionUtils;
import pneumaticCraft.common.tileentity.TileEntityPressureTube;

public abstract class PacketUpdateTubeModule<REQ extends PacketUpdateTubeModule> extends LocationIntPacket<REQ>{

    protected EnumFacing moduleSide;

    public PacketUpdateTubeModule(){}

    public PacketUpdateTubeModule(TubeModule module){
        super(module.getTube().pos());
        moduleSide = module.getDirection();
    }

    @Override
    public void toBytes(ByteBuf buffer){
        super.toBytes(buffer);
        buffer.writeByte((byte)moduleSide.ordinal());
    }

    @Override
    public void fromBytes(ByteBuf buffer){
        super.fromBytes(buffer);
        moduleSide = EnumFacing.func_82600_a(buffer.readByte());
    }

    @Override
    public void handleClientSide(REQ message, EntityPlayer player){
        handleServerSide(message, player);
    }

    @Override
    public void handleServerSide(REQ message, EntityPlayer player){
        TileEntityPressureTube te = ModInteractionUtils.getInstance().getTube(message.getTileEntity(player.func_130014_f_()));
        if(te != null) {
            TubeModule module = te.modules[message.moduleSide.ordinal()];
            if(module != null) {
                onModuleUpdate(module, message, player);
                if(!player.field_70170_p.field_72995_K) NetworkHandler.sendToAllAround(message, player.field_70170_p);
            }
        }
    }

    protected abstract void onModuleUpdate(TubeModule module, REQ message, EntityPlayer player);

}
