package pneumaticCraft.common.progwidgets;

import java.util.List;

import net.minecraft.client.gui.GuiScreen;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.client.gui.GuiProgrammer;
import pneumaticCraft.client.gui.programmer.GuiProgWidgetDigAndPlace;
import pneumaticCraft.common.ai.DroneAIBlockInteraction;

public abstract class ProgWidgetDigAndPlace extends ProgWidgetAreaItemBase implements IBlockOrdered, IMaxActions{
    private EnumOrder order;
    private int maxActions = 1;
    private boolean useMaxActions;

    @Override
    public EnumOrder getOrder(){
        return order;
    }

    @Override
    public void setOrder(EnumOrder order){
        this.order = order;
    }

    @Override
    public void getTooltip(List<String> curTooltip){
        super.getTooltip(curTooltip);
        curTooltip.add("Order: " + order.getLocalizedName());
    }

    public ProgWidgetDigAndPlace(EnumOrder order){
        this.order = order;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public GuiScreen getOptionWindow(GuiProgrammer guiProgrammer){
        return new GuiProgWidgetDigAndPlace(this, guiProgrammer);
    }

    @Override
    public void writeToNBT(NBTTagCompound tag){
        super.writeToNBT(tag);
        tag.func_74768_a("order", order.ordinal());
        tag.func_74757_a("useMaxActions", useMaxActions);
        tag.func_74768_a("maxActions", maxActions);
    }

    @Override
    public void readFromNBT(NBTTagCompound tag){
        super.readFromNBT(tag);
        order = EnumOrder.values()[tag.func_74762_e("order")];
        useMaxActions = tag.func_74767_n("useMaxActions");
        maxActions = tag.func_74762_e("maxActions");
    }

    @Override
    public String getExtraStringInfo(){
        return order.getLocalizedName();
    }

    @Override
    public void setMaxActions(int maxActions){
        this.maxActions = maxActions;
    }

    @Override
    public int getMaxActions(){
        return maxActions;
    }

    @Override
    public void setUseMaxActions(boolean useMaxActions){
        this.useMaxActions = useMaxActions;
    }

    @Override
    public boolean useMaxActions(){
        return useMaxActions;
    }

    protected DroneAIBlockInteraction setupMaxActions(DroneAIBlockInteraction ai, IMaxActions widget){
        if(widget.useMaxActions()) {
            ai.setMaxActions(widget.getMaxActions());
        }
        return ai;
    }
}
