package pneumaticCraft.common.progwidgets;

import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.client.gui.GuiProgrammer;
import pneumaticCraft.client.gui.programmer.GuiProgWidgetCondition;
import pneumaticCraft.common.ai.IDroneBase;

public abstract class ProgWidgetDroneEvaluation extends ProgWidgetConditionBase implements ICondition{

    private boolean isAndFunction;
    private ICondition.Operator operator = ICondition.Operator.HIGHER_THAN_EQUALS;
    private int requiredCount = 1;

    @Override
    public boolean isAndFunction(){
        return isAndFunction;
    }

    @Override
    public void setAndFunction(boolean isAndFunction){
        this.isAndFunction = isAndFunction;
    }

    @Override
    public boolean evaluate(IDroneBase drone, IProgWidget widget){
        int count = getCount(drone, widget);
        return getOperator() == Operator.EQUALS ? count == getRequiredCount() : count >= getRequiredCount();
    }

    protected abstract int getCount(IDroneBase drone, IProgWidget widget);

    @Override
    public EntityAIBase getWidgetAI(IDroneBase drone, IProgWidget widget){
        if(widget instanceof ProgWidgetDroneEvaluation) {
            return null;
        } else {
            return new EntityAIBase(){//Trick the CC program into thinking this is an executable piece.
                @Override
                public boolean func_75250_a(){
                    return false;
                }
            };
        }
    }

    @Override
    public int getRequiredCount(){
        return requiredCount;
    }

    @Override
    public void setRequiredCount(int count){
        requiredCount = count;
    }

    @Override
    public Operator getOperator(){
        return operator;
    }

    @Override
    public void setOperator(Operator operator){
        this.operator = operator;
    }

    @Override
    public void writeToNBT(NBTTagCompound tag){
        super.writeToNBT(tag);
        tag.func_74757_a("isAndFunction", isAndFunction);
        tag.func_74774_a("operator", (byte)operator.ordinal());
        tag.func_74768_a("requiredCount", requiredCount);
    }

    @Override
    public void readFromNBT(NBTTagCompound tag){
        super.readFromNBT(tag);
        isAndFunction = tag.func_74767_n("isAndFunction");
        operator = ICondition.Operator.values()[tag.func_74771_c("operator")];
        requiredCount = tag.func_74762_e("requiredCount");
    }

    @Override
    @SideOnly(Side.CLIENT)
    public GuiScreen getOptionWindow(GuiProgrammer guiProgrammer){
        return new GuiProgWidgetCondition(this, guiProgrammer){
            @Override
            protected boolean isUsingAndOr(){
                return false;
            }
        };
    }

    @Override
    public String getExtraStringInfo(){
        String anyAll = I18n.func_135052_a(isAndFunction() ? "gui.progWidget.condition.all" : "gui.progWidget.condition.any");
        return anyAll + " " + getOperator().toString() + " " + getRequiredCount();
    }

}
