package pneumaticCraft.common.recipes;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.item.crafting.ShapedRecipes;
import net.minecraft.village.MerchantRecipe;
import net.minecraft.village.MerchantRecipeList;
import net.minecraftforge.fluids.FluidContainerRegistry;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.oredict.OreDictionary;
import net.minecraftforge.oredict.RecipeSorter;
import net.minecraftforge.oredict.RecipeSorter.Category;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;

import org.apache.commons.lang3.tuple.ImmutablePair;

import pneumaticCraft.api.PneumaticRegistry;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.api.recipe.IPneumaticRecipeRegistry;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.block.tubes.ModuleRegistrator;
import pneumaticCraft.common.config.Config;
import pneumaticCraft.common.fluid.Fluids;
import pneumaticCraft.common.item.ItemNetworkComponents;
import pneumaticCraft.common.item.ItemPlastic;
import pneumaticCraft.common.item.ItemProgrammingPuzzle;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.semiblock.SemiBlockHeatFrame;
import pneumaticCraft.common.semiblock.SemiBlockManager;
import pneumaticCraft.lib.Names;

public class CraftingRegistrator{
    public static void init(){
        ItemStack lapis = new ItemStack(Items.field_151100_aR, 1, 4);
        ItemStack cobbleSlab = new ItemStack(Blocks.field_150333_U, 1, 3);
        // tubes
        addRecipe(new ItemStack(Blockss.pressureTube, 8, 0 /* normal */), "igi", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass");
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_FLOW_DETECTOR)), "bbb", "btb", "bbb", 'b', Itemss.turbineBlade, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_SAFETY_VALVE)), " g ", "ltl", 'g', Itemss.pressureGauge, 'l', Blocks.field_150442_at, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_REGULATOR)), "sts", 's', ModuleRegistrator.getModuleItem(Names.MODULE_SAFETY_VALVE), 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_AIR_GRATE)), " b ", "btb", " b ", 'b', Blocks.field_150411_aY, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_GAUGE)), " g ", "rtr", 'g', Itemss.pressureGauge, 'r', Items.field_151137_ax, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_CHARGING)), " r ", "rtr", " r ", 'r', Blockss.chargingStation, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_LOGISTICS), 4), "pip", "iri", "pip", 'i', Names.INGOT_IRON_COMPRESSED, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.SQUID_PLANT_DAMAGE), 'r', ModuleRegistrator.getModuleItem(Names.MODULE_REGULATOR));
        addRecipe(new ItemStack(ModuleRegistrator.getModuleItem(Names.MODULE_LOGISTICS), 4), "ipi", "prp", "ipi", 'i', Names.INGOT_IRON_COMPRESSED, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.SQUID_PLANT_DAMAGE), 'r', ModuleRegistrator.getModuleItem(Names.MODULE_REGULATOR));

        // tube addons
        addRecipe(new ItemStack(Itemss.pressureGauge), " g ", "gig", " g ", 'g', Items.field_151043_k, 'i', Names.INGOT_IRON_COMPRESSED);

        // pressure chamber
        addRecipe(new ItemStack(Blockss.pressureChamberWall, 16), "iii", "i i", "iii", 'i', Names.INGOT_IRON_COMPRESSED);
        addRecipe(new ItemStack(Blockss.pressureChamberGlass, 16), "iii", "igi", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass");
        addShapelessRecipe(new ItemStack(Blockss.pressureChamberGlass, 4), new ItemStack(Blockss.pressureChamberWall), new ItemStack(Blockss.pressureChamberWall), new ItemStack(Blockss.pressureChamberWall), new ItemStack(Blockss.pressureChamberWall), Blocks.field_150359_w);
        addRecipe(new ItemStack(Blockss.pressureChamberValve, 16, 0), "iii", "iti", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addShapelessRecipe(new ItemStack(Blockss.pressureChamberValve, 4, 0), new ItemStack(Blockss.pressureChamberWall, 1, 0), new ItemStack(Blockss.pressureChamberWall), new ItemStack(Blockss.pressureChamberWall), new ItemStack(Blockss.pressureChamberWall), new ItemStack(Blockss.pressureTube));
        addShapelessRecipe(new ItemStack(Blockss.pressureChamberInterface), Blockss.pressureChamberWall, Blocks.field_150438_bZ);
        addShapelessRecipe(new ItemStack(Blockss.pressureChamberValve, 1, 0), Blockss.pressureChamberWall, Blockss.pressureTube);
        addShapelessRecipe(new ItemStack(Blockss.pressureChamberGlass), new ItemStack(Blockss.pressureChamberWall), Blocks.field_150359_w);

        //Oil related
        addRecipe(new ItemStack(Itemss.seismicSensor), " t ", "grg", "gcg", 't', Blocks.field_150429_aA, 'g', "blockGlass", 'r', Items.field_151107_aW, 'c', Items.field_151044_h);
        addRecipe(new ItemStack(Blockss.refinery), "iii", "gdg", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass", 'd', "gemDiamond");
        addRecipe(new ItemStack(Blockss.thermopneumaticProcessingPlant), "igi", "tri", "igi", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass", 'r', "dustRedstone", 't', Blockss.pressureTube);
        addRecipe(new ItemStack(Blockss.gasLift), " t ", "tgt", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass", 't', Blockss.pressureTube);

        // cannon
        addRecipe(new ItemStack(Blockss.airCannon), " b ", " st", "hhh", 'b', Itemss.cannonBarrel, 's', Itemss.stoneBase, 't', new ItemStack(Blockss.pressureTube, 1, 0 /* normal */), 'h', cobbleSlab);
        addRecipe(new ItemStack(Itemss.stoneBase), "s s", "sts", 's', Blocks.field_150348_b, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addRecipe(new ItemStack(Itemss.cannonBarrel), true, "i i", "i i", "pii", 'i', Names.INGOT_IRON_COMPRESSED, 'p', ModuleRegistrator.getModuleItem(Names.MODULE_SAFETY_VALVE));

        addRecipe(new ItemStack(Itemss.GPSTool), " r ", "pgp", "pdp", 'r', Blocks.field_150429_aA, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.FIRE_FLOWER_DAMAGE), 'g', Blocks.field_150410_aZ, 'd', Items.field_151045_i);
        addRecipe(new ItemStack(Itemss.remote), " i ", "tgt", "tdt", 'i', new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_IO_PORT), 't', Itemss.transistor, 'g', Itemss.GPSTool, 'd', new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_DATA_STORAGE));

        // compressor
        addRecipe(new ItemStack(Blockss.airCompressor), true, "iii", "i t", "ifi", 'i', Names.INGOT_IRON_COMPRESSED, 't', new ItemStack(Blockss.pressureTube, 1, 0), 'f', Blocks.field_150460_al);
        addRecipe(new ItemStack(Blockss.advancedAirCompressor), true, "iii", "i t", "ifi", 'i', Names.INGOT_IRON_COMPRESSED, 't', new ItemStack(Blockss.advancedPressureTube, 1, 0), 'f', Blockss.airCompressor);
        addRecipe(new ItemStack(Blockss.liquidCompressor), true, "pbp", "lcl", 'p', Blockss.pressureTube, 'l', Items.field_151116_aA, 'b', Items.field_151133_ar, 'c', Blockss.airCompressor);
        addRecipe(new ItemStack(Blockss.advancedLiquidCompressor), true, "iii", "ibt", "ici", 'i', new ItemStack(Itemss.plastic, 1, ItemPlastic.RAIN_PLANT_DAMAGE), 'b', Items.field_151133_ar, 'c', Blockss.liquidCompressor, 't', Blockss.advancedPressureTube);
        addRecipe(new ItemStack(Blockss.electrostaticCompressor), "bpb", "prp", "bcb", 'b', Blocks.field_150411_aY, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.BURST_PLANT_DAMAGE), 'r', Itemss.turbineRotor, 'c', Blockss.airCompressor);

        // Charging Station
        addRecipe(new ItemStack(Blockss.chargingStation), "  t", "ppp", "sss", 's', cobbleSlab, 't', new ItemStack(Blockss.pressureTube, 1, 0), 'p', Items.field_151118_aC);

        addRecipe(new ItemStack(Blockss.elevatorFrame, 4, 0), "i i", "i i", "i i", 'i', Names.INGOT_IRON_COMPRESSED);
        addRecipe(new ItemStack(Itemss.pneumaticCylinder), "pip", "pip", "pbp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.RAIN_PLANT_DAMAGE), 'i', Names.INGOT_IRON_COMPRESSED, 'b', Itemss.cannonBarrel);
        addRecipe(new ItemStack(Blockss.elevatorBase, 4, 0), "cp", "pc", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.BURST_PLANT_DAMAGE), 'c', Itemss.pneumaticCylinder);
        addRecipe(new ItemStack(Blockss.elevatorBase, 4, 0), "pc", "cp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.BURST_PLANT_DAMAGE), 'c', Itemss.pneumaticCylinder);
        addRecipe(new ItemStack(Blockss.elevatorCaller, 1, 0), "cpc", "prp", "cpc", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.SLIME_PLANT_DAMAGE), 'c', new ItemStack(Itemss.plastic, 1, ItemPlastic.FLYING_FLOWER_DAMAGE), 'r', Items.field_151137_ax);
        addRecipe(new ItemStack(Blockss.elevatorCaller, 1, 0), "cpc", "prp", "cpc", 'c', new ItemStack(Itemss.plastic, 1, ItemPlastic.SLIME_PLANT_DAMAGE), 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.FLYING_FLOWER_DAMAGE), 'r', Items.field_151137_ax);

        //Security Station
        addRecipe(new ItemStack(Blockss.securityStation), "gbg", "tpt", "ggg", 'g', new ItemStack(Itemss.plastic, 1, ItemPlastic.BURST_PLANT_DAMAGE), 'b', new ItemStack(Itemss.plastic, 1, ItemPlastic.SQUID_PLANT_DAMAGE), 't', Itemss.turbineRotor, 'p', Itemss.printedCircuitBoard);
        addRecipe(new ItemStack(Itemss.networkComponent, 16, ItemNetworkComponents.NETWORK_NODE), "ttt", "tct", "ttt", 't', Itemss.transistor, 'c', Blocks.field_150486_ae);
        addRecipe(new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_IO_PORT), "ttt", "tct", "ttt", 't', Itemss.capacitor, 'c', Blocks.field_150486_ae);
        addRecipe(new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_REGISTRY), "ttt", "tct", "ttt", 't', new ItemStack(Itemss.plastic, 1, ItemPlastic.REPULSION_PLANT_DAMAGE), 'c', Blocks.field_150486_ae);
        addRecipe(new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.DIAGNOSTIC_SUBROUTINE), "ttt", "tct", "ttt", 't', new ItemStack(Itemss.plastic, 1, ItemPlastic.FIRE_FLOWER_DAMAGE), 'c', Blocks.field_150486_ae);
        addRecipe(new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_API), "ttt", "tct", "ttt", 't', new ItemStack(Itemss.plastic, 1, ItemPlastic.RAIN_PLANT_DAMAGE), 'c', Blocks.field_150486_ae);
        addRecipe(new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_DATA_STORAGE), "ttt", "tct", "ttt", 't', new ItemStack(Itemss.plastic, 1, ItemPlastic.BURST_PLANT_DAMAGE), 'c', Blocks.field_150486_ae);

        // Machine Upgrades
        addRecipe(getUpgrade(EnumUpgrade.VOLUME), "lil", "ici", "lil", 'l', lapis, 'i', Names.INGOT_IRON_COMPRESSED, 'c', new ItemStack(Itemss.airCanister, 1, OreDictionary.WILDCARD_VALUE));
        addRecipe(getUpgrade(EnumUpgrade.DISPENSER), "lil", "idi", "lil", 'l', lapis, 'i', Items.field_151128_bU, 'd', Blocks.field_150367_z);
        addRecipe(getUpgrade(EnumUpgrade.ITEM_LIFE), "lal", "aca", "lal", 'l', lapis, 'a', Items.field_151034_e, 'c', Items.field_151113_aN);
        addRecipe(getUpgrade(EnumUpgrade.ENTITY_TRACKER), "lbl", "bsb", "lbl", 'l', lapis, 'b', Items.field_151103_aS, 's', Items.field_151071_bq);
        addRecipe(getUpgrade(EnumUpgrade.BLOCK_TRACKER), "lwl", "wsw", "lwl", 'l', lapis, 'w', Blockss.pressureChamberWall, 's', Items.field_151071_bq);
        addRecipe(getUpgrade(EnumUpgrade.SPEED), "lsl", "scs", "lsl", 'l', lapis, 's', Items.field_151102_aT, 'c', Fluids.getBucket(Fluids.lubricant));
        addRecipe(getUpgrade(EnumUpgrade.SEARCH), "lel", "ege", "lel", 'l', lapis, 'e', Items.field_151061_bv, 'g', Items.field_151150_bK);
        addRecipe(getUpgrade(EnumUpgrade.COORDINATE_TRACKER), "lrl", "rgr", "lrl", 'l', lapis, 'r', Items.field_151137_ax, 'g', Itemss.GPSTool);
        addRecipe(getUpgrade(EnumUpgrade.RANGE), "lal", "aba", "lal", 'l', lapis, 'a', Items.field_151032_g, 'b', Items.field_151031_f);
        addRecipe(getUpgrade(EnumUpgrade.SECURITY), "lol", "obo", "lol", 'l', lapis, 'o', Blocks.field_150343_Z, 'b', ModuleRegistrator.getModuleItem("safetyTubeModule"));

        addRecipe(new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()), " t ", "iri", "iri", 'i', Names.INGOT_IRON_COMPRESSED, 'r', Items.field_151137_ax, 't', new ItemStack(Blockss.pressureTube, 1, 0));

        addRecipe(new ItemStack(Itemss.turbineRotor), " b ", " i ", "b b", 'i', Names.INGOT_IRON_COMPRESSED, 'b', Itemss.turbineBlade);
        addRecipe(new ItemStack(Blockss.vacuumPump), "grg", "trt", "sss", 'g', Itemss.pressureGauge, 'r', Itemss.turbineRotor, 's', cobbleSlab, 't', new ItemStack(Blockss.pressureTube, 1, 0));

        // NEI support recipes
        addRecipe(new ItemStack(Itemss.vortexCannon, 1, Itemss.vortexCannon.func_77612_l()), "idi", "c  ", "ili", 'd', "dyeYellow", 'i', Itemss.ingotIronCompressed, 'l', Blocks.field_150442_at, 'c', new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()));
        addRecipe(new ItemStack(Itemss.pneumaticWrench, 1, Itemss.pneumaticWrench.func_77612_l()), "idi", "c  ", "ili", 'd', "dyeOrange", 'i', Itemss.ingotIronCompressed, 'l', Blocks.field_150442_at, 'c', new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()));
        addRecipe(new ItemStack(Itemss.logisticsConfigurator, 1, Itemss.logisticsConfigurator.func_77612_l()), "idi", "c  ", "ili", 'd', "dyeRed", 'i', Itemss.ingotIronCompressed, 'l', Blocks.field_150442_at, 'c', new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()));
        addRecipe(new ItemStack(Itemss.amadronTablet, 1, Itemss.amadronTablet.func_77612_l()), "ppp", "pgp", "pcp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.BURST_PLANT_DAMAGE), 'g', Itemss.GPSTool, 'c', new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()));
        addRecipe(new ItemStack(Itemss.pneumaticHelmet, 1), "cec", "c c", 'e', Itemss.printedCircuitBoard, 'c', new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()));
        addShapelessRecipe(new ItemStack(Itemss.manometer, 1, Itemss.manometer.func_77612_l()), new ItemStack(Itemss.airCanister, 1, Itemss.airCanister.func_77612_l()), Itemss.pressureGauge);

        // Pneumatic Items
        GameRegistry.addRecipe(new RecipeGun("dyeYellow", Itemss.vortexCannon));
        GameRegistry.addRecipe(new RecipeGun("dyeOrange", Itemss.pneumaticWrench));
        GameRegistry.addRecipe(new RecipeGun("dyeRed", Itemss.logisticsConfigurator));
        GameRegistry.addRecipe(new RecipePneumaticHelmet());
        GameRegistry.addRecipe(new RecipeManometer());
        GameRegistry.addRecipe(new RecipeColorDrone());
        GameRegistry.addRecipe(new RecipeLogisticToDrone());
        GameRegistry.addRecipe(new RecipeGunAmmo());
        GameRegistry.addRecipe(new RecipeAmadronTablet());

        RecipeSorter.register("pneumaticcraft:gun", RecipeGun.class, Category.SHAPED, "after:minecraft:shaped");
        RecipeSorter.register("pneumaticcraft:amadronTablet", RecipeAmadronTablet.class, Category.SHAPED, "after:minecraft:shaped");
        RecipeSorter.register("pneumaticcraft:pneumaticHelmet", RecipePneumaticHelmet.class, Category.SHAPED, "after:minecraft:shaped");
        RecipeSorter.register("pneumaticcraft:manometer", RecipeManometer.class, Category.SHAPED, "after:minecraft:shaped");
        RecipeSorter.register("pneumaticcraft:colorDrone", RecipeColorDrone.class, Category.SHAPELESS, "after:minecraft:shapeless");
        RecipeSorter.register("pneumaticcraft:logisticToDrone", RecipeLogisticToDrone.class, Category.SHAPELESS, "after:minecraft:shapeless");
        RecipeSorter.register("pneumaticcraft:gunAmmo", RecipeGunAmmo.class, Category.SHAPELESS, "after:minecraft:shapeless");
        RecipeSorter.register("pneumaticcraft:fluid", RecipeFluid.class, Category.SHAPED, "after:minecraft:shaped");

        //Heat related
        addRecipe(new ItemStack(Blockss.heatSink), "bbb", "igi", 'i', Names.INGOT_IRON_COMPRESSED, 'b', Blocks.field_150411_aY, 'g', "ingotGold");
        addRecipe(new ItemStack(Blockss.vortexTube), "iti", "gtg", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "ingotGold", 't', Blockss.pressureTube);
        addRecipe(new ItemStack(SemiBlockManager.getItemForSemiBlock(SemiBlockHeatFrame.class)), "iii", "ifi", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'f', Blocks.field_150460_al);
        //misc
        addRecipe(new ItemStack(Blockss.compressedIron), "iii", "iii", "iii", 'i', Names.INGOT_IRON_COMPRESSED);
        addShapelessRecipe(new ItemStack(Itemss.ingotIronCompressed, 9, 0), Names.BLOCK_IRON_COMPRESSED);

        addShapelessRecipe(new ItemStack(Itemss.printedCircuitBoard), Itemss.unassembledPCB, Itemss.transistor, Itemss.transistor, Itemss.transistor, Itemss.capacitor, Itemss.capacitor, Itemss.capacitor);
        addRecipe(new ItemStack(Itemss.advancedPCB), "rpr", "pcp", "rpr", 'c', Itemss.printedCircuitBoard, 'r', Items.field_151137_ax, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.HELIUM_PLANT_DAMAGE));
        addRecipe(new ItemStack(Itemss.advancedPCB), "prp", "rcr", "prp", 'c', Itemss.printedCircuitBoard, 'r', Items.field_151137_ax, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.HELIUM_PLANT_DAMAGE));
        addRecipe(new ItemStack(Blockss.uvLightBox), "lll", "ibt", "iii", 'l', Blocks.field_150379_bu, 'b', Itemss.PCBBlueprint, 'i', Names.INGOT_IRON_COMPRESSED, 't', new ItemStack(Blockss.pressureTube, 1, 0));
        addShapelessRecipe(new ItemStack(Itemss.gunAmmo), new ItemStack(Items.field_151016_H), Names.INGOT_IRON_COMPRESSED, "ingotGold");
        addRecipe(new ItemStack(Blockss.sentryTurret), " m ", "pip", "i i", 'm', Itemss.minigun, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.SQUID_PLANT_DAMAGE), 'i', Names.INGOT_IRON_COMPRESSED);
        addRecipe(new ItemStack(Itemss.minigun), "cib", "g  ", 'c', Names.BLOCK_IRON_COMPRESSED, 'i', Names.INGOT_IRON_COMPRESSED, 'b', Itemss.cannonBarrel, 'g', "ingotGold");

        //Assembly Machines
        addRecipe(new ItemStack(Blockss.assemblyDrill), true, "dcc", "  c", "ipi", 'd', Items.field_151045_i, 'c', Itemss.pneumaticCylinder, 'i', Names.INGOT_IRON_COMPRESSED, 'p', Itemss.printedCircuitBoard);
        addRecipe(new ItemStack(Blockss.assemblyLaser), true, "dcc", "  c", "ipi", 'd', new ItemStack(Items.field_151100_aR, 1, 1), 'c', Itemss.pneumaticCylinder, 'i', Names.INGOT_IRON_COMPRESSED, 'p', Itemss.printedCircuitBoard);
        addRecipe(new ItemStack(Blockss.assemblyIOUnit), true, "hcc", "  c", "ipi", 'h', Blocks.field_150438_bZ, 'c', Itemss.pneumaticCylinder, 'i', Names.INGOT_IRON_COMPRESSED, 'p', Itemss.printedCircuitBoard);
        addRecipe(new ItemStack(Blockss.assemblyPlatform), true, "a a", "ppp", "ici", 'a', Itemss.pneumaticCylinder, 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.PROPULSION_PLANT_DAMAGE), 'i', Names.INGOT_IRON_COMPRESSED, 'c', Itemss.printedCircuitBoard);
        addRecipe(new ItemStack(Blockss.assemblyController), true, " c ", "tcc", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'c', Itemss.printedCircuitBoard, 't', new ItemStack(Blockss.pressureTube, 1, 0));

        GameRegistry.addSmelting(Itemss.failedPCB, new ItemStack(Itemss.emptyPCB, 1, Itemss.emptyPCB.func_77612_l()), 0);

        addRecipe(new ItemStack(Blockss.pneumaticDoor), "cc", "cc", "cc", 'c', Names.INGOT_IRON_COMPRESSED);
        addRecipe(new ItemStack(Blockss.pneumaticDoorBase), true, " #c", "cct", "ccc", '#', Itemss.pneumaticCylinder, 'c', Names.INGOT_IRON_COMPRESSED, 't', new ItemStack(Blockss.pressureTube, 1, 0));

        addRecipe(new ItemStack(Blockss.universalSensor), "plp", "lpl", "pcp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.ENDER_PLANT_DAMAGE), 'l', new ItemStack(Itemss.plastic, 1, ItemPlastic.CHOPPER_PLANT_DAMAGE), 'c', "dustRedstone");
        addRecipe(new ItemStack(Blockss.aerialInterface), "whw", "ese", "wtw", 'w', Blockss.pressureChamberWall, 'h', Blocks.field_150438_bZ, 'e', Items.field_151079_bi, 's', new ItemStack(Items.field_151144_bL, 1, 1), 't', new ItemStack(Blockss.advancedPressureTube, 1, 0));
        addRecipe(new ItemStack(Blockss.omnidirectionalHopper), "i i", "ici", " i ", 'i', Names.INGOT_IRON_COMPRESSED, 'c', Blocks.field_150486_ae);
        addRecipe(new ItemStack(Blockss.liquidHopper), "i i", "ici", " i ", 'i', "blockGlass", 'c', Blocks.field_150438_bZ);

        addRecipe(new ItemStack(Blockss.plasticMixer), "igi", "g g", "iii", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass");
        addRecipe(new ItemStack(Blockss.keroseneLamp), " i ", "g g", "ibi", 'i', Names.INGOT_IRON_COMPRESSED, 'g', "blockGlass", 'b', Items.field_151133_ar);

        addRecipe(new ItemStack(Itemss.drone), " b ", "bcb", " b ", 'b', Itemss.turbineRotor, 'c', Itemss.printedCircuitBoard);
        addRecipe(new ItemStack(Blockss.programmableController), "iri", "cdp", "ini", 'i', Names.INGOT_IRON_COMPRESSED, 'c', Itemss.printedCircuitBoard, 'r', Itemss.remote, 'd', Itemss.drone, 'p', Blockss.advancedPressureTube, 'n', new ItemStack(Itemss.networkComponent, 1, ItemNetworkComponents.NETWORK_REGISTRY));

        addRecipe(new ItemStack(Blockss.programmer), "gbg", "tpt", "ggg", 'g', new ItemStack(Itemss.plastic, 1, ItemPlastic.FIRE_FLOWER_DAMAGE), 'b', new ItemStack(Itemss.plastic, 1, ItemPlastic.SQUID_PLANT_DAMAGE), 't', Itemss.turbineRotor, 'p', Itemss.printedCircuitBoard);

        addRecipe(new ItemStack(Itemss.logisticsDrone), " b ", "bcb", " b ", 'b', Itemss.turbineRotor, 'c', "dustRedstone");
        addRecipe(new ItemStack(Itemss.logisticsFramePassiveProvider), "ppp", "p p", "ppp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.FIRE_FLOWER_DAMAGE));
        addRecipe(new ItemStack(Itemss.logisticsFrameActiveProvider), "ppp", "p p", "ppp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.ENDER_PLANT_DAMAGE));
        addRecipe(new ItemStack(Itemss.logisticsFrameRequester), "ppp", "p p", "ppp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.RAIN_PLANT_DAMAGE));
        addRecipe(new ItemStack(Itemss.logisticsFrameStorage), "ppp", "p p", "ppp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.HELIUM_PLANT_DAMAGE));
        addRecipe(new ItemStack(Itemss.logisticsFrameDefaultStorage), "ppp", "p p", "ppp", 'p', new ItemStack(Itemss.plastic, 1, ItemPlastic.REPULSION_PLANT_DAMAGE));

        addShapelessRecipe(new ItemStack(Itemss.assemblyProgram, 1, 2), new ItemStack(Itemss.assemblyProgram, 1, 0), new ItemStack(Itemss.assemblyProgram, 1, 1));

        addPressureChamberRecipes();
        addAssemblyRecipes();
        addThermopneumaticProcessingPlantRecipes();
        registerAmadronOffers();
        addCoolingRecipes();
    }

    public static ItemStack getUpgrade(EnumUpgrade upgrade){
        return new ItemStack(Itemss.upgrades.get(upgrade), 1);
    }

    public static void addProgrammingPuzzleRecipes(){
        List<ItemStack> widgets = new ArrayList<ItemStack>();
        ItemProgrammingPuzzle.addItems(widgets);
        for(ItemStack output : widgets) {
            output.field_77994_a = 4;
            addRecipe(output, "ppp", "pcp", "ppp", 'p', new ItemStack(Itemss.plastic, 1, output.func_77952_i()), 'c', Itemss.printedCircuitBoard);
        }
    }

    private static void addPressureChamberRecipes(){
        IPneumaticRecipeRegistry registry = PneumaticRegistry.getInstance().getRecipeRegistry();
        // diamond
        if(Config.enableCoalToDiamondsRecipe) registry.registerPressureChamberRecipe(new ItemStack[]{new ItemStack(Blocks.field_150402_ci, 8, 0)}, 4.0F, new ItemStack[]{new ItemStack(Items.field_151045_i, 1, 0)});
        // compressed iron
        registry.registerPressureChamberRecipe(new Object[]{new ImmutablePair("ingotIron", 1)}, 2F, new ItemStack[]{new ItemStack(Itemss.ingotIronCompressed, 1, 0)});
        registry.registerPressureChamberRecipe(new Object[]{new ImmutablePair("blockIron", 1)}, 2F, new ItemStack[]{new ItemStack(Blockss.compressedIron, 1, 0)});

        // turbine blade
        registry.registerPressureChamberRecipe(new Object[]{new ImmutablePair("dustRedstone", 2), new ImmutablePair("ingotGold", 1)}, 1F, new ItemStack[]{new ItemStack(Itemss.turbineBlade, 1, 0)});
        // Empty PCB
        registry.registerPressureChamberRecipe(new Object[]{new ItemStack(Itemss.plastic, 1, ItemPlastic.CREEPER_PLANT_DAMAGE), new ImmutablePair(Names.INGOT_IRON_COMPRESSED, 1)}, 1.5F, new ItemStack[]{new ItemStack(Itemss.emptyPCB, 1, Itemss.emptyPCB.func_77612_l())});
        // Etching Acid Bucket
        registry.registerPressureChamberRecipe(new ItemStack[]{new ItemStack(Itemss.plastic, 2, ItemPlastic.CREEPER_PLANT_DAMAGE), new ItemStack(Items.field_151078_bh, 2, 0), new ItemStack(Items.field_151016_H, 2, 0), new ItemStack(Items.field_151070_bp, 2, 0), new ItemStack(Items.field_151131_as)}, 1.0F, new ItemStack[]{new ItemStack(Fluids.getBucket(Fluids.etchingAcid))});
        // Transistor
        registry.registerPressureChamberRecipe(new Object[]{new ItemStack(Itemss.plastic, 1, ItemPlastic.SQUID_PLANT_DAMAGE), new ImmutablePair("ingotIronCompressed", 1), new ImmutablePair("dustRedstone", 1)}, 1.0F, new ItemStack[]{new ItemStack(Itemss.transistor)});
        // Capacitor
        registry.registerPressureChamberRecipe(new Object[]{new ItemStack(Itemss.plastic, 1, ItemPlastic.LIGHTNING_PLANT_DAMAGE), new ImmutablePair("ingotIronCompressed", 1), new ImmutablePair("dustRedstone", 1)}, 1.0F, new ItemStack[]{new ItemStack(Itemss.capacitor)});
        //Vacuum dis-enchanting
        registry.registerPressureChamberRecipe(new PressureChamberVacuumEnchantHandler());
    }

    private static void addAssemblyRecipes(){
        AssemblyRecipe.addLaserRecipe(new ItemStack(Itemss.emptyPCB, 1, Itemss.emptyPCB.func_77612_l()), Itemss.unassembledPCB);
        AssemblyRecipe.addLaserRecipe(new ItemStack(Blockss.pressureChamberValve, 20, 0), new ItemStack(Blockss.advancedPressureTube, 8, 0));
        AssemblyRecipe.addLaserRecipe(Blocks.field_150371_ca, new ItemStack(Blockss.aphorismTile, 4, 0));

        AssemblyRecipe.addDrillRecipe(new ItemStack(Blockss.compressedIron, 1, 0), new ItemStack(Blockss.pressureChamberValve, 20, 0));
        AssemblyRecipe.addDrillRecipe(new ItemStack(Items.field_151137_ax, 1, 0), new ItemStack(Items.field_151100_aR, 5, 1));
    }

    public static void addAssemblyCombinedRecipes(){
        calculateAssemblyChain(AssemblyRecipe.drillRecipes, AssemblyRecipe.laserRecipes, AssemblyRecipe.drillLaserRecipes);
    }

    private static void calculateAssemblyChain(List<AssemblyRecipe> firstRecipeList, List<AssemblyRecipe> secondRecipeList, List<AssemblyRecipe> totalRecipeList){
        for(AssemblyRecipe firstRecipe : firstRecipeList) {
            for(AssemblyRecipe secondRecipe : secondRecipeList) {
                if(firstRecipe.getOutput().func_77969_a(secondRecipe.getInput()) && firstRecipe.getOutput().field_77994_a % secondRecipe.getInput().field_77994_a == 0 && secondRecipe.getOutput().func_77976_d() >= secondRecipe.getOutput().field_77994_a * (firstRecipe.getOutput().field_77994_a / secondRecipe.getInput().field_77994_a)) {
                    ItemStack output = secondRecipe.getOutput().func_77946_l();
                    output.field_77994_a = output.field_77994_a * (firstRecipe.getOutput().field_77994_a / secondRecipe.getInput().field_77994_a);
                    totalRecipeList.add(new AssemblyRecipe(firstRecipe.getInput(), output));
                }
            }
        }
    }

    /**
     * Adds recipes like 9 gold ingot --> 1 gold block, and 1 gold block --> 9 gold ingots.
     */
    public static void addPressureChamberStorageBlockRecipes(){
        List<IRecipe> recipes = CraftingManager.func_77594_a().func_77592_b();
        for(IRecipe recipe : recipes) {
            if(recipe instanceof ShapedRecipes) {
                ShapedRecipes shaped = (ShapedRecipes)recipe;
                ItemStack[] input = shaped.field_77574_d;
                ItemStack ref = input[0];
                if(ref == null || input.length < 9) continue;
                boolean valid = true;
                for(int i = 0; i < 9; i++) {
                    if(input[i] == null || !input[i].func_77969_a(ref)) {
                        valid = false;
                        break;
                    }
                }
                if(valid) {
                    ItemStack inputStack = ref.func_77946_l();
                    inputStack.field_77994_a = 9;
                    PressureChamberRecipe.chamberRecipes.add(new PressureChamberRecipe(new ItemStack[]{inputStack}, 1.0F, new ItemStack[]{shaped.func_77571_b()}, false));

                    ItemStack inputStack2 = shaped.func_77571_b().func_77946_l();
                    inputStack2.field_77994_a = 1;
                    PressureChamberRecipe.chamberRecipes.add(new PressureChamberRecipe(new ItemStack[]{inputStack2}, -0.5F, new ItemStack[]{inputStack}, false));

                }
            }
        }
    }

    public static void addThermopneumaticProcessingPlantRecipes(){
        PneumaticRecipeRegistry registry = PneumaticRecipeRegistry.getInstance();
        registry.registerThermopneumaticProcessingPlantRecipe(new FluidStack(Fluids.lpg, 100), new ItemStack(Items.field_151044_h), new FluidStack(Fluids.plastic, 1000), 373, 0);
        registry.registerThermopneumaticProcessingPlantRecipe(new FluidStack(Fluids.diesel, 1000), new ItemStack(Items.field_151137_ax), new FluidStack(Fluids.lubricant, 1000), 373, 0);
        registry.registerThermopneumaticProcessingPlantRecipe(new FluidStack(Fluids.diesel, 100), null, new FluidStack(Fluids.kerosene, 80), 573, 2);
        registry.registerThermopneumaticProcessingPlantRecipe(new FluidStack(Fluids.kerosene, 100), null, new FluidStack(Fluids.gasoline, 80), 573, 2);
        registry.registerThermopneumaticProcessingPlantRecipe(new FluidStack(Fluids.gasoline, 100), null, new FluidStack(Fluids.lpg, 80), 573, 2);
    }

    private static void registerAmadronOffers(){
        PneumaticRecipeRegistry registry = PneumaticRecipeRegistry.getInstance();
        registry.registerDefaultStaticAmadronOffer(new ItemStack(Items.field_151166_bC, 8), new ItemStack(Itemss.PCBBlueprint));
        registry.registerDefaultStaticAmadronOffer(new ItemStack(Items.field_151166_bC, 8), new ItemStack(Itemss.assemblyProgram, 1, 0));
        registry.registerDefaultStaticAmadronOffer(new ItemStack(Items.field_151166_bC, 8), new ItemStack(Itemss.assemblyProgram, 1, 1));
        registry.registerDefaultStaticAmadronOffer(new ItemStack(Items.field_151166_bC, 14), new ItemStack(Itemss.assemblyProgram, 1, 2));
        registry.registerDefaultStaticAmadronOffer(new FluidStack(Fluids.oil, 5000), new ItemStack(Items.field_151166_bC, 1));
        registry.registerDefaultStaticAmadronOffer(new FluidStack(Fluids.diesel, 4000), new ItemStack(Items.field_151166_bC, 1));
        registry.registerDefaultStaticAmadronOffer(new FluidStack(Fluids.lubricant, 2500), new ItemStack(Items.field_151166_bC, 1));
        registry.registerDefaultStaticAmadronOffer(new FluidStack(Fluids.kerosene, 3000), new ItemStack(Items.field_151166_bC, 1));
        registry.registerDefaultStaticAmadronOffer(new FluidStack(Fluids.gasoline, 2000), new ItemStack(Items.field_151166_bC, 1));
        registry.registerDefaultStaticAmadronOffer(new FluidStack(Fluids.lpg, 1000), new ItemStack(Items.field_151166_bC, 1));
        registry.registerDefaultStaticAmadronOffer(new ItemStack(Items.field_151166_bC), new FluidStack(Fluids.oil, 1000));
        registry.registerDefaultStaticAmadronOffer(new ItemStack(Items.field_151166_bC, 5), new FluidStack(Fluids.lubricant, 1000));

        for(int i = 0; i < 256; i++) {
            try {
                for(int j = 0; j < 10; j++) {
                    EntityVillager villager = new EntityVillager(null, i);
                    MerchantRecipeList list = villager.func_70934_b(null);
                    for(MerchantRecipe recipe : list) {
                        if(recipe.func_77396_b() == null && recipe.func_77394_a() != null && recipe.func_77394_a().func_77973_b() != null && recipe.func_77397_d() != null && recipe.func_77397_d().func_77973_b() != null) {
                            registry.registerDefaultPeriodicAmadronOffer(recipe.func_77394_a(), recipe.func_77397_d());
                        }
                    }
                }
            } catch(Throwable e) {}
        }
    }

    private static void addCoolingRecipes(){
        PneumaticRecipeRegistry registry = PneumaticRecipeRegistry.getInstance();
        registry.registerHeatFrameCoolRecipe(new ItemStack(Items.field_151131_as), new ItemStack(Blocks.field_150432_aD));
        registry.registerHeatFrameCoolRecipe(new ItemStack(Items.field_151129_at), new ItemStack(Blocks.field_150343_Z));
    }

    private static void addRecipe(ItemStack result, Object... recipe){
        ShapedOreRecipe newRecipe = new ShapedOreRecipe(result, recipe);
        GameRegistry.addRecipe(newRecipe);
        scanForFluids(newRecipe);
    }

    public static void addShapelessRecipe(ItemStack result, Object... recipe){
        GameRegistry.addRecipe(new ShapelessOreRecipe(result, recipe));
    }

    private static void scanForFluids(ShapedOreRecipe recipe){
        for(int i = 0; i < recipe.func_77570_a(); i++) {
            Object o = recipe.getInput()[i];
            if(o instanceof ItemStack) {
                ItemStack stack = (ItemStack)o;
                FluidStack fluid = FluidContainerRegistry.getFluidForFilledItem(stack);
                if(fluid != null) {
                    GameRegistry.addRecipe(new RecipeFluid(recipe, i));
                }
            }
        }
    }
}
