package pneumaticCraft.common.recipes;

import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.fluids.FluidContainerRegistry;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.oredict.ShapedOreRecipe;

public class RecipeFluid extends AbstractRecipe{

    private final ShapedOreRecipe recipe;
    private final int fluidIndex;
    private final FluidStack fluidStack;
    private final ItemStack originalStack;

    public RecipeFluid(ShapedOreRecipe recipe, int fluidIndex){
        this.recipe = recipe;
        originalStack = (ItemStack)recipe.getInput()[fluidIndex];
        fluidStack = FluidContainerRegistry.getFluidForFilledItem(originalStack);
        if(fluidStack == null) throw new IllegalArgumentException("Recipe doesn't have fluid item at index " + fluidIndex + ". Item: " + originalStack);
        this.fluidIndex = fluidIndex;
    }

    @Override
    public boolean func_77569_a(InventoryCrafting inv, World world){
        if(fluidIndex >= inv.func_70302_i_()) return false;
        ItemStack stack = inv.func_70301_a(fluidIndex);
        FluidStack otherFluid = FluidContainerRegistry.getFluidForFilledItem(stack);
        if(otherFluid != null && otherFluid.isFluidEqual(fluidStack) && otherFluid.amount == fluidStack.amount) {
            recipe.getInput()[fluidIndex] = stack.func_77946_l();
            boolean matches = recipe.func_77569_a(inv, world);
            recipe.getInput()[fluidIndex] = originalStack;
            return matches;
        } else {
            return false;
        }
    }

    @Override
    public ItemStack func_77572_b(InventoryCrafting inv){
        return recipe.func_77572_b(inv);
    }

    @Override
    public int func_77570_a(){
        return recipe.func_77570_a();
    }

    @Override
    public ItemStack func_77571_b(){
        return recipe.func_77571_b();
    }

}
