package pneumaticCraft.common.remote;

import net.minecraft.client.gui.GuiScreen;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import pneumaticCraft.client.gui.GuiButtonSpecial;
import pneumaticCraft.client.gui.GuiRemoteEditor;
import pneumaticCraft.client.gui.remote.GuiRemoteButton;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketSetGlobalVariable;

public class ActionWidgetButton extends ActionWidgetVariable<GuiButtonSpecial> implements IActionWidgetLabeled{

    public BlockPos settingCoordinate = new BlockPos(0, 0, 0);//The coordinate the variable is set to when the button is pressed.

    public ActionWidgetButton(){
        super();
    }

    public ActionWidgetButton(GuiButtonSpecial widget){
        super(widget);
    }

    @Override
    public void readFromNBT(NBTTagCompound tag, int guiLeft, int guiTop){
        super.readFromNBT(tag, guiLeft, guiTop);
        widget = new GuiButtonSpecial(-1, tag.func_74762_e("x") + guiLeft, tag.func_74762_e("y") + guiTop, tag.func_74762_e("width"), tag.func_74762_e("height"), tag.func_74779_i("text"));
        settingCoordinate = new BlockPos(tag.func_74762_e("settingX"), tag.func_74762_e("settingY"), tag.func_74762_e("settingZ"));
        widget.setTooltipText(tag.func_74779_i("tooltip"));
    }

    @Override
    public NBTTagCompound toNBT(int guiLeft, int guiTop){
        NBTTagCompound tag = super.toNBT(guiLeft, guiTop);
        tag.func_74768_a("x", widget.field_146128_h - guiLeft);
        tag.func_74768_a("y", widget.field_146129_i - guiTop);
        tag.func_74768_a("width", widget.field_146120_f);
        tag.func_74768_a("height", widget.field_146121_g);
        tag.func_74778_a("text", widget.field_146126_j);
        tag.func_74768_a("settingX", settingCoordinate.func_177958_n());
        tag.func_74768_a("settingY", settingCoordinate.func_177956_o());
        tag.func_74768_a("settingZ", settingCoordinate.func_177952_p());
        tag.func_74778_a("tooltip", widget.getTooltip());
        return tag;
    }

    @Override
    public String getId(){
        return "button";
    }

    @Override
    public void setText(String text){
        widget.field_146126_j = text;
    }

    @Override
    public String getText(){
        return widget.field_146126_j;
    }

    @Override
    public void onActionPerformed(){
        NetworkHandler.sendToServer(new PacketSetGlobalVariable(getVariableName(), settingCoordinate));
    }

    @Override
    public void onVariableChange(){
        // widget.checked = GlobalVariableManager.getBoolean(getVariableName());
    }

    @Override
    public GuiScreen getGui(GuiRemoteEditor guiRemote){
        return new GuiRemoteButton(this, guiRemote);
    }

    @Override
    public void setWidgetPos(int x, int y){
        widget.field_146128_h = x;
        widget.field_146129_i = y;
    }

    public void setWidth(int width){
        widget.field_146120_f = width;
    }

    public int getWidth(){
        return widget.field_146120_f;
    }

    public void setHeight(int height){
        widget.field_146121_g = height;
    }

    public int getHeight(){
        return widget.field_146121_g;
    }

    @Override
    public void setTooltip(String text){
        widget.setTooltipText(text);
    }

    @Override
    public String getTooltip(){
        return widget.getTooltip();
    }
}
