package pneumaticCraft.common.remote;

import net.minecraft.nbt.NBTTagCompound;
import pneumaticCraft.client.gui.widget.GuiCheckBox;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketSetGlobalVariable;

public class ActionWidgetCheckBox extends ActionWidgetVariable<GuiCheckBox> implements IActionWidgetLabeled{

    public ActionWidgetCheckBox(){
        super();
    }

    public ActionWidgetCheckBox(GuiCheckBox widget){
        super(widget);
    }

    @Override
    public void readFromNBT(NBTTagCompound tag, int guiLeft, int guiTop){
        super.readFromNBT(tag, guiLeft, guiTop);
        widget = new GuiCheckBox(-1, tag.func_74762_e("x") + guiLeft, tag.func_74762_e("y") + guiTop, 0xFF000000, tag.func_74779_i("text"));
        setTooltip(tag.func_74779_i("tooltip"));
    }

    @Override
    public NBTTagCompound toNBT(int guiLeft, int guiTop){
        NBTTagCompound tag = super.toNBT(guiLeft, guiTop);
        tag.func_74768_a("x", widget.x - guiLeft);
        tag.func_74768_a("y", widget.y - guiTop);
        tag.func_74778_a("text", widget.text);
        tag.func_74778_a("tooltip", widget.getTooltip());
        return tag;
    }

    @Override
    public String getId(){
        return "checkbox";
    }

    @Override
    public void setText(String text){
        widget.text = text;
    }

    @Override
    public String getText(){
        return widget.text;
    }

    @Override
    public void onActionPerformed(){
        NetworkHandler.sendToServer(new PacketSetGlobalVariable(getVariableName(), widget.checked));
    }

    @Override
    public void onVariableChange(){
        widget.checked = GlobalVariableManager.getInstance().getBoolean(getVariableName());
    }

    @Override
    public void setWidgetPos(int x, int y){
        widget.x = x;
        widget.y = y;
    }

    @Override
    public void setTooltip(String text){
        widget.setTooltip(text);
    }

    @Override
    public String getTooltip(){
        return widget.getTooltip();
    }
}
