package pneumaticCraft.common.remote;

import net.minecraft.client.gui.GuiScreen;
import net.minecraft.nbt.NBTTagCompound;
import pneumaticCraft.client.gui.GuiRemoteEditor;
import pneumaticCraft.client.gui.remote.GuiRemoteOptionBase;

public class ActionWidgetLabel extends ActionWidget<WidgetLabelVariable> implements IActionWidgetLabeled{

    public ActionWidgetLabel(WidgetLabelVariable widget){
        super(widget);
    }

    public ActionWidgetLabel(){}

    @Override
    public NBTTagCompound toNBT(int guiLeft, int guiTop){
        NBTTagCompound tag = super.toNBT(guiLeft, guiTop);
        tag.func_74778_a("text", widget.text);
        tag.func_74768_a("x", widget.getBounds().x - guiLeft);
        tag.func_74768_a("y", widget.getBounds().y - guiTop);
        tag.func_74778_a("tooltip", widget.getTooltip());
        return tag;
    }

    @Override
    public void readFromNBT(NBTTagCompound tag, int guiLeft, int guiTop){
        super.readFromNBT(tag, guiLeft, guiTop);
        widget = new WidgetLabelVariable(tag.func_74762_e("x") + guiLeft, tag.func_74762_e("y") + guiTop, tag.func_74779_i("text"));
        widget.setTooltipText(tag.func_74779_i("tooltip"));
    }

    @Override
    public String getId(){
        return "label";
    }

    @Override
    public void setText(String text){
        widget.text = text;
    }

    @Override
    public String getText(){
        return widget.text;
    }

    @Override
    public GuiScreen getGui(GuiRemoteEditor guiRemote){
        return new GuiRemoteOptionBase(this, guiRemote);
    }

    @Override
    public void setWidgetPos(int x, int y){
        widget.x = x;
        widget.y = y;
    }

    @Override
    public void setTooltip(String text){
        widget.setTooltipText(text);
    }

    @Override
    public String getTooltip(){
        return widget.getTooltip();
    }
}
