package pneumaticCraft.common.sensor.pollSensors;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;
import pneumaticCraft.api.universalSensor.IPollSensorSetting;
import pneumaticCraft.common.item.Itemss;
import pneumaticCraft.common.tileentity.TileEntityUniversalSensor;

public abstract class BlockAndCoordinatePollSensor implements IPollSensorSetting{
    @Override
    public String getSensorPath(){
        return "blockTracker_gpsTool";
    }

    @Override
    public int getRedstoneValue(World world, BlockPos pos, int sensorRange, String textBoxText){
        TileEntity te = world.func_175625_s(pos);
        if(te instanceof TileEntityUniversalSensor) {
            TileEntityUniversalSensor teUs = (TileEntityUniversalSensor)te;

            for(int i = TileEntityUniversalSensor.UPGRADE_SLOT_1; i <= TileEntityUniversalSensor.UPGRADE_SLOT_4; i++) {
                if(teUs.func_70301_a(i) != null && teUs.func_70301_a(i).func_77973_b() == Itemss.GPSTool && teUs.func_70301_a(i).func_77942_o()) {
                    NBTTagCompound gpsTag = teUs.func_70301_a(i).func_77978_p();
                    int toolX = gpsTag.func_74762_e("x");
                    int toolY = gpsTag.func_74762_e("y");
                    int toolZ = gpsTag.func_74762_e("z");
                    if(Math.abs(toolX - pos.func_177958_n()) <= sensorRange && Math.abs(toolY - pos.func_177956_o()) <= sensorRange && Math.abs(toolZ - pos.func_177952_p()) <= sensorRange) {
                        return getRedstoneValue(world, pos, sensorRange, textBoxText, new BlockPos(toolX, toolY, toolZ));
                    }
                }
            }
        }
        return 0;
    }

    public abstract int getRedstoneValue(World world, BlockPos pos, int sensorRange, String textBoxText, BlockPos toolPos);

}
