package pneumaticCraft.common.tileentity;

import java.util.Arrays;
import java.util.Iterator;

import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemFood;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.event.ForgeEventFactory;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.FluidTankInfo;
import net.minecraftforge.fluids.IFluidHandler;
import net.minecraftforge.fml.common.Loader;
import pneumaticCraft.api.item.IItemRegistry.EnumUpgrade;
import pneumaticCraft.common.PneumaticCraftAPIHandler;
import pneumaticCraft.common.block.Blockss;
import pneumaticCraft.common.network.GuiSynced;
import pneumaticCraft.common.util.PneumaticCraftUtils;
import pneumaticCraft.lib.ModIds;
import pneumaticCraft.lib.PneumaticValues;

import com.mojang.authlib.GameProfile;

//TODO TE dep @Optional.InterfaceList({@Optional.Interface(iface = "cofh.api.energy.IEnergyReceiver", modid = ModIds.COFH_CORE), @Optional.Interface(iface = "cofh.api.tileentity.IEnergyInfo", modid = ModIds.COFH_CORE)})
public class TileEntityAerialInterface extends TileEntityPneumaticBase implements ISidedInventory, IFluidHandler,
        IMinWorkingPressure, IRedstoneControl, IComparatorSupport/*, IEnergyReceiver, IEnergyInfo*/{
    private ItemStack[] inventory;

    private final int INVENTORY_SIZE = 4;

    private static final int UPGRADE_SLOT_START = 0;
    private static final int UPGRADE_SLOT_END = 3;

    @GuiSynced
    public String playerName = "";
    public String playerUUID = "";

    private Fluid curXpFluid;

    @GuiSynced
    public int redstoneMode;
    @GuiSynced
    public int feedMode;
    private boolean oldRedstoneStatus;
    private boolean updateNeighbours;
    @GuiSynced
    public boolean isConnectedToPlayer;
    private boolean dispenserUpgradeInserted;

    public TileEntityAerialInterface(){
        super(PneumaticValues.DANGER_PRESSURE_AERIAL_INTERFACE, PneumaticValues.MAX_PRESSURE_AERIAL_INTERFACE, PneumaticValues.VOLUME_AERIAL_INTERFACE, UPGRADE_SLOT_START, 1, 2, UPGRADE_SLOT_END);
        inventory = new ItemStack[INVENTORY_SIZE];
        addApplicableUpgrade(EnumUpgrade.DISPENSER);

        if(isRFAvailable()) initRF();
    }

    public void setPlayer(GameProfile gameProfile){
        setPlayer(gameProfile.getName(), gameProfile.getId() != null ? gameProfile.getId().toString() : "");
    }

    public void setPlayer(String username, String uuid){
        playerName = username;
        playerUUID = uuid;
        updateNeighbours = true;
    }

    @Override
    public void func_73660_a(){
        if(!field_145850_b.field_72995_K && updateNeighbours) {
            updateNeighbours = false;
            updateNeighbours();
        }
        if(!field_145850_b.field_72995_K) {
            if(getPressure() > PneumaticValues.MIN_PRESSURE_AERIAL_INTERFACE && isConnectedToPlayer) {
                if(energyRF != null) tickRF();
                addAir(-PneumaticValues.USAGE_AERIAL_INTERFACE);
                if(field_145850_b.func_82737_E() % 40 == 0) dispenserUpgradeInserted = getUpgrades(EnumUpgrade.DISPENSER) > 0;
                if(field_145850_b.func_82737_E() % 20 == 0) {
                    EntityPlayer player = getPlayer();
                    if(player != null && player.func_70086_ai() <= 280) {
                        player.func_70050_g(player.func_70086_ai() + 20);
                        addAir(-4000);
                    }
                }
            }
            if(field_145850_b.func_82737_E() % 20 == 0) getPlayerInventory();
        }

        if(oldRedstoneStatus != shouldEmitRedstone()) {
            oldRedstoneStatus = shouldEmitRedstone();
            updateNeighbours = true;
        }

        super.func_73660_a();

    }

    @Override
    public void handleGUIButtonPress(int buttonID, EntityPlayer player){
        if(buttonID == 0) {
            redstoneMode++;
            if(redstoneMode > 1) redstoneMode = 0;
            // updateNeighbours();
        } else if(buttonID >= 1 && buttonID < 4) {
            feedMode = buttonID - 1;
        }
    }

    public boolean shouldEmitRedstone(){
        // if(!worldObj.isRemote) System.out.println("redstone mode: " +
        // redstoneMode + ", charging: " + charging + ",discharging: " +
        // disCharging);

        switch(redstoneMode){
            case 0:
                return false;
            case 1:
                return isConnectedToPlayer;

        }
        return false;
    }

    private InventoryPlayer getPlayerInventory(){
        EntityPlayer player = getPlayer();
        return player != null ? player.field_71071_by : null;
    }

    private EntityPlayer getPlayer(){
        if(field_145850_b != null && !field_145850_b.field_72995_K) {
            EntityPlayer player = PneumaticCraftUtils.getPlayerFromId(playerUUID);
            isConnectedToPlayer = player != null;
            return player;
        }
        return null;
    }

    @Override
    public boolean func_145818_k_(){
        return false;
    }

    /**
     * Returns the number of slots in the inventory.
     */
    @Override
    public int func_70302_i_(){
        InventoryPlayer inventoryPlayer = getPlayerInventory();
        return inventory.length + (inventoryPlayer != null ? inventoryPlayer.func_70302_i_() + (dispenserUpgradeInserted ? 1 : 0) : 0);
    }

    /**
     * Returns the stack in slot i
     */
    @Override
    public ItemStack func_70301_a(int slot){
        if(slot < 4) {
            return inventory[slot];
        } else {
            InventoryPlayer inventoryPlayer = getPlayerInventory();
            return inventoryPlayer != null ? slot == inventory.length + inventoryPlayer.func_70302_i_() ? null : inventoryPlayer.func_70301_a(slot - 4) : null;
        }
    }

    @Override
    public ItemStack func_70298_a(int slot, int amount){
        if(slot < 4) {
            ItemStack itemStack = func_70301_a(slot);
            if(itemStack != null) {
                if(itemStack.field_77994_a <= amount) {
                    func_70299_a(slot, null);
                } else {
                    itemStack = itemStack.func_77979_a(amount);
                    if(itemStack.field_77994_a == 0) {
                        func_70299_a(slot, null);
                    }
                }
            }

            return itemStack;
        } else {
            InventoryPlayer inventoryPlayer = getPlayerInventory();
            return inventoryPlayer != null ? inventoryPlayer.func_70298_a(slot - 4, amount) : null;
        }
    }

    @Override
    public ItemStack func_70304_b(int slot){
        if(slot < 4) {
            ItemStack itemStack = func_70301_a(slot);
            if(itemStack != null) {
                func_70299_a(slot, null);
            }
            return itemStack;
        } else {
            InventoryPlayer inventoryPlayer = getPlayerInventory();
            return inventoryPlayer != null ? inventoryPlayer.func_70304_b(slot - 4) : null;
        }
    }

    @Override
    public void func_70299_a(int slot, ItemStack itemStack){
        if(slot < 4) {
            inventory[slot] = itemStack;
            if(itemStack != null && itemStack.field_77994_a > func_70297_j_()) {
                itemStack.field_77994_a = func_70297_j_();
            }
        } else {
            EntityPlayer player = getPlayer();
            if(dispenserUpgradeInserted) {
                if(itemStack != null && itemStack.func_77973_b() instanceof ItemFood) {
                    int startValue = itemStack.field_77994_a;
                    while(itemStack.field_77994_a > 0) {
                        ItemStack remainingItem = itemStack.func_77950_b(player.field_70170_p, player);
                        remainingItem = ForgeEventFactory.onItemUseFinish(player, itemStack, 0, remainingItem);
                        if(remainingItem != null && remainingItem.field_77994_a > 0 && (remainingItem != itemStack || remainingItem.field_77994_a != startValue)) {
                            if(!player.field_71071_by.func_70441_a(remainingItem) && remainingItem.field_77994_a > 0) {
                                player.func_71019_a(remainingItem, false);
                            }
                        }
                        if(itemStack.field_77994_a == startValue) break;
                    }
                }
            } else {
                InventoryPlayer inventoryPlayer = player != null ? player.field_71071_by : null;
                if(inventoryPlayer != null) {
                    inventoryPlayer.func_70299_a(slot - 4, itemStack);
                } else if(field_145850_b != null && !field_145850_b.field_72995_K) {
                    EntityItem item = new EntityItem(field_145850_b, func_174877_v().func_177958_n(), func_174877_v().func_177956_o(), func_174877_v().func_177952_p(), itemStack);
                    field_145850_b.func_72838_d(item);
                }
            }
        }

    }

    @Override
    public String getName(){

        return Blockss.aerialInterface.func_149739_a();
    }

    @Override
    public int func_70297_j_(){

        return 64;
    }

    @Override
    public void func_145839_a(NBTTagCompound tag){

        super.func_145839_a(tag);
        // Read in the ItemStacks in the inventory from NBT

        redstoneMode = tag.func_74762_e("redstoneMode");
        feedMode = tag.func_74762_e("feedMode");
        setPlayer(tag.func_74779_i("playerName"), tag.func_74779_i("playerUUID"));
        isConnectedToPlayer = tag.func_74767_n("connected");
        if(tag.func_74764_b("curXpFluid")) curXpFluid = FluidRegistry.getFluid(tag.func_74779_i("curXpFluid"));
        if(energyRF != null) readRF(tag);

        NBTTagList tagList = tag.func_150295_c("Items", 10);
        inventory = new ItemStack[4];
        for(int i = 0; i < tagList.func_74745_c(); ++i) {
            NBTTagCompound tagCompound = tagList.func_150305_b(i);
            byte slot = tagCompound.func_74771_c("Slot");
            if(slot >= 0 && slot < inventory.length) {
                inventory[slot] = ItemStack.func_77949_a(tagCompound);
            }
        }
        dispenserUpgradeInserted = getUpgrades(EnumUpgrade.DISPENSER) > 0;
    }

    @Override
    public void func_145841_b(NBTTagCompound tag){

        super.func_145841_b(tag);
        // Write the ItemStacks in the inventory to NBT
        tag.func_74768_a("redstoneMode", redstoneMode);
        tag.func_74768_a("feedMode", feedMode);
        tag.func_74778_a("playerName", playerName);
        tag.func_74778_a("playerUUID", playerUUID);
        if(curXpFluid != null) tag.func_74778_a("curXpFluid", curXpFluid.getName());
        if(energyRF != null) saveRF(tag);

        tag.func_74757_a("connected", isConnectedToPlayer);
        NBTTagList tagList = new NBTTagList();
        for(int currentIndex = 0; currentIndex < inventory.length; ++currentIndex) {
            if(inventory[currentIndex] != null) {
                NBTTagCompound tagCompound = new NBTTagCompound();
                tagCompound.func_74774_a("Slot", (byte)currentIndex);
                inventory[currentIndex].func_77955_b(tagCompound);
                tagList.func_74742_a(tagCompound);
            }
        }
        tag.func_74782_a("Items", tagList);
    }

    @Override
    public boolean func_94041_b(int i, ItemStack itemstack){
        return i >= 4 || canInsertUpgrade(i, itemstack);
    }

    @Override
    // upgrades in bottom, fuel in the rest.
    public int[] func_180463_a(EnumFacing var1){
        if(var1 == EnumFacing.UP) {
            return new int[]{0, 1, 2, 3};
        } else if(getPlayerInventory() == null) {
            return new int[0];
        } else if(var1 == EnumFacing.DOWN) {
            return new int[]{40, 41, 42, 43};
        } else if(dispenserUpgradeInserted) {
            return new int[]{44};
        } else {
            int[] mainInv = new int[36];
            for(int i = 0; i < 36; i++) {
                mainInv[i] = i + 4;
            }
            return mainInv;
        }

    }

    @Override
    public boolean func_180462_a(int i, ItemStack itemstack, EnumFacing j){
        if(i < 4) return true;
        EntityPlayer player = getPlayer();
        if(player == null) return false;
        if(getPressure() > PneumaticValues.MIN_PRESSURE_AERIAL_INTERFACE) {
            if(!dispenserUpgradeInserted || i >= 40 && i <= 43) {
                return i < 40 || itemstack != null && itemstack.func_77973_b() instanceof ItemArmor && ((ItemArmor)itemstack.func_77973_b()).field_77881_a == 43 - i;
            } else {
                if(i == 4 + player.field_71071_by.func_70302_i_() && getFoodValue(itemstack) > 0) {
                    int foodValue = getFoodValue(itemstack);
                    int curFoodLevel = player.func_71024_bL().func_75116_a();
                    int feedMode = this.feedMode;
                    if(feedMode == 2) {
                        feedMode = player.func_110138_aP() - player.func_110143_aJ() > 0 ? 1 : 0;
                    }
                    switch(feedMode){
                        case 0:
                            return 20 - curFoodLevel >= foodValue * itemstack.field_77994_a;
                        case 1:
                            return 20 - curFoodLevel >= foodValue * (itemstack.field_77994_a - 1) + 1;
                    }
                }
                return false;
            }
        } else {
            return false;
        }
    }

    @Override
    public boolean func_180461_b(int i, ItemStack itemstack, EnumFacing j){
        return i < 4 || getPressure() > PneumaticValues.MIN_PRESSURE_AERIAL_INTERFACE;
    }

    @Override
    public boolean func_70300_a(EntityPlayer var1){
        return isGuiUseableByPlayer(var1);
    }

    @Override
    public void func_174889_b(EntityPlayer player){}

    @Override
    public void func_174886_c(EntityPlayer player){}

    @Override
    public void func_174888_l(){
        Arrays.fill(inventory, null);
    }

    private int getFoodValue(ItemStack item){
        return item != null && item.func_77973_b() instanceof ItemFood ? ((ItemFood)item.func_77973_b()).func_150905_g(item) : 0;
    }

    /*
     * 
     * ------------------------ Liquid XP handling
     * 
     */

    @Override
    public int fill(EnumFacing from, FluidStack resource, boolean doFill){
        if(resource != null && canFill(from, resource.getFluid())) {
            EntityPlayer player = getPlayer();
            if(player != null) {
                int liquidToXP = PneumaticCraftAPIHandler.getInstance().liquidXPs.get(resource.getFluid());
                int xpPoints = resource.amount / liquidToXP;
                if(doFill) {
                    player.func_71023_q(xpPoints);
                    curXpFluid = resource.getFluid();
                }
                return xpPoints * liquidToXP;
            }
        }
        return 0;
    }

    @Override
    public FluidStack drain(EnumFacing from, FluidStack resource, boolean doDrain){
        if(resource != null && canDrain(from, resource.getFluid())) {
            EntityPlayer player = getPlayer();
            if(player != null) {
                int liquidToXP = PneumaticCraftAPIHandler.getInstance().liquidXPs.get(resource.getFluid());
                int pointsDrained = Math.min(getPlayerXP(player), resource.amount / liquidToXP);
                if(doDrain) addPlayerXP(player, -pointsDrained);
                return new FluidStack(resource.getFluid(), pointsDrained * liquidToXP);
            }
        }
        return null;
    }

    @Override
    public FluidStack drain(EnumFacing from, int maxDrain, boolean doDrain){
        updateXpFluid();
        if(curXpFluid == null) return null;
        return drain(from, new FluidStack(curXpFluid, maxDrain), doDrain);
    }

    private void updateXpFluid(){
        if(curXpFluid == null) {
            Iterator<Fluid> fluids = PneumaticCraftAPIHandler.getInstance().liquidXPs.keySet().iterator();
            if(fluids.hasNext()) curXpFluid = fluids.next();
        }
    }

    @Override
    public boolean canFill(EnumFacing from, Fluid fluid){
        return fluid != null && PneumaticCraftAPIHandler.getInstance().liquidXPs.containsKey(fluid) && getPlayer() != null && getPressure() > PneumaticValues.MIN_PRESSURE_AERIAL_INTERFACE && dispenserUpgradeInserted;
    }

    @Override
    public boolean canDrain(EnumFacing from, Fluid fluid){
        return (fluid == null || PneumaticCraftAPIHandler.getInstance().liquidXPs.containsKey(fluid)) && getPlayer() != null && getPressure() > PneumaticValues.MIN_PRESSURE_AERIAL_INTERFACE && dispenserUpgradeInserted;
    }

    @Override
    public FluidTankInfo[] getTankInfo(EnumFacing from){
        updateXpFluid();
        if(curXpFluid != null) {
            EntityPlayer player = getPlayer();
            if(player != null) {
                return new FluidTankInfo[]{new FluidTankInfo(new FluidStack(curXpFluid, getPlayerXP(player) * PneumaticCraftAPIHandler.getInstance().liquidXPs.get(curXpFluid)), Integer.MAX_VALUE)};
            }
        }
        return null;
    }

    /**
     * This method is copied from OpenMods' OpenModsLib
     * https://github.com/OpenMods/OpenModsLib/blob/master/src/main/java/openmods/utils/EnchantmentUtils.java
     * @param player
     * @return
     */

    private static int getPlayerXP(EntityPlayer player){
        return (int)(getExperienceForLevel(player.field_71068_ca) + player.field_71106_cc * player.func_71050_bK());
    }

    /**
     * This method is copied from OpenMods' OpenModsLib
     * https://github.com/OpenMods/OpenModsLib/blob/master/src/main/java/openmods/utils/EnchantmentUtils.java
     * @param player
     * @return
     */

    private static int getExperienceForLevel(int level){
        if(level == 0) {
            return 0;
        }
        if(level > 0 && level < 16) {
            return level * 17;
        } else if(level > 15 && level < 31) {
            return (int)(1.5 * Math.pow(level, 2) - 29.5 * level + 360);
        } else {
            return (int)(3.5 * Math.pow(level, 2) - 151.5 * level + 2220);
        }
    }

    /**
     * This method is copied from OpenMods' OpenModsLib
     * https://github.com/OpenMods/OpenModsLib/blob/master/src/main/java/openmods/utils/EnchantmentUtils.java
     * @param player
     * @return
     */

    private static void addPlayerXP(EntityPlayer player, int amount){
        int experience = getPlayerXP(player) + amount;
        player.field_71067_cb = experience;
        player.field_71068_ca = getLevelForExperience(experience);
        int expForLevel = getExperienceForLevel(player.field_71068_ca);
        player.field_71106_cc = (float)(experience - expForLevel) / (float)player.func_71050_bK();
    }

    /**
     * This method is copied from OpenMods' OpenModsLib
     * https://github.com/OpenMods/OpenModsLib/blob/master/src/main/java/openmods/utils/EnchantmentUtils.java
     * @param player
     * @return
     */

    private static int getLevelForExperience(int experience){
        int i = 0;
        while(getExperienceForLevel(i) <= experience) {
            i++;
        }
        return i - 1;
    }

    @Override
    public float getMinWorkingPressure(){
        return PneumaticValues.MIN_PRESSURE_AERIAL_INTERFACE;
    }

    @Override
    public int getRedstoneMode(){
        return redstoneMode;
    }

    @Override
    public int getComparatorValue(){
        return shouldEmitRedstone() ? 15 : 0;
    }

    /**
     * RF integration
     */

    private Object energyRF;
    private static final int RF_PER_TICK = 1000;

    private boolean isRFAvailable(){
        return Loader.isModLoaded(ModIds.COFH_CORE);
    }

    private void initRF(){
        // TODO TE dep   energyRF = new EnergyStorage(100000);
    }

    private void saveRF(NBTTagCompound tag){
        //TODO TE dep     getEnergy().writeToNBT(tag);
    }

    private void readRF(NBTTagCompound tag){
        //TODO TE dep    getEnergy().readFromNBT(tag);
    }

    private void tickRF(){
        /*TODO TE dep
          if(getEnergyStored(null) > 0) {
              InventoryPlayer inv = getPlayerInventory();
              if(inv != null) {
                  for(int i = 0; i < inv.getSizeInventory(); i++) {
                      ItemStack stack = inv.getStackInSlot(i);
                      if(stack != null && stack.getItem() instanceof IEnergyContainerItem) {
                          IEnergyContainerItem chargingItem = (IEnergyContainerItem)stack.getItem();
                          int energyLeft = getEnergyStored(null);
                          if(energyLeft > 0) {
                              getEnergy().extractEnergy(chargingItem.receiveEnergy(stack, energyLeft, false), false);
                          } else {
                              break;
                          }
                      }
                  }
              }
          }*/
    }

    /* @Optional.Method(modid = ModIds.COFH_CORE)
     private EnergyStorage getEnergy(){
         return (EnergyStorage)energyRF;
     }

     @Override
     public boolean canConnectEnergy(EnumFacing from){
         return true;
     }

     @Override
     public int getInfoEnergyPerTick(){
         return RF_PER_TICK;
     }

     @Override
     public int getInfoMaxEnergyPerTick(){
         return RF_PER_TICK;
     }

     @Override
     public int getInfoEnergyStored(){
         return getEnergy().getEnergyStored();
     }

     @Override
     public int getInfoMaxEnergyStored(){
         return getEnergy().getMaxEnergyStored();
     }

     @Override
     public int receiveEnergy(EnumFacing from, int maxReceive, boolean simulate){
         return getEnergy().receiveEnergy(maxReceive, simulate);
     }

     @Override
     public int getEnergyStored(EnumFacing from){
         return getEnergy().getEnergyStored();
     }

     @Override
     public int getMaxEnergyStored(EnumFacing from){
         return getEnergy().getMaxEnergyStored();
     }*/
}
