package pneumaticCraft.common.tileentity;

import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import pneumaticCraft.api.PneumaticRegistry;
import pneumaticCraft.api.heat.IHeatExchangerLogic;
import pneumaticCraft.api.tileentity.IHeatExchanger;

public class TileEntityHeatSink extends TileEntityCompressedIronBlock implements IHeatExchanger{

    private final IHeatExchangerLogic airExchanger = PneumaticRegistry.getInstance().getHeatRegistry().getHeatExchangerLogic();

    public TileEntityHeatSink(){
        airExchanger.addConnectedExchanger(heatExchanger);
        airExchanger.setThermalResistance(14);
    }

    @Override
    public IHeatExchangerLogic getHeatExchangerLogic(EnumFacing side){
        return side == null || side == getRotation() ? super.getHeatExchangerLogic(side) : null;
    }

    /**
     * Gets the valid sides for heat exchanging to be allowed. returning an empty array will allow any side.
     * @return
     */
    @Override
    protected EnumFacing[] getConnectedHeatExchangerSides(){
        return new EnumFacing[]{getRotation()};
    }

    @Override
    protected boolean shouldRerenderChunkOnDescUpdate(){
        return false;
    }

    @Override
    public void func_73660_a(){
        super.func_73660_a();
        airExchanger.update();
        airExchanger.setTemperature(295);
    }

    public void onFannedByAirGrate(){
        heatExchanger.update();
        airExchanger.setTemperature(295);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public AxisAlignedBB getRenderBoundingBox(){
        return new AxisAlignedBB(func_174877_v().func_177958_n(), func_174877_v().func_177956_o(), func_174877_v().func_177952_p(), func_174877_v().func_177958_n() + 1, func_174877_v().func_177956_o() + 1, func_174877_v().func_177952_p() + 1);
    }

}
