package pneumaticCraft.common.tileentity;

import java.util.List;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import pneumaticCraft.api.tileentity.IManoMeasurable;
import pneumaticCraft.common.block.BlockPressureChamberWall;
import pneumaticCraft.common.block.Blockss;

public class TileEntityPressureChamberWall extends TileEntityBase implements IManoMeasurable{

    protected TileEntityPressureChamberValve teValve;
    private int valveX;
    private int valveY;
    private int valveZ;

    public TileEntityPressureChamberWall(){
        super();
    }

    public TileEntityPressureChamberWall(int... upgradeSlots){
        super(upgradeSlots);
    }

    public TileEntityPressureChamberValve getCore(){
        if(teValve == null && (valveX != 0 || valveY != 0 || valveZ != 0)) {// when the saved TE equals null, check if we can
            // retrieve the TE from the NBT saved coords.

            TileEntity te = field_145850_b.func_175625_s(new BlockPos(valveX, valveY, valveZ));
            setCore(te instanceof TileEntityPressureChamberValve ? (TileEntityPressureChamberValve)te : null);
        }
        return teValve;
    }

    public void onBlockBreak(){
        teValve = getCore();
        if(teValve != null) {
            teValve.onMultiBlockBreak();
        }
    }

    public void setCore(TileEntityPressureChamberValve te){

        if(!field_145850_b.field_72995_K) {
            if(te != null) {
                valveX = te.func_174877_v().func_177958_n();
                valveY = te.func_174877_v().func_177956_o();
                valveZ = te.func_174877_v().func_177952_p();
            } else {
                valveX = 0;
                valveY = 0;
                valveZ = 0;
            }
        }
        boolean hasChanged = teValve != te;
        teValve = te;
        if(hasChanged && !field_145850_b.field_72995_K) {
            IBlockState curState = field_145850_b.func_180495_p(func_174877_v());
            if(curState.func_177230_c() == Blockss.pressureChamberWall) {
                IBlockState newState = ((BlockPressureChamberWall)Blockss.pressureChamberWall).updateState(curState, field_145850_b, func_174877_v());
                field_145850_b.func_180501_a(func_174877_v(), newState, 2);
            }
        }
    }

    @Override
    public void onDescUpdate(){
        super.onDescUpdate();
        teValve = null;
    }

    /**
     * Reads a tile entity from NBT.
     */
    @Override
    public void func_145839_a(NBTTagCompound tag){
        super.func_145839_a(tag);
        valveX = tag.func_74762_e("valveX");
        valveY = tag.func_74762_e("valveY");
        valveZ = tag.func_74762_e("valveZ");
        teValve = null;
    }

    @Override
    public void func_145841_b(NBTTagCompound tag){
        super.func_145841_b(tag);
        tag.func_74768_a("valveX", valveX);
        tag.func_74768_a("valveY", valveY);
        tag.func_74768_a("valveZ", valveZ);
    }

    @Override
    public void printManometerMessage(EntityPlayer player, List<String> curInfo){
        if(getCore() != null) {
            teValve.getAirHandler(null).printManometerMessage(player, curInfo);
        }
    }

    @Override
    protected boolean shouldRerenderChunkOnDescUpdate(){
        return true;
    }

}
