/*
 * This file is part of Blue Power. Blue Power is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. Blue Power is
 * distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along
 * with Blue Power. If not, see <http://www.gnu.org/licenses/>
 */
package pneumaticCraft.common.util;

import java.util.Random;

import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.world.World;
import pneumaticCraft.common.network.NetworkHandler;
import pneumaticCraft.common.network.PacketDebugBlock;

/**
 * Class aimed for debugging purposes only
 * 
 * @author MineMaarten
 */
public class Debugger{

    private static Random rand = new Random();

    public static void indicateBlock(TileEntity te){

        indicateBlock(te.func_145831_w(), te.func_174877_v());
    }

    public static void indicateBlock(World world, BlockPos pos){

        if(world != null) {
            if(world.field_72995_K) {
                for(int i = 0; i < 5; i++) {
                    double dx = pos.func_177958_n() + 0.5;
                    double dy = pos.func_177956_o() + 0.5;
                    double dz = pos.func_177952_p() + 0.5;
                    world.func_175688_a(EnumParticleTypes.REDSTONE, dx, dy, dz, 0, 0, 0);
                }
            } else {
                NetworkHandler.sendToAllAround(new PacketDebugBlock(pos), world);
            }
        }
    }
}
