package pneumaticCraft.proxy;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.relauncher.Side;
import pneumaticCraft.client.gui.GuiAdvancedAirCompressor;
import pneumaticCraft.client.gui.GuiAdvancedLiquidCompressor;
import pneumaticCraft.client.gui.GuiAerialInterface;
import pneumaticCraft.client.gui.GuiAirCannon;
import pneumaticCraft.client.gui.GuiAirCompressor;
import pneumaticCraft.client.gui.GuiAmadron;
import pneumaticCraft.client.gui.GuiAmadronAddTrade;
import pneumaticCraft.client.gui.GuiAphorismTile;
import pneumaticCraft.client.gui.GuiAssemblyController;
import pneumaticCraft.client.gui.GuiChargingStation;
import pneumaticCraft.client.gui.GuiCreativeCompressor;
import pneumaticCraft.client.gui.GuiDrone;
import pneumaticCraft.client.gui.GuiElectrostaticCompressor;
import pneumaticCraft.client.gui.GuiElevator;
import pneumaticCraft.client.gui.GuiGasLift;
import pneumaticCraft.client.gui.GuiKeroseneLamp;
import pneumaticCraft.client.gui.GuiLiquidCompressor;
import pneumaticCraft.client.gui.GuiLiquidHopper;
import pneumaticCraft.client.gui.GuiOmnidirectionalHopper;
import pneumaticCraft.client.gui.GuiPlasticMixer;
import pneumaticCraft.client.gui.GuiPneumaticDoor;
import pneumaticCraft.client.gui.GuiPneumaticHelmet;
import pneumaticCraft.client.gui.GuiPressureChamber;
import pneumaticCraft.client.gui.GuiPressureChamberInterface;
import pneumaticCraft.client.gui.GuiProgrammableController;
import pneumaticCraft.client.gui.GuiProgrammer;
import pneumaticCraft.client.gui.GuiRefinery;
import pneumaticCraft.client.gui.GuiRemote;
import pneumaticCraft.client.gui.GuiRemoteEditor;
import pneumaticCraft.client.gui.GuiSecurityStationHacking;
import pneumaticCraft.client.gui.GuiSecurityStationInventory;
import pneumaticCraft.client.gui.GuiSentryTurret;
import pneumaticCraft.client.gui.GuiThermopneumaticProcessingPlant;
import pneumaticCraft.client.gui.GuiUVLightBox;
import pneumaticCraft.client.gui.GuiUniversalSensor;
import pneumaticCraft.client.gui.GuiVacuumPump;
import pneumaticCraft.client.gui.semiblock.GuiLogisticsProvider;
import pneumaticCraft.client.gui.semiblock.GuiLogisticsRequester;
import pneumaticCraft.client.gui.semiblock.GuiLogisticsStorage;
import pneumaticCraft.client.gui.tubemodule.GuiAirGrateModule;
import pneumaticCraft.client.gui.tubemodule.GuiPressureModule;
import pneumaticCraft.common.CommonHUDHandler;
import pneumaticCraft.common.HackTickHandler;
import pneumaticCraft.common.inventory.Container4UpgradeSlots;
import pneumaticCraft.common.inventory.ContainerAdvancedAirCompressor;
import pneumaticCraft.common.inventory.ContainerAdvancedLiquidCompressor;
import pneumaticCraft.common.inventory.ContainerAirCannon;
import pneumaticCraft.common.inventory.ContainerAirCompressor;
import pneumaticCraft.common.inventory.ContainerAmadron;
import pneumaticCraft.common.inventory.ContainerAmadronAddTrade;
import pneumaticCraft.common.inventory.ContainerAssemblyController;
import pneumaticCraft.common.inventory.ContainerChargingStation;
import pneumaticCraft.common.inventory.ContainerChargingStationItemInventory;
import pneumaticCraft.common.inventory.ContainerElevator;
import pneumaticCraft.common.inventory.ContainerGasLift;
import pneumaticCraft.common.inventory.ContainerKeroseneLamp;
import pneumaticCraft.common.inventory.ContainerLiquidCompressor;
import pneumaticCraft.common.inventory.ContainerLiquidHopper;
import pneumaticCraft.common.inventory.ContainerLogistics;
import pneumaticCraft.common.inventory.ContainerOmnidirectionalHopper;
import pneumaticCraft.common.inventory.ContainerPlasticMixer;
import pneumaticCraft.common.inventory.ContainerPneumaticBase;
import pneumaticCraft.common.inventory.ContainerPneumaticDoor;
import pneumaticCraft.common.inventory.ContainerPressureChamber;
import pneumaticCraft.common.inventory.ContainerPressureChamberInterface;
import pneumaticCraft.common.inventory.ContainerProgrammableController;
import pneumaticCraft.common.inventory.ContainerProgrammer;
import pneumaticCraft.common.inventory.ContainerRefinery;
import pneumaticCraft.common.inventory.ContainerRemote;
import pneumaticCraft.common.inventory.ContainerSecurityStationHacking;
import pneumaticCraft.common.inventory.ContainerSecurityStationInventory;
import pneumaticCraft.common.inventory.ContainerSentryTurret;
import pneumaticCraft.common.inventory.ContainerThermopneumaticProcessingPlant;
import pneumaticCraft.common.inventory.ContainerUVLightBox;
import pneumaticCraft.common.inventory.ContainerUniversalSensor;
import pneumaticCraft.common.inventory.ContainerVacuumPump;
import pneumaticCraft.common.semiblock.ItemSemiBlockBase;
import pneumaticCraft.common.semiblock.SemiBlockActiveProvider;
import pneumaticCraft.common.semiblock.SemiBlockLogistics;
import pneumaticCraft.common.semiblock.SemiBlockManager;
import pneumaticCraft.common.semiblock.SemiBlockRequester;
import pneumaticCraft.common.semiblock.SemiBlockStorage;
import pneumaticCraft.common.thirdparty.ThirdPartyManager;
import pneumaticCraft.common.tileentity.TileEntityAdvancedAirCompressor;
import pneumaticCraft.common.tileentity.TileEntityAdvancedLiquidCompressor;
import pneumaticCraft.common.tileentity.TileEntityAerialInterface;
import pneumaticCraft.common.tileentity.TileEntityAirCannon;
import pneumaticCraft.common.tileentity.TileEntityAirCompressor;
import pneumaticCraft.common.tileentity.TileEntityAphorismTile;
import pneumaticCraft.common.tileentity.TileEntityAssemblyController;
import pneumaticCraft.common.tileentity.TileEntityBase;
import pneumaticCraft.common.tileentity.TileEntityChargingStation;
import pneumaticCraft.common.tileentity.TileEntityCreativeCompressor;
import pneumaticCraft.common.tileentity.TileEntityElectrostaticCompressor;
import pneumaticCraft.common.tileentity.TileEntityElevatorBase;
import pneumaticCraft.common.tileentity.TileEntityGasLift;
import pneumaticCraft.common.tileentity.TileEntityKeroseneLamp;
import pneumaticCraft.common.tileentity.TileEntityLiquidCompressor;
import pneumaticCraft.common.tileentity.TileEntityLiquidHopper;
import pneumaticCraft.common.tileentity.TileEntityOmnidirectionalHopper;
import pneumaticCraft.common.tileentity.TileEntityPlasticMixer;
import pneumaticCraft.common.tileentity.TileEntityPneumaticDoorBase;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberInterface;
import pneumaticCraft.common.tileentity.TileEntityPressureChamberValve;
import pneumaticCraft.common.tileentity.TileEntityProgrammableController;
import pneumaticCraft.common.tileentity.TileEntityProgrammer;
import pneumaticCraft.common.tileentity.TileEntityRefinery;
import pneumaticCraft.common.tileentity.TileEntitySecurityStation;
import pneumaticCraft.common.tileentity.TileEntitySentryTurret;
import pneumaticCraft.common.tileentity.TileEntityThermopneumaticProcessingPlant;
import pneumaticCraft.common.tileentity.TileEntityUVLightBox;
import pneumaticCraft.common.tileentity.TileEntityUniversalSensor;
import pneumaticCraft.common.tileentity.TileEntityVacuumPump;

public class CommonProxy implements IGuiHandler{
    protected CommonHUDHandler clientHudHandler;
    private CommonHUDHandler serverHudHandler;

    public int PneumaticHelmetRenderID = 0;

    public static enum EnumGuiId{
        AIR_COMPRESSOR, AIR_CANNON, PRESSURE_CHAMBER, CHARGING_STATION, ELEVATOR, PNEUMATIC_HELMET, PRESSURE_CHAMBER_INTERFACE, VACUUM_PUMP, PNEUMATIC_DOOR, ASSEMBLY_CONTROLLER, UV_LIGHT_BOX, SECURITY_STATION_INVENTORY, HACKING, UNIVERSAL_SENSOR, PNEUMATIC_GENERATOR, ELECTRIC_COMPRESSOR, PNEUMATIC_ENGINE, KINETIC_COMPRESSOR, AERIAL_INTERFACE, ELECTROSTATIC_COMPRESSOR, APHORISM_TILE, OMNIDIRECTIONAL_HOPPER, PROGRAMMER, DRONE, PRESSURE_MODULE, AIR_GRATE_MODULE, PNEUMATIC_DYNAMO, FLUX_COMPRESSOR, PLASTIC_MIXER, LIQUID_COMPRESSOR, ADVANCED_AIR_COMPRESSOR, LIQUID_HOPPER, ADVANCED_LIQUID_COMPRESSOR, REMOTE, REMOTE_EDITOR, PROGRAMMABLE_CONTROLLER, GAS_LIFT, REFINERY, THERMOPNEUMATIC_PROCESSING_PLANT, LOGISTICS_REQUESTER, LOGISTICS_STORAGE, LOGISTICS_PASSIVE_PROVIDER, AMADRON, AMADRON_ADD_TRADE, CREATIVE_COMPRESSOR, KEROSENE_LAMP, SENTRY_TURRET;
    }

    private final HackTickHandler serverHackTickHandler = new HackTickHandler();

    public void initConfig(Configuration config){}

    public World getClientWorld(){
        return null;
    }

    public EntityPlayer getPlayer(){
        return null;
    }

    public CommonHUDHandler getCommonHudHandler(){
        if(getSide() == Side.CLIENT) {
            return clientHudHandler;
        } else {
            return serverHudHandler;
        }
    }

    public Side getSide(){
        return FMLCommonHandler.instance().getEffectiveSide();
    }

    public void postInit(){}

    @Override
    public Object getServerGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z){
        BlockPos pos = new BlockPos(x, y, z);
        TileEntity te = world.func_175667_e(pos) ? world.func_175625_s(pos) : null;
        switch(EnumGuiId.values()[ID]){
            case AIR_COMPRESSOR:
                return new ContainerAirCompressor(player.field_71071_by, (TileEntityAirCompressor)te);
            case ADVANCED_AIR_COMPRESSOR:
                return new ContainerAdvancedAirCompressor(player.field_71071_by, (TileEntityAdvancedAirCompressor)te);
            case AIR_CANNON:
                return new ContainerAirCannon(player.field_71071_by, (TileEntityAirCannon)te);
            case PRESSURE_CHAMBER:
                return new ContainerPressureChamber(player.field_71071_by, (TileEntityPressureChamberValve)te);
            case CHARGING_STATION:
                return new ContainerChargingStation(player.field_71071_by, (TileEntityChargingStation)te);
            case ELEVATOR:
                return new ContainerElevator(player.field_71071_by, (TileEntityElevatorBase)te);
            case PNEUMATIC_HELMET:
            case DRONE:
                return new ContainerChargingStationItemInventory(player.field_71071_by, (TileEntityChargingStation)te);
            case PRESSURE_CHAMBER_INTERFACE:
                return new ContainerPressureChamberInterface(player.field_71071_by, (TileEntityPressureChamberInterface)te);
            case VACUUM_PUMP:
                return new ContainerVacuumPump(player.field_71071_by, (TileEntityVacuumPump)te);
            case PNEUMATIC_DOOR:
                return new ContainerPneumaticDoor(player.field_71071_by, (TileEntityPneumaticDoorBase)te);
            case ASSEMBLY_CONTROLLER:
                return new ContainerAssemblyController(player.field_71071_by, (TileEntityAssemblyController)te);
            case UV_LIGHT_BOX:
                return new ContainerUVLightBox(player.field_71071_by, (TileEntityUVLightBox)te);
            case SECURITY_STATION_INVENTORY:
                return new ContainerSecurityStationInventory(player.field_71071_by, (TileEntitySecurityStation)te);
            case HACKING:
                return new ContainerSecurityStationHacking(player.field_71071_by, (TileEntitySecurityStation)te);
            case UNIVERSAL_SENSOR:
                return new ContainerUniversalSensor(player.field_71071_by, (TileEntityUniversalSensor)te);
            case AERIAL_INTERFACE:
                return new Container4UpgradeSlots(player.field_71071_by, (TileEntityAerialInterface)te);
            case ELECTROSTATIC_COMPRESSOR:
                return new Container4UpgradeSlots(player.field_71071_by, (TileEntityElectrostaticCompressor)te);
            case OMNIDIRECTIONAL_HOPPER:
                return new ContainerOmnidirectionalHopper(player.field_71071_by, (TileEntityOmnidirectionalHopper)te);
            case PROGRAMMER:
                return new ContainerProgrammer(player.field_71071_by, (TileEntityProgrammer)te);
            case PLASTIC_MIXER:
                return new ContainerPlasticMixer(player.field_71071_by, (TileEntityPlasticMixer)te);
            case LIQUID_COMPRESSOR:
                return new ContainerLiquidCompressor(player.field_71071_by, (TileEntityLiquidCompressor)te);
            case ADVANCED_LIQUID_COMPRESSOR:
                return new ContainerAdvancedLiquidCompressor(player.field_71071_by, (TileEntityAdvancedLiquidCompressor)te);
            case LIQUID_HOPPER:
                return new ContainerLiquidHopper(player.field_71071_by, (TileEntityLiquidHopper)te);
            case REMOTE:
            case REMOTE_EDITOR:
                return new ContainerRemote(player.func_71045_bC());
            case PROGRAMMABLE_CONTROLLER:
                return new ContainerProgrammableController(player.field_71071_by, (TileEntityProgrammableController)te);
            case GAS_LIFT:
                return new ContainerGasLift(player.field_71071_by, (TileEntityGasLift)te);
            case REFINERY:
                return new ContainerRefinery(player.field_71071_by, (TileEntityRefinery)te);
            case THERMOPNEUMATIC_PROCESSING_PLANT:
                return new ContainerThermopneumaticProcessingPlant(player.field_71071_by, (TileEntityThermopneumaticProcessingPlant)te);
            case LOGISTICS_REQUESTER:
            case LOGISTICS_STORAGE:
            case LOGISTICS_PASSIVE_PROVIDER:
                return new ContainerLogistics(player.field_71071_by, (SemiBlockLogistics)SemiBlockManager.getInstance(world).getSemiBlock(world, pos));
            case AMADRON:
                return new ContainerAmadron(player);
            case AMADRON_ADD_TRADE:
                return new ContainerAmadronAddTrade();
            case CREATIVE_COMPRESSOR:
                return new ContainerPneumaticBase((TileEntityBase)te);
            case KEROSENE_LAMP:
                return new ContainerKeroseneLamp(player.field_71071_by, (TileEntityKeroseneLamp)te);
            case SENTRY_TURRET:
                return new ContainerSentryTurret(player.field_71071_by, (TileEntitySentryTurret)te);
        }
        return ThirdPartyManager.instance().getServerGuiElement(ID, player, world, x, y, z);
    }

    @Override
    public Object getClientGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z){
        BlockPos pos = new BlockPos(x, y, z);
        TileEntity te = world.func_175667_e(pos) ? world.func_175625_s(pos) : null;
        switch(EnumGuiId.values()[ID]){
            case AIR_COMPRESSOR:
                return new GuiAirCompressor(player.field_71071_by, (TileEntityAirCompressor)te);
            case ADVANCED_AIR_COMPRESSOR:
                return new GuiAdvancedAirCompressor(player.field_71071_by, (TileEntityAdvancedAirCompressor)te);
            case AIR_CANNON:
                return new GuiAirCannon(player.field_71071_by, (TileEntityAirCannon)te);
            case PRESSURE_CHAMBER:
                return new GuiPressureChamber(player.field_71071_by, (TileEntityPressureChamberValve)te);
            case CHARGING_STATION:
                return new GuiChargingStation(player.field_71071_by, (TileEntityChargingStation)te);
            case ELEVATOR:
                return new GuiElevator(player.field_71071_by, (TileEntityElevatorBase)te);
            case PNEUMATIC_HELMET:
                return new GuiPneumaticHelmet(new ContainerChargingStationItemInventory(player.field_71071_by, (TileEntityChargingStation)te), (TileEntityChargingStation)te);
            case PRESSURE_CHAMBER_INTERFACE:
                return new GuiPressureChamberInterface(player.field_71071_by, (TileEntityPressureChamberInterface)te);
            case VACUUM_PUMP:
                return new GuiVacuumPump(player.field_71071_by, (TileEntityVacuumPump)te);
            case PNEUMATIC_DOOR:
                return new GuiPneumaticDoor(player.field_71071_by, (TileEntityPneumaticDoorBase)te);
            case ASSEMBLY_CONTROLLER:
                return new GuiAssemblyController(player.field_71071_by, (TileEntityAssemblyController)te);
            case UV_LIGHT_BOX:
                return new GuiUVLightBox(player.field_71071_by, (TileEntityUVLightBox)te);
            case SECURITY_STATION_INVENTORY:
                return new GuiSecurityStationInventory(player.field_71071_by, (TileEntitySecurityStation)te);
            case HACKING:
                return new GuiSecurityStationHacking(player.field_71071_by, (TileEntitySecurityStation)te);
            case UNIVERSAL_SENSOR:
                return new GuiUniversalSensor(player.field_71071_by, (TileEntityUniversalSensor)te);
            case AERIAL_INTERFACE:
                return new GuiAerialInterface(player.field_71071_by, (TileEntityAerialInterface)te);
            case ELECTROSTATIC_COMPRESSOR:
                return new GuiElectrostaticCompressor(player.field_71071_by, (TileEntityElectrostaticCompressor)te);
            case APHORISM_TILE:
                return new GuiAphorismTile((TileEntityAphorismTile)te);
            case OMNIDIRECTIONAL_HOPPER:
                return new GuiOmnidirectionalHopper(player.field_71071_by, (TileEntityOmnidirectionalHopper)te);
            case PROGRAMMER:
                return new GuiProgrammer(player.field_71071_by, (TileEntityProgrammer)te);
            case DRONE:
                return new GuiDrone(new ContainerChargingStationItemInventory(player.field_71071_by, (TileEntityChargingStation)te), (TileEntityChargingStation)te);
            case PRESSURE_MODULE:
                return new GuiPressureModule(player, x, y, z);
            case AIR_GRATE_MODULE:
                return new GuiAirGrateModule(player, x, y, z);
            case PLASTIC_MIXER:
                return new GuiPlasticMixer(player.field_71071_by, (TileEntityPlasticMixer)te);
            case LIQUID_COMPRESSOR:
                return new GuiLiquidCompressor(player.field_71071_by, (TileEntityLiquidCompressor)te);
            case ADVANCED_LIQUID_COMPRESSOR:
                return new GuiAdvancedLiquidCompressor(player.field_71071_by, (TileEntityAdvancedLiquidCompressor)te);
            case LIQUID_HOPPER:
                return new GuiLiquidHopper(player.field_71071_by, (TileEntityLiquidHopper)te);
            case REMOTE:
                return new GuiRemote(player.func_71045_bC());
            case REMOTE_EDITOR:
                return new GuiRemoteEditor(player.func_71045_bC());
            case PROGRAMMABLE_CONTROLLER:
                return new GuiProgrammableController(player.field_71071_by, (TileEntityProgrammableController)te);
            case GAS_LIFT:
                return new GuiGasLift(player.field_71071_by, (TileEntityGasLift)te);
            case REFINERY:
                return new GuiRefinery(player.field_71071_by, (TileEntityRefinery)te);
            case THERMOPNEUMATIC_PROCESSING_PLANT:
                return new GuiThermopneumaticProcessingPlant(player.field_71071_by, (TileEntityThermopneumaticProcessingPlant)te);
            case LOGISTICS_REQUESTER:
                return new GuiLogisticsRequester(player.field_71071_by, (SemiBlockRequester)SemiBlockManager.getInstance(world).getSemiBlock(world, pos));
            case LOGISTICS_STORAGE:
                return new GuiLogisticsStorage(player.field_71071_by, (SemiBlockStorage)SemiBlockManager.getInstance(world).getSemiBlock(world, pos));
            case LOGISTICS_PASSIVE_PROVIDER:
                return new GuiLogisticsProvider(player.field_71071_by, (SemiBlockActiveProvider)SemiBlockManager.getInstance(world).getSemiBlock(world, pos));
            case AMADRON:
                return new GuiAmadron(player.field_71071_by);
            case AMADRON_ADD_TRADE:
                return new GuiAmadronAddTrade();
            case CREATIVE_COMPRESSOR:
                return new GuiCreativeCompressor((TileEntityCreativeCompressor)te);
            case KEROSENE_LAMP:
                return new GuiKeroseneLamp(player.field_71071_by, (TileEntityKeroseneLamp)te);
            case SENTRY_TURRET:
                return new GuiSentryTurret(player.field_71071_by, (TileEntitySentryTurret)te);
        }
        return ThirdPartyManager.instance().getClientGuiElement(ID, player, world, x, y, z);
    }

    public int getArmorRenderID(String armorName){
        return 0;
    }

    public int getRenderIdForRenderer(Class clazz){
        return 0;
    }

    public void registerVillagerSkins(){}

    public HackTickHandler getHackTickHandler(){
        return serverHackTickHandler;
    }

    public boolean isSneakingInGui(){
        return false;
    }

    public void preInit(){

    }

    public void init(){
        MinecraftForge.EVENT_BUS.register(serverHudHandler = new CommonHUDHandler());
        MinecraftForge.EVENT_BUS.register(getHackTickHandler());
    }

    public void registerSemiBlockRenderer(ItemSemiBlockBase semiBlock){

    }
}
